/*
  //export 
  export PATH=/opt/sun-jdk-1.4.2.03/bin:$PATH
  PATH=$JAVA_HOME/bin:$PATH
  export PATH

  //how to run 
  bash -x ./otb.sh -stopPage 5 djvus/alice.djvu


  so libraries
  1)
  Try exporting the library path.
  /usr/local/share/j2sdk1.4.2_03/jre/lib/i386/libPornographyAnalyzer.so
  
  2)
  java -Djava.library.path=<Dir where your so resides> FullyQualifiedClass
  
*/

import java.io.ByteArrayOutputStream; 
import java.io.DataInputStream;
import java.io.IOException;
import java.io.File;
import java.util.StringTokenizer;

public class Otb
{
    //private Process		process;	
    //private Runtime		runtime;	

    static public String JAVA_HOME= null;
    static public int commentsLevel= 1;
    static public int startPage= 0;
    static public int stopPage= 1;

    static public String commentlevel_string;
    static public String startPage_string = "0";
    static public String stopPage_string= "unlimited";

    static public boolean genImage= true;
    static public boolean runJava= true;
    static public String filename;
    
    //unix
    static public String PROGNAME= "otb";
    static public String OTB_HOME= null;
    
    static public String GL4JAVA_HOME= null;
    static public String ITEXT_HOME= null; 
    static public String JMAGIC_HOME= null; 
    static public String DJVU_HOME= null;
    static public String IMAGEMAGICK_HOME= null;
    static public String GS_HOME= null;

    static public String EBOOK_DIR= null;
    static public String PAGE_DIR= null;
    static public String EBOOK_FILE= null;
    static public String EBOOK_TYPE= null;
    static public String IMAGE_FORMAT= "png";
    static public String IMAGE_WIDTH_STRING= "512";
    static public String IMAGE_HEIGHT_STRING= "512";
    
    static public int totalPages= 0;
    static public String totalPages_string= null;

    static public String OTB_JAR= null;
    static public String JARS= null;
    static public String JMAGIC_BIN= null;
    static public String GL4JAVA_BIN=null;
    static public String ITEXT_BIN=null;
    static public String ARGS_FRONT= null;
    static public String ARGS_BACK= null; 
    
    static public String CONFIG_FILE= "testdata.config"; 
    static public String WINDOW_WIDTH= "1024"; 
    static public String WINDOW_HEIGHT= "700";
    static public String WINDOW_START_X= "10";
    static public String WINDOW_START_Y= "20";
    
    static public String VIEWPORT_WIDTH= "1024"; 
    static public String VIEWPORT_HEIGHT= "700";
    static public String VIEWPORT_START_X= "0";
    static public String VIEWPORT_START_Y= "0";

    static public String TEMP_DIR= null;
    static public String TEMP_FILE= "temp.pnm";
    
    
        
    /*
      exec(String[] cmdarray, String[] envp) 
    */

    
    
    

    public Otb(String[] args)
    {
	parse_options(args);

	//set environment variables
	GL4JAVA_HOME= OTB_HOME + "/installed/GL4Java";
	ITEXT_HOME= OTB_HOME + "/installed/itext";
	JMAGIC_HOME= OTB_HOME + "/installed/JMagick";
	DJVU_HOME= OTB_HOME + "/installed/djvulibre";
	IMAGEMAGICK_HOME= OTB_HOME + "/installed/ImageMagick";
	GS_HOME= OTB_HOME + "/installed/ghostscript";
	OTB_JAR= OTB_HOME +"/installed/otb.jar" ;
	GL4JAVA_BIN= GL4JAVA_HOME + "/jre/lib/ext";
	ITEXT_BIN= ITEXT_HOME + "/bin";
	JMAGIC_BIN= JMAGIC_HOME + "/lib";
	JARS= 
	    JMAGIC_BIN + "/jmagick.jar:"+ 
	    GL4JAVA_BIN + "/png.jar:" + 
	    GL4JAVA_BIN + "/gl4java.jar:" + 
	    GL4JAVA_BIN + "/gl4java-glffonts.jar:" + 
	    GL4JAVA_BIN + "/gl4java-glutfonts.jar:" + 
	    ITEXT_BIN + "/iText.jar:" + 
	    OTB_JAR;
			
	if(commentsLevel >= 1){
	    System.err.println("GL4JAVA_HOME: " +  GL4JAVA_HOME );
	    System.err.println("ITEXT_HOME: " +  ITEXT_HOME );
	    System.err.println("JMAGIC_HOME: " +  JMAGIC_HOME );
	    System.err.println("DJVU_HOME: " +  DJVU_HOME );
	    System.err.println("IMAGEMAGIC_HOME: " + IMAGEMAGICK_HOME );
	    System.err.println("GS_HOME: " + GS_HOME );
	}
	
	
	EBOOK_DIR= OTB_HOME + "/data/";
	PAGE_DIR= OTB_HOME + "/pagecache/";

	int startIndex=0 , endIndex= 0; 
	//EBOOK_TYPE
	startIndex= filename.lastIndexOf('.') + 1;
	endIndex= filename.length();
	EBOOK_TYPE= filename.substring(startIndex, endIndex);
	

	if(EBOOK_TYPE.compareTo("pdf") == 0){
	    //EBOOK_FILE
	    EBOOK_DIR= EBOOK_DIR + "pdfs/";
	    startIndex= filename.lastIndexOf('/')+1;
	    endIndex= filename.lastIndexOf('.');
	    EBOOK_FILE= filename.substring(startIndex, endIndex);
	    
	}else if(EBOOK_TYPE.compareTo("djvu") == 0){
	    EBOOK_DIR= EBOOK_DIR + "djvus/";
	    //EBOOK_FILE
	    startIndex= filename.lastIndexOf('/')+1;
	    endIndex= filename.lastIndexOf('.');
	    EBOOK_FILE= filename.substring(startIndex, endIndex);
	}else{
	    
	}
	

	if(commentsLevel >= 1){
	    System.err.println("commentsLevel: " + commentsLevel);
	    System.err.println("startPage: " + startPage);
	    System.err.println("stopPage: " + stopPage);
	    
	    if(genImage)
		System.err.println("genImage: y");
	    else
		System.err.println("genImage: n");
	    
	    if(runJava)
		System.err.println("runJava: y");
	    else
		System.err.println("runJava: n");
	    System.err.println("filename: " + filename);
	    
	    
	    System.err.println("ebook directory: " + EBOOK_DIR);
	    System.err.println("page directory: " + PAGE_DIR);
	    System.err.println("ebook file: " + EBOOK_FILE);
	    System.err.println("type: " + EBOOK_TYPE);
	}


	searchTotalpages();
	if(genImage){
	    System.err.println("Generate images");
	    	    
	    generating_image(startPage, stopPage);
	    if(stopPage < totalPages){ 
		generating_image(totalPages-2, totalPages-1); // generate the last page
		}
	    System.err.println("image generation complete: ");
	}

	ARGS_FRONT=
	    "-classpath " + JARS + 
	    " TTPproject.Ttp -prefix " + 
	    OTB_HOME + " -datafile "+  CONFIG_FILE;

	String commentlevel_string= Integer.toString(commentsLevel);
	
	ARGS_BACK=
	    "-from " + startPage_string + " " +
	    "-to " + stopPage_string + " " + 
	    "-totalPages " + totalPages_string + " " + 
	    "-commentlevel "+ commentlevel_string + " " +
	    "-yearlevel 10 "+  
	    "-window " + WINDOW_WIDTH + " " + WINDOW_HEIGHT + " " + WINDOW_START_X + " " + WINDOW_START_Y + " " + 
	    "-viewport " + VIEWPORT_WIDTH + " " + VIEWPORT_HEIGHT + " " + VIEWPORT_START_X + " " + VIEWPORT_START_Y;
	    
    }

    protected void print_usage()
    {
	System.err.println("Usage: otb.sh [-commentLevel num] [-genImage y/n] [-startPage num]" + 
			   "[-stopPage num] [-javarun y/n] -ebookfile ebookfile.[pdf|djvu]");
	System.exit(1);
    }
    
    protected void parse_options(String[] args)
    {
	int i= 0; 

	System.err.println("args length: " +  args.length);

	if(args.length == 0){
	    print_usage();
	}

	int argument_index= 0;
	String next_token= null;
	
	while(argument_index < args.length || next_token != null) {
	    // 1. We start by attempting to parse an argument name. An argument must start with a '-', and should not contain spaces. If anything else is encountered it is ignored.
	    String argument_name = null;
	    if(next_token == null) {
		next_token = args[argument_index];
		
		argument_index++;
	    }
	    if(next_token.startsWith("-")) {
		System.err.println("does start With '-' ");

		// Trim second '-' just to be kind to Unixy-type people
		if(next_token.startsWith("--")) {
		    argument_name = next_token.substring(1);
		}
		else {
		    argument_name = next_token;
		}
	    }

	    
	    next_token = null;
	    // 2. If we now have an argument name we continue by attempting to parse a value. A value is taken to be the sequence of space seperated Strings between the last argument name and up to but not including the next argument name. Of course an argument needn't have any value (ie -debug, -help), in which case value will be null.
	    if(argument_name != null) {
		System.err.println("argument_name: " +  argument_name);
		String argument_value = null;
		StringBuffer argument_value_buffer = new StringBuffer("");
		while(argument_index < args.length && next_token == null) {
		    next_token = args[argument_index];
		    argument_index++;
		    // If we just parsed an arbitary String then append it to value, followed by a single space
		    if(!next_token.startsWith("-")) {
			System.err.println("next_token:  " + next_token);

			argument_value_buffer.append(next_token);
			argument_value_buffer.append(" ");
			next_token = null;
		    }
		    // If the argument token retrieved is an argument name, then leave it in next_token, which will cause the argument parsing process to move onto the next step.
		}
		// If a value now exists in argument buffer, retrieve it. Remove the last character as it will be an erroneous space.
		if(argument_value_buffer.length() > 0) {
		    argument_value = argument_value_buffer.substring(0, argument_value_buffer.length() - 1);
		}
		
		// 3. We now have the argument name, and any associated value. We are ready to store the data in the appropriate variables
		// 3a. First those arguments that have no associated value
		if(argument_value == null) {
		    System.err.println("argument_value ==  null ");

		}	
		else {
		    System.err.println("argument_value != null ");

		    if( argument_name.compareTo("-commentlevel") == 0 ){
			
			//int 
			commentlevel_string= argument_value;
			commentsLevel= Integer.parseInt(argument_value) ;
		    }
		    
		    if( argument_name.compareTo("-startPage") == 0 ){
			//int
			startPage_string= argument_value;
			startPage= Integer.parseInt(argument_value) ;
		    }
		    
		    if( argument_name.compareTo("-stopPage") == 0 ){
			//int
			stopPage_string= argument_value;
			stopPage= Integer.parseInt(argument_value) ;
		    }
		    
		    if( argument_name.compareTo("-genImage") == 0 ){
			//boolean
			
			String myboolean= new String(argument_value);
			if (myboolean.compareTo("y") == 0){
			    genImage= true;
			}else{
			    genImage= false;
			}
			

		    }
		    
		    if( argument_name.compareTo("-javarun") == 0 ){
			//boolean
			
			String myboolean= new String(argument_value);
			if (myboolean.compareTo("y") == 0){
			    runJava= true;
			}else{
			    runJava= false;
			}
		    }

		    if( argument_name.compareTo("-ebookfile") == 0 ){
			filename= argument_value ;
		    }
		    		    
		}
		
	    }else{
		System.err.println("argument_name is null ");
		
		
	    }
	    
	    
	    
	}
	
	
	/*
	while(i< args.length){
	    if( args[i].compareTo("-commentlevel") == 0 ){
		//int 
		i++;
		commentsLevel= Integer.parseInt(args[i]) ;
	    }
	    
	    if( args[i].compareTo("-startPage") == 0 ){
		//int
		i++;
		startPage= Integer.parseInt(args[i]) ;
	    }

	    if( args[i].compareTo("-stoptPage") == 0 ){
		//int
		i++;
		stopPage= Integer.parseInt(args[i]) ;
	    }

	    if( args[i].compareTo("-genImage") == 0 ){
		//boolean
		i++;
		String myboolean= new String(args[i]);
		if (myboolean.compareTo("y") == 0){
		    genImage= true;
		}else{
		    genImage= false;
		}
		

	    }
	    
	    if( args[i].compareTo("-runJava") == 0 ){
		//boolean
		i++;
		String myboolean= new String(args[i]);
		if (myboolean.compareTo("y") == 0){
		    runJava= true;
		}else{
		    runJava= false;
		}
	    }
	    

	    i++;
	    }*/

	
	
	//print_usage();
    }

    protected void searchTotalpages()
    {
	System.err.println("searchTotalpages()");
	
	String full_ebookfile= EBOOK_DIR + EBOOK_FILE + "." + EBOOK_TYPE;
	
	System.err.println("full ebook path> " + full_ebookfile);

	//experiment
	String djvuenvp[] = {
	    "LD_LIBRARY_PATH=" + DJVU_HOME + "/lib", 
	    "PATH=" + DJVU_HOME + "/bin"
	};
	
	String[] pdfinfo = {"bash", "-c", "pdfinfo "+ full_ebookfile + " | grep Pages | awk '{print $2}'"};
	String[] djvused = {"bash", "-c", "djvused "+ full_ebookfile + " -e 'n'"};
	
		
	Runtime runtime = Runtime.getRuntime();
	Process process= null;
	try{
	    if(EBOOK_TYPE.compareTo("pdf") == 0 ){
		System.err.println("pdf");
		process = runtime.exec(pdfinfo);
	    }else if(EBOOK_TYPE.compareTo("djvu") == 0){
		System.err.println("djvu");
		process = runtime.exec(djvused, djvuenvp);
		
	    }else{
		System.err.println("unknown type");
		System.exit(1);
	    }
	    
	    try{
		process.waitFor();
	    }catch(InterruptedException e) { }
	    
	    java.io.InputStream	input;
	    
	    // Get stdout from the process and a buffer for the data...
	    input  = process.getInputStream();
	    byte [] buffer = new byte[8196];
	    ByteArrayOutputStream pdfstreambuffer= new ByteArrayOutputStream();

	   
	    int bytes= 0;
	    int total_bytes= 0;
	    while ((bytes = input.read(buffer)) > 0){
		
		System.out.println( "Number of bytes read: "+ bytes );
		
		pdfstreambuffer.write(buffer, 0, bytes);
		total_bytes += bytes;
	    }
	    
	    

	    String temp= new String( pdfstreambuffer.toString());
	    
	    
	    //see if any newline characters at the end of the string
	    int endindex= temp.lastIndexOf("\n");
	    
	    if(endindex > -1){
		//int endindex= new String("999").lastIndexOf("\n");
		System.err.println("endindex> " + endindex);
		totalPages_string = temp.substring(0, endindex);
	    }else{
		totalPages_string= new String(temp);
	    }
	    
	    System.err.println("totalPages string> " + totalPages_string );
	    totalPages= Integer.parseInt(totalPages_string);

	    System.err.println("totalPages> " + totalPages );

	    if(stopPage_string.compareTo("unlimited") == 0){
		stopPage= totalPages-1;
		stopPage_string= new String(totalPages_string);
		System.err.println("stopPage_string> " + stopPage_string);
	    }

	}catch (java.io.IOException e){
	    System.err.println("****Fatal Error during running process" + e.toString());
	}

	
    }
    
    void generating_image(int fromPage , int toPage)
    {
	
	int page_num;
	

	String envp[] = {
	    "GS_HOME=" + GS_HOME,
	    "GS_LIB=" + GS_HOME + "/share/ghostscript/fonts:" + GS_HOME + "/share/ghostscript/8.14/lib",
	    "MAGICK_HOME=" + IMAGEMAGICK_HOME,
	    "LD_LIBRARY_PATH=" + IMAGEMAGICK_HOME  + "/lib:" + DJVU_HOME + "/lib",
	    "PATH=" + DJVU_HOME + "/bin:" + IMAGEMAGICK_HOME + "/bin:" + GS_HOME + "/bin"
	};
	
	
	for(page_num=fromPage; page_num<= toPage; page_num++){
	    String digits= "000000" + page_num;
	    digits= digits.substring(digits.length()-4, digits.length());
	    
	    String imagepath= PAGE_DIR + EBOOK_FILE + digits + "." + IMAGE_FORMAT;
	    
	    System.err.println("Current page> " + imagepath);
	    
	    File file= new File(imagepath);
	    if(!file.exists()){
		System.err.println("Current page image does not exist");
		if(EBOOK_TYPE.compareTo("pdf") == 0 ){
		    
		    System.err.println("pdf");
		    String page_numString= Integer.toString(page_num) ;
		    String full_ebookfile
			= EBOOK_DIR + EBOOK_FILE + "." + EBOOK_TYPE + "[" + page_numString + "]";
		    String geometry= "-geometry " + IMAGE_WIDTH_STRING + "x" + IMAGE_HEIGHT_STRING + "!";
		    
		    System.err.println("full_ebookfile>  " + full_ebookfile);
		    
			String[] pdf2png = 
			    {"bash",
			     "-c", 
			     "convert -verbose " + full_ebookfile +  " " +
			     geometry + " " +
			     imagepath };
			String pdf2png2= 
			    "convert -verbose " + full_ebookfile +  " " +
			    geometry + " " + 
			    
			    imagepath;
			
			/*StringTokenizer st= new StringTokenizer(pdf2png2);
			System.err.println("testtoken");
			while (st.hasMoreTokens()) {
			    System.err.println(st.nextToken());
			    }*/
			runProcess( pdf2png, envp);
			
// 			System.err.println("pdf2png command>  " + pdf2png[2] );
// 			Runtime runtime = Runtime.getRuntime();
// 			try{

// 			    Process process = runtime.exec(pdf2png, envp);
			    

// 			    // any output?
// 			    StreamGobbler outputGobbler = new
// 				StreamGobbler(process.getInputStream(), "OUTPUT");
			    
			    
// 			    // any error message?
// 			    StreamGobbler errorGobbler = new
// 				StreamGobbler(process.getErrorStream(), "ERROR");            
			    
// 			    // kick them off
// 			    errorGobbler.start();
// 			    outputGobbler.start();
			    
// 			    try{
				
// 				process.waitFor();
// 			    }catch(InterruptedException e) { }
			    
// 			}catch (java.io.IOException e){
// 			    System.err.println("****Fatal Error during running process" + e.toString());
// 			}
		    }
		else if(EBOOK_TYPE.compareTo("djvu") == 0){
		    System.err.println("djvu");
		    String full_ebookfile
			    = EBOOK_DIR + EBOOK_FILE + "." + EBOOK_TYPE ;
		    String geometry= "-geometry " + IMAGE_WIDTH_STRING + "x" + IMAGE_HEIGHT_STRING + "!";
		    String page_numString= Integer.toString(page_num+1);
		    String[] djvu2png = 
			{"bash",
			 "-c",
			 "ddjvu -page " + page_numString + " " +  full_ebookfile +  " - | " +
			 "convert -verbose pnm:- " +
			 geometry + " " + " " +
			 imagepath
			};


		    String[] djvu2pnm = 
			{"bash",
			 "-c",
			 "ddjvu -page " + page_numString + " " +  full_ebookfile + " "  + TEMP_DIR + TEMP_FILE
			};

		    String[] pnm2png = 
			{"bash",
			 "-c",
			 "convert -verbose " + TEMP_DIR + TEMP_FILE +  " " +
			 geometry + " " +
			 imagepath 
			};
		    
		    
		    //writing to TEMP directory
		    runProcess( djvu2pnm , envp );
		    runProcess( pnm2png, envp );
		    
		    
		    //System.err.println("djvu2pnm> " + djvu2pnm[2]);
		    //System.err.println("djvu2png> " + djvu2png[2]);
// 		    Runtime runtime = Runtime.getRuntime();
// 		    try{
			
// 			Process process = runtime.exec(djvu2pnm, envp);
			
// 			// any output?
// 			StreamGobbler outputGobbler = new
// 			    StreamGobbler(process.getInputStream(), "OUTPUT");
			

// 			// any error message?
// 			StreamGobbler errorGobbler = new
// 			    StreamGobbler(process.getErrorStream(), "ERROR");            
			
// 			// kick them off
// 			errorGobbler.start();
// 			outputGobbler.start();
			
// 			try{
// 			    process.waitFor();
// 			}catch(InterruptedException e) { }
			
// 		    }catch (java.io.IOException e){
// 			System.err.println("****Fatal Error during running process" + e.toString());
// 		    }
		
		    
		}else{
		    System.err.println("Unknown type");
		}
	    }else{
		System.err.println("Current page image already exist");
	    }
	}

    }

    protected void runProcess( String [] cmd, String[] envp )
    {
	System.err.println("runProcess> " + cmd [2]);
	
	Runtime runtime = Runtime.getRuntime();
	try{
	    Process process = runtime.exec(cmd, envp);
	    
	    // any output?
	    StreamGobbler outputGobbler = new
		StreamGobbler(process.getInputStream(), "OUTPUT");
	    
	    
	    // any error message?
	    StreamGobbler errorGobbler = new
		StreamGobbler(process.getErrorStream(), "ERROR");            
	    
	    // kick them off
	    errorGobbler.start();
	    outputGobbler.start();
	    
	    try{
		process.waitFor();
	    }catch(InterruptedException e) { }
	    
	}catch (java.io.IOException e){
	    System.err.println("****Fatal Error during running process" + e.toString());
	}

    }

    
    public void run()
    {
	String ebook= EBOOK_FILE + "." + EBOOK_TYPE;
	
	if(runJava){
	    
	    String envp[] = {
		"GS_HOME=" + GS_HOME,
		"GS_LIB=" + GS_HOME + "/share/ghostscript/fonts:" + GS_HOME + "/share/ghostscript/8.14/lib",
		"MAGICK_HOME=" + IMAGEMAGICK_HOME,
		"LD_LIBRARY_PATH=" + IMAGEMAGICK_HOME  + "/lib:" + DJVU_HOME + "/lib"
		
	    };

	    Runtime runtime = Runtime.getRuntime();
	    Process process= null; 
	    String library_path= GL4JAVA_HOME + "/lib:" + JMAGIC_HOME + "/lib";
	    String JAVARUN = "java -Djava.library.path="+ library_path + " " + ARGS_FRONT + " -pdffile 1 " +  ebook + " " +  ARGS_BACK  ;
	    String JAVARUN2 = "java -Djava.library.path="+ library_path + " " + ARGS_FRONT + " -djvufile " +  ebook + " " +  ARGS_BACK  ;
	    //String JAVARUN = "java Test";
	    
	    
	    try{
		if(EBOOK_TYPE.compareTo("pdf") == 0 ){
		    //java $ARGS_FRONT -pdffile 1 $ebookfile_tail $ARGS_BACK -viewport 700 700 0 0
		    String[] cmd = {"bash", "-c",  JAVARUN };
		    System.err.println("pdf");

		    System.err.println(cmd[2]);
		    process = runtime.exec(cmd, envp);
		}else if(EBOOK_TYPE.compareTo("djvu") == 0 ){
		    System.err.println("djvu");
		    //java $ARGS_FRONT -djvufile $ebookfile_tail $ARGS_BACK -viewport 700 700 0 0
		    String[] cmd = {"bash", "-c",  JAVARUN2 };

		    System.err.println(cmd[2]);
		    process = runtime.exec(cmd, envp);
		}else{
		    System.err.println("Unknown type");
		}

		// any output?
		StreamGobbler outputGobbler = new
		    StreamGobbler(process.getInputStream(), "OUTPUT");
		
		// any error message?
		StreamGobbler errorGobbler = new
		    StreamGobbler(process.getErrorStream(), "ERROR");            
		
		// kick them off
		errorGobbler.start();
		outputGobbler.start();

		try{
		    process.waitFor();//wait for process finished
		}catch(InterruptedException e) { }
		
	    }catch (java.io.IOException e){
		System.err.println("****Fatal Error during running process " + e.toString());
	    }
	}
    }
        
    public static void main(String[] args) 
    {
	//check version
	String version = System.getProperty("java.version");
	String working_directory = System.getProperty("user.dir");
	JAVA_HOME= System.getProperty("java.home");

	
	TEMP_DIR= System.getProperty("java.io.tmpdir") + "/";
	version = version.substring(0, version.lastIndexOf("."));
	
	System.err.println("VERSION: " + version);
	System.err.println("working_directory: " + working_directory);
	System.err.println("Temporary dir: " + TEMP_DIR);
	System.err.println("Java home: " + JAVA_HOME);
	
	
	int rightindex= working_directory.lastIndexOf("/bin/script");
	OTB_HOME= working_directory.substring(0, rightindex); 
	System.out.println( "OTB_HOME> " + OTB_HOME );
	
	float ver = new Float(version).floatValue() ;
	boolean isJava4_ = (ver >= 1.4f) ? true : false;
	
	if(isJava4_){
	    Otb otb= new Otb(args);
	    otb.run();
	}else{
	    System.err.println("Error: You need to use jdk 1.4 or above");
	    System.exit(1);
	}
    }
}
