#!/bin/sh
FONTS="ghostscript-fonts-std-8.11.tar.gz"

if [ ! -n "$OTB_HOME" ] ; then 
    echo "Error: Environment variable OTB_HOME not set."
    echo "       Have you run 'source setup.bash' ?"
    exit 1
fi

exe=
if [ $OTBOS = "cygwin" ] ; then
  exe=".exe"
fi

cd $OTB_HOME/installed

echo "-------------------"
du -ks *
echo "-------------------"

echo "Pairing install directory to barebones"

if [ -e GL4Java ] ; then
  echo "  GL4Java"
  /bin/rm -rf GL4Java/jre/lib/ext/gl4java
  /bin/rm -f GL4Java/lib/libGL4JavaJauGljJNI.so*
  /bin/rm -f GL4Java/lib/libGL4JavaJauGljJNI12.so*
  /bin/rm -f GL4Java/lib/libGL4JavaJauGljJNI13.so*
fi

if [ -e ImageMagick ] ; then
  echo "  ImageMagick"
  /bin/rm -rf ImageMagick/include
  /bin/rm -rf ImageMagick/man
  /bin/rm -rf ImageMagick/share

  /bin/mv ImageMagick/bin/convert$exe .
  /bin/rm -f ImageMagick/bin/*
  /bin/mv convert$exe ImageMagick/bin/.
fi

if [ -e JMagick ] ; then
  echo "  JMagick"
  # Nothing to be done
  /bin/cp $OTB_HOME/packages/lib/libpng.so.2 JMagick/lib/.

fi

if [ -e djvulibre ] ; then
  echo "  djvulibre"
  /bin/rm -rf djvulibre/man
  /bin/rm -rf djvulibre/lib/netscape

  /bin/mv djvulibre/bin/ddjvu$exe .
  /bin/mv djvulibre/bin/djvused$exe .
  /bin/rm -f djvulibre/bin/*
  /bin/mv ddjvu$exe djvulibre/bin/.
  /bin/mv djvused$exe djvulibre/bin/.
fi

if [ -e ghostscript ] ; then
  echo "  ghostscript"
  /bin/rm -rf ghostscript/man
  /bin/rm -rf ghostscript/share/ghostscript/8.14/Resource
  /bin/rm -rf ghostscript/share/ghostscript/8.14/examples
  /bin/rm -rf ghostscript/share/ghostscript/8.14/doc

  /bin/mv ghostscript/bin/gs$exe .
  /bin/rm -f ghostscript/bin/*
  /bin/mv gs$exe ghostscript/bin/.
fi


#add fonts
if [ ! -e ghostscript/share/ghostscript/fonts ] ; then
  echo "  untar ghostscript fonts"
  tar xzvf $OTB_HOME/packages/ghostscript/$FONTS -C ghostscript/share/ghostscript/
else 
  echo "  ghostscript fonts already existed"
fi

if [ -e itext ] ; then
  echo "  itext"
  # Nothing to be done
fi

if [ -e javacc ] ; then
  echo "  javacc"
  echo "**** Currently not installed!  Doesn't look like its needed!"
fi

echo "-------------------"
du -ks *
echo "-------------------"
