#!/bin/bash

commentlevel=1

while : ; do
    case $# in 0 ) break ;; esac # no arguments
    case $# in 1 ) break ;; esac # only filename at end remains
    case "$1" in
      -commentlevel )
        shift
        commentlevel=$1
        shift
       ;;
      -- )     # Stop option processing
        shift
        break
       ;;
      * )
        break
       ;;
    esac
done


type=$1
pagedir=$2
ebookdir=$3
fromPage=$4
toPage=$5
ebookfile=$6
suffix=$7
imageWidth=$8
imageHeight=$9

#$OTBOS has not assigned yet
#if [ $OTBOS = "cygwin" ] ; then
#  exeext=".exe"
#else
#  exeext=""
#fi

if [ $commentlevel -gt "1" ] ; then
  echo "page directory : $pagedir"
  echo "ebook directory: $ebookdir"
  echo "fromPage       : $fromPage"
  echo "toPage         : $toPage"
  echo "ebookfile      : $ebookfile"
  echo "image Width    : $imageWidth"
  echo "image Height   : $imageHeight"
fi

#CONVERT=$OTB_HOME/installed/ImageMagick/bin/convert$exeext

#generate page images

if [ "${ebookfile##/*}x" = "x" ] ; then
  full_ebookfile=$ebookfile
else
  full_ebookfile="$ebookdir$ebookfile"
fi

ebookfile_tail=${ebookfile##*/}

for((i = $fromPage; i <= $toPage; i++))
do
    image=`printf "$ebookfile_tail%04d.$suffix\n" $i`
    if [ ! -e "$pagedir$image" ] ; then

      if [ $commentlevel -gt 0 ] ; then
        echo "${ebookfile_tail}.${type}: extracting page $i"
      fi
      if [ $commentlevel -gt 1 ] ; then
        echo "Saved as image: $image"
      fi
      if [ $type = "pdf" ] ; then
        output=`( convert -verbose "$full_ebookfile.pdf[$i]" -geometry ${imageWidth}x${imageHeight}! +profile "*" "$pagedir"$image ) 2>&1`
      else
        ip1=$(($i+1))
##        `ddjvu$exeext -page $ip1 "$full_ebookfile.djvu" "$full_ebookfile.ppm"`
##        output=`( $CONVERT -verbose "$full_ebookfile.ppm" -geometry ${imageWidth}x${imageHeight}! +profile "*" "$pagedir"$image ) 2>&1`
        output=`( ddjvu$exeext -page $ip1 "$full_ebookfile.djvu" - | convert -verbose pnm:- -geometry ${imageWidth}x${imageHeight}! +profile "*" "$pagedir"$image ) 2>&1`
      fi

      if [ $commentlevel -gt 2 ] ; then
        echo $output
      fi
    fi
done