package TTPproject;

import javax.vecmath.Color4f;
import java.awt.event.InputEvent;

/**
 * 
 * @author Jack(Yi-Chun), Chu
 * @version 0.0, June 2002
 */
public interface CONSTANTS {
    
    //Query command
    // nx , nz and elementLength
    int PAGE_DIMENSION= 0;
    
    // zMax, xMax
    int COVER_DIMENSION= 1;
    
    // perspective param
    // fov, aspect, near & far
    int PERSPECTIVE_PARAMETERS= 2;
    
    // eye & lookAt points
    // upVector 
    int CAMERA_PARAMETERS =3;
    
    // total_pages
    int BOOK_PARAMETERS= 4;

    //intersection experiment
    int INTERSECTION_POINTS= 5;

    // side of double-pages spread 
    int RIGHT_SPREAD= 5;
    
    int LEFT_SPREAD= 6;

    // selection mode
    int UNSELECTED= 7;
    
    int SELECTED= 8;

    // dragging mode
    //int TURNING= 12;
    int ANIMATING = 12;
    
    //int NOT_TURNING= 13;
    int NOT_ANIMATING= 13;
    int FLIPPING= 14;
    
    
    

    //page_mode & page type
    int DYNAMIC= 9;
    int STATIC= 10;

    //Query Command
    // Turning parameters
    int TURNING_PARAMETERS= 11;

    //face
    byte UP= 0;

    byte DOWN= 1;

    //selected page
    int NONE= -1;

    //cover state
    int CLOSE= 1;
    int OPEN= 2;

    //renderCube control parameters
    byte LINE= 0;
    byte FILL= 1;
    byte TEXTURE= 2;

    //Bezier Curve & selected page side & 
    byte RIGHT= 0;
    byte LEFT= 1;
    
    //turning direction
    byte CLOCKWISE= 0;
    byte ANTI_CLOCKWISE= 1;
   
    //spine orientation
    byte POSITIVE= 0;
    byte NEGATIVE= 1;

    //page region
    int TOP= 0;
    int MIDDLE= 1;
    int BOTTOM= 2;
    
    //texture index
    int CHECKBOARD= 0;
    int BOOKFRONT_EDGE= 1;
    int BOOKSIDE= 2;
    int BOOK_FRONT_COVER= 3;
    int BOOK_BACK_COVER= 4;
    int BOOK_SPINE= 5;
    int PAGE_EDGE= 6; //left & right edge share the same texture
    int PAGE_MATERIAL= 7;
    int COVER_MATERIAL= 8;
    int BORDER= 9;
    int INSIDE_BOOK_FRONT_COVER= 10;
    int INSIDE_BOOK_BACK_COVER= 11;

    int num_fixed_tex_obj= 12;
    
    //input masks
    int altdown_button1mask= InputEvent.ALT_MASK | InputEvent.BUTTON1_MASK;
    int shiftdown_button1mask= InputEvent.SHIFT_MASK  | InputEvent.BUTTON1_MASK;
    int ctrldown_button1mask= InputEvent.CTRL_MASK | InputEvent.BUTTON1_MASK;
    int ctrldown_mask= InputEvent.CTRL_MASK;
    int shiftdown_mask= InputEvent.SHIFT_MASK;
    int altdown_mask= InputEvent.ALT_MASK;
    
    //MAX values 
    int MAX_PAGES= 1000;
    double MAX_COVER_THICKNESS= .3;
    double MAX_SPINEF2_HEIGHT= .5;
    double MAX_SPINEF5_HEIGHT= .5;
    
    //buffering options
    int WINDOWING= 0;
    int DIRECT_ONE= 1;// direct manipulation generate 2 pages with n second delay
    int DIRECT_TWO= 2;// directly to page with low resolution rendering at first, and then on the fly 
    //int ANCHORING= 3; // anchor points with precompiled page
    int MIX_ONE= 4;   // DIRECT_ONE then WINDOWING without lastWindow and firstWindow

    //image format
    int PNG= 0;
    int JPEG= 1;
    int TGA= 2;//???

    //image resolution
    int HIGH= 0;
    int LOW= 1;

    //progressive update 
    int ADD= 0;
    int MULTIPLY= 1;
    
    //cursor
    int IDLE= 0;
    int HAND= 1;
    int GRAB= 2;
    int WAIT= 3;
    int FORWARD= 4;
    int BACKWARD= 5;
    int RIGHTPRESS= 6;
    int BACKGROUND= 7;
    

    //program state
    int LOADING= 0;
    int RUNNING= 1;

    //running type
    int NO_ANCHORING= 0;
    int ANCHORING= 1;

    //anchoring type
    int STEPPING= 0;
    int RANDOM_JUMP= 1;
    int FROM_FILE= 2;

    //control mode
    int USER= 0;
    int ANIMATION= 1;

    //seeds
    long RAND_MAX= 999999;
    
    static final String newline = "\n";
       
    //page color
    static final Color4f BROWN= new Color4f(0.68f , 0.49f , 0.25f, 1.0f);
    static final Color4f WHITE= new Color4f(1.0f , 1.0f , 1.0f, 1.0f);
    static final int PERIOD= 10;

    static final int PDF= 0;
    static final int DJVU= 1;

    //reading mode or non reading mode
    static final int Three_D_MODE= 0;
    static final int READING_MODE= 1;
    
    
    static final int NO_MESSAGE= 0;
    static final int MESSAGE= 1;
    
}
