package TTPproject;

import java.awt.*;
import javax.swing.ImageIcon;


public class CursorManager
    implements CONSTANTS
{
    //pre-defined cursor
    Cursor cur_wait;
    Cursor cur_default;
    Cursor cur_crosshair;
    Cursor cur_text;
    Cursor cur_hand;
    Cursor cur_move;
	
    //Custom cursor
    Cursor cur_hand_custom;
    Cursor cur_grab_custom;
    Cursor cur_flipForward_custom;
    Cursor cur_flipBackward_custom;
    Cursor cur_rightMouse_pressed;
    Cursor cur_background;
    
    Cursor currentCursor;
    int currentCursorType;
    Cursor previousCursor;
    int previousCursorType;

    
    /**
     * Constructor
     * Create the predefined cursors & new custom cursors
     */
    public CursorManager()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("CursorManager()");
	}

	
    }


    public void doInitialized()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("CursorManager.java: doInitialized()");
	}
	
	//predefined cursor
	cur_wait = new Cursor(Cursor.WAIT_CURSOR);
	cur_crosshair = new Cursor(Cursor.CROSSHAIR_CURSOR);
	cur_hand = new Cursor(Cursor.HAND_CURSOR);
	/*
	  Cursor cur_default = new Cursor(Cursor.DEFAULT_CURSOR);
	  Cursor cur_crosshair = new Cursor(Cursor.CROSSHAIR_CURSOR);
	  Cursor cur_text = new Cursor(Cursor.TEXT_CURSOR);
	  Cursor cur_hand = new Cursor(Cursor.HAND_CURSOR);
	  Cursor cur_move = new Cursor(Cursor.MOVE_CURSOR);
	*/
	
	//curstom cursor
	cur_hand_custom= makeCustomCursor("hand.gif");
	cur_grab_custom= makeCustomCursor("grab.gif");
	cur_flipForward_custom= makeCustomCursor("flipForward.gif");
	cur_flipBackward_custom= makeCustomCursor("flipBackward.gif");
	cur_rightMouse_pressed= makeCustomCursor("rightbuttonpressed.gif");
	cur_background= makeCustomCursor("background.gif");

    }
    

    public Cursor makeCustomCursor(String name)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("CursorManager.java: makeCustomCursor()");
	    System.out.println("CursorManager.java: icon dir " + Ttp.iconPrefix+name);
	}
	
	Cursor cur_cust;
	Toolkit tk = Toolkit.getDefaultToolkit();
	
	Image img = new ImageIcon(Ttp.iconPrefix+name).getImage();
	Point p = new Point(0,0); // This is the hot-spot in the cursor
	try{
	    cur_cust = tk.createCustomCursor(img, p, name);
	}
	catch(IndexOutOfBoundsException ioobe){
	    if(Ttp.commentslevel >= 3){
		System.out.println("****CursorManager.java: error in  makeCustomCursor()" + ioobe);
	    }
	    return null;
	}
	
	return cur_cust;
    }

    public Cursor getCursor(int type)
    {
	Cursor cursor= null;
	switch(type){
	case IDLE:
	    cursor=cur_crosshair;
	    previousCursor= cursor;
	    previousCursorType= type;
	    break;
	case HAND: 
	    cursor= cur_hand_custom;
	    previousCursor= cursor;
	    previousCursorType= type;
	    break;
	case GRAB: 
	    cursor= cur_grab_custom;
	    previousCursor= cursor;
	    previousCursorType= type;
	    break;
	case FORWARD: 
	    cursor= cur_flipForward_custom;
	    previousCursor= cursor;
	    previousCursorType= type;
	    break;
	case BACKWARD: 
	    cursor= cur_flipBackward_custom;
	    previousCursor= cursor;
	    previousCursorType= type;
	    break;
	case RIGHTPRESS:
	    cursor= cur_rightMouse_pressed;
	    previousCursor= cursor;
	    previousCursorType= type;
	    break;
	case WAIT:
	    cursor=cur_wait;
	    break;
	case BACKGROUND:
	    cursor=cur_background;
	    break;    

	}
	
	currentCursor=cursor;
	currentCursorType= type;

	return cursor;
    }

    public Cursor setPreviousCursor()
    {
	return previousCursor;
    }
    
    /*public boolean inWaitingState()
    {
	System.out.println("CursorManager.java: isWaiting()");
	if(currentCursorType == WAIT) 
	    return true;
	else
	    return false;
	
	    }*/

}
