
package TTPproject;
import gl4java.awt.GLCanvas;
import gl4java.GLFunc;
import javax.vecmath.*;

public class CurveManipulator
{
    
    /*
      simple calculate the distance between two points
     */
    public static void calculate_curve_length_1(Point3d [] p,
						double [] length)
    {
	int i;
	double t_l=0;
	
	for(i=0; i<(p.length-1); i++){
	    length[i]= p[i].length(p[i+1]);
	    if(Ttp.commentslevel >= 3){
		System.out.println("length[" + i + "] = " + length[i]);
	    }
	    
	    t_l += length[i];
	}
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("total_length> " + t_l);
	}
    }



    public static void refitting(int num_pts, double unit_len,
				 Point3d [] pts, Point3d [] new_pts,
				 double [] l )
    {
	int cur_seg,cur_pts, steps;
	double m, alpha;
	steps= num_pts-1;
	cur_seg=0;
	cur_pts=1;
	m= unit_len;
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("num_pts> " + num_pts);
	    System.out.println("pts.length> " + pts.length);
	}
	//begin
	new_pts[0].set(pts[0].x,
		       pts[0].y,
		       pts[0].z);

	try{
	if(Ttp.commentslevel >= 3){
	    System.out.println("Begin");
	}
	
	//for(; cur_pts < pts.length; ){
	for(; true; ){
		while(cur_seg < steps){
		    if(m <= l[cur_seg]) break;
		    
		    if(Ttp.commentslevel >= 3){
			System.out.println( "m:" + m  
					    + ", cur_seg: " + cur_seg 
					    + ", cur_pts: " + cur_pts 
					    + ", length: " + l[cur_seg]);
		    
			System.out.println("Searching");
		    }
		    
		    m-=l[cur_seg];
		    cur_seg++;
		}
		
		if(cur_seg == steps){ 
		    if(Ttp.commentslevel >= 3){
			System.out.println("beyond the last segment");
			System.out.println("Extending");
		    }
		      int last_seg= cur_seg;
		      if(Ttp.commentslevel >= 3){
			  System.out.println("last Segment: " + last_seg );
			  System.out.println("cur_pts: " + cur_pts );
			  System.out.println("m: " + m );
		      }
		      
		      Vector3d unit_vector= new Vector3d(pts[last_seg].minus(pts[last_seg-1])).normalized();
		      if(Ttp.commentslevel >= 3){
			  System.out.println("unit_vector length: " + unit_vector.length() );
		      }
		      
		      while(cur_pts < pts.length){
			  new_pts[cur_pts].scaleAdd(m, unit_vector, pts[last_seg]);
			  if(Ttp.commentslevel >= 3){
			      System.out.println("length> " + new_pts[cur_pts].length(new_pts[cur_pts-1]));
			  }
			  cur_pts++;
			  m += unit_len;
		      }
		      break;
		}
		
		while(cur_pts < pts.length){
		    if(Ttp.commentslevel >= 3){
			System.out.println("Dividing");
			System.out.println( "m:" + m  
					    + ", cur_seg: " + cur_seg 
					    + ", cur_pts: " + cur_pts
					    + ", length: " + l[cur_seg]);
		    }
		    
		    if(m > l[cur_seg])break;
		    alpha= m / l[cur_seg];
		    new_pts[cur_pts].interpolate(pts[cur_seg], pts[cur_seg+1], alpha);
		    
		    m += unit_len;
		    cur_pts++;
		}
		
		m-= l[cur_seg];
		cur_seg++;
		
	    }
	    
	}catch(ArrayIndexOutOfBoundsException e){
	    if(Ttp.commentslevel >= 3){
		System.out.println("****CurveManipulator.java refitting() Exception Occured: " + e );
	    }
	}

	

    }
    
    //debug
    public static void displayLineStrip(GLCanvas canvas, Color3f color,
					float width,
					Point3d [] pts )
    {
	GLFunc gl = canvas.gl;
	int i;

	gl.glPushAttrib(canvas.GL_ALL_ATTRIB_BITS); 
	gl.glColor3f(color.x,
		     color.y,
		     color.z );
	gl.glLineWidth(width); 

	gl.glBegin(canvas.GL_LINE_STRIP);
	for(i=0; i< (pts.length-1); i++){
	    gl.glVertex3dv(pts[i].get3dv());
	    gl.glVertex3dv(pts[i+1].get3dv());
	}
	gl.glEnd();
	gl.glPopAttrib(); 

    }


    //debug
    public static void displayPts(GLCanvas canvas, Color3f color,
				  float size,
				  Point3d [] pts )
    {
	GLFunc gl = canvas.gl;
	int i;
	
	gl.glPointSize(size);
	gl.glColor3f(color.x,
		     color.y,
		     color.z );

	gl.glBegin(canvas.GL_POINTS);
	for(i= 0; i < pts.length; i++ ){
	    gl.glVertex3dv(pts[i].get3dv());
	}
	gl.glEnd(); 
	
    }

}
