package TTPproject;

import javax.vecmath.*;
import gl4java.awt.GLCanvas;
import gl4java.GLFunc;
import gl4java.GLUFunc;
import gl4java.GLEnum;

import java.util.Random;


public class DynamicPage
    implements GLEnum, CONSTANTS{
    private Configuration config;

    int page_num_up;
    int page_num_down;
    int pageMaterialUp, pageMaterialDown;
    
    int texNameUp;
    int texNameDown;
        
    //int textureName_up;
    //int textureName_down;
    byte turningdirection;
    
    
    double elementlength= 0;
    int nx= 0, nz= 0;
    //start position
    private Point3d start= null;
    private double y_offset1= .05; //top page offset
    private double y_offset2= - .02; //bottom page offset
    private Vector3d [] jvLeftCurveUP= null; 
    private Vector3d [] jvRightCurveUP= null;
    
    private Point3d [][] resultPos= null;
    private Point3d [][] finalresultPos= null;
    private Point3d [][] finalresultPos2= null;
    private Point3d [] upborder= null;
    private Point3d [] downborder= null;
    private Point3d [] leftborder= null;
    private Point3d [] rightborder= null;
    
    private Vector3d [][] normals= null;
    private Point3d [] tempPos= null; /*The 1st row Jack curve*/

    //rotation parameters
    private double angleStep= 0;
    private double approx_lobb_rot_angle;
    private double approx_jack_rot_angle;
    private double approx_pivot_angle;

    Vector3d [] jackVector;
    Vector3d [] lobbVector;
    
    Point3d [] initial_pos;
    double [] initial_angle; // in radian
    Vector2d xaxis= new Vector2d(1,0);
    Vector2d minus_xaxis= new Vector2d(-1,0);
        
    //used for refitting experiment
    double [] length= null;
    Point3d [] newPts= null;

    //random number generator
    //Random rand= null;
    //double rand_num= 0;

    byte selected_side;
    
    public DynamicPage(Configuration config)
    {
	this.config= config;
	
	nx= config.get_nx();
	nz= config.get_nz();
	elementlength= config.get_elementLength();
	angleStep= config.get_angleStep();

	//read in lobbs vector
	//get step interval
	resultPos= new Point3d[nz][nx];
	finalresultPos= new Point3d[nz][nx];
	finalresultPos2= new Point3d[nz][nx];
	upborder= new Point3d[nx];
	downborder= new Point3d[nx];
	leftborder= new Point3d[nz];
	rightborder= new Point3d[nz];
	normals= new Vector3d[nz][nx];
	

	for(int row=0; row < nz; row++){
	    for(int col= 0; col < nx; col++){
		resultPos[row][col]= new Point3d(0,0,0);
		finalresultPos[row][col]= new Point3d(0,0,0);
		finalresultPos2[row][col]= new Point3d(0,0,0);

		normals[row][col]= new Vector3d(0,0,0);
		//tempPos[row][col]= new Point3d(0,0,0);
	    }
	}

	for(int col= 0; col < nx; col++){
	    upborder[col]= new Point3d(0,0,0);
	    downborder[col]= new Point3d(0,0,0);
	}

	for(int row= 0; row < nz; row++){
	    rightborder[row]= new Point3d(0,0,0);
	    leftborder[row]= new Point3d(0,0,0);
	}
	
	jackVector= new Vector3d[nx];
	lobbVector= new Vector3d[nx];
	initial_pos= new Point3d[nx];
	initial_angle= new double[nx];
	
	tempPos= new Point3d[nx];
	
	jvLeftCurveUP= new Vector3d[nx];
	jvRightCurveUP= new Vector3d[nx];
	length= new double[nx-1];
	newPts= new Point3d[nx];
	for(int i= 0; i < nx; i++){
	    jvLeftCurveUP[i]= new Vector3d(0,0,0);
	    jvRightCurveUP[i]= new Vector3d(0,0,0);
	    jackVector[i]= new Vector3d(0,0,0);
	    lobbVector[i]= new Vector3d(0,0,0);
	    tempPos[i]= new Point3d(0,0,0);
	    initial_pos[i]= new Point3d(0,0,0);
	    newPts[i]= new Point3d(0,0,0);
	}

    } 

    
    public void setPageMaterialUP(int pageMaterial)
    {
	this.pageMaterialUp= pageMaterial;
    }

    public void setPageMaterialDOWN(int pageMaterial)
    {
	this.pageMaterialDown= pageMaterial;
    }

    /*
    public void setAll(int page_num, int start,
		       int pageMaterial)
    {
	this.page_num_up= page_num;
	this.pageMaterial= pageMaterial;
	
	if(turningdirection == ANTI_CLOCKWISE){
	    //right page selected
	    page_num_down= page_num+1;
	}else{
	    //left page selected
	    page_num_down= page_num-1;
	}
	
	System.out.println("Upper page no.> " + page_num_up);
	System.out.println("lower page no.> " + page_num_down);
	
	textureName_up= page_num_up % 4 + start;
	textureName_down= page_num_down % 4 + start;

	rand_num= rand.nextDouble();
	//System.out.println("Random Number> " + 
	//	   rand_num);
    }
    */


    public void setPageContent(int page_name_up, 
			       int page_name_down, 
			       int texNameUp,
			       int texNameDown)
    {
	setPageUPContent(page_name_up, texNameUp);
	setPageDOWNContent(page_name_down, texNameDown);
    }

    public void setPageUPContent(int page_name_up, 
				 int texNameUp )
    {
	this.page_num_up= page_name_up;
	this.texNameUp= texNameUp;
    }

    
    
    public void setPageDOWNContent(int page_name_down, 
				   int texNameDown )
    {
	this.page_num_down= page_name_down;
	this.texNameDown= texNameDown;
    }
   
    public int getPage_numUP()
    {
	return this.page_num_up;
    }

    public int getPage_numDOWN()
    {
	return this.page_num_down;
    }
    

    public void setStartPosition(Point3d start)
    {
	this.start= new Point3d(start);
	this.start.y += y_offset1;
    }

    /*
      Copy Jack Vectors 
     */
    public void setJackVectors(Vector3d [] leftjv, Vector3d [] rightjv)
    {
	//System.arraycopy(leftjv, 0, jvLeftCurveUP, 0, nx);
	Utilities.arrayCopy(leftjv, 0, jvLeftCurveUP, 0, nx);
	//System.arraycopy(rightjv, 0, jvRightCurveUP, 0, nx);
	Utilities.arrayCopy(rightjv, 0, jvRightCurveUP, 0, nx);
	
	setInitialPos();
    }



    void setInitialPos()
    {
	int i;
	double width;
	Vector2d v = new Vector2d(0,0);

	//start from the second point
	for(i=1; i<nx; i++){
	    width= i*elementlength;

	    if(turningdirection == ANTI_CLOCKWISE){
		if(Ttp.commentslevel >= 3){
		    System.out.println("anti-clockwised" );
		}
		v.set(width + jvRightCurveUP[i].x,
		      jvRightCurveUP[i].y );
		initial_angle[i]= v.angle(xaxis);
		
		if(jvRightCurveUP[i].y < 0) initial_angle[i]= -(initial_angle[i]);
		initial_pos[i].set(width + jvRightCurveUP[i].x, 
				   jvRightCurveUP[i].y,
				   0);
		 
	    }else{ //CLOSEWISE
		if(Ttp.commentslevel >= 3){
		    System.out.println("clockwised" );
		}

		width= -width;
		v.set(width + jvLeftCurveUP[i].x,
		      jvLeftCurveUP[i].y );
		v.normalize();
		initial_angle[i]= v.angle(minus_xaxis);

		if(jvLeftCurveUP[i].y < 0) initial_angle[i]= -(initial_angle[i]);
		initial_pos[i].set(width + jvLeftCurveUP[i].x, 
				   jvLeftCurveUP[i].y,
				   0);
	    }
	    if(Ttp.commentslevel >= 3){
		System.out.println("base curve angle: "+ Utilities.rad2degree( initial_angle[i] ) );
	    }
	}
    }
    
    
    public void setTurningDirection(byte direction)
    {
	this.turningdirection= direction;
    }


    // lob could be greater than maxAngle
    // lob is in degrees
    public void set_approx_rot_angle(double lob)
    {
	if(Ttp.commentslevel >= 3){
	    System.out.println("lobb_rot_angle: "+ lob );
	}
	
	int temp;
	double jack;
	double maxAngle= config.getMaxAngle();
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("set_approx_rot_angle: maxAngle> "+ maxAngle );
	}
	
	if(turningdirection == ANTI_CLOCKWISE){
	    // make sure lob is within the constraint region
	    if(Ttp.commentslevel >= 3){
		System.out.println("anticlockwise");
	    }
	    
	    if(lob > maxAngle) lob= maxAngle; 
	    
	    if(lob > 180)
		jack= 180;
	    else
		jack= lob;
	}else{ // CLOCKWISE
	    if(Ttp.commentslevel >= 3){
		System.out.println("clockwise");
	    }
	    
	    if(lob < -maxAngle) lob= -maxAngle; 
	    
	    if(lob < -180)
		jack= -180;
	    else
		jack= lob;
	    lob= Utilities.abs(lob);
	  
	}
	
	
	temp=(int)jack/(int)angleStep;
	approx_jack_rot_angle= temp * angleStep;

	temp=(int)lob/(int)angleStep;
	approx_lobb_rot_angle= temp * angleStep;

	if(Ttp.commentslevel >= 3){
	    System.out.println("approximate jack angle> " +  approx_jack_rot_angle);
	    System.out.println("approximate lob angle> " +  approx_lobb_rot_angle);
	}

    }

    /*
      set up mid point line,i.e. initialize approx_pivot_angle
     */
    public void setpivotAngle( Point3d [] left,
			       Point3d [] right)
    {
	Vector3d a= new Vector3d(left[1].minus(left[0]) );
	Vector3d b= new Vector3d(right[1].minus(right[0]) );
	
	Vector3d c;
	if(turningdirection == ANTI_CLOCKWISE){
	    a= new Vector3d(left[1].minus(left[0]) );
	    b= new Vector3d(right[1].minus(right[0]) );
	    c= new Vector3d(1,0,0);
	}else{
	    a= new Vector3d(right[1].minus(right[0]) );
	    b= new Vector3d(left[1].minus(left[0]) );
	    c= new Vector3d(-1,0,0);
	}
	double theta, phi, temp, pivot;
	

	theta= a.angle(c);
	phi= b.angle(c);
	temp= phi + (theta-phi)/2.0;
	pivot=  Utilities.rad2degree(temp);
	if(Ttp.commentslevel >= 3){
	    System.out.println("real pivot> " + pivot);
	}

	//calculate approximation
	temp=(int)pivot/(int)angleStep;
	
	approx_pivot_angle= temp * angleStep; // always positive
	if(Ttp.commentslevel >= 3){
	    System.out.println("approximate pivot> " +  approx_pivot_angle);
	}
    }

    void genJackVector(double theta, Vector3d first, Vector3d second, Vector3d result,
		       Matrix4d m )
    {
	double scale;
	
	if(theta <= approx_pivot_angle){
	    scale= 1.0 - (theta / approx_pivot_angle);
	    m.transform(first, result);
	}else{
	    scale= (theta - approx_pivot_angle) / (180 - approx_pivot_angle);
	    m.transform(second, result);
	    result.set(-(result.x), 
		       -(result.y),
		       0);
	}
	result.scale(scale);
    }


    /* subdivided nth row*/
    void refitting(int row)
    {
	
	CurveManipulator.calculate_curve_length_1(resultPos[row],
						  length);
	
	CurveManipulator.refitting(nx, elementlength, 
				   resultPos[row], finalresultPos[row],
				   length);
	
	
	//  CurveManipulator.displayLineStrip(canvas, new Color3f(.0f, 1.0f, .0f),
	//  					  3.0f,
	//  					  newPts);
	
    }

    void collision_detection(int i, Point3d pos)
    {
	double cur_angle; //in radian
	
	Vector2d v = new Vector2d(pos.x,pos.y);
	if(turningdirection ==  ANTI_CLOCKWISE)
	    cur_angle= v.angle(xaxis);
	else
	    cur_angle= v.angle(minus_xaxis);
	    
	
	if(pos.y < 0 ) cur_angle= -(cur_angle);
	
	if(cur_angle < initial_angle[i]){
	    pos.set( initial_pos[i].x,
		     initial_pos[i].y,
		     pos.z);
	}

    }

    

    /*
      loadLobbsvector
      genJackVector
      refitting
      collision_detection
      
      once Jack Vectors have been generated
      load the rest of lobbsvectors
      computer surface normals

     */
    void interpolation() 
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("DynamicPage.java: interpolation()");
	}
	
	int i, j;
	Point3d ref= new Point3d(0,0,0);
		
	Matrix4d m=
	    Matrix4d.rotAroundZ(Utilities.degree2rad(approx_jack_rot_angle));
	
	double disx,disy;
	double width;
		
	// load in the first row 
	// assume PR is not equal to null
	config.PR.loadLobbsvector(config.getRegion(),
				  0, 
				  approx_lobb_rot_angle, 
				  lobbVector);

		

	/*Start from the 2nd column*/
	for(j=1; j<nx; j++){
	    /*Generate the first cross-section of Jack Curve*/
	    if(turningdirection == ANTI_CLOCKWISE){
		genJackVector(approx_jack_rot_angle, 
			      jvRightCurveUP[j],
			      jvLeftCurveUP[j],
			      jackVector[j],
			      m );
		width= j*elementlength;
	    }else{
		//clockwise
		genJackVector(-approx_jack_rot_angle, 
			      jvLeftCurveUP[j],
			      jvRightCurveUP[j],
			      jackVector[j],
			      m);
		width= -j*elementlength;
		lobbVector[j].x=  -(lobbVector[j].x);
	    }
	    
	    /*flat-point line*/
	    disx= width * Math.cos(Utilities.degree2rad(approx_jack_rot_angle));
	    disy= width * Math.sin(Utilities.degree2rad(approx_jack_rot_angle));
	    
	    if(Ttp.commentslevel >= 3){
		System.out.println("\twidth= " + width);
		System.out.println("\tapprox_jack_rot_angle= " + approx_jack_rot_angle);
		System.out.println("\tcos= " + Math.cos(Utilities.degree2rad(approx_jack_rot_angle)));
		System.out.println("\tsin= " + Math.sin(Utilities.degree2rad(approx_jack_rot_angle)));
		System.out.println("\tdisx= " + disx);
	    }
	    
	    ref.set(disx, disy, 0);
	    
	    tempPos[j].set( ref.plus(jackVector[j]) );
	    /*Resulting Curve*/
	    resultPos[0][j].set( tempPos[j].plus(lobbVector[j]) );
	   
	    /*simple collision detection: Min operation */
	    if(turningdirection == ANTI_CLOCKWISE){
		if(approx_jack_rot_angle <= approx_pivot_angle )
		    collision_detection(j, resultPos[0][j]);
	    }else{
		if(approx_jack_rot_angle >= -approx_pivot_angle )
		    collision_detection(j, resultPos[0][j]);
	    }
	}
	
	/*subdivide the 1st row*/
	refitting(0);

	double zlen;
	
	/*The rest of row*/
	for(i=1; i < nz; i++){
	    config.PR.loadLobbsvector( config.getRegion(), 
				       i, 
				       approx_lobb_rot_angle, 
				       lobbVector );
	    zlen= i*elementlength;
	    resultPos[i][0].set( 0, 0, zlen);

	    /*start from the second column*/
	    for(j= 1; j < nx; j++){
		
		if(turningdirection == CLOCKWISE) lobbVector[j].x=  -(lobbVector[j].x);
		
		
		resultPos[i][j].set( tempPos[j].x + lobbVector[j].x,
				     tempPos[j].y + lobbVector[j].y,
				     zlen + lobbVector[j].z);
		if(turningdirection == ANTI_CLOCKWISE){
		    if(approx_jack_rot_angle <= approx_pivot_angle )
			collision_detection(j, resultPos[i][j]);
		}else{
		    if(approx_jack_rot_angle >= -approx_pivot_angle )
			collision_detection(j, resultPos[i][j]);
		}
	    }
	    
	    refitting(i);
	}

	
	//compute normals
	Point3d pos= new Point3d(0,0,0);
	Vector3d normal= new Vector3d(0,0,0);
	Vector3d normal_total= new Vector3d(0,0,0);
	Vector3d vCur= new Vector3d(0,0,0);
	Vector3d vLast= new Vector3d(0,0,0);	
	for(i= 0; i< nz; i++){
	    for(j= 0; j < nx; j++){
		//border
		if(i==0){
		    upborder[j].set(finalresultPos[i][j]);
		}
		
		if(i==(nz-1)){
		    downborder[j].set(finalresultPos[i][j]);
		}
		
		if(j==0){
		    leftborder[i].set(finalresultPos[i][j]);
		}

		if(j==(nx-1)){
		    rightborder[i].set(finalresultPos[i][j]);
		}

		vLast.sub( getNeighbour(i, j, 3), finalresultPos[i][j]);
		for (int neighbour = 0; neighbour < 4; neighbour++) {
		    //in anti-clockwised direction
		    //so the normal points upwards
		    vCur.sub(getNeighbour(i, j, neighbour), finalresultPos[i][j]);
		    normal.cross(vLast, vCur);
		    normal_total.add(normal);
		    vLast.set(vCur);
		}
		normals[i][j].normalize(normal_total);
		normal_total.set(0,0,0); 
		
		if(turningdirection == CLOCKWISE){
		    normals[i][j].negate();
		}
		
		/*flip side*/
		finalresultPos2[i][j].scaleAdd(y_offset2 , normals[i][j], finalresultPos[i][j]);
		
	    }
	}
	
    }
    
    
    Point3d getNeighbour(int row, int col, int neighbour) 
    {
        int dx = 0, dz = 0;
        switch(neighbour) {
	case 0: dx = 1; break; // right
	case 1: dz = -1; break; // up
	case 2: dx = -1; break; // left
	case 3: dz = 1; break; // down
        }
        
	int x = col + dx, z = row + dz;
        if (x < 0 || z < 0 || z >= nz || x >= nx)
            return finalresultPos[row][col];
        else
            return finalresultPos[z][x];
    }


      
    void displaypts(GLCanvas canvas,  int row)
    {
	GLFunc gl = canvas.gl;
	
	int i;
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glColor3f(.0f, .7f, .7f);

	gl.glBegin(GL_LINE_STRIP);
	for(i= 0; i < nx; i++){
	    gl.glVertex3dv(resultPos[row][i].get3dv());
	}
	gl.glEnd();
	gl.glPopAttrib();

    }
 
    
    void displayFirstSurface(GLCanvas canvas,  byte command, int drawing_mode, Color3f color)
    {	
	if(Ttp.commentslevel >= 2){
	    System.out.println("DynamicPage.java: displayFirstSurface()" );
	}
	
	
	GLFunc gl = canvas.gl;
	
	int i, j;
	double nx_intervals= nx - 1.0;
	double nz_intervals= nz - 1.0;
	boolean ef= false, et= false;

	switch(command){
	case LINE:{ 
	    if(Ttp.commentslevel >= 3){
		System.out.println("line");
	    }
	    ef= false; et=false;
	    break;}
	case FILL:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("fill" );
	    }
	    ef= true; et=false;
	    break;}
	case TEXTURE:{ 
	    if(Ttp.commentslevel >= 3){
		System.out.println("texture" );
	    }
	    ef= true; et=true;
	    break;}
	}

	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	
	gl.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	gl.glEnable(GL_BLEND);
	    
	if(ef)
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	else
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);

	if(et){
	    //gl.glEnable(GL_TEXTURE_2D);
	    //gl.glBindTexture(GL_TEXTURE_2D, textureName_up);
	    gl.glActiveTextureARB(GL_TEXTURE0_ARB);
	    gl.glEnable(GL_TEXTURE_2D);
	    gl.glBindTexture(GL_TEXTURE_2D, texNameUp);
	    
	    gl.glActiveTextureARB(GL_TEXTURE1_ARB);
	    gl.glEnable(GL_TEXTURE_2D);
	    gl.glBindTexture(GL_TEXTURE_2D, pageMaterialUp);
	}
	else 
	    gl.glDisable(GL_TEXTURE_2D);


//  	gl.glColor3f(.0f, .0f, 1.0f);
//  	for (i = 0; i < nz - 1; i++) {
//  	    gl.glBegin(GL_QUAD_STRIP);
//              for (j = 0; j < nx; j++) {
//  		gl.glTexCoord2d( (j / nx_intervals), (i+1) / nz_intervals );
//  		gl.glVertex3dv(resultPos[i+1][j].get3dv());
//  		gl.glTexCoord2d( (j / nx_intervals), i / nz_intervals );
//  		gl.glVertex3dv(resultPos[i][j].get3dv());
//  	    }
//              gl.glEnd();
//  	}

	if(turningdirection == ANTI_CLOCKWISE){
	    gl.glFrontFace(GL_CW); //cuelling
	}
	
	if (drawing_mode == GL_SELECT) gl.glLoadName(page_num_up);

	
	for (i = 0; i < nz - 1; i++) {
	    if (drawing_mode == GL_SELECT) gl.glPushName(i);
	    gl.glBegin(GL_QUAD_STRIP);
            for (j = 0; j < nx; j++) {
		switch(config.imageformat){
		case PNG:
		    if(Ttp.commentslevel >= 3){
			System.out.println("PNG"); 
		    }
		    //png
		    if(turningdirection == ANTI_CLOCKWISE){
			//gl.glTexCoord2d( (j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
		    }else{
			//gl.glTexCoord2d( -(j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
		    }
		    
		    break;
		case JPEG:
		    if(Ttp.commentslevel >= 3){
			System.out.println("JPEG"); 
		    }
		    
		    //jpeg
		    if(turningdirection == ANTI_CLOCKWISE){
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, j /nx_intervals, (i+1) / nz_intervals);

		    }else{
			//need to change
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -j /nx_intervals, (i+1) / nz_intervals);

		    }

		    break;
		case TGA:{
		    if(Ttp.commentslevel >= 3){
			System.out.println("TGA"); 
		    }
		    
		    if(turningdirection == ANTI_CLOCKWISE){
			//gl.glTexCoord2d( (j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
			//gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
		    }else{
			//gl.glTexCoord2d( -(j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -(i+1) / nz_intervals );
			//gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, -(j / nx_intervals), -(i+1) / nz_intervals );
		    }
		    //not yet implemented
		    break;
		}
		}
		
		
		gl.glNormal3dv(normals[i+1][j].get3dv());
		gl.glVertex3dv(finalresultPos[i+1][j].get3dv());

		switch(config.imageformat){
		case PNG:
		    //png
		    if(Ttp.commentslevel >= 3){
			System.out.println("PNG"); 
		    }
		    
		    if(turningdirection == ANTI_CLOCKWISE){
			//gl.glTexCoord2d( (j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -i / nz_intervals);
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -i / nz_intervals);
		    }else{
			//gl.glTexCoord2d( -(j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -i / nz_intervals);
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -i / nz_intervals);
		    }
		    
		    break;
		case JPEG:
		    //jpeg
		    if(Ttp.commentslevel >= 3){
			System.out.println("JPEG"); 
		    }
		    
		    if(turningdirection == ANTI_CLOCKWISE){
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, j/nx_intervals, i / nz_intervals);
		    }else{
			//need to change
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -j/nx_intervals, i / nz_intervals);
		    }
		    
		    break;
		case TGA:{
		    if(Ttp.commentslevel >= 3){
			System.out.println("TGA"); 
		    }
		    
		    if(turningdirection == ANTI_CLOCKWISE){
			//gl.glTexCoord2d( (j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -i / nz_intervals);
			//gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -i / nz_intervals);
		    }else{
			//gl.glTexCoord2d( -(j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -i / nz_intervals);
			//gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, -(j / nx_intervals), -i / nz_intervals);
		    }
		    //not yet implemented
		    break;
		}
		}
		
		gl.glNormal3dv(normals[i][j].get3dv());
		gl.glVertex3dv(finalresultPos[i][j].get3dv());
		
	    }
            gl.glEnd();
	    if (drawing_mode == GL_SELECT)gl.glPopName ();
        }

	gl.glPopAttrib();
    }


    void displaySecondSurface(GLCanvas canvas,  byte command, int drawing_mode, Color3f color)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("DynamicPage.java: displaySecondSurface()" );
	}
	
	GLFunc gl = canvas.gl;
	
	int i, j;
	double nx_intervals= nx - 1.0;
	double nz_intervals= nz - 1.0;
	boolean ef= false, et= false;

	switch(command){
	case LINE:{ 
	    if(Ttp.commentslevel >= 3){
		System.out.println("line");
	    }
	    ef= false; et=false;
	    break;}
	case FILL:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("fill" );
	    }
	    
	    ef= true; et=false;
	    break;}
	case TEXTURE:{ 
	    if(Ttp.commentslevel >= 3){
		System.out.println("texture" );
	    }
	    
	    // correct mapping will be hard
	    ef= true; et=true;
	    break;}
	}

	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	
	gl.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	//gl.glBlendFunc(GL_ONE, GL_ZERO);
	gl.glEnable(GL_BLEND);


	if(ef)
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	else
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);

	if(et){
	    //gl.glEnable(GL_TEXTURE_2D);
	    //gl.glBindTexture(GL_TEXTURE_2D, textureName_down);
	    gl.glActiveTextureARB(GL_TEXTURE0_ARB);
	    gl.glEnable(GL_TEXTURE_2D);
	    gl.glBindTexture(GL_TEXTURE_2D, texNameDown);
	    
	    gl.glActiveTextureARB(GL_TEXTURE1_ARB);
	    gl.glEnable(GL_TEXTURE_2D);
	    gl.glBindTexture(GL_TEXTURE_2D, pageMaterialDown);
	}
	else 
	    gl.glDisable(GL_TEXTURE_2D);


	//gl.glColor3f(color.x, color.y, color.z);
	
	if(turningdirection == ANTI_CLOCKWISE){
	    gl.glFrontFace(GL_CW); 
	}

	if (drawing_mode == GL_SELECT) gl.glLoadName(page_num_down);

	for (i = 0; i < nz - 1; i++) {
	    if (drawing_mode == GL_SELECT) gl.glPushName(nz-1-i);
	    
	    gl.glBegin(GL_QUAD_STRIP);
            for (j = 0; j < nx; j++) {

		switch(config.imageformat){
		case PNG:
		    if(Ttp.commentslevel >= 3){
			System.out.println("PNG"); 
		    }
		    //png
		    if(turningdirection == CLOCKWISE){
			//gl.glTexCoord2d( (j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
		    }else{
			//anti-clockwise
			//gl.glTexCoord2d( -(j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
		    }
		    break;

		case JPEG:
		    if(Ttp.commentslevel >= 3){
			System.out.println("JPEG"); 
		    }
		    
		    //jpeg
		    if(turningdirection == CLOCKWISE){
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, j /nx_intervals, (i+1) / nz_intervals);

		    }else{
			//need to change
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -j /nx_intervals, (i+1) / nz_intervals);

		    }

		    break;
		case TGA:{
		    if(Ttp.commentslevel >= 3){
			System.out.println("TGA"); 
		    }

		    if(turningdirection == CLOCKWISE){
			//gl.glTexCoord2d( (j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
			//gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
		    }else{
			//gl.glTexCoord2d( -(j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -(i+1) / nz_intervals );
			//gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, -(j / nx_intervals), -(i+1) / nz_intervals );
		    }
		    break;
		}
		}

		
		gl.glNormal3dv(normals[i+1][j].get3dv());
		gl.glVertex3dv(finalresultPos2[i+1][j].get3dv());

		switch(config.imageformat){
		case PNG:
		    //png
		    if(Ttp.commentslevel >= 3){
			System.out.println("PNG"); 
		    }
		    
		    if(turningdirection == CLOCKWISE){
			//gl.glTexCoord2d( (j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -i / nz_intervals);
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -i / nz_intervals);
		    }else{
			//gl.glTexCoord2d( -(j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -i / nz_intervals);
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -i / nz_intervals);
		    }
		    break;

		case JPEG:
		    //jpeg
		    if(Ttp.commentslevel >= 3){
			System.out.println("JPEG"); 
		    }
		    
		    if(turningdirection == CLOCKWISE){
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, j/nx_intervals, i / nz_intervals);
		    }else{
			//need to change
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -j/nx_intervals, i / nz_intervals);
		    }
		    
		    break;
		case TGA:{
		    if(Ttp.commentslevel >= 3){
			System.out.println("TGA"); 
		    }
		    if(turningdirection == CLOCKWISE){
			//gl.glTexCoord2d( (j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -i / nz_intervals);
			//gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -i / nz_intervals);
		    }else{
			//gl.glTexCoord2d( -(j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -i / nz_intervals);
			//gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, -(j / nx_intervals), -i / nz_intervals);
		    }
		    //not yet implemented
		    break;
		}
		}
		
		gl.glNormal3dv(normals[i][j].get3dv());
		gl.glVertex3dv(finalresultPos2[i][j].get3dv());
	    }
            gl.glEnd();
	    if (drawing_mode == GL_SELECT)gl.glPopName ();
        }

	gl.glPopAttrib();

	
    }

    
    public void drawBorder(GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("DynamicPage.java: drawBorder()");
	}

	GLFunc gl = canvas.gl;
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glLineWidth(1.5f);
	//gl.glEnable(GL_TEXTURE_1D);
	//gl.glBindTexture(GL_TEXTURE_1D, border);
	gl.glColor3f(0.0f, 0.0f, 0.0f);
	gl.glBegin (GL_LINE_STRIP);
	for(int i= 0; i < nx; i++){
	    gl.glVertex3dv(upborder[i].get3dv());
	}
	
	gl.glEnd();
	
	gl.glBegin (GL_LINE_STRIP);
	for(int i= 0; i < nx; i++){
	    gl.glVertex3dv(downborder[i].get3dv());
	}
	gl.glEnd();

	gl.glBegin (GL_LINE_STRIP);
	for(int i= 0; i < nz; i++){
	    gl.glVertex3dv(leftborder[i].get3dv());
	}
	gl.glEnd();
	
	gl.glBegin (GL_LINE_STRIP);
	for(int i= 0; i < nz; i++){
	    gl.glVertex3dv(rightborder[i].get3dv());
	}
	gl.glEnd();

	gl.glPopAttrib();
    }
 
    public void display(GLCanvas canvas, int drawing_mode)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("DynamicPage.java: display()");
	}
	
	GLFunc gl = canvas.gl;
	interpolation();
	
	gl.glPushMatrix();
	gl.glTranslated(start.x, start.y, start.z);
	//displaypts(0);
	gl.glPushAttrib(canvas.GL_ALL_ATTRIB_BITS); 
	gl.glMaterialfv(canvas.GL_FRONT_AND_BACK, canvas.GL_AMBIENT_AND_DIFFUSE, config.getPageColor());
        gl.glMaterialfv(canvas.GL_FRONT_AND_BACK, canvas.GL_SPECULAR, config.getPageSpecularColor());
        gl.glMaterialf(canvas.GL_FRONT_AND_BACK, canvas.GL_SHININESS, config.getPageShiness());
	
	
	displayFirstSurface(canvas, TEXTURE , drawing_mode, new Color3f(.0f, 1.0f, 1.0f));
	displaySecondSurface(canvas, TEXTURE, drawing_mode, new Color3f(.3f, .0f, .3f));
	
	
	gl.glPopAttrib();

	float [] black= {0.0f, 0.0f, 0.0f, 1.0f};
	gl.glPushAttrib(canvas.GL_ALL_ATTRIB_BITS); 
	gl.glMaterialfv(canvas.GL_FRONT_AND_BACK, canvas.GL_AMBIENT_AND_DIFFUSE, black);
	drawBorder(canvas);
	gl.glPopAttrib();

	gl.glPopMatrix();
    }
}

