package TTPproject;

import java.lang.Integer;// parse integer
import java.util.*;
import java.io.*;

/*itext*/
import com.lowagie.text.*;
import com.lowagie.text.pdf.*;


/*JMagick*/
import magick.MagickImage;
import magick.ImageInfo;
import magick.MagickException;
import magick.MagickApiException;
import magick.CompressionType;
import magick.InterlaceType;
import magick.PixelPacket;

/*gl4java*/
import gl4java.utils.textures.*;
import gl4java.awt.GLCanvas;
import gl4java.GLFunc;
import gl4java.GLUFunc;

class HtmlConverter
    implements CONSTANTS, CompressionType, InterlaceType
{
    
    byte		buffer [];	// Buffer for 
    byte		buffer2 [];	// Buffer for 
    byte		pdfbuffer [];	// Buffer for 

    
    Vector              imageBuffer;

    PdfReader           reader;

    

    Rectangle           psize;// page Size
    Document            document;
    //int imageWidth_high, imageHeight_high;
    
    float imageWidth2, imageHeight2;
    
    public int                 totalNumberPages= 0; 
    
    
    //testing reading pdf file
    PdfReader           reader2;
    Rectangle           psize2;// page Size
    
    
    //linux
    String pdfprefix= null;
    String pageprefix= null;
    String source= "/research/ycc1/packages/htmldoc-1.8.23/doc/";
    String dest= "/research/ycc1/TurningThePages/data/content/";
    
    //windows
    //String source= "C:\\progra~1\\HTMLDOC\\doc\\";
    //String dest= "C:\\TurningThePages\\data\\";
    String [] fname= { "intro.html",
		       "1-install.html",
		       "2-starting.html",
		       "3-books.html",
  		       "4-cmdline.html",
  		       "5-cgi.html",
  		       "6-htmlref.html",
  		       "7-guiref.html",
  		       "8-cmdref.html",
  		       "a-license.html",
  		       "b-book.html",
  		       "c-relnotes.html" };

    int imageformat= PNG;
    Configuration config= null;

    public HtmlConverter(Configuration config, 
			 int imageformat, 
			 String pdfprefix,
			 String pageprefix )
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("HtmlConverter.java: ");
	}
	
	this.imageformat= imageformat;
	this.config= config;
	this.pdfprefix= pdfprefix;
	this.pageprefix= pageprefix;
	this.totalNumberPages= config.get_pdf_total_pages();
    }

    

    String             sourcefile;
    
    // Convert HTMLDoc to PDF on stdout...
    public int topdf(String name )// I - Name of file to convert
    {
	this.sourcefile= name;
	String		command;	// Command string
	Process		process;	// Process for HTMLDOC
	Runtime		runtime;	// Local runtime object
	java.io.InputStream	input;		// Output from HTMLDOC
	
	int			bytes= 0;		// Number of bytes
	int                     total_bytes= 0;
	
	String filename; 	
	

	// First tell the client that we will be sending PDF...
	if(Ttp.commentslevel >= 3){
	    System.out.print("Content-type: application/pdf\n\n");
	}
	
	// Construct the command string
	//command = "htmldoc --quiet --jpeg -t pdf --left 36 " +
	//  "--header .t. --footer .1. --book";


	command= "htmldoc -t pdf --toclevels 2 --no-numbered --toctitle \"Table of Contents\"--title --titleimage " + source + "htmldoc.bmp --linkstyle plain --linkcolor #aa090e --size Universal --left 1.00in --right 0.50in --top 0.50in --bottom 0.50in --header .t. --footer h.1 --tocheader .t. --tocfooter ..i --duplex --portrait --color --no-pscommands --no-xrxcomments --compression=9 --jpeg=75 --fontsize 14.0 --fontspacing 1.2 --headingfont Helvetica --bodyfont Times --headfootsize 11.0 --headfootfont Helvetica-Oblique --charset 8859-1 --links --no-embedfonts --pagemode outline --pagelayout single --firstpage c1 --pageeffect none --pageduration 10 --effectduration 1.0 --no-encryption --permissions all  --owner-password \"\"  --user-password \"\" --browserwidth 680 --book";
	
	for(int i= 0; i < fname.length; i++){
	    filename= " " + source + fname[i];
	    command = command + filename ;
	}

	if(Ttp.commentslevel >= 3){
	    System.out.println("Command are> " + command);
	}
	

	//Run the process and wait for it to complete...
	runtime = Runtime.getRuntime();
	
	try{
	    // Create a new HTMLDOC process...
	    process = runtime.exec(command);
	    
	    // Get stdout from the process and a buffer for the data...
	    input  = process.getInputStream();
	    buffer = new byte[8196];
	    ByteArrayOutputStream pdfstreambuffer= new ByteArrayOutputStream();
	    

	    // Read output from HTMLDOC until we have it all...
	    if(Ttp.commentslevel >= 3){
		System.out.println("Start writing");
	    }
	    
	    int i=0, j=0, end=0;
	    while ((bytes = input.read(buffer)) > 0){
		if(Ttp.commentslevel >= 3){
		    System.out.println( "Number of bytes read: "+ bytes );
		}
		pdfstreambuffer.write(buffer, 0, bytes);
		total_bytes += bytes;
	    }

	    	  
	    if(Ttp.commentslevel >= 3){
		System.out.println( "Total No. of bytes: "+ total_bytes );
	    }
	    pdfbuffer= pdfstreambuffer.toByteArray();
	    

	    reader = new PdfReader(pdfbuffer);
	    totalNumberPages= reader.getNumberOfPages();
	    if(Ttp.commentslevel >= 3){
		System.out.println("There are " + totalNumberPages + " pages in the pdf.");
	    }
	    
	    psize = reader.getPageSize(1);
	    //imageWidth2 = psize.width();
            //imageHeight2 = psize.height();
	    
	    
	    
	    document= new Document(psize, 50, 50, 50, 50); // move
	    
	    return (process.waitFor());
	}
	catch (Exception e){
	    // An error occurred - send it to stderr for the web server...
	    if(Ttp.commentslevel >= 3){
		System.out.println(e.toString() + " caught while running:\n\n");
		System.out.println("Command> " + command);
		System.out.println("Total Number of bytes> " + total_bytes );
	    }
	    return (1);
	}
    }
    
    

    
    /*
      read pdf directly 
     */
    public int readFromfile(String [] fnames)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("HtmlConverter.java: readFromfile()");
	}
	
	try{
	    long starttime= 0;
	    int numberfiles= fnames.length;
	    String [] args; 
	    String destfile;

	    if(Ttp.commentslevel >= 3){
		System.out.println("HtmlConverter.java: readFromfile() args: ");
	    }
	    
	    if(numberfiles > 1){ // more than one pdf file
		args= new String[numberfiles + 1]; // inputfile1 destfile
		int i; 
		for(i=0; i<numberfiles; i++){
		    args[i]= pdfprefix + fnames[i];
		    if(Ttp.commentslevel == 1){
			if(Ttp.commentslevel >= 3){
			    System.out.println("args> " + args[i]);
			}
		    }
		}
		
		args[i]= pdfprefix + "result.pdf";
		if(Ttp.commentslevel >= 3){
		    System.out.println("args> " + args[i]);
		}

		destfile= args[i];
				
		if(Ttp.commentslevel >= 3){
		    System.out.println("Start concatenating process");
		}
		
		starttime = System.currentTimeMillis();
		ConcatePdf concatenator= new ConcatePdf(args);
		
		if(Ttp.commentslevel >= 3){
		    System.out.println("Concatenating pdfs take >  " +
				       (System.currentTimeMillis() - starttime) + " milli scs to complete." );
		}

	    }else{
		//one pdf file
		destfile= pdfprefix + fnames[0];
	    }
	    
	    if(Ttp.commentslevel >= 3){
		System.out.println("Start reading " + destfile);
	    }
	    
	    starttime = System.currentTimeMillis();
	    reader = new PdfReader(destfile);
	    
	    if(Ttp.commentslevel >= 3){
		System.out.println("Reading pdf takes >  " +
				   (System.currentTimeMillis() - starttime) + " milli scs to complete." );
	    }

	    totalNumberPages= reader.getNumberOfPages();
	    if(Ttp.commentslevel >= 3){
		System.out.println("There are " + totalNumberPages + " pages in the pdf.");
	    }

	    psize = reader.getPageSize(2);// The first page is 1
	    
	    imageWidth2 = psize.width();
            imageHeight2 = psize.height();
	    
	    if(Ttp.commentslevel >= 3){
		System.out.println("page size> " + imageWidth2 + "x" + imageHeight2);
	    }
	    
	    //document= new Document(psize, 50, 50, 50, 50); //pagesize & page margin
	    document= new Document(psize, 0, 0, 0, 0); //pagesize & page margin

	    return 0;
	}catch (IOException e){
	    if(Ttp.commentslevel >= 3){
		System.out.println("****HtmlConverter.java: readFromfile() Unable to read from : " + fname[0]);
	    }
	    return 1;
	}
    }


    


    /*
      deprecated
    */
    public void genImages()
    {
	int i= 1;
	int totalbytes= 0;
	int size= 0;

	ByteArrayOutputStream  out= null;
	PdfWriter           writer= null;
	PdfImportedPage       page= null;
	PdfContentByte          cb= null;
	long                   starttime= 0;
	
	ImageInfo             info= null;
	MagickImage          image= null; 

	imageBuffer= new Vector(totalNumberPages);
	starttime = System.currentTimeMillis();

	while(i<= totalNumberPages){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Generate " +i+ " page>" );
	    }
	    try{
		out = new ByteArrayOutputStream();
		writer = PdfWriter.getInstance(document , out);
		document.open(); //open
		cb = writer.getDirectContent();
		document.newPage();
		page= writer.getImportedPage(reader, i);
		cb.addTemplate(page, 1.f, 0, 0, 1.f, 0, 0);
		document.close();
		if(Ttp.commentslevel >= 3){
		    System.out.println("Close document");
		}
		writer.close();
		if(Ttp.commentslevel >= 3){
		    System.out.println("Close writer");
		}

		try{
		    info = new ImageInfo();
		    image = new MagickImage(info, out.toByteArray()).scaleImage(config.imageWidth_highresol,
										config.imageHeight_highresol);

		    if( imageformat == PNG){
			image.setMagick("PNG");
			if(Ttp.commentslevel >= 3){
			    System.out.println("Set PNG");
			}
			
		    }else if( imageformat == JPEG){
			image.setMagick("JPEG");
			if(Ttp.commentslevel >= 3){
			    System.out.println("Set JPEG");
			}
			
		    }else if( imageformat == TGA){
			image.setMagick("TGA");
			if(Ttp.commentslevel >= 3){
			    System.out.println("Set TGA");
			}
			
		    }else{
			//report error
		    }
		    		    

		    imageBuffer.add(i-1, image.imageToBlob(info)); 
		    size= ((byte []) imageBuffer.get(i-1)).length;

		    if(Ttp.commentslevel >= 3){
			System.out.println("the size= " + size );
		    }
		    
		    totalbytes += size;
		    
		}catch(MagickApiException ex){
		    if(Ttp.commentslevel >= 3){
			System.out.println("****HtmlConverter.java genImages() MagickException: " + ex + ": " +
					   ex.getReason() + ", " + ex.getDescription());
		    }
		}

	    }catch (Exception e){
		// An error occurred - send it to stderr for the web server...
		if(Ttp.commentslevel >= 3){
		    System.out.print("****HtmlConverter.java genImages()" + e.toString() + " caught while running:\n\n");
		}
		
	    }

	    i++;
	}
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("Total time >  " +
			       (System.currentTimeMillis() - starttime) + " milli secs ." );
	    System.out.println("Total Size: " + totalbytes + " bytes.\n" );
	}
	
    }



    
    
    


//      public int toPNG(int begin, int end)
//      {
//  	int i;

//  	try{
	    
	    
	    
//              // we retrieve the size of the first page
//              Rectangle psize = reader.getPageSize(1);
//              float width = psize.width();
//              float height = psize.height();
	    
//  	    Map documentTable= new HashMap();
//  	    if(end > totalNumberPages) 
//  		end= totalNumberPages;
	    
//  	    for(i=begin; i <= end; i++){
//  		documentTable.put( new Integer(i) , 
//  				   new Document(psize, 50, 50, 50, 50) );
//  	    }

//  	    PdfWriter writer=null;
//  	    String imagefilename= null;
//  	    PdfContentByte cb = null;
//  	    PdfImportedPage page= null; 
//  	    ImageInfo info = null; 
//  	    MagickImage image = null;
//  	    Document document= null;// a pointer to the returned document object from the table
//  	    ByteArrayOutputStream out= null;
//  	    i=begin;
	    
//  	    while(i <= end){
		
		
//  		document= (Document) documentTable.get(new Integer(i));//fetch a document 
		
//  		// step 2: we create a writer that listens to the document
//  		out = new ByteArrayOutputStream();
		
//  		writer = PdfWriter.getInstance(document , out);
//  		//System.out.println(outFileName);
		
//  		// step 3: open the document
//  		document.open();
		
//  		// step 4: we add content
//  		cb = writer.getDirectContent();
//  		//create a new empty page
//  		document.newPage();

//  		//perform copying and splitting
//  		page= writer.getImportedPage(reader, i); // i starts from 1, page 1
//  		cb.addTemplate(page, 1.f, 0, 0, 1.f, 0, 0);
		
//  		//close document, writer objects
//  		document.close();
//  		System.out.println("Close document");
//  		writer.close();
//  		System.out.println("Close writer");

		
//  		//convert to png 
//  		try{
//  		    info = new ImageInfo();
//  		    image = new MagickImage(info, out.toByteArray());
//  		    image.setMagick("PNG");
//  		    System.out.println("Set PNG");
//  		    byte [] blob = image.imageToBlob(info);
		    
//  		    //writing into the file
//  		    try {
//  			imagefilename= 
//  			    new StringBuffer()
//  				.append(dest)
//  				.append( Utilities.imageNumber(sourcefile, i,  "png") )
//  				.toString();
			
			
//  			FileOutputStream fout = new FileOutputStream(imagefilename);
//  			fout.write(blob);
//  			fout.close();
//  		    }
//  		    catch(IOException ex) {
//  			System.out.println("Unable to write blob to file: " + ex);
//  		    }
		    
//  		} catch(MagickApiException ex) {
//  		    System.out.println("MagickException: " + ex + ": " +
//  				       ex.getReason() + ", " + ex.getDescription());
//  		}
//  		catch(MagickException ex) {
//  		    System.out.println("MagickException: " + ex);
//  		}

		
		
//  		System.out.println();
//  		i++;
//  	    }

	    
//  	    return 0;

//  	}
//  	catch (Exception e){
//  	    // An error occurred - send it to stderr for the web server...
//  	    System.err.print(e.toString() + " caught while running:\n\n");
//  	    return (1);
//  	}
//      }

    /*
      Read from the pdfreader
     
    */
    public synchronized byte [] getPageBytes(int pdf_page_number, 
					     int imageWidth, int imageHeight)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("HtmlConverter.java: getPageBytes()");
	}
	
	if(pdf_page_number > totalNumberPages || pdf_page_number < 1 ){
	    if(Ttp.commentslevel >= 3){
		System.out.println("****HtmlConverter.java: getPageBytes() Out of range");
	    }
	    return null;
	}
	
	try{
	    ByteArrayOutputStream  out = new ByteArrayOutputStream();
	    PdfWriter           writer = PdfWriter.getInstance(document , out);
	    PdfImportedPage page= null;
	    document.open(); //open
	    PdfContentByte cb = writer.getDirectContent();
	    document.newPage();
	    
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tpdf_page_number: " + pdf_page_number);
	    }
	    
	    page= writer.getImportedPage(reader, pdf_page_number); // i starts from page 1
	    cb.addTemplate(page, 1.f, 0, 0, 1.f, 0, 0);
	    document.close();// any exceptions during previously writing document 
	                     // will cause subsequent failure to write
	    if(Ttp.commentslevel >= 3){
		System.out.println("Close document");
	    }
	    writer.close();
	    if(Ttp.commentslevel >= 3){
		System.out.println("Close writer");
	    }

	    //convert to png 
	    try{
		ImageInfo info = new ImageInfo();
		byte [] pdf= out.toByteArray();
		int size= pdf.length;
		
		info.setSize(java.lang.Integer.toString(size));

		//Quality
		info.setQuality(75); //default
		if(Ttp.commentslevel >= 3){
		    System.out.println("Quality> " + info.getQuality() );
		}

		//Density
		//info.setDensity("20x20");
		if(Ttp.commentslevel >= 3){
		    System.out.println("Density> " + info.getDensity() );
		}
		
		info.setInterlace(LineInterlace);

		if(Ttp.commentslevel >= 3){
		    System.out.print("Interlace type> ");
		
		    switch(info.getInterlace()){
		    case LineInterlace:
			
			System.out.println("LineInterlace");
			break;
		    case NoInterlace:
			System.out.println("NoInterlace");
			break;
		    case PartitionInterlace: 
			System.out.println("PartitionInterlace");
			break;
		    case PlaneInterlace:
			System.out.println("PlaneInterlace");
			break;
		    case UndefinedInterlace:
			System.out.println("UndefinedInterlace");
			break;
		    default: 
			System.out.println("Unknown interlace type");
		    }
		}
		//int imageWidth, imageHeight;
		//if(resol == HIGH){
		//System.out.println("High resolution");
		//imageWidth= config.imageWidth_highresol;
		//imageHeight= config.imageHeight_highresol;
		//}else{
		//System.out.println("Low resolution");
		//imageWidth= config.imageWidth_lowresol;
		//imageHeight= config.imageHeight_lowresol;
		//}
		//System.out.println("Set PNG");
		
		if(Ttp.commentslevel >= 3){
		    System.out.println("imageWidth> " + imageWidth);
		    System.out.println("imageHeight> " + imageHeight);
		}
		MagickImage image = new MagickImage(info, pdf).scaleImage(imageWidth,imageHeight);
				
		if( imageformat == PNG){
		    image.setMagick("PNG");
		    if(Ttp.commentslevel >= 3){
			System.out.println("Set PNG");
		    }
		}else if( imageformat == JPEG){
		    image.setCompression(JPEGCompression );
		    image.setMagick("JPEG");
		    if(Ttp.commentslevel >= 3){
			System.out.println("Set JPEG");
		    }
		}else if( imageformat == TGA){
		    image.setMagick("TGA");
		    if(Ttp.commentslevel >= 3){
			System.out.println("Set TGA");
		    }
		}else{
		    //report error
		}
		
		if(Ttp.commentslevel >= 3){
		    System.out.println("Compression : " + image.getCompression() ) ;// get compression type
		}
		
		byte [] blob = image.imageToBlob(info);
		if(Ttp.commentslevel >= 3){
		    System.out.println("the size of blob: " + blob.length ) ;
		}

		/*PipedOutputStream pipeout= new PipedOutputStream();
		PipedInputStream pipein= new PipedInputStream(pipeout);
		DataOutputStream pout= new DataOutputStream(pipeout);
		
		new OutputThread(pout, blob).start();
		return new BufferedInputStream(pipein);*/

		/*
		  //save images
		  String digits= "000000" + pdf_page_number;
		digits= digits.substring(digits.length()-4, digits.length());
		String texturepath= "/research/ycc1/TurningThePages/data/Agricul" + digits + ".tga";
		FileOutputStream fileout= new FileOutputStream(texturepath);
		fileout.write(blob);
		fileout.close();*/

		return blob;
	    }catch(MagickApiException ex) {
		if(Ttp.commentslevel >= 3){
		    System.out.println("****HtmlConverter.java: getPageBytes() MagickException: " + ex + ": " +
				       ex.getReason() + ", " + ex.getDescription());
		}
		return null;
	    }
	    catch(MagickException ex) {
		if(Ttp.commentslevel >= 3){
		    System.out.println("****HtmlConverter.java: getPageBytes() MagickException: " + ex);
		}
		return null;
	    }
	    
	}catch (Exception e){
	    // An error occurred - send it to stderr for the web server...
	    if(Ttp.commentslevel >= 3){
		System.out.print("****HtmlConverter.java: getPageBytes()" + e.toString() + " caught while running:\n\n");
	    }
	    return null;
	}
    
    }

    /*
      Directly read from the precompile images 
     */
    public synchronized byte [] getPageBytesfromFile(int page_num)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("HtmlConverter.java: getPageBytesfromFile()");
	}
	String digits= "000000" + page_num;
	//String ebookfilename= config.param.getEbookfilename();
	String ebookfilename= Ttp.ebook_file_name;
	String suffix= ".png";
	String imagepath;
	
	
	digits= digits.substring(digits.length()-4, digits.length());// max digits 
	imagepath= pageprefix + ebookfilename + digits + suffix;
	if(Ttp.commentslevel >= 2){
	    System.out.println("HtmlConverter.java: getPageBytesfromFile() imagepath= " + imagepath);
	}

	try{
	    ImageInfo info = new ImageInfo(imagepath);
	    MagickImage image = new MagickImage(info);
	    byte [] blob = image.imageToBlob(info);

	    if(Ttp.commentslevel >= 3){
		System.out.println("the size of blob: " + blob.length ) ;
	    }
	    return blob;
	} catch(MagickException ex) {
	    if(Ttp.commentslevel >= 3){
		System.out.println("****HtmlConverter.java: getPageBytesfromFile() MagickException: " + ex);
	    }
	    return null;
	}

    }


    
    public synchronized InputStream getImagesFromPdf(int pdf_page_number, 
					int imageWidth, int imageHeight)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("HtmlConverter.java: getImagesFromPdf()");
	}
	
	byte [] imageBuffer= getPageBytes(pdf_page_number,
					  imageWidth, imageHeight);
	return new ByteArrayInputStream(imageBuffer, 
					0,
					imageBuffer.length);

    }


    /*
      Invoke by 'readPageTextureFromImageBuffer(int page_num)'
     */
    public InputStream getImageFromImageBuffer(int pdf_page_number)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("getImageFromImageBuffer()");
	}
	
	if(pdf_page_number > totalNumberPages || pdf_page_number < 1 ){
	    if(Ttp.commentslevel >= 3){
		System.out.println("****HtmlConverter.java: getImageFromImageBuffer() Out of range");
	    }
	    return null;
	}
	
	
	byte [] blob= (byte []) imageBuffer.get(pdf_page_number-1);
	
	try{
	    /*PipedOutputStream pipeout= new PipedOutputStream();
	    PipedInputStream pipein= new PipedInputStream(pipeout);
	    DataOutputStream pout= new DataOutputStream(pipeout);
	    
	    new OutputThread(pout, blob).start();
	    
	    return new BufferedInputStream(pipein);*/

	    return new ByteArrayInputStream(blob, 0, blob.length);
	}catch(Exception e){
	    if(Ttp.commentslevel >= 3){
		System.out.print("****HtmlConverter.java: getImageFromImageBuffer()" + e.toString() + " caught while running:\n\n");
	    }
	    return null;
	}
	
    }

    
}
