package TTPproject;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.List;
import java.util.ArrayList;// anchorPageList

import java.util.Iterator;//traverse through anchorPageList

public class InitializationThread
    extends Thread{
    
    protected Configuration config= null; 
    protected Ttp callback= null;
    protected Scene scene= null;
    protected CursorManager cursorManager= null;
    protected TexturePools texturePools= null; 
    protected List anchorListLeft= null; 
    protected List anchorListRight= null; 
    

    public InitializationThread(Ttp callee,
				Scene scene,
				Configuration config, 
				CursorManager cursorManager,
				TexturePools texturePools,
				List anchorListLeft,
				List anchorListRight)
    {
	this.callback= callee;
	this.scene= scene;
	this.config= config;
	this.cursorManager= cursorManager;
	this.texturePools= texturePools;
	this.anchorListLeft= anchorListLeft ;
	this.anchorListRight= anchorListRight ;
    }

    public void run()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("InitializationThread.java run()");
	}

	if(Ttp.commentslevel >= 1){
	    System.out.println("---------------------------");
	    System.out.println("Reading Configuration file");
	    System.out.println("---------------------------");
	}
	config.doInitialized();	

	if(Ttp.commentslevel >= 1){
	    System.out.println("---------------------------");
	    System.out.println("Initialized cursorManager");
	    System.out.println("---------------------------");
	}
	cursorManager.doInitialized();
	

	if(Ttp.commentslevel >= 1){
	    System.out.println("---------------------------");
	    System.out.println("Initialized TexturePools");
	    System.out.println("---------------------------");
	}
	texturePools.doInitialized(config);
	
	displayAnchorPageList(anchorListLeft);
	displayAnchorPageList(anchorListRight);
	
	scene.setFields(config,
			cursorManager,
			texturePools,
			anchorListLeft,
			anchorListRight
			);
	

	if(Ttp.commentslevel >= 1){
	    System.out.println("---------------------------");
	    System.out.println("Constructing book model, Reading Fixed Textures, and setting up lighting etc.");
	    System.out.println("---------------------------");
	}
	scene.postInit();
	scene.bc.initialize_staticPages();//setup anchors, page material etc

	

	callback.actionPerformed(new ActionEvent(this, 0, "INITIALIZATION_FINISHED"));
    }
    
    
    /*
      it is only displayed once
     */
    protected void displayAnchorPageList(List pageList)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("InitializationThread.java: displayAnchorPageList()");
	}
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("InitializationThread.java: display anchor page list: ");
	    synchronized(pageList) {
		Iterator i = pageList.iterator(); // Must be in synchronized block
		while (i.hasNext()){
		    System.out.print( ((Integer)(i.next())).intValue() + " ");
		}
	    }
	    
	    System.out.println();
	}
    }



}
