package TTPproject;

import javax.vecmath.*;

import gl4java.awt.GLCanvas;
import gl4java.GLFunc;
import gl4java.GLUFunc;
import gl4java.GLEnum;

/**
 * 
 * @author Jack(Yi-Chun), Chu
 * @version 0.0, June 2002
 */


public class Pages
    implements GLEnum, CONSTANTS
{
    private Configuration config;
    
    
    //two ends
    private Vector3d [] jvLeftCurveUP= null; 
    private Vector3d [] jvRightCurveUP= null;
    private Vector3d [] jvLeftCurveDOWN= null; 
    private Vector3d [] jvRightCurveDOWN= null;
    
    private Vector3d [] jackVectorUP= null;
    private Vector3d [] jackVectorDOWN= null;
    
    //cylinder model
    private Vector3d [] cylinderVectorAC= null;
    private Vector3d [] cylinderVectorC= null;
    private Vector3d [] resultcylinderVector= null;
    
    
    private Point3d [] resultCylinderCurve= null; //temporary
    private Point3d [] resultCurveUP2= null;
    private Point3d [] resultCurveDOWN2= null;
    

    private Point3d [] resultCurveUP= null;
    private Point3d [][] resultSurfaceUP= null;
    private Point3d [] resultCurveDOWN= null;
    private Point3d [][] resultSurfaceDOWN= null;
    
    private Point3d startUP= null;
    private Point3d startDOWN= null;

    private double elementlength= 0;
    private int nx= 0, nz= 0;
    
    private byte turningdirection;
    private double rotAngle= 0;
    private double pivot_angle= 0;

    public Pages(Configuration config)
    {
	int i;
	this.config= config;
	
	nx= config.get_nx();
	nz= config.get_nz();
	elementlength= config.get_elementLength();
	
	jvLeftCurveUP= new Vector3d [nx];
	jvRightCurveUP= new Vector3d [nx];
	jvLeftCurveDOWN= new Vector3d [nx];
	jvRightCurveDOWN= new Vector3d [nx];
	jackVectorUP= new Vector3d [nx];
	jackVectorDOWN= new Vector3d [nx];
	resultCurveUP= new Point3d[nx];
	resultCurveUP2= new Point3d[nx];
	resultCurveDOWN= new Point3d[nx];
	resultCurveDOWN2= new Point3d[nx];

	//cylinder model
	cylinderVectorAC= new Vector3d [nx];
	cylinderVectorC= new Vector3d [nx];
	resultcylinderVector= new Vector3d [nx];
	
	resultCylinderCurve= new Point3d [nx];
	
	resultSurfaceUP= new Point3d[nz][nx];
	resultSurfaceDOWN= new Point3d[nz][nx];
	
	for(i= 0; i<nx; i++){
	    jvLeftCurveUP[i]= new Vector3d(0,0,0);
	    jvRightCurveUP[i]= new Vector3d (0,0,0);
	    jvLeftCurveDOWN[i]= new Vector3d (0,0,0);
	    jvRightCurveDOWN[i]= new Vector3d (0,0,0);
	    jackVectorUP[i]= new Vector3d (0,0,0);
	    jackVectorDOWN[i]= new Vector3d (0,0,0);
	    resultCurveUP[i]= new Point3d (0,0,0);
	    resultCurveDOWN[i]= new Point3d (0,0,0);

	    //cylinder model
	    cylinderVectorAC[i]= new Vector3d(0,0,0);
	    cylinderVectorC[i]= new Vector3d(0,0,0);
	    resultcylinderVector[i]= new Vector3d(0,0,0);
	    
	
	    resultCylinderCurve[i]= new Point3d(0,0,0);
	    resultCurveUP2[i]= new Point3d(0,0,0);
	    resultCurveDOWN2[i]= new Point3d(0,0,0);
	}

	for(int r= 0; r< nz; r++ ){
	    for(int c= 0; c< nx; c++ ){
		resultSurfaceUP[r][c]= new Point3d(0,0,0);
		resultSurfaceDOWN[r][c]= new Point3d(0,0,0);
	    }
	}

	initCylinderVectors();
	
    }


    public void initCylinderVectors()
    {
	Point3d [] points= new Point3d[nx];
	int i;
	double n; // n points across
	double radius, arc_len;
	double phi, phi_delta;
	double x, y;
	double ninity_degree= Math.PI/2.0; 
	double unit_length= config.get_elementLength();

	

	arc_len= unit_length*(double)(nx-1);
	radius= arc_len/2;

	x= 0.0f; y= 0.0f;
	n= nx-1;

	phi= 0.0f;
	phi_delta= arc_len/(radius*n);
	
	//generate nx points
	for(i=0; i < nx; i++){
	    if(phi <= ninity_degree){
		//first quadrant
		if(Ttp.commentslevel >= 3){
		    System.out.println("first quadrant"); 
		}
		x= radius * Math.sin(phi);
		y= radius - radius * Math.cos(phi);
	    }else{
		//second quadrant
		if(Ttp.commentslevel >= 3){
		    System.out.println("Second quadrant"); 
		}

		x= radius * Math.cos(phi-ninity_degree);
		y= radius + radius * Math.sin(phi-ninity_degree);
	    }
	    phi += phi_delta;
	    points[i]= new Point3d(x,y,0);
	}

	//given i th point, work out the angle
	Vector2d xaxis= new Vector2d(1,0);
	Vector2d baseline= new Vector2d(points[nx-1].x-points[0].x, 
					points[nx-1].y-points[0].y);
	double radian= baseline.angle(xaxis);
	if(Ttp.commentslevel >= 3){
	    System.out.println("Angle> " + Utilities.rad2degree(radian)); 
	}

	//applied transformation
	Matrix4d rot=
	    Matrix4d.rotAroundZ(-radian);

	for(i= 0; i< nx; i++){
	    rot.transform(points[i]);
	}

	double disx, disy;
	double width;
	Point3d []refpts= new Point3d[nx];
	//generate vectors
	for(i= 0; i< nx; i++){
	    disx= i*unit_length;
	    //disx= width * Math.cos(radian);
	    //disy= width * Math.sin(radian);

	    refpts[i]= new Point3d(disx,0,0);
	    cylinderVectorAC[i].set(points[i].x - refpts[i].x,
				    points[i].y - refpts[i].y,
				    0);
	    cylinderVectorC[i].set(-cylinderVectorAC[i].x,
				   cylinderVectorAC[i].y,
				   cylinderVectorAC[i].z);
	    if(Ttp.commentslevel >= 3){
		System.out.println("CylinderVectorAV ["+ i + "]= " + cylinderVectorAC[i].toString() ); 
	    }
	    
	}

	
	//generate final position
	//In the future, this should move to interpolation
	/*Point3d ref= new Point3d();
	for(i= 0; i< nx; i++){
	    disx= i*unit_length;
	    ref.set(disx,0,0);
	    resultCylinderCurve[i].set(ref.x + cylinderVector[i].x,
				       ref.y + cylinderVector[i].y,
				       0);
				       }*/
	
	/*double length; 
	for(i= 0; i< nx-1; i++){
	    length= resultCylinderCurve[i].length(resultCylinderCurve[i+1]);
	    System.out.println("resutl length ["+ i + "]= " + length );  
	    length= refpts[i].length(refpts[i+1]);
	    System.out.println("refpts length ["+ i + "]= " + length );  

	    }*/
	
    }

    
    /*
      
     */
    public void setJackVectors(Vector3d [] leftjvUP, Vector3d [] rightjvUP,
			       Vector3d [] leftjvDOWN, Vector3d [] rightjvDOWN )
    {
	Utilities.arrayCopy(leftjvUP, 0, jvLeftCurveUP, 0, nx);
	Utilities.arrayCopy(rightjvUP, 0, jvRightCurveUP, 0, nx);
	Utilities.arrayCopy(leftjvDOWN, 0, jvLeftCurveDOWN, 0, nx);
	Utilities.arrayCopy(rightjvDOWN, 0, jvRightCurveDOWN, 0, nx);
    }

    public void setTurningDirection(byte direction)
    {
	this.turningdirection= direction;
    }
    
    
    public void setpivotAngle()
    {
	pivot_angle= 90;
    }

    public void setStartUPPosition(Point3d s)
    {
	startUP= new Point3d(s);
    }

    public void setStartDOWNPosition(Point3d s)
    {
	startDOWN= new Point3d(s);
    }
   
    public void setRotationAngle(double rot)
    {
	if(turningdirection == ANTI_CLOCKWISE){
	    if(rot > 180)
		rotAngle= 180;
	    else
		rotAngle= rot;
	}else{
	    if(rot < -180)
		rotAngle= -180;
	    else
		rotAngle= rot;
	}
	
	interpolation();
    }

    public void displayCurve(GLCanvas canvas, Point3d [] curvepts, float [] color)
    {
	GLFunc gl = canvas.gl;
	int i;

	gl.glPushAttrib(gl.GL_ALL_ATTRIB_BITS);
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, color );
	gl.glLineWidth(3.f);
	gl.glBegin(GL_LINE_STRIP);
	for(i=0; i< nx-1; i++){
	    gl.glVertex3dv(curvepts[i].get3dv());
	    gl.glVertex3dv(curvepts[i+1].get3dv());
	}
	gl.glEnd();
	
	
	gl.glPopAttrib();
    }


    public void displayleftVectorCurve(GLCanvas canvas, Vector3d [] v, float [] color)
    {
	GLFunc gl = canvas.gl;
	int i;
	double width;
	Point3d ref= new Point3d(0,0,0);


	gl.glPushAttrib(gl.GL_ALL_ATTRIB_BITS);
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, color );
	gl.glLineWidth(.3f);
	gl.glBegin(GL_LINE_STRIP);
	for(i=0; i< nx-1; i++){
	    width= -i*elementlength;
	    ref.set(width, 0, 0);
	    ref.set(ref.plus(v[i]));
	    gl.glVertex3dv(ref.get3dv());
	
	    width= -(i+1)*elementlength;
	    ref.set(width, 0, 0);
	    ref.set(ref.plus(v[i+1]));
	    gl.glVertex3dv(ref.get3dv());
	}
	gl.glEnd();
	
	
	gl.glPopAttrib();
    }

     public void displayrightVectorCurve(GLCanvas canvas, Vector3d [] v, float [] color)
    {
	GLFunc gl = canvas.gl;
	int i;
	double width;
	Point3d ref= new Point3d(0,0,0);


	gl.glPushAttrib(gl.GL_ALL_ATTRIB_BITS);
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, color );
	gl.glLineWidth(.3f);
	gl.glBegin(GL_LINE_STRIP);
	for(i=0; i< nx-1; i++){
	    width= i*elementlength;
	    ref.set(width, 0, 0);
	    ref.set(ref.plus(v[i]));
	    gl.glVertex3dv(ref.get3dv());
	
	    width= (i+1)*elementlength;
	    ref.set(width, 0, 0);
	    ref.set(ref.plus(v[i+1]));
	    gl.glVertex3dv(ref.get3dv());
	}
	gl.glEnd();
	
	
	gl.glPopAttrib();
    }

    public void interpolation()
    {
	double width, disx, disy;
	int i,j;
	Point3d ref= new Point3d(0,0,0);
	Matrix4d m1=
	    Matrix4d.rotAroundZ(Utilities.degree2rad(rotAngle));
	Matrix4d mUp= Matrix4d.shift( startUP.x, startUP.y, startUP.z );
	Matrix4d mDown= Matrix4d.shift( startDOWN.x, startDOWN.y, startDOWN.z );

	for(j=0; j<nx; j++){
	    if(turningdirection == ANTI_CLOCKWISE){
		genJackVector(rotAngle, 
			      jvRightCurveUP[j],
			      jvLeftCurveUP[j],
			      jackVectorUP[j],
			      m1 );
		genCylinderVector(rotAngle, 
				  cylinderVectorAC[j], // maximum
				  resultcylinderVector[j], 
				  m1);
		
		genJackVector(rotAngle, 
			      jvRightCurveDOWN[j],
			      jvLeftCurveDOWN[j],
			      jackVectorDOWN[j],
			      m1 );
		width= j*elementlength;
	    }else{
		
		genJackVector(-rotAngle, 
			      jvLeftCurveUP[j],
			      jvRightCurveUP[j],
			      jackVectorUP[j],
			      m1 );
		
		
		genCylinderVector(-rotAngle, 
				  cylinderVectorC[j], // maximum
				  resultcylinderVector[j], 
				  m1);
		
		genJackVector(-rotAngle, 
			      jvLeftCurveDOWN[j],
			      jvRightCurveDOWN[j],
			      jackVectorDOWN[j],
			      m1 );
		width= -j*elementlength;
		
	    }

	    disx= width * Math.cos(Utilities.degree2rad(rotAngle));
	    disy= width * Math.sin(Utilities.degree2rad(rotAngle));
	    
	    if(Ttp.commentslevel >= 3){
		System.out.println("\twidth= " + width);
		System.out.println("\trotAngle= " + rotAngle);
		System.out.println("\tcos= " + Math.cos(Utilities.degree2rad(rotAngle)));
		System.out.println("\tsin= " + Math.sin(Utilities.degree2rad(rotAngle)));
		System.out.println("\tdisx= " + disx);
	    }

	    ref.set(disx, disy, 0);
	    
	    resultCylinderCurve[j].set(ref.x + resultcylinderVector[j].x,
				       ref.y + resultcylinderVector[j].y,
				       0);
	    resultCurveUP[j].set( resultCylinderCurve[j].x + jackVectorUP[j].x,
				  resultCylinderCurve[j].y + jackVectorUP[j].y,
				  0);
	    resultCurveUP2[j].set(resultCylinderCurve[j].x + jackVectorUP[j].x,
				  resultCylinderCurve[j].y + jackVectorUP[j].y,
				  0);

	    resultCurveDOWN[j].set(resultCylinderCurve[j].x + jackVectorDOWN[j].x,
				   resultCylinderCurve[j].y + jackVectorDOWN[j].y,
				   0);
	    resultCurveDOWN2[j].set(resultCylinderCurve[j].x + jackVectorDOWN[j].x,
				    resultCylinderCurve[j].y + jackVectorDOWN[j].y,
				    0);
	    
	    mUp.transform(resultCurveUP[j]);
	    mDown.transform(resultCurveDOWN[j]);

	    //cylindrical curve
	    mUp.transform(resultCylinderCurve[j]);
	    mUp.transform(resultCurveUP2[j]);
	    mDown.transform(resultCurveDOWN2[j]);
	}
	//genModel();
    }

    
    /*
      set up mid point line,i.e. initialize approx_pivot_angle
     */
    public void setpivotAngle( Point3d [] left,
			       Point3d [] right)
    {
	Vector3d a= new Vector3d(left[1].minus(left[0]) );
	Vector3d b= new Vector3d(right[1].minus(right[0]) );
	
	Vector3d c;
	if(turningdirection == ANTI_CLOCKWISE){
	    a= new Vector3d(left[1].minus(left[0]) );
	    b= new Vector3d(right[1].minus(right[0]) );
	    c= new Vector3d(1,0,0);
	}else{
	    a= new Vector3d(right[1].minus(right[0]) );
	    b= new Vector3d(left[1].minus(left[0]) );
	    c= new Vector3d(-1,0,0);
	}
	double theta, phi, temp, pivot;
	

	theta= a.angle(c);
	phi= b.angle(c);
	temp= phi + (theta-phi)/2.0;
	pivot_angle=  Utilities.rad2degree(temp);
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("real pivot> " + pivot_angle);
	}
    }



    void genModel()
    {
	int row, col;
	double zlen= 0; 

	//starts from the second row
	for(row= 0; row < nz; row++){
	    zlen= row*elementlength;
	    for(col= 0; col < nx; col++){
		resultSurfaceUP[row][col].set(resultCurveUP[col].x, 
					      resultCurveUP[col].y, 
					      resultCurveUP[col].z + zlen);
		resultSurfaceDOWN[row][col].set(resultCurveDOWN[col].x, 
						resultCurveDOWN[col].y, 
						resultCurveDOWN[col].z + zlen);
	    }
	}
	
	//compute normals
    }
    

    void genJackVector(double theta, Vector3d first, Vector3d second, Vector3d result,
		       Matrix4d m )
    {
	double scale;
	
	if(theta <= pivot_angle){
	    scale= 1.0 - (theta / pivot_angle);
	    m.transform(first, result);
	}else{
	    scale= (theta - pivot_angle) / (180 - pivot_angle);
	    m.transform(second, result);
	    result.set(-(result.x), 
		       -(result.y),
		       0);
	}
	
	result.scale(scale);
    }


    void genCylinderVector(double theta, Vector3d cylinderVector, Vector3d result, Matrix4d m)
    {
	double scale; 
	
	if(theta <= pivot_angle){ 
	    scale= theta / pivot_angle; // increase scale
	}else{
	    scale= 1- ((theta - pivot_angle) / (180 - pivot_angle)); //decrease scale
	}

	m.transform(cylinderVector, result);
	result.scale(scale);
    }
    
    void displayUP(GLCanvas canvas, int drawing_mode)
    {
	GLFunc gl = canvas.gl;
	
	int i, j; 
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	
	for(i=0; i< nz-1; i++){
	    gl.glBegin(GL_QUAD_STRIP);
	    for(j=0; j< nx; j++){
		gl.glVertex3dv(resultSurfaceUP[i+1][j].get3dv());
		gl.glVertex3dv(resultSurfaceUP[i][j].get3dv());
	    }
	    gl.glEnd();
	}
	
	gl.glPopAttrib();
    }

    
    
    

    void displayDOWN(GLCanvas canvas, int drawing_mode)
    {
	GLFunc gl = canvas.gl;
	
	int i, j; 
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	
	for(i=0; i< nz-1; i++){
	    gl.glBegin(GL_QUAD_STRIP);
	    for(j=0; j< nx; j++){
		gl.glVertex3dv(resultSurfaceDOWN[i+1][j].get3dv());
		gl.glVertex3dv(resultSurfaceDOWN[i][j].get3dv());
	    }
	    gl.glEnd();
	}
	
	gl.glPopAttrib();
    }

    public Point3d [] getUPcurvePts()
    {
	return resultCurveUP;
    }

    public Point3d [] getDOWNcurvePts()
    {
	return resultCurveDOWN;
    }
    
    public void display(GLCanvas canvas, int drawing_mode)
    {
	GLFunc gl = canvas.gl;
	float [] u ={.0f, .6f, .6f}; 
	float [] d ={.6f, .6f, .0f}; 

	//displayCurve(canvas, resultCurveUP , u );
	//displayCurve(canvas, resultCurveDOWN , d );

	//cylindrical model
	//displayCurve(canvas, resultCylinderCurve, d );
	displayCurve(canvas, resultCurveUP2, u );
	displayCurve(canvas, resultCurveDOWN2, d );
	
	
	//displayUP(canvas, drawing_mode);
	//displayDOWN(canvas, drawing_mode);


	//displayDOWN();
	
	//debug
	//displayleftVectorCurve(canvas, jvLeftCurveDOWN , d );
	//displayrightVectorCurve(canvas, jvRightCurveDOWN , u );
	
    }
}
