package TTPproject;

import java.lang.Integer;
import java.awt.Rectangle;

public class Parameters 
    implements CONSTANTS{
    
    
    String conf_file_name= null;
    String [] pdf_file_names= null;
    
    int particle_x, particle_z;
    
    //default values 
    int from= 0;
    int to= 1;
    int totalPages= 3;
    int yearLevel= 10;// from 1 to 10 
    int filetype= 0;
    
   
    
    private Rectangle window_bounds= new Rectangle(10, 
						   20,
						   700,
						   700 );
		
    private Rectangle viewport_bounds= new Rectangle(0, 
						     0,
						     700,
						     700 );

    private int viewport_width;
    private int viewport_height;
    private int viewport_offset_x;
    private int viewport_offset_y;


    public Parameters(String [] args){
	System.out.println("---------------------------");
	System.out.println("  Input arguments ");
	System.out.println("---------------------------");
	int i= 0;
	while(i< args.length){
	    
	    if( args[i].compareTo("-prefix") == 0 ){
		i++;
		String prefix= new String(args[i]);
		Ttp.prefix= prefix + "/data/"; // data 
		Ttp.pdfprefix= prefix + "/data/pdfs/"; //pdf prefix 
		Ttp.djvusprefix= prefix + "/data/djvus/"; //djvu prefix 
		//Ttp.pagePrefix= prefix + "/pagecache/";//pagescache
		Ttp.pagePrefix= prefix + "/pagecache/";//pagescache
		Ttp.iconPrefix= prefix + "/data/icons/"; //icon prefix 
		Ttp.snapshotPrefix= Ttp.pagePrefix; //snapshot prefix 
				
		
		System.out.println("pdf prefix> " + Ttp.prefix);
		System.out.println("pagecache prefix> " + Ttp.pagePrefix);
	    }
	    	    
	    if( args[i].compareTo("-datafile") == 0 ){
		i++;
		conf_file_name= new String(args[i]);
		System.out.println("Configuration filename> " + conf_file_name);
	    }

	    if( args[i].compareTo("-pdffile") == 0 ){
		filetype= PDF;

		i++;
		int num_files= Integer.parseInt(args[i]) ;
		i++;
		
		System.out.println("Number of input files> " + num_files);

		int j= 0;
		pdf_file_names= new String[num_files];
		

		while(j < num_files){
		    pdf_file_names[j]= new String(args[i]);
		    System.out.println("Pdf filename> " + pdf_file_names[j]);
		    j++;
		    i++;
		}

		//extract pdf name without suffix '.pdf'
		//pdf_file_name;
		int index= pdf_file_names[0].lastIndexOf('.');
		Ttp.ebook_file_name= pdf_file_names[0].substring(0, index);
		System.out.println("pdf filename> " + Ttp.ebook_file_name);
		Ttp.full_ebook_file_name= Ttp.ebook_file_name + ".pdf";
		
		
	    }

	    if( args[i].compareTo("-djvufile") == 0 ){
		filetype= DJVU;
		i++;
		String filename= args[i];
				
		//extract file name without suffix '.djvu'
		//pdf_file_name;
		int index= filename.lastIndexOf('.');
		Ttp.ebook_file_name= filename.substring(0, index);
		Ttp.full_ebook_file_name= Ttp.ebook_file_name + ".djvu";
		System.out.println("djvu filename> " + Ttp.ebook_file_name);
	    }

	    if( args[i].compareTo("-tgaSnapshot") == 0 ){
		System.out.println("Taking the first snap shot");
		i++;
		Ttp.screen_file_name= args[i];
		Ttp.grabbing_initial_screen= true;
		System.out.println("screen_file_name> " + Ttp.screen_file_name);
		
	    }

	    if( args[i].compareTo("-from") == 0 ){
		i++;
		from= Integer.parseInt(args[i]) ;
		System.out.println("from> " + from);
	    }
	    
	    if( args[i].compareTo("-to") == 0 ){
		i++;
		to= Integer.parseInt(args[i]) ;
		System.out.println("to> " + to);
	    }

	    if( args[i].compareTo("-totalPages") == 0 ){
		i++;
		totalPages= Integer.parseInt(args[i]) ;
		System.out.println("totalPages> " + totalPages);
	    }

	    if( args[i].compareTo("-yearlevel") == 0 ){
		i++;
		yearLevel= Integer.parseInt(args[i]) ;
		System.out.println("year Level> " + yearLevel);
	    }

	    if( args[i].compareTo("-commentlevel") == 0 ){
		i++;
		Ttp.commentslevel= Integer.parseInt(args[i]) ;
		System.out.println("Comments Level> " + Ttp.commentslevel);
	    }

	    if( args[i].compareTo("-3dfonts") == 0 ){
		i++;
		Ttp.fonts3d_type= Integer.parseInt(args[i]) ;
		System.out.println("****Font type> " + Ttp.fonts3d_type);
	    }

	    if( args[i].compareTo("-3dfonts_format") == 0 ){/*glf or bmf*/
		i++;
		Ttp.fonts3d_format= new String(args[i]);
		System.out.println("****Font  format> " + Ttp.fonts3d_format);
	    }

	    if( args[i].compareTo("-3dfonts_form") == 0 ){ /*wire or solid*/
		i++;
		Ttp.fonts3d_form= new String(args[i]);
		System.out.println("****Font form> " + Ttp.fonts3d_form);
	    }

	    if( args[i].compareTo("-window") == 0 ){
		i++;

		window_bounds.width= Integer.parseInt(args[i]);
		i++;
		window_bounds.height= Integer.parseInt(args[i]);
		i++;
		window_bounds.x= Integer.parseInt(args[i]);
		i++;
		window_bounds.y= Integer.parseInt(args[i]);
		
		System.out.println("Win width> " + window_bounds.width );
		System.out.println("Win height> " + window_bounds.height );
		System.out.println("Win offset_x> " + window_bounds.x );
		System.out.println("Win offset_y> " + window_bounds.y );
	    }

	    if( args[i].compareTo("-viewport") == 0 ){
		i++;
		viewport_bounds.width= Integer.parseInt(args[i]);
		i++;
		viewport_bounds.height= Integer.parseInt(args[i]);
		i++;
		viewport_bounds.x= Integer.parseInt(args[i]);
		i++;
		viewport_bounds.y= Integer.parseInt(args[i]);
				
		System.out.println("Viewport Width> " + viewport_bounds.width);
		System.out.println("Viewport height> " + viewport_bounds.height);
		System.out.println("viewport offset_x> " + viewport_bounds.x);
		System.out.println("viewport offset_y> " + viewport_bounds.y);
	    }
	    
	    
	    i++;

	}

    }

    public String getConfigfile(){ return conf_file_name;} 
    public String [] getPdffilenames(){ return pdf_file_names;}
    //public String getEbookfilename(){ return ebook_file_name;}// return pdf file name without suffix
    public int getpageFrom(){return from;}
    public int getpageTo(){return to;}
    public int getTotalPages(){return totalPages;}
    public int getYearLevel(){return yearLevel;}
    public int getfileType(){return filetype;}
    public Rectangle getWindowBounds(){ return window_bounds; }
    public Rectangle getViewportBounds(){ return viewport_bounds; }
    
    
}
