package TTPproject;


import gl4java.awt.GLAnimCanvas;
import gl4java.utils.textures.PngTextureLoader;
import gl4java.utils.glut.*;
import gl4java.utils.glut.fonts.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import java.util.List;
import java.util.ArrayList;// anchorPageList


import java.awt.Rectangle;

public class Scene 
    extends GLAnimCanvas 
    implements ActionListener, CONSTANTS{
    
    protected ActionListener callback= null;

    protected GLUTFunc glut = null;
    
    protected Rectangle viewportbounds= null;
    protected PngTextureLoader pngtexLoader= null; // reader the background
    private double simpletextureHeight= 450;
    private double simpletextureWidth= 600;
    
    private double startX_simpletexture= 0;
    private double startY_simpletexture= 0;
    int [] simpletexture= null;
    
    private int number_displays= 1;

    //OpenGL flag
    protected boolean USE_REPAINT_FLAG= true;
    protected boolean USE_FPS_SLEEP_FLAG= false;
    protected boolean DOUBLE_BUFFERING_FLAG= true;
    protected boolean STEREO_VIEW_FLAG= false;
   
    
    //BookConstructor bc= null;
    
    public int running_state= LOADING; 
    Configuration config= null;
    CursorManager cursorManager= null;
    TexturePools texturePools= null;
    List anchorListLeft= null; 
    List anchorListRight= null;
    

    public Scene(ActionListener callee, 
		 int width, int height,
		 Rectangle viewportbounds) {
	super(width, height);
	if(Ttp.commentslevel >= 2){
	    System.out.println("Scene.java: Scene()");
	}
	
	this.callback= callee;
	
	//save viewport 
	this.viewportbounds= viewportbounds;
	startX_simpletexture= (double)(width-simpletextureWidth)/2;
	startY_simpletexture= (double)(height-simpletextureHeight)/2;

	//Use repaint to initiate rendering
	setUseRepaint(USE_REPAINT_FLAG);
	//Drop the frames per second sleeps
	setUseFpsSleep(USE_FPS_SLEEP_FLAG); 



    }


    /**
     * This is your pre-init method. preInit is called just BEFORE the 
     * GL-Context is created. You should override preInit, to initialize
     * your visual-stuff, like the protected vars: doubleBuffer and 
     * stereoView 
     */
    public void preInit()
    { 
	if(Ttp.commentslevel >= 2){
	    System.out.println("Scene.java: preInit():");
	}
	
	
	this.doubleBuffer = DOUBLE_BUFFERING_FLAG; 
	this.stereoView = STEREO_VIEW_FLAG; // buffering but not stereoview
    }

    /**
     * init is called right after the GL-Context is initialized. The default 
     * implementation calls init() on all of this component's GLEventListeners. 
     * If using the subclassing model, you can override this to perform one-time 
     * OpenGL initializations such as setting up lights and display lists.
     * loading textures
     */
    public void init()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Scene.java: init():");
	}

	//message
	gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f); //background color
	gl.glEnable(GL_DEPTH_TEST);              //Enables Depth Testing
	gl.glDepthRange(0.0, 1.0);
	glj.gljCheckGL();

	
	glut = new GLUTFuncLightImplWithFonts(this.gl, this.glu);
	
	//setup simple texture
	simpletexture= new int[1];
	gl.glGenTextures(1, simpletexture);

	pngtexLoader= new PngTextureLoader(this.gl, this.glu);
	String loading_simpleTexture= Ttp.prefix + "loadingtexture.png";
	pngtexLoader.readTexture(loading_simpleTexture);
	if(pngtexLoader.isOk()){
	    gl.glBindTexture(GL_TEXTURE_2D, simpletexture[0]);
	    gl.glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	    gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	    gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	    gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	    gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	    
	    glu.gluBuild2DMipmaps(GL_TEXTURE_2D, 
				  3, 
				  pngtexLoader.getImageWidth(), 
				  pngtexLoader.getImageHeight(), 
				  GL_RGB, 
				  GL_UNSIGNED_BYTE, 
				  pngtexLoader.getTexture());
	}
	
	
		
    }

    /**
     * ReInit should be overwritten by you, to enter your re-initialisation within setSuspended(false)
     */
    public void ReInit()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Scene.java: ReInit():");
	}
	
    }

        /**
     * reshape method will be invoked after the first paint command after GLCanvas.componentResize 
     * is called AND only if "gljMakeCurrent" was successful (so a call of gljMakeCurrent is redundant).
     * "reshape" is not an overloading of java.awt.Component.reshape, "reshape" is more like 
     * "glut"-reshape.
     */
    public void reshape(int width, int height)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Scene.java: reshape():");
	}
	
	gl.glViewport(0,  
		      0, 
		      width, 
		      height);

	if(running_state == RUNNING){
	    config.updateAspect(width, height); //update aspect ratio
	}
	
	
    }


    //after the second display 
    public void init_configuration()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Scene.java: init_configuration()");
	}
	
    }
    


    public void display()
    {
	if(!glj.gljMakeCurrent()) {
            throw new RuntimeException("****Fatal error Scene.java: gljMakeCurrent failed");
	}

	gl.glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	if(Ttp.commentslevel >= 2){
	    System.out.println("Scene.java: display()");
	}

	int viewport[]= new int[4];
	
	// Get the viewport
	gl.glGetIntegerv(GL_VIEWPORT, viewport);
	
	// Remap the viewing volume to match window coordinates (approximately)
	gl.glMatrixMode(GL_PROJECTION);
	gl.glLoadIdentity();
	
	// Establish clipping volume (left, right, bottom, top, near, far)
	gl.glOrtho(viewport[0], viewport[2], viewport[3], viewport[1], -1, 1);
	
	gl.glMatrixMode(GL_MODELVIEW);
	gl.glLoadIdentity();
	
	displaySimpleTexture();

	glj.gljSwap(); 
	glj.gljCheckGL();
	glj.gljFree();

		
	if(number_displays < 2){
	    number_displays++;
	    if(Ttp.commentslevel >= 3){
		System.out.println("Scene(): " + number_displays );
	    }
	    
	}else if(number_displays == 2){
	    number_displays++;
	    
	    if(Ttp.commentslevel >= 3){
		System.out.println("Scene(): " + number_displays );
		System.out.println("Scene(): issue actionEvent" );
	    }
	    callback.actionPerformed(new ActionEvent(this, 0, "INITIALIZATION"));
	    
	}
	
    }

    /**
     * This method is used to remove/release a GLCanvas
     */
    public void cvsDispose()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Scene.java: cvsDispose()");
	}
	
    }


    public void setFields(Configuration config,
			  CursorManager cursorManager,
			  TexturePools texturePools,
			  List anchorListLeft, 
			  List anchorListRight )
    {
	this.config= config;
	this.cursorManager= cursorManager;
	this.texturePools= texturePools;
	this.anchorListLeft= anchorListLeft;
	this. anchorListRight= anchorListRight;
    }


    
    protected void displaySimpleTexture()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Scene.java: displaySimpleTexture()");
	}
	
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 

	gl.glEnable(GL_TEXTURE_2D);
	gl.glBindTexture(GL_TEXTURE_2D, simpletexture[0]);
	
	gl.glPushMatrix();
	gl.glTranslated(startX_simpletexture,startY_simpletexture,0);
		
	gl.glBegin (GL_QUADS);	
	
	gl.glTexCoord2d(0, 0);
	gl.glVertex2d(0, simpletextureHeight);
	
	gl.glTexCoord2d(1, 0);
	gl.glVertex2d(simpletextureWidth, simpletextureHeight);

	gl.glTexCoord2d(1, 1);
	gl.glVertex2d(simpletextureWidth, 0);
	
	gl.glTexCoord2d(0, 1);
	gl.glVertex2d(0, 0);
	
	gl.glEnd();
	gl.glPopMatrix();

	gl.glPopAttrib();

	//display text in the scene 
	/*
	  gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	  gl.glColor3f(1.0f, 1.0f, 1.0f);
	  gl.glRasterPos2d(300,50);
	  glut.glutBitmapString(glut.GLUT_BITMAP_9_BY_15,"Loading Anchor Pages");
	  gl.glPopAttrib();
	*/
    }


    public void postInit()
    {

	if(!glj.gljMakeCurrent()) {
            throw new RuntimeException("gljMakeCurrent failed");
	}

	//book constructor
	/*bc= new BookConstructor(config, 
				this,
				texturePools,
				anchorListRight);*/
	
	glj.gljSwap(); 
	glj.gljCheckGL();
	glj.gljFree();// free the GL Context
    }
    
    public void performTexturefilling(Texture reader,
				      int pdf_name,
				      int texName)
    {
	Texture textureReader= reader;
	if(Ttp.commentslevel >= 2){
	    System.out.println("Scene: performTexturefilling()");
	}
	if(!glj.gljMakeCurrent()) {
            throw new RuntimeException("gljMakeCurrent failed");
	}
	
	if(textureReader.readPageTextureFromPdfReader(pdf_name, 128, 128)){
	    bc.setupMipmapsTexturing(this, texName);
	}else{
	    if(Ttp.commentslevel >= 3){
		System.out.println("*****Scene.java Fail to read from the pdf, Continue to read the next one" );
	    }
	}

	glj.gljSwap(); 
	glj.gljCheckGL();
	glj.gljFree();// free the GL Context
    }

    public void genNewTexNames(int len, int [] texNames)
    {
	if(Ttp.commentslevel >= 3){
	    System.out.println("Scene: genNewTexNames()");
	}
	if(!glj.gljMakeCurrent()) {
            throw new RuntimeException("gljMakeCurrent failed");
	}
	
	gl.glGenTextures(len, texNames);
		
	//glj.gljSwap(); 
	glj.gljCheckGL();
	glj.gljFree();
	if(Ttp.commentslevel >= 3){
	    System.out.println("Scene: genNewTexNames() free");
	}

    }
    

    public void actionPerformed(ActionEvent evt)
    {

    }

}
