package TTPproject;

import javax.vecmath.*;
import gl4java.awt.GLCanvas;
import gl4java.GLFunc;
import gl4java.GLUFunc;
import gl4java.GLEnum;


public class Spine
    implements GLEnum, CONSTANTS{

    /*private GLCanvas canvas;
      private GLFunc gl= null;
      private GLUFunc glu= null;
    */

    private Configuration config;
    
    int textureName;
    byte orientation;

    Point3d [] cube_vertex= null;
    int num_cube_vertex= 8;
    double edge_len;

    Point3d [] face_two_ctrl_pts= null;
    Point3d [][] face_two_vertex= null;
    Vector3d [] face_two_normals= null;
    
    BezierCurve face_two_curve= null;
    int num_face_two_vertex_x= 10;
    int num_face_two_vertex_z= 12;


    Point3d [] face_five_ctrl_pts= null;
    Point3d [][] face_five_vertex= null;
    Vector3d [] face_five_normals= null;
    
    Vector3d face_one_normal= null;
    Vector3d face_three_normal= null;
    Vector3d face_six_normal= null;
    Vector3d face_four_normal= null;

    BezierCurve face_five_curve= null;
    int num_face_five_vertex_x= 8;
    int num_face_five_vertex_z= 12;
    int face_five_num_row_showing= 4;

    Point3d [] inner_side_vertex= null; // can be used by face 4 &
                                  // face 6 
    
    public Spine(Configuration config)
    {
	/*this.canvas= canvas;
	  this.gl= canvas.gl;
	  this.glu= canvas.glu;
	*/
	
	this.config= config;
	int i,j;
	cube_vertex= new Point3d[num_cube_vertex];
	for(i=0; i < num_cube_vertex; i++){
	    cube_vertex[i]= new Point3d(0,0,0);
	}

	face_two_ctrl_pts= new Point3d[4];
	face_five_ctrl_pts= new Point3d[4];
	for(i=0; i< 4; i++){
	    face_two_ctrl_pts[i]= new Point3d(0,0,0);
	    face_five_ctrl_pts[i]= new Point3d(0,0,0);
	}
	
	face_two_curve= new BezierCurve(num_face_two_vertex_x, 1.f);
	face_five_curve= new BezierCurve(num_face_five_vertex_x, 1.f);


	face_two_vertex= new Point3d[num_face_two_vertex_z][num_face_two_vertex_x];
	
	for(i=0; i<num_face_two_vertex_z; i++){
	    for(j=0; j<num_face_two_vertex_x; j++){
		face_two_vertex[i][j]= new Point3d(0,0,0);
	    }
	}

	face_five_vertex= new Point3d[face_five_num_row_showing][num_face_five_vertex_x];
	for(i=0; i<face_five_num_row_showing; i++){
	    for(j=0; j<num_face_five_vertex_x; j++){
		face_five_vertex[i][j]= new Point3d(0,0,0);
	    }
	}

	face_five_normals= new Vector3d[num_face_five_vertex_x];
	for(i=0; i<num_face_five_vertex_x; i++){
	    face_five_normals[i]= new Vector3d(0,0,0);
	}
	
	inner_side_vertex= new Point3d[num_face_two_vertex_x];
	face_two_normals= new Vector3d[num_face_two_vertex_x];
	for(i=0; i<num_face_two_vertex_x; i++){
	    inner_side_vertex[i]= new Point3d(0,0,0);
	    face_two_normals[i]= new Vector3d(0,0,0);
	}
	
	face_one_normal= new Vector3d(0,0,0);
	face_three_normal= new Vector3d(0,0,0);
	face_six_normal= new Vector3d(0,0,1);
	face_four_normal= new Vector3d(0,0,-1);
	
	
    } 
    

    public void setOrientation(byte orientation)
    {
	this.orientation= orientation;
    }

    public void setVertex(double [] v, double len)
    {
	int i, n;
	for(i=0; i<num_cube_vertex; i++){
	    n= i*3;
	    cube_vertex[i].set(v[n], v[n+1], v[n+2]);
	}
	
	edge_len= len;

	construct_face_two();
	construct_face_five();
	construct_inner_side();
	if(orientation == POSITIVE){
	    face_one_normal.set(-1,0,0);
	    face_three_normal.set(1,0,0);
	}else{
	    face_one_normal.set(1,0,0);
	    face_three_normal.set(-1,0,0);
	}
	
	
    }


    void construct_inner_side()
    {
	int from, to;
	inner_side_vertex[0].set(cube_vertex[0].x,
				 cube_vertex[0].y,
				 0);

	for(from=0, to=1; to<(inner_side_vertex.length-1); to++, from++){
	    inner_side_vertex[to].set(face_five_vertex[0][from].x,
				      face_five_vertex[0][from].y,
				      0 );
	}

	inner_side_vertex[inner_side_vertex.length-1].set(cube_vertex[3].x,
							  cube_vertex[3].y,
							  0);
    }

    /*void construct_face_two()
    {
	double y= config.getSpineface2_height();
	double x= config.getBookThickness() + 2* edge_len;

	   
	//2 end points
	face_two_ctrl_pts[0].set(cube_vertex[4].x, 
				 cube_vertex[4].y,
				 0 );

	face_two_ctrl_pts[3].set(cube_vertex[7].x,
				 cube_vertex[7].y,
				 0);
	
	// c1
	if(orientation == POSITIVE){
	    face_two_ctrl_pts[1].set(-x/3, 
				     cube_vertex[4].y - y,
				     0 );
	}else{
	    face_two_ctrl_pts[1].set(x/3, 
				     cube_vertex[4].y - y,
				     0 );
	}
	 
	
	//c2
	if(orientation == POSITIVE){
	    face_two_ctrl_pts[2].set(cube_vertex[7].x +  x/3, 
				     cube_vertex[7].y - y,
				     0 );
	}else{
	    face_two_ctrl_pts[2].set(cube_vertex[7].x -  x/3, 
				     cube_vertex[7].y - y,
				     0 );
	}



	face_two_curve.setKnots(face_two_ctrl_pts);
	face_two_curve.genCurves();

	//System.arraycopy(face_two_curve.getPts(0), 0, face_two_vertex[0], 0, num_face_two_vertex_x);
	Utilities.arrayCopy(face_two_curve.getPts(0), 0, face_two_vertex[0], 0, num_face_two_vertex_x);
	

	int i, j;
	double z;
	double unit_len= (config.get_zMax()+config.getCoverMargin())/ (num_face_two_vertex_z-1);
	
	for(i=0; i<num_face_two_vertex_z; i++){
	    for(j=0; j<num_face_two_vertex_x; j++){
		z= cube_vertex[5].z + i*unit_len;
		face_two_vertex[i][j].set(face_two_vertex[0][j].x, 
					  face_two_vertex[0][j].y,
					  z );
	    }
	}

	Point3d pos= new Point3d(0,0,0);
	Vector3d normal= new Vector3d(0,0,0);
	Vector3d normal_total= new Vector3d(0,0,0);
	Vector3d vCur= new Vector3d(0,0,0);
	Vector3d vLast= new Vector3d(0,0,0);
	
	//compute normals
	
	for(j= 0; j < num_face_two_vertex_x; j++){
	    vLast.sub( getNeighbour(0, j, 3, face_two_vertex, 
				    num_face_two_vertex_x, num_face_two_vertex_z), 
		       face_two_vertex[0][j]);
	    
	    for (int neighbour = 0; neighbour < 4; neighbour++) {
		//in anti-clockwised direction
		//so the normal points upwards
		vCur.sub(getNeighbour(0, j, neighbour, face_two_vertex, 
				      num_face_two_vertex_x, num_face_two_vertex_z), 
			 face_two_vertex[0][j]);

		normal.cross(vLast, vCur);
		normal_total.add(normal);
		vLast.set(vCur);
	    }
	    face_two_normals[j].normalize(normal_total);
	    normal_total.set(0,0,0); 
	    face_two_normals[j].negate();
	    
	}
	}*/

    
     void construct_face_two()
    {
	//double y= config.getSpineface2_height();
	double y= config.getSpineface2_height();
	double x= config.getBookThickness() + 2* edge_len;
	//2 end points
	face_two_ctrl_pts[0].set(cube_vertex[4].x, 
				 cube_vertex[4].y,
				 0 );

	face_two_ctrl_pts[3].set(cube_vertex[7].x,
				 cube_vertex[7].y,
				 0);
	
	// c1
	if(orientation == POSITIVE){
	    face_two_ctrl_pts[1].set(cube_vertex[4].x - x/3, 
				     cube_vertex[4].y - y,
				     0 );
	}else{
	    face_two_ctrl_pts[1].set(cube_vertex[4].x + x/3, 
				     cube_vertex[4].y - y,
				     0 );
	}
	 
	
	//c2
	if(orientation == POSITIVE){
	    face_two_ctrl_pts[2].set(cube_vertex[7].x +  x/3, 
				     cube_vertex[7].y - y,
				     0 );
	}else{
	    face_two_ctrl_pts[2].set(cube_vertex[7].x -  x/3, 
				     cube_vertex[7].y - y,
				     0 );
	}
	
	build_face_two();
    }


    void construct_face_two(double spineAngle)
    {
	
	double x= config.getBookThickness() + 2* edge_len;
	double y= 0;
	double max_y= config.getSpineface2_height();
	double min_y= config.getSpineface2_height()*.1;
	double alpha= 0;
	if(spineAngle <= 0){// phase2
	    //-90 -> 0
	    alpha= Math.abs(spineAngle)/90;
	    if(Ttp.commentslevel >= 3){
		System.out.println("alpha> "+ alpha);//debug
	    }
	    y= (1-alpha)*min_y + alpha*max_y;
	    
	}else{
	    //0 -> 90
	    alpha= spineAngle/90;
	    if(Ttp.commentslevel >= 3){
		System.out.println("alpha> "+ alpha);//debug
	    }
	    y= (1-alpha)*min_y + alpha*max_y;

	}

	face_two_ctrl_pts[0].set(cube_vertex[4].x, 
				 cube_vertex[4].y,
				 0 );

	face_two_ctrl_pts[3].set(cube_vertex[7].x,
				 cube_vertex[7].y,
				 0);
	
	// c1
	if(orientation == POSITIVE){
	    face_two_ctrl_pts[1].set(cube_vertex[4].x - x/3, 
				     cube_vertex[4].y - y,
				     0 );
	}else{
	    face_two_ctrl_pts[1].set(cube_vertex[4].x + x/3, 
				     cube_vertex[4].y - y,
				     0 );
	}
	 
	
	//c2
	if(orientation == POSITIVE){
	    face_two_ctrl_pts[2].set(cube_vertex[7].x +  x/3, 
				     cube_vertex[7].y - y,
				     0 );
	}else{
	    face_two_ctrl_pts[2].set(cube_vertex[7].x -  x/3, 
				     cube_vertex[7].y - y,
				     0 );
	}
	
	build_face_two();
	construct_inner_side();
	
    }
    
    
    void build_face_two()
    {
	face_two_curve.setKnots(face_two_ctrl_pts);
	face_two_curve.genCurves();

	//System.arraycopy(face_two_curve.getPts(0), 0, face_two_vertex[0], 0, num_face_two_vertex_x);
	Utilities.arrayCopy(face_two_curve.getPts(0), 0, face_two_vertex[0], 0, num_face_two_vertex_x);
	

	int i, j;
	double z;
	double unit_len= (config.get_zMax()+config.getCoverMargin())/ (num_face_two_vertex_z-1);
	
	for(i=0; i<num_face_two_vertex_z; i++){
	    for(j=0; j<num_face_two_vertex_x; j++){
		z= cube_vertex[5].z + i*unit_len;
		face_two_vertex[i][j].set(face_two_vertex[0][j].x, 
					  face_two_vertex[0][j].y,
					  z );
	    }
	}

	Point3d pos= new Point3d(0,0,0);
	Vector3d normal= new Vector3d(0,0,0);
	Vector3d normal_total= new Vector3d(0,0,0);
	Vector3d vCur= new Vector3d(0,0,0);
	Vector3d vLast= new Vector3d(0,0,0);
	
	//compute normals
	
	for(j= 0; j < num_face_two_vertex_x; j++){
	    vLast.sub( getNeighbour(0, j, 3, face_two_vertex, 
				    num_face_two_vertex_x, num_face_two_vertex_z), 
		       face_two_vertex[0][j]);
	    
	    for (int neighbour = 0; neighbour < 4; neighbour++) {
		//in anti-clockwised direction
		//so the normal points upwards
		vCur.sub(getNeighbour(0, j, neighbour, face_two_vertex, 
				      num_face_two_vertex_x, num_face_two_vertex_z), 
			 face_two_vertex[0][j]);

		normal.cross(vLast, vCur);
		normal_total.add(normal);
		vLast.set(vCur);
	    }
	    face_two_normals[j].normalize(normal_total);
	    normal_total.set(0,0,0); 
	    face_two_normals[j].negate();
	    
	}


    }
    

    Point3d getNeighbour(int row, int col, int neighbour, Point3d [][] resultPos,
			 int nx, int nz) 
    {
        int dx = 0, dz = 0;
        switch(neighbour) {
	case 0: dx = 1; break; // right
	case 1: dz = -1; break; // up
	case 2: dx = -1; break; // left
	case 3: dz = 1; break; // down
        }
        
	int x = col + dx, z = row + dz;
        if (x < 0 || z < 0 || z >= nz || x >= nx)
            return resultPos[row][col];
        else
            return resultPos[z][x];
    }
    
    /*
    //deprecated
    void construct_face_five()
    {
	double y= config.getSpineface5_height();
	double x= config.getBookThickness();

	if(orientation == POSITIVE){
	    
	    face_five_ctrl_pts[0].set(cube_vertex[0].x-edge_len,
				      cube_vertex[0].y, 
				      0 );
	    
	    face_five_ctrl_pts[3].set(cube_vertex[3].x+edge_len,
				      cube_vertex[3].y,
				      0);

	    face_five_ctrl_pts[1].set(-x/3, 
				      cube_vertex[0].y - y,
				      0);

	    face_five_ctrl_pts[2].set(cube_vertex[3].x +  x/3, 
				      cube_vertex[3].y - y,
				      0 );
	}else{
	    face_five_ctrl_pts[0].set(cube_vertex[0].x + edge_len,
				      cube_vertex[0].y, 
				      0 );
	    
	    face_five_ctrl_pts[3].set(cube_vertex[3].x - edge_len,
				      cube_vertex[3].y,
				      0);

	    face_five_ctrl_pts[1].set(x/3, 
				      cube_vertex[0].y - y,
				      0);

	    face_five_ctrl_pts[2].set(cube_vertex[3].x -  x/3, 
				      cube_vertex[3].y - y,
				      0 );
	}
	
	
	face_five_curve.setKnots(face_five_ctrl_pts);
	face_five_curve.genCurves();

	Utilities.arrayCopy(face_five_curve.getPts(0), 0, face_five_vertex[0], 0, num_face_five_vertex_x);
	
	int i, j, k;
	double z;
	double unit_len= (config.get_zMax()+config.getCoverMargin())/ (num_face_five_vertex_z-1);
	int mid=  face_five_num_row_showing/2;

	// build the 1st two row
	for(i=0; i<mid; i++){
	    for(j=0; j<num_face_five_vertex_x; j++){
		z= cube_vertex[1].z + i*unit_len;
		face_five_vertex[i][j].set(face_five_vertex[0][j].x, 
					   face_five_vertex[0][j].y,
					   z);
	    }
	}
	
	


	//construct the last two row
	for(k= num_face_five_vertex_z-mid, i=mid; i<face_five_num_row_showing; i++, k++){
	    for(j=0; j<num_face_five_vertex_x; j++){
		z= cube_vertex[1].z + k*unit_len;
		face_five_vertex[i][j].set(face_five_vertex[0][j].x, 
					   face_five_vertex[0][j].y,
					   z);
	    }
	}


	Point3d pos= new Point3d(0,0,0);
	Vector3d normal= new Vector3d(0,0,0);
	Vector3d normal_total= new Vector3d(0,0,0);
	Vector3d vCur= new Vector3d(0,0,0);
	Vector3d vLast= new Vector3d(0,0,0);
	//compute normals
	for(j= 0; j < num_face_five_vertex_x; j++){
	    vLast.sub( getNeighbour(0, j, 3, face_five_vertex, 
				    num_face_five_vertex_x, num_face_five_vertex_z), 
		       face_five_vertex[0][j]);
	    
	    for (int neighbour = 0; neighbour < 4; neighbour++) {
		//in anti-clockwised direction
		//so the normal points upwards
		vCur.sub(getNeighbour(0, j, neighbour, face_five_vertex, 
				      num_face_five_vertex_x, num_face_five_vertex_z), 
			 face_five_vertex[0][j]);

		normal.cross(vLast, vCur);
		normal_total.add(normal);
		vLast.set(vCur);
	    }

	    face_five_normals[j].normalize(normal_total);
	    normal_total.set(0,0,0); 
	    face_five_normals[j].negate();
	}
	
	}*/

    void construct_face_five()
    {
	double y= config.getSpineface5_height();
	double x= config.getBookThickness();

	if(orientation == POSITIVE){
	    
	    face_five_ctrl_pts[0].set(cube_vertex[0].x-edge_len,
				      cube_vertex[0].y, 
				      0 );
	    
	    face_five_ctrl_pts[3].set(cube_vertex[3].x+edge_len,
				      cube_vertex[3].y,
				      0);

	    face_five_ctrl_pts[1].set(cube_vertex[0].x-edge_len-x/3, 
				      cube_vertex[0].y - y,
				      0);

	    face_five_ctrl_pts[2].set(cube_vertex[3].x +  x/3, 
				      cube_vertex[3].y - y,
				      0 );
	}else{
	    face_five_ctrl_pts[0].set(cube_vertex[0].x + edge_len,
				      cube_vertex[0].y, 
				      0 );
	    
	    face_five_ctrl_pts[3].set(cube_vertex[3].x - edge_len,
				      cube_vertex[3].y,
				      0);

	    face_five_ctrl_pts[1].set(cube_vertex[0].x+edge_len+x/3, 
				      cube_vertex[0].y - y,
				      0);

	    face_five_ctrl_pts[2].set(cube_vertex[3].x -  x/3, 
				      cube_vertex[3].y - y,
				      0 );
	}

	build_face_five();
    }


    void construct_face_five(double spineAngle)
    {
	double x= config.getBookThickness();
	double y= 0;
	double max_y= config.getSpineface5_height();
	double min_y= config.getSpineface5_height()*.1;
	double alpha= 0;
	if(spineAngle <= 0){// phase2
	    //-90 -> 0
	    alpha= Math.abs(spineAngle)/90;
	    if(Ttp.commentslevel >= 3){
		System.out.println("alpha> "+ alpha);//debug
	    }
	    y= (1-alpha)*min_y + alpha*max_y;
	}else{
	    //0 -> 90
	    alpha= spineAngle/90;
	    if(Ttp.commentslevel >= 3){
		System.out.println("alpha> "+ alpha);//debug
	    }
	    y= (1-alpha)*min_y + alpha*max_y;
	}

	if(orientation == POSITIVE){
	    
	    face_five_ctrl_pts[0].set(cube_vertex[0].x-edge_len,
				      cube_vertex[0].y, 
				      0 );
	    
	    face_five_ctrl_pts[3].set(cube_vertex[3].x+edge_len,
				      cube_vertex[3].y,
				      0);

	    face_five_ctrl_pts[1].set(cube_vertex[0].x-edge_len-x/3, 
				      cube_vertex[0].y - y,
				      0);

	    face_five_ctrl_pts[2].set(cube_vertex[3].x +  x/3, 
				      cube_vertex[3].y - y,
				      0 );
	}else{
	    face_five_ctrl_pts[0].set(cube_vertex[0].x + edge_len,
				      cube_vertex[0].y, 
				      0 );
	    
	    face_five_ctrl_pts[3].set(cube_vertex[3].x - edge_len,
				      cube_vertex[3].y,
				      0);

	    face_five_ctrl_pts[1].set(cube_vertex[0].x+edge_len+x/3, 
				      cube_vertex[0].y - y,
				      0);

	    face_five_ctrl_pts[2].set(cube_vertex[3].x -  x/3, 
				      cube_vertex[3].y - y,
				      0 );
	}

	build_face_five();
	construct_inner_side();
    }
    
    void build_face_five()
    {
	
	
	face_five_curve.setKnots(face_five_ctrl_pts);
	face_five_curve.genCurves();

	Utilities.arrayCopy(face_five_curve.getPts(0), 0, face_five_vertex[0], 0, num_face_five_vertex_x);
	
	int i, j, k;
	double z;
	double unit_len= (config.get_zMax()+config.getCoverMargin())/ (num_face_five_vertex_z-1);
	int mid=  face_five_num_row_showing/2;

	// build the 1st two row
	for(i=0; i<mid; i++){
	    for(j=0; j<num_face_five_vertex_x; j++){
		z= cube_vertex[1].z + i*unit_len;
		face_five_vertex[i][j].set(face_five_vertex[0][j].x, 
					   face_five_vertex[0][j].y,
					   z);
	    }
	}
	
	


	//construct the last two row
	for(k= num_face_five_vertex_z-mid, i=mid; i<face_five_num_row_showing; i++, k++){
	    for(j=0; j<num_face_five_vertex_x; j++){
		z= cube_vertex[1].z + k*unit_len;
		face_five_vertex[i][j].set(face_five_vertex[0][j].x, 
					   face_five_vertex[0][j].y,
					   z);
	    }
	}


	Point3d pos= new Point3d(0,0,0);
	Vector3d normal= new Vector3d(0,0,0);
	Vector3d normal_total= new Vector3d(0,0,0);
	Vector3d vCur= new Vector3d(0,0,0);
	Vector3d vLast= new Vector3d(0,0,0);
	//compute normals
	for(j= 0; j < num_face_five_vertex_x; j++){
	    vLast.sub( getNeighbour(0, j, 3, face_five_vertex, 
				    num_face_five_vertex_x, num_face_five_vertex_z), 
		       face_five_vertex[0][j]);
	    
	    for (int neighbour = 0; neighbour < 4; neighbour++) {
		//in anti-clockwised direction
		//so the normal points upwards
		vCur.sub(getNeighbour(0, j, neighbour, face_five_vertex, 
				      num_face_five_vertex_x, num_face_five_vertex_z), 
			 face_five_vertex[0][j]);

		normal.cross(vLast, vCur);
		normal_total.add(normal);
		vLast.set(vCur);
	    }

	    face_five_normals[j].normalize(normal_total);
	    normal_total.set(0,0,0); 
	    face_five_normals[j].negate();
	}
	
    }


    //temp
    public void setTextureName( int textureName)
    {  
	this.textureName= textureName; 
    }

    
    
    //debug
    void displayCubeVertex(GLCanvas canvas)
    {
	GLFunc gl = canvas.gl;
	
	int i;
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	
	gl.glPointSize(5f);
	gl.glColor3f(1.0f, 0.0f, 1.0f);

	gl.glBegin(GL_POINTS);
	for(i= 0; i < cube_vertex.length; i++ ){
	    gl.glVertex3dv(cube_vertex[i].get3dv());
	}
	gl.glEnd(); 
	gl.glPopAttrib();
    }

    void displayFace2ctrl_pts(GLCanvas canvas)
    {
	GLFunc gl = canvas.gl;
	int i;
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	
	gl.glPointSize(5f);
	gl.glColor3f(.0f, 1.0f, 1.0f);

	gl.glBegin(GL_POINTS);
	for(i= 0; i < face_two_ctrl_pts.length; i++ ){
	    gl.glVertex3dv(face_two_ctrl_pts[i].get3dv());
	}
	gl.glEnd(); 
	gl.glPopAttrib();
    }

    void displayFaceOne(GLCanvas canvas, int drawing_mode, byte command, Color3f color )
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Spine.java: displayFaceOne()" );
	}

	GLFunc gl = canvas.gl;
	
	boolean ef= false;

	switch(command){
	case LINE:{ 
	    if(Ttp.commentslevel >= 3){
		System.out.println("line");
	    }
	    ef= false;
	    break;}
	case FILL:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("fill" );
	    }

	    ef= true;
	    break;}
	}
	    

	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	
	if(ef) // polygon mode
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	else
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
		
	gl.glColor3f(color.x, color.y, color.z);
	gl.glEnable(GL_CULL_FACE);
	gl.glCullFace(GL_BACK);
 	
	if(orientation == NEGATIVE){
	    gl.glFrontFace(GL_CW); 
	}

	gl.glBegin (GL_QUADS);
	gl.glNormal3dv(face_one_normal.get3dv());
	gl.glVertex3dv(cube_vertex[7].get3dv());
	gl.glVertex3dv(cube_vertex[3].get3dv());
	gl.glVertex3dv(cube_vertex[2].get3dv());
	gl.glVertex3dv(cube_vertex[6].get3dv());
	
	gl.glEnd();
	
	gl.glPopAttrib();
    }

    void displayFaceThree(GLCanvas canvas, int drawing_mode, byte command, Color3f color )
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Spine.java: displayFaceThree()" );
	}

	GLFunc gl = canvas.gl;

	boolean ef= false;

	switch(command){
	case LINE:{ 
	    if(Ttp.commentslevel >= 3){
		System.out.println("line");
	    }
	    ef= false;
	    break;}
	case FILL:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("fill" );
	    }
	    ef= true;
	    break;}
	
	}
	
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	
	if(ef) // polygon mode
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	else
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);

	gl.glColor3f(color.x, color.y, color.z);

	gl.glEnable(GL_CULL_FACE);
	gl.glCullFace(GL_BACK);
 	
	if(orientation == NEGATIVE){
	    gl.glFrontFace(GL_CW); 
	}

	gl.glBegin (GL_QUADS);
	gl.glNormal3dv(face_three_normal.get3dv());
	gl.glVertex3dv(cube_vertex[0].get3dv());
	gl.glVertex3dv(cube_vertex[4].get3dv());
	gl.glVertex3dv(cube_vertex[5].get3dv());
	gl.glVertex3dv(cube_vertex[1].get3dv());
	gl.glEnd();
	gl.glPopAttrib();
    }

    void displayFaceTwo(GLCanvas canvas, int drawing_mode, byte command, Color3f color)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Spine.java: displayFaceTwo()" );
	}
	
	GLFunc gl = canvas.gl;
	
	int i, j;
	
	boolean ef= false, et= false; 
        double nx_intervals= num_face_two_vertex_x-1;
	double nz_intervals= num_face_two_vertex_z-1;

	switch(command){
	case LINE:{ 
	    if(Ttp.commentslevel >= 3){
		System.out.println("line");
	    }
	    ef= false; et=false;
	    break;}
	case FILL:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("fill" );
	    }
	    ef= true; et= false;
	    break;}
	
	case TEXTURE:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("texture" );
	    }

	    ef= true; et= true;
	    break;}
	
	}
	
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	
	if(ef) // polygon mode
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	else
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);

	//texture
	if(et){
	    gl.glEnable(GL_TEXTURE_2D);
	    gl.glBindTexture(GL_TEXTURE_2D, textureName);
	}else 
	    gl.glDisable(GL_TEXTURE_2D);
	
	//gl.glColor3f(color.x, color.y, color.z);
	
	for (i = 0; i < num_face_two_vertex_z - 1; i++) {
	    gl.glBegin(GL_QUAD_STRIP);
            for (j = 0; j < num_face_two_vertex_x; j++) {
		gl.glTexCoord2d( (j / nx_intervals), (i+1)/ nz_intervals );
		gl.glNormal3dv(face_two_normals[j].get3dv());
		gl.glVertex3dv(face_two_vertex[i+1][j].get3dv());
		
		gl.glTexCoord2d( (j / nx_intervals), i / nz_intervals );
		gl.glNormal3dv(face_two_normals[j].get3dv());
		gl.glVertex3dv(face_two_vertex[i][j].get3dv());
	    }
            gl.glEnd();
	}

	gl.glPopAttrib();
    }
 
    void displayFaceFive(GLCanvas canvas, int drawing_mode, byte command, Color3f color)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Spine.java: displayFaceFive()" );
	}

	GLFunc gl = canvas.gl;
	
	int i, j;
	int mid= face_five_num_row_showing/2;
	boolean ef= false;

	switch(command){
	case LINE:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("line");
	    }
	    ef= false;
	    break;}
	case FILL:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("fill" );
	    }
	    ef= true;
	    break;}
	
	}
	
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	
	if(ef) // polygon mode
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	else
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	
	//gl.glColor3f(color.x, color.y, color.z);
	
	for (i = 0; i < mid - 1; i++) {
	    gl.glBegin(GL_QUAD_STRIP);
            for (j = 0; j < num_face_five_vertex_x; j++) {
		gl.glNormal3dv(face_five_normals[j].get3dv());
		//gl.glTexCoord2d( (j / nx_intervals), (i+1) / nz_intervals );
		gl.glVertex3dv(face_five_vertex[i+1][j].get3dv());
		//gl.glTexCoord2d( (j / nx_intervals), i / nz_intervals );
		gl.glVertex3dv(face_five_vertex[i][j].get3dv());
	    }
            gl.glEnd();
	}

	for(i = mid; i <  face_five_num_row_showing - 1; i++) {
	    gl.glBegin(GL_QUAD_STRIP);
            for (j = 0; j < num_face_five_vertex_x; j++) {
		gl.glNormal3dv(face_five_normals[j].get3dv());
		//gl.glTexCoord2d( (j / nx_intervals), (i+1) / nz_intervals );
		gl.glVertex3dv(face_five_vertex[i+1][j].get3dv());
		//gl.glTexCoord2d( (j / nx_intervals), i / nz_intervals );
		gl.glVertex3dv(face_five_vertex[i][j].get3dv());
	    }
            gl.glEnd();
	}

	gl.glPopAttrib();
    }

    void displayFaceFour(GLCanvas canvas, int drawing_mode, byte command, Color3f color)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Spine.java: displayFaceFour()" );
	}
	
	GLFunc gl = canvas.gl;

	gl.glPushMatrix();
	gl.glTranslated(0,0, -config.getCoverMargin());
	//display_side(drawing_mode, command, color);
	int i;
	boolean ef= false;

	switch(command){
	case LINE:{ 
	    if(Ttp.commentslevel >= 3){
		System.out.println("line");
	    }
	    ef= false;
	    break;}
	case FILL:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("fill" );
	    }
	    ef= true;
	    break;}
	}

	
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glColor3f(color.x, color.y, color.z);

	if(orientation == NEGATIVE){
	    gl.glFrontFace(GL_CW); 
	}
	
	gl.glEnable(GL_CULL_FACE);
	gl.glCullFace(GL_BACK); 	
	if(ef){
	    gl.glEnable(GL_CULL_FACE);
	    gl.glCullFace(GL_BACK); 	
	    gl.glBegin(GL_TRIANGLE_STRIP);
	    gl.glNormal3dv(face_four_normal.get3dv());
	    for(i=0; i<  num_face_two_vertex_x; i++){
		gl.glVertex3d(inner_side_vertex[i].x,
			      inner_side_vertex[i].y,
			      0 );
		gl.glVertex3d(face_two_vertex[0][i].x,
			      face_two_vertex[0][i].y,
			      0 );
	    }
	    gl.glEnd();
	}else{
	    
	    gl.glBegin(GL_LINE_STRIP);
	    for(i=0; i<  num_face_two_vertex_x; i++){
		gl.glVertex3d(inner_side_vertex[i].x,
			      inner_side_vertex[i].y,
			      0 );
	    }
	    gl.glEnd();

	    gl.glBegin(GL_LINE_STRIP);
	    for(i=0; i<  num_face_two_vertex_x; i++){
		gl.glVertex3d(face_two_vertex[0][i].x,
			      face_two_vertex[0][i].y,
			      0 );
	    }
	    gl.glEnd();
	}
	    
	gl.glPopAttrib();
	gl.glPopMatrix();
    }

    void displayFaceSix(GLCanvas canvas, int drawing_mode, byte command, Color3f color)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Spine.java: displayFaceSix()" );
	}

	GLFunc gl = canvas.gl;
	
	gl.glPushMatrix();
	gl.glTranslated(0,0, config.get_zMax());
	//display_side(drawing_mode, command, color);
	int i;
	boolean ef= false;

	switch(command){
	case LINE:{ 
	    if(Ttp.commentslevel >= 3){
		System.out.println("line");
	    }
	    ef= false;
	    break;}
	case FILL:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("fill" );
	    }
	    ef= true;
	    break;}
	}

	
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	
	gl.glColor3f(color.x, color.y, color.z);
	if(orientation == POSITIVE){
	    gl.glFrontFace(GL_CW); 
	}
	
	gl.glEnable(GL_CULL_FACE);
	gl.glCullFace(GL_BACK); // culled here means discarded

	if(ef){
	  
	    gl.glBegin(GL_TRIANGLE_STRIP);
	    gl.glNormal3dv(face_six_normal.get3dv());
	    for(i=0; i<  num_face_two_vertex_x; i++){
		
		gl.glVertex3d(inner_side_vertex[i].x,
			      inner_side_vertex[i].y,
			      0 );
		gl.glVertex3d(face_two_vertex[0][i].x,
			      face_two_vertex[0][i].y,
			      0 );
	    }
	    gl.glEnd();
	}else{
	    gl.glBegin(GL_LINE_STRIP);
	    for(i=0; i<  num_face_two_vertex_x; i++){
		gl.glVertex3d(inner_side_vertex[i].x,
			      inner_side_vertex[i].y,
			      0 );
	    }
	    gl.glEnd();

	    gl.glBegin(GL_LINE_STRIP);
	    for(i=0; i<  num_face_two_vertex_x; i++){
		gl.glVertex3d(face_two_vertex[0][i].x,
			      face_two_vertex[0][i].y,
			      0 );
	    }
	    gl.glEnd();
	}
	    
	gl.glPopAttrib();
	gl.glPopMatrix();
    }

    void display_side(int drawing_mode, byte command, Color3f color)
    {
	

    }
    

    /*
      @param drawing_mode: 
      @param canvas: 
    */
    public void display( int drawing_mode, GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Spine.java: display()" );
	}


	GLFunc gl = canvas.gl;
	
	//displayCubeVertex();
	//displayFace2ctrl_pts();
	//face_two_curve.displayCurve(canvas, 0, new Color3f(1f, .2f, 0f));
	//face_two_curve.displayPts(canvas, 0, new Color3f(.2f, .2f, .0f));
	
	/*Two Bezier outlines*/
  	//face_five_curve.displayCurve(canvas, 0, new Color3f(1f, .2f, 0f));
  	//face_five_curve.displayPts(canvas, 0, new Color3f(.2f, .2f, .0f));
	
	
	displayFaceOne(canvas, drawing_mode, FILL, new Color3f(.0f, 1.0f, 1.0f) );
  	displayFaceTwo(canvas, drawing_mode, FILL, new Color3f(1.0f, .0f, 1.0f));
 	displayFaceThree(canvas, drawing_mode, FILL, new Color3f(1.0f, .0f, .0f));
  	displayFaceFour(canvas, drawing_mode, FILL, new Color3f(.0f, .0f, 1.0f));
  	displayFaceFive(canvas, drawing_mode, FILL, new Color3f(.3f, .2f, .3f));
  	displayFaceSix(canvas, drawing_mode, FILL, new Color3f(.0f, .0f, 1.0f));
    }
}
