package TTPproject;

import javax.vecmath.*;
import gl4java.awt.GLCanvas;
import gl4java.GLFunc;
import gl4java.GLUFunc;
import gl4java.GLEnum;

import java.util.List;
import java.util.ArrayList;// anchorPageList
import java.util.Iterator;//traverse through anchorPageList


public class StaticPage
    implements GLEnum, CONSTANTS{

    
    private Configuration config;
    
    int totalpapers; // number of papers in this stack
    int edge_name;
    int page_num_Top; //start
    int page_num_Bottom; //finish
    int topTexture; 
    int bottomTexture; 
    int pageTextureUP, pageTextureDOWN; // page material
    int start_page_num;
    int edgetexture;
    Color3f color=null; //testing 
    byte side;
    
    double elementlength= 0;
    int nx= 0, nz= 0;

    //two curves, top & bottom
    Point3d [] top=null; 
    Point3d [] bottom= null;
    
    //borders
    private Point3d [] top_topborder= null;
    private Point3d [] top_bottomborder= null;
    private Point3d [] top_leftborder= null;
    private Point3d [] top_rightborder= null;

    private Point3d [] bottom_topborder= null;
    private Point3d [] bottom_bottomborder= null;
    private Point3d [] bottom_leftborder= null;
    private Point3d [] bottom_rightborder= null;

    //anchor point
    private Point3d anchor_point= null;
    

    //top vector array
    double [] top_VA= null;
    int [] top_indices= null;
    double [] top_normals_va= null;

    //top vector array
    double [] bottom_VA= null;
    int [] bottom_indices= null;
    double [] bottom_normals_va= null;


    //side vector array
    double [] side_VA= null;
    int [] side_indices;

    //edge
    double startX= 0;
    double endX= 0;
    int startPaper, endPaper;
    Point3d [] edge_vertex= null;
    Vector3d edge_normal= null;
    Vector3d dx= null; 
    Vector3d dy= null;
    Point3d base= null;
    double height;
    double width;
    double m; // gradient
    

    //side
    Vector3d front_side_normal= null;
    Vector3d back_side_normal= null;

    //classify region 
    int first= 6; 
    int second= 12;

    //anchor pages list
    List anchorPageList= null;// a copy
    int startAnchorIndex, endAnchorIndex;
    int firstanchorPaper= 0;
    int lastanchorPaper=0;
    
    
    
    /*
      @param config: 
    */
    public StaticPage(Configuration config, int edge_name)
    {
	this.config= config;
	this.edge_name= edge_name;
	
	nx= config.get_nx();
	nz= config.get_nz();
	elementlength= config.get_elementLength();
	
	int i;
	top= new Point3d[nx];
	bottom= new Point3d[nx];
	for(i=0; i<nx; i++){
	    top[i]= new Point3d(0,0,0);
	    bottom[i]= new Point3d(0,0,0);
	}
		
	top_VA= new double[nx*nz*3];
	top_indices= new int[nx*nz];
	top_normals_va= new double[nx*nz*3];
	
	bottom_VA= new double[nx*nz*3];
	bottom_indices= new int[nx*nz];
	bottom_normals_va= new double[nx*nz*3];
	

	side_VA= new double[nx*2*3];
	side_indices= new int[nx*2*3];
	
	//page edge
	edge_normal= new Vector3d(0,0,0);
	base= new Point3d(0,0,0);
	dx= new Vector3d(0,0,0);
	dy= new Vector3d(0,0,0);

	edge_vertex= new Point3d[4];
	for(i=0; i< edge_vertex.length; i++){
	    edge_vertex[i]= new Point3d(0,0,0);
	}
	
	front_side_normal= new Vector3d(0,0,1);
	back_side_normal= new Vector3d(0,0,-1);

	top_topborder= new Point3d [nx];
	top_bottomborder= new Point3d [nx];
	top_leftborder= new Point3d [nz];
	top_rightborder= new Point3d [nz];
	
	bottom_topborder= new Point3d [nx];
	bottom_bottomborder= new Point3d [nx];
	bottom_leftborder= new Point3d [nz];
	bottom_rightborder= new Point3d [nz];
	
	for(int col= 0; col < nx; col++){
	    top_topborder[col]= new Point3d(0,0,0);
	    bottom_topborder[col]= new Point3d(0,0,0);
	    top_bottomborder[col]= new Point3d(0,0,0);
	    bottom_bottomborder[col]= new Point3d(0,0,0);
	}

	for(int row= 0; row < nz; row++){
	    top_leftborder[row]= new Point3d(0,0,0);
	    bottom_leftborder[row]= new Point3d(0,0,0);
	    top_rightborder[row]= new Point3d(0,0,0);
	    bottom_rightborder[row]= new Point3d(0,0,0);
	}

	//anchors
	anchor_point= new Point3d(0,0,0);
	this.anchorPageList= new ArrayList(); //empty list with an initial capacity 10
	
    } 

    //almost deprecated
    public void setAll(int page_num, int texName, int edgetexture,
		       int pageTexture,
		       Color3f color, byte side)
    {
	this.page_num_Top= page_num;
	this.pageTextureUP= pageTexture;
	setPage_num(texName, page_num_Top);
	this.edgetexture= edgetexture;
	setcolor(color);
	setSide(side);
    }

    public void setPapers(int papers)
    {
	this.totalpapers= papers;
    }

    public void setPageAnchors(List anchorPageList)
    {
	this.anchorPageList= new ArrayList(anchorPageList);
	int anchorPage;
	int size= anchorPageList.size();
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("****anchor size= " + size );
	}

	anchorPage= ((Integer)anchorPageList.get(size-1)).intValue();
	lastanchorPaper= anchorPage/2 + 1;
	anchorPage= ((Integer)anchorPageList.get(0)).intValue(); 
	firstanchorPaper = anchorPage/2 + 1;
    }

    public int getPageMaterial()//changed
    {
	return pageTextureUP; 
    }
    
    public void setMaterial(int pageTexture, int edgetexture)
    {
	//this.pageTexture= pageTexture;
	setPageMaterialUP(pageTexture);
	this.edgetexture= edgetexture;
    }
    
    public void setPageMaterialUP(int pageTexture)
    {
	this.pageTextureUP= pageTexture;
    }

    public void setPageMaterialDOWN(int pageTexture)
    {
	this.pageTextureDOWN= pageTexture;
    }


    /*
      public void setAll(int page_num, int start, int edgetexture,
	  	         int pageTexture,
		         Color3f color, byte side)
      {
	this.page_num= page_num;
	this.start_page_num= start;
	this.pageTexture= pageTexture;
	setPage_num(page_num);
	this.edgetexture= edgetexture;
	setcolor(color);
	setSide(side);
	}
    */
    
    /*
      public void setPage_num( int page_no)
     { 
	this.page_num= page_no;
	this.topTexture= page_num % 4 + start_page_num;
	}
    */

    public void setPage_num( int texName, int  page_no)
    {
	this.page_num_Top= page_no;
	this.topTexture= texName; 
    }
    
    public void setPage_num2(int page_noTop, int page_noBottom,  int texNameTop, 
			     int texNameBottom)
    {
	setPageUPContent(page_noTop,
			 texNameTop);

	setPageUPContent(page_noBottom,
			 texNameBottom);
	
    }

    public void setPageUPContent(int page_noTop, 
				 int texNameTop )
    {
	setPageUPPageName(page_noTop );
	setPageUPTexture(texNameTop);
    }

    public void setPageUPTexture(int texNameTop )
    {
	this.topTexture= texNameTop; 
    }

    /*
      initialize
      page_num_Top
      startPaper
    */
    public void setPageUPPageName(int page_no_top )
    {
	this.page_num_Top= page_no_top;
	
	if(side == RIGHT){
	    this.startPaper= page_num_Top/2 + 1;
	    searchStartAnchorIndex();
	    if(Ttp.commentslevel >= 3){
		System.out.println("startPaper= " + endPaper );
	    }
	}else if(side == LEFT){
	    this.endPaper= page_num_Top/2 + 1;
	    searchEndAnchorIndex();
	    if(Ttp.commentslevel >= 3){
		System.out.println("endPaper= " + endPaper );
	    }
	}
	

    }

   
    /*
      called through threadA used for animate
     */
    public void updatePageUPContent(int page_noTop, 
				    int texNameTop )
    {
	this.page_num_Top= page_noTop;
	this.topTexture= texNameTop; 
    }

    public void setPageDOWNContent(int page_noBottom, 
				   int texNameBottom)
    {
	setPageDOWNPageName(page_noBottom);
	setPageDOWNTexture(texNameBottom);
    }

    public void setPageDOWNTexture(int texNameBottom )
    {
	this.bottomTexture= texNameBottom; 
    }
    
    public void setPageDOWNPageName(int page_noBottom )
    {
	this.page_num_Bottom= page_noBottom;
	if(side == RIGHT){
	    this.endPaper= page_num_Bottom/2 + 1;
	    searchEndAnchorIndex();
	    
	    if(Ttp.commentslevel >= 3){
		System.out.println("endPaper= " + endPaper );
	    }
	}else if(side == LEFT){
	    this.startPaper= page_num_Bottom/2 + 1;
	    searchStartAnchorIndex();
	   
	    if(Ttp.commentslevel >= 3){
		System.out.println("startPaper= " + endPaper );
	    }
	}
    }

    public void setStartX(double startX)
    {
	this.startX= startX;
    }
    
    public void setEndX(double endX)
    {
	this.endX= endX;
    }


    public void setcolor( Color3f color )
    { 
	this.color= new Color3f(color);
    }

    public void setSide(byte side)
    {
	this.side= side;
    }
   
    public int getPage_num(){ return page_num_Top; }
    public int getTextureName(){ return topTexture; }
    public Color3f getcolor(){ return  new Color3f(color);}
  
    public void genModel(Point3d [] t, Point3d [] b)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("StaticPage: genModel()" );
	}
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("\t1st top= " + t[0].toString());
	    System.out.println("\t1st bottom= "+ b[0].toString());
	}
	
	System.arraycopy(t, 0, top, 0, t.length);
	
	Utilities.arrayCopy(t, 0, top, 0, t.length);
	//System.arraycopy(b, 0, bottom, 0, b.length);
	Utilities.arrayCopy(b, 0, bottom, 0, b.length);

	genTopSurface();
	genBottomSurface();
	genSide();
	genEdge();
		
    }

    public void genModel2(Point3d [] t, Point3d [] b)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("StaticPage: genModel2()" );
	}
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("\t1st top= " + t[0].toString());
	    System.out.println("\t1st bottom= "+ b[0].toString());
	}
	
	System.arraycopy(t, 0, top, 0, t.length);	
	Utilities.arrayCopy(t, 0, top, 0, t.length);
	//System.arraycopy(b, 0, bottom, 0, b.length);
	Utilities.arrayCopy(b, 0, bottom, 0, b.length);

	genTopSurface();
	genBottomSurface();
	genSide();
	genEdge();
	
    }

    public void destroyModel()
    {
	destroyTopSurface();
	destroyBottomSurface();
	destroySide();
	destroyEdge();
	
	for(int col= 0; col < nx; col++){
	    top_topborder[col].set(0,0,0);
	    bottom_topborder[col].set(0,0,0);
	    top_bottomborder[col].set(0,0,0);
	    bottom_bottomborder[col].set(0,0,0);
	}

	for(int row= 0; row < nz; row++){
	    top_leftborder[row].set(0,0,0);
	    bottom_leftborder[row].set(0,0,0);
	    top_rightborder[row].set(0,0,0);
	    bottom_rightborder[row].set(0,0,0);
	}

    }

    void destroyTopSurface()
    {
	int i, j, n, m;
	
	for(i= 0; i < nz; i++){
	    for(j= 0; j < nx; j++){
		n= i*nx + j;
		m= n * 3;
		top_VA[m]= 0;
		top_VA[m+1]= 0;
		top_VA[m+2]= 0;
		top_indices[n]= n;
	    }
	}

    }
    
    void destroyBottomSurface()
    {
	int i, j, n, m;
	for(i= 0; i < nz; i++){
	    for(j= 0; j < nx; j++){
		n= i*nx + j;
		m= n * 3;
		bottom_VA[m]= 0;
		bottom_VA[m+1]= 0;
		bottom_VA[m+2]= 0;
		bottom_indices[n]= n;
	    }
	}
    }

    void destroySide()
    {
	int i, j, n;
	
	for(i=0, j=0 ; i<nx; i++){
	    n= j*3;
	    side_VA[n]= 0;
	    side_VA[n+1]= 0;
	    side_VA[n+2]= 0;
	    side_indices[j]= j;
	    j++;

	    n= j*3;
	    side_VA[n]= 0;
	    side_VA[n+1]= 0;
	    side_VA[n+2]= 0;
	    side_indices[j]= j;
	    j++;
	}

    }

    void destroyEdge()
    {
	edge_vertex[0].set(0,0,0);
	edge_vertex[1].set(0,0,0);
	edge_vertex[2].set(0,0,0);
	edge_vertex[3].set(0,0,0);

    }

    
  

    void genBottomSurface()
    {
	int i, j, n, m;

	for(i= 0; i < nz; i++){
	    for(j= 0; j < nx; j++){
		n= i*nx + j;
		m= n * 3;
		bottom_VA[m]= bottom[j].x;
		bottom_VA[m+1]= bottom[j].y;
		bottom_VA[m+2]= i * elementlength;
		bottom_indices[n]= n;
		
		if(i == 0 ){
		    bottom_topborder[j].set(bottom_VA[m],
					    bottom_VA[m+1],
					    bottom_VA[m+2]);
		    
		}
		
		if(i == (nz-1) ){
		    bottom_bottomborder[j].set(bottom_VA[m],
					       bottom_VA[m+1],
					       bottom_VA[m+2]);
		}

		if(j == 0 ){
		    bottom_leftborder[i].set(bottom_VA[m],
					     bottom_VA[m+1],
					     bottom_VA[m+2]);
		}

		if(j == (nx-1) ){
		    bottom_rightborder[i].set(bottom_VA[m],
					      bottom_VA[m+1],
					      bottom_VA[m+2]);
		}
	    }
	}

	Point3d curPos= new Point3d(0,0,0);
	Vector3d normal= new Vector3d(0,0,0);
	Vector3d normal_total= new Vector3d(0,0,0);
	Vector3d vCur= new Vector3d(0,0,0);
	Vector3d vLast= new Vector3d(0,0,0);

	//compute normals
	for(j=0; j<nx; j++){
	    m= j*3;
	    curPos.set(bottom_VA[m], bottom_VA[m+1], bottom_VA[m+2] );
	    vLast.sub( getNeighbour(0,j,3), curPos );
	    for (int neighbour = 0; neighbour < 4; neighbour++) {
		//in anti-clockwised direction
		//so the normal points upwards
		vCur.sub(getNeighbour(0,j, neighbour), curPos);
		normal.cross(vLast, vCur);
		normal_total.add(normal);
		vLast.set(vCur);
	    }
	    normal_total.normalize();
	  
	    if(side == RIGHT) normal_total.negate();
	   
	    bottom_normals_va[m]= normal_total.x;
	    bottom_normals_va[m+1]= normal_total.y;
	    bottom_normals_va[m+2]= normal_total.z;

	    normal_total.set(0,0,0);
	}

	int from;
	for(i=1; i< nz; i++){
	    for(j=0; j<nx; j++){
		from= j*3;
		m= (i*nx+j)*3;
		
		bottom_normals_va[m]= bottom_normals_va[from];
		bottom_normals_va[m+1]= bottom_normals_va[from+1];
		bottom_normals_va[m+2]= bottom_normals_va[from+2];
	    }
	}

    }
    

    /*
      For anchor display
      What needs to initialize before turning
      
      Inputs are 
      (1)startX: So the new base starts with 
                        (edge_vertex[2].x, edge_vertex[2].y, edge_vertex[2].z + displacementX) 
      (2)startPaper: 
      (3)endPaper: given these two, we worked out totalPapers
      

      What varies during pages turning
      (1) its(edge) height
     */

    void genEdge()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("StaticPage: genEdge()" );
	}
	double pl= config.getPaperHeight();
	double pt= config.getPaperThickness();
	double edge_thickness; //work out distance between top 2 and top 1
	Vector3d a= new Vector3d(0,0,0); 
	Vector3d b= new Vector3d(0,0,0);
		
	
	edge_vertex[0].set(bottom[nx-1].x,
			   bottom[nx-1].y,
			   pl);
	edge_vertex[1].set(bottom[nx-1].x,
			   bottom[nx-1].y,
			   0);
	edge_vertex[2].set(top[nx-1].x,
			   top[nx-1].y,
			   0);
	edge_vertex[3].set(top[nx-1].x,
			   top[nx-1].y,
			   pl);
	
	

	//a.sub(edge_vertex[1], edge_vertex[0]);
	//b.sub(edge_vertex[3], edge_vertex[0]);
	if(side == RIGHT){
	    //normal
	    a.sub(edge_vertex[0], edge_vertex[3]);
	    b.sub(edge_vertex[2], edge_vertex[3]);
	    edge_normal.cross(a,b);
	    edge_normal.normalize();
	    
	    //test anchor point
	    dx.sub(edge_vertex[3], edge_vertex[2]);
	    dy.sub(edge_vertex[1], edge_vertex[2]);
	    dx.normalize();
	    dy.normalize();
	    
	    //height & width
	    height= edge_vertex[2].distance(edge_vertex[1]);
	    
	    if(height < pt) height= pt;// implies only 1 paper

	    //width= pl-startX-endX;
	    width= pl-startX-endX;
	    
	    m= height/width; 
	    if(Ttp.commentslevel >= 3){
		System.out.println("startX= " + startX);
		System.out.println("endY= " + endX);
		System.out.println("height= " + height );
		System.out.println("width= " + width );
		System.out.println("m= " + m );
	    }
	    
	    base.set(edge_vertex[2].x,
		     edge_vertex[2].y,
		     edge_vertex[2].z + startX);
	    //lift up base point 
	    Vector3d v= new Vector3d(0,0,0);
	    v.scale( 0.1, edge_normal);
	    base.add(v);
	    
	    
	}else{
	    //normal ? 
	    a.sub(edge_vertex[0], edge_vertex[3]);
	    b.sub(edge_vertex[2], edge_vertex[3]);
	    edge_normal.cross(a,b);
	    edge_normal.normalize();
	    
	    //direction vectors
	    dx.sub(edge_vertex[0], edge_vertex[1]);
	    dy.sub(edge_vertex[2], edge_vertex[1]);
	    dx.normalize();
	    dy.normalize();

	    //height & width
	    height= edge_vertex[1].distance(edge_vertex[2]);
	    if(height < pt) height= pt;// implies only 1 paper

	    //width= pl-startX-endX;
	    width= pl-startX-endX;
	    	    
	    //gradient
	    m= height/width; 
	    
	    if(Ttp.commentslevel >= 3){
		System.out.println("startX= " + startX);
		System.out.println("endY= " + endX);
		System.out.println("height= " + height );
		System.out.println("width= " + width );
		System.out.println("m= " + m );
	    }
	    
	    //anchor starting point
	    base.set(edge_vertex[1].x,
		     edge_vertex[1].y,
		     edge_vertex[1].z + startX);
	    //lift up the base point
	    Vector3d v= new Vector3d(0,0,0);
	    v.scale( -0.1, edge_normal);
	    base.add(v);

	}
    }

    Point3d getNeighbour(int row, int col, int neighbour) 
    {
        int dx = 0, dz = 0;
	int n,m;
	Point3d pts= new Point3d(0,0,0);

        switch(neighbour) {
	case 0: dx = 1; break; // right
	case 1: dz = -1; break; // up
	case 2: dx = -1; break; // left
	case 3: dz = 1; break; // down
        }
        
	int x = col + dx, z = row + dz;
        if (x < 0 || z < 0 || z >= nz || x >= nx)
	    n= row*nx + col;
	else
	    n= z*nx + x;
		
	m= n*3;
	pts.set(top_VA[m], top_VA[m+1], top_VA[m+2]);
	return pts;
    }


    void genTopSurface()
    {
	int i, j, n, m;
	
	for(i= 0; i < nz; i++){
	    for(j= 0; j < nx; j++){

		n= i*nx + j;
		m= n * 3;
		top_VA[m]= top[j].x;
		top_VA[m+1]= top[j].y;
		top_VA[m+2]= i * elementlength;
		top_indices[n]= n;
		
		if(i == 0 ){
		    top_topborder[j].set(top_VA[m],
					 top_VA[m+1],
					 top_VA[m+2]);
		    
		}
		
		if(i == (nz-1) ){
		    top_bottomborder[j].set(top_VA[m],
					    top_VA[m+1],
					    top_VA[m+2]);
		}

		if(j == 0 ){
		    top_leftborder[i].set(top_VA[m],
					  top_VA[m+1],
					  top_VA[m+2]);
		}

		if(j == (nx-1) ){
		    top_rightborder[i].set(top_VA[m],
					   top_VA[m+1],
					   top_VA[m+2]);
		}
	    }
	}

	Point3d curPos= new Point3d(0,0,0);
	Vector3d normal= new Vector3d(0,0,0);
	Vector3d normal_total= new Vector3d(0,0,0);
	Vector3d vCur= new Vector3d(0,0,0);
	Vector3d vLast= new Vector3d(0,0,0);

	//compute normals
	for(j=0; j<nx; j++){
	    m= j*3;
	    curPos.set(top_VA[m], top_VA[m+1], top_VA[m+2] );
	    vLast.sub( getNeighbour(0,j,3), curPos );
	    for (int neighbour = 0; neighbour < 4; neighbour++) {
		//in anti-clockwised direction
		//so the normal points upwards
		vCur.sub(getNeighbour(0,j, neighbour), curPos);
		normal.cross(vLast, vCur);
		normal_total.add(normal);
		vLast.set(vCur);
	    }
	    normal_total.normalize();
	  
	    if(side == LEFT) normal_total.negate();
	   
	    top_normals_va[m]= normal_total.x;
	    top_normals_va[m+1]= normal_total.y;
	    top_normals_va[m+2]= normal_total.z;

	    normal_total.set(0,0,0);
	}

	int from;
	for(i=1; i< nz; i++){
	    for(j=0; j<nx; j++){
		from= j*3;
		m= (i*nx+j)*3;
		
		top_normals_va[m]= top_normals_va[from];
		top_normals_va[m+1]= top_normals_va[from+1];
		top_normals_va[m+2]= top_normals_va[from+2];
	    }
	}
	
	
    }

    void genSide()
    {
	int i, j, n;
	
	for(i=0, j=0 ; i<nx; i++){
	    n= j*3;
	    side_VA[n]= top[i].x;
	    side_VA[n+1]= top[i].y;
	    side_VA[n+2]= 0;
	    side_indices[j]= j;
	    j++;

	    n= j*3;
	    side_VA[n]= bottom[i].x;
	    side_VA[n+1]= bottom[i].y;
	    side_VA[n+2]= 0;
	    side_indices[j]= j;
	    j++;
	}
	
    }
    
    public void drawBorder(GLCanvas canvas)
    {
	GLFunc gl = canvas.gl;
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glLineWidth(1.5f);

	//top
	gl.glBegin (GL_LINE_STRIP);
	for(int i= 0; i < nx; i++){
	    gl.glVertex3dv(top_topborder[i].get3dv());
	}
	gl.glEnd();
	
	gl.glBegin (GL_LINE_STRIP);
	for(int i= 0; i < nx; i++){
	    gl.glVertex3dv(bottom_topborder[i].get3dv());
	}
	gl.glEnd();
	

	//bottom
	gl.glBegin (GL_LINE_STRIP);
	for(int i= 0; i < nx; i++){
	    gl.glVertex3dv(top_bottomborder[i].get3dv());
	}
	gl.glEnd();

	gl.glBegin (GL_LINE_STRIP);
	for(int i= 0; i < nx; i++){
	    gl.glVertex3dv(bottom_bottomborder[i].get3dv());
	}
	gl.glEnd();

	//left
	gl.glBegin (GL_LINE_STRIP);
	for(int i= 0; i < nz; i++){
	    gl.glVertex3dv(top_leftborder[i].get3dv());
	}
	gl.glEnd();
	
	gl.glBegin (GL_LINE_STRIP);
	for(int i= 0; i < nz; i++){
	    gl.glVertex3dv(bottom_leftborder[i].get3dv());
	}
	gl.glEnd();
	
	//right
	gl.glBegin (GL_LINE_STRIP);
	for(int i= 0; i < nz; i++){
	    gl.glVertex3dv(top_rightborder[i].get3dv());
	}
	gl.glEnd();

	gl.glBegin (GL_LINE_STRIP);
	for(int i= 0; i < nz; i++){
	    gl.glVertex3dv(bottom_rightborder[i].get3dv());
	}
	gl.glEnd();
	
	gl.glPopAttrib();
    }

    
    /*
      @param drawing_mode: 
      @param canvas: 
    */
    public void display(int drawing_mode, GLCanvas canvas)
    {
	
	if(Ttp.commentslevel >= 2){
	    System.out.println("Static.java: display()");
	}
	
	GLFunc gl = canvas.gl;
	int i;
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glLineWidth(1);
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, config.getPageColor());
        gl.glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, config.getPageSpecularColor());
        gl.glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, config.getPageShiness());
		
	displayBack(canvas, drawing_mode, TEXTURE, new Color3f(1.0f, 1.0f, 1.0f));
	displayEdge(canvas, TEXTURE, new Color3f(1.0f, 1.0f, 1.0f));	
	displayFront(canvas, drawing_mode, TEXTURE, new Color3f(1.0f, 1.0f, 1.0f));
	displayTop(canvas, drawing_mode,TEXTURE , new Color3f(1.0f, 1.0f, 1.0f));
	gl.glPopAttrib();

	
	float [] black= {0.0f, 0.0f, 0.0f, 1.0f};
	gl.glPushAttrib(canvas.GL_ALL_ATTRIB_BITS); 
	gl.glMaterialfv(canvas.GL_FRONT_AND_BACK, canvas.GL_AMBIENT_AND_DIFFUSE, black);
	gl.glLoadName(NONE);
	drawBorder(canvas);
	gl.glPopAttrib();

	//anchors
	if(config.displayAnchorpoint){
	    if(endAnchorIndex == NONE || startAnchorIndex== NONE){
	    
	    }else{
		drawAnchors(canvas);
	    }
	}
    }

    public void display2(int drawing_mode, GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Static.java: display2()");
	}
	
	GLFunc gl = canvas.gl;
	int i;
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glLineWidth(1);
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, config.getPageColor());
        gl.glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, config.getPageSpecularColor());
        gl.glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, config.getPageShiness());
		
	displayBack(canvas, drawing_mode, TEXTURE, new Color3f(1.0f, 1.0f, 1.0f));
	displayEdge(canvas, TEXTURE, new Color3f(1.0f, 1.0f, 1.0f));	
	displayFront(canvas, drawing_mode, TEXTURE, new Color3f(1.0f, 1.0f, 1.0f));
	displayTop(canvas, drawing_mode,TEXTURE , new Color3f(1.0f, 1.0f, 1.0f));
	displayBottom(canvas, drawing_mode,TEXTURE , new Color3f(1.0f, 1.0f, 1.0f));
	
	gl.glPopAttrib();
	
	float [] black= {0.0f, 0.0f, 0.0f, 1.0f};
	gl.glPushAttrib(canvas.GL_ALL_ATTRIB_BITS); 
	gl.glMaterialfv(canvas.GL_FRONT_AND_BACK, canvas.GL_AMBIENT_AND_DIFFUSE, black);
	gl.glLoadName(NONE);
	drawBorder(canvas);
	gl.glPopAttrib();

	//anchors
	if(config.displayAnchorpoint){
	    if(endAnchorIndex == NONE || startAnchorIndex == NONE){
	    
	    }else{
		drawAnchors(canvas);
	    }
	}
    }
    

    void displayTop(GLCanvas canvas, int drawing_mode, byte command, Color3f color)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Static.java: displayTop()");
	}
	
	GLFunc gl = canvas.gl;
	
	int i, j, n;
	
	boolean ef= false, et= false;
	double nx_intervals= nx - 1.0;
	double nz_intervals= nz - 1.0;
	
	switch(command){
	case LINE:{ 
	    if(Ttp.commentslevel >= 3){
		System.out.println("line");
	    }
	    ef= false; et=false;
	    break;}
	case FILL:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("fill" );
	    }
	    ef= true; et=false;
	    break;}
	case TEXTURE:{ 
	    if(Ttp.commentslevel >= 3){
		System.out.println("texture" );
	    }
	    // correct mapping will be hard
	    ef= true; et=true;
	    break;}
	}
	
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glPushClientAttrib(GL_ALL_CLIENT_ATTRIB_BITS);

	if (drawing_mode == GL_SELECT) gl.glLoadName(page_num_Top);
	gl.glEnableClientState(GL_VERTEX_ARRAY); 
	gl.glEnableClientState(GL_NORMAL_ARRAY); 
	gl.glVertexPointer (3, GL_DOUBLE, 0, top_VA);
	gl.glNormalPointer(GL_DOUBLE, 0, top_normals_va);

	if(ef)
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	else
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);

	if(et){
	    //gl.glEnable(GL_TEXTURE_2D);
	    //gl.glBindTexture(GL_TEXTURE_2D, topTexture);
	    gl.glActiveTextureARB(GL_TEXTURE0_ARB);
	    gl.glEnable(GL_TEXTURE_2D);
	    gl.glBindTexture(GL_TEXTURE_2D, topTexture);
	    
	    gl.glActiveTextureARB(GL_TEXTURE1_ARB);
	    gl.glEnable(GL_TEXTURE_2D);
	    gl.glBindTexture(GL_TEXTURE_2D, pageTextureUP);
   	}
	else 
	    gl.glDisable(GL_TEXTURE_2D);

	//gl.glColor3fv(color.get3fv());
	if(side == LEFT){
	    gl.glFrontFace(GL_CW); 
	}
	
	gl.glEnable(GL_CULL_FACE);
	gl.glCullFace(GL_BACK); 	
	
	for(i=0; i< nz-1; i++){
	    if (drawing_mode == GL_SELECT)gl.glPushName(i);
	    gl.glBegin(GL_QUAD_STRIP);
	    for(j=0; j< nx; j++){
  		n= i*nx + j;

		switch(config.imageformat){
		case PNG:
		    //png
		    //System.out.println("PNG"); 
		    if(side == RIGHT){
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -i / nz_intervals);
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -i / nz_intervals);
		    }else{
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -i / nz_intervals);
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -i / nz_intervals);
		    }
		    
		    break;
		case JPEG:
		    //jpeg
		    //System.out.println("JPEG"); 
		    if(side == RIGHT){
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, j/nx_intervals, i / nz_intervals);
		    }else{
			//need to change
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -j/nx_intervals, i / nz_intervals);
		    }
		    
		    break;
		case TGA:{
		    //System.out.println("TGA"); 
		    if(side == RIGHT){
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -i / nz_intervals);
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -i / nz_intervals);
		    }else{
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -i / nz_intervals);
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, -(j / nx_intervals), -i / nz_intervals);
		    }
		    break;
		}
		}

		gl.glArrayElement(top_indices[n]);

		switch(config.imageformat){
		case PNG:
		    //System.out.println("PNG"); 
		    //png
		    if(side == RIGHT){
			//gl.glTexCoord2d( (j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
		    }else{
			//gl.glTexCoord2d( -(j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
		    }
		    
		    break;
		case JPEG:
		    //System.out.println("JPEG"); 
		    
		    //jpeg
		    if(side == RIGHT){
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, j /nx_intervals, (i+1) / nz_intervals);

		    }else{
			//need to change
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -j /nx_intervals, (i+1) / nz_intervals);

		    }

		    break;
		case TGA:{
		    //System.out.println("TGA"); 
		    if(side == RIGHT){
			//gl.glTexCoord2d( (j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
			//gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -(i+1) / nz_intervals );
		    }else{
			//gl.glTexCoord2d( -(j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -(i+1) / nz_intervals );
			//gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, -(j / nx_intervals), -(i+1) / nz_intervals );
		    }
		    //not yet implemented
		    break;
		}
		}
		
		gl.glArrayElement(top_indices[n+nx]);
		
	    }
	    gl.glEnd();
	    if (drawing_mode == GL_SELECT)gl.glPopName ();

	}
	
	//gl.glDisableClientState(GL_VERTEX_ARRAY); 
	//gl.glDisableClientState(GL_NORMAL_ARRAY);		      
	gl.glPopClientAttrib(); 
	gl.glPopAttrib();
    }
   
    void displayBottom(GLCanvas canvas, int drawing_mode, byte command, Color3f color)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Static.java: displayBottom()");
	}

	GLFunc gl = canvas.gl;
	
	int i, j, n;
	
	boolean ef= false, et= false;
	double nx_intervals= nx - 1.0;
	double nz_intervals= nz - 1.0;
	
	switch(command){
	case LINE:{ 
	    if(Ttp.commentslevel >= 3){
		System.out.println("line");
	    }
	    ef= false; et=false;
	    break;}
	case FILL:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("fill" );
	    }
	    ef= true; et=false;
	    break;}
	case TEXTURE:{ 
	    if(Ttp.commentslevel >= 3){
		System.out.println("texture" );
	    }
	    // correct mapping will be hard
	    ef= true; et=true;
	    break;}
	}
	
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glPushClientAttrib(GL_ALL_CLIENT_ATTRIB_BITS);

	if (drawing_mode == GL_SELECT) gl.glLoadName(page_num_Bottom);
	gl.glEnableClientState(GL_VERTEX_ARRAY); 
	gl.glEnableClientState(GL_NORMAL_ARRAY); 
	gl.glVertexPointer (3, GL_DOUBLE, 0, bottom_VA);
	gl.glNormalPointer(GL_DOUBLE, 0, bottom_normals_va);

	if(ef)
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	else
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);

	if(et){
	    //gl.glEnable(GL_TEXTURE_2D);
	    //gl.glBindTexture(GL_TEXTURE_2D, bottomTexture);
	    gl.glActiveTextureARB(GL_TEXTURE0_ARB);
	    gl.glEnable(GL_TEXTURE_2D);
	    gl.glBindTexture(GL_TEXTURE_2D, bottomTexture);
   
	    gl.glActiveTextureARB(GL_TEXTURE1_ARB);
	    gl.glEnable(GL_TEXTURE_2D);
	    gl.glBindTexture(GL_TEXTURE_2D, pageTextureDOWN);
   	}
	else 
	    gl.glDisable(GL_TEXTURE_2D);

	//gl.glColor3fv(color.get3fv());
	if(side == RIGHT){
	    gl.glFrontFace(GL_CW); 
	}
	
	gl.glEnable(GL_CULL_FACE);
	gl.glCullFace(GL_BACK); 	
	
	for(i=0; i< nz-1; i++){
	    if (drawing_mode == GL_SELECT)gl.glPushName(i);
	    gl.glBegin(GL_QUAD_STRIP);
	    for(j=0; j< nx; j++){
  		n= i*nx + j;

		switch(config.imageformat){
		case PNG:
		    //png
		    //System.out.println("PNG"); 
		    if(side == LEFT){
			//gl.glTexCoord2d( (j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -i / nz_intervals);
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -i / nz_intervals);
		    }else{
			//gl.glTexCoord2d( -(j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -i / nz_intervals);
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -i / nz_intervals);
		    }
		    break;

		case JPEG:
		    //jpeg
		    //System.out.println("JPEG"); 
		    if(side == LEFT){
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, j/nx_intervals, i / nz_intervals);
		    }else{
			//need to change
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -j/nx_intervals, i / nz_intervals);
		    }
		    
		    break;
		case TGA:{
		    //System.out.println("TGA");
		    if(side == LEFT){
			//gl.glTexCoord2d( (j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (j / nx_intervals), -i / nz_intervals);
			//gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -i / nz_intervals);
		    }else{
			//gl.glTexCoord2d( -(j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -i / nz_intervals);
			//gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, -(j / nx_intervals), -i / nz_intervals);
		    }
		    break;
		}
		}

		gl.glArrayElement(bottom_indices[n]);


		switch(config.imageformat){
		case PNG:
		    //png
		    //System.out.println("PNG"); 
		    if(side == LEFT){ // selected side
			//gl.glTexCoord2d( (j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB,  (j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -(i+1) / nz_intervals);
		    }else{
			//gl.glTexCoord2d( -(j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -(i+1) / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -(i+1) / nz_intervals);
		    }
		    break;

		case JPEG:
		    //jpeg
		    //System.out.println("JPEG"); 
		    if(side == LEFT){
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, j /nx_intervals, (i+1) / nz_intervals);
			
		    }else{
			//need to change
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -j /nx_intervals, (i+1) / nz_intervals);
			
		    }
		    
		    break;
		case TGA:{
		    //System.out.println("TGA"); 
		    
		    if(side == LEFT){
			//gl.glTexCoord2d( (j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB,  (j / nx_intervals), -(i+1) / nz_intervals );
			//gl.glMultiTexCoord2dARB(GL_TEXTURE1_ARB, (j / nx_intervals), -i / nz_intervals);
		    }else{
			//gl.glTexCoord2d( -(j / nx_intervals), -i / nz_intervals );
			gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, -(j / nx_intervals), -(i+1) / nz_intervals );
			
		    }
		    //not yet implemented
		    break;
		}
		}
		
		gl.glArrayElement(bottom_indices[n+nx]);
		
	    }
	    gl.glEnd();
	    if (drawing_mode == GL_SELECT)gl.glPopName();

	}
	
	//gl.glDisableClientState(GL_VERTEX_ARRAY); 
	//gl.glDisableClientState(GL_NORMAL_ARRAY);		      
	gl.glPopClientAttrib(); 
	gl.glPopAttrib();
    }

    void displayBack(GLCanvas canvas, int drawing_mode, byte command, Color3f color)
    {
	GLFunc gl = canvas.gl;

	if (drawing_mode == GL_SELECT) gl.glLoadName(NONE);
	//displaySide(command, color, back_side_normal);
	int i, n=0;
	
	boolean ef= false, et= false;
	
	switch(command){
	case LINE:{ 
	    //System.out.println("line");
	    ef= false; et=false;
	    break;}
	case FILL:{
	    //System.out.println("fill" );
	    ef= true; et=false;
	    break;}
	case TEXTURE:{ 
	    //System.out.println("texture" );
	    // correct mapping will be hard
	    ef= true; et=true;
	    break;}
	}
	
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glEnableClientState(GL_VERTEX_ARRAY); 
	gl.glVertexPointer (3, GL_DOUBLE, 0, side_VA);
	gl.glColor3fv(color.get3fv());

	if(ef){
	   if(side == RIGHT){
		gl.glFrontFace(GL_CW); 
	    }
	    
	    gl.glBegin(GL_TRIANGLE_STRIP);
	    gl.glNormal3dv(back_side_normal.get3dv());
	    for(i=0; i< nx; i++){
		n=i*2;
		gl.glArrayElement(side_indices[n]);
		gl.glArrayElement(side_indices[n+1]);
	    }
	    gl.glEnd();
	}else{
	    
	    //top row 
	    gl.glBegin(GL_LINE_STRIP);
	    for(i=0; i< nx; i++){
		n=i*2;
		gl.glArrayElement(side_indices[n]);
	    }
	    gl.glEnd();
	    
	    //bottom row
	    gl.glBegin(GL_LINE_STRIP);
	    gl.glArrayElement(side_indices[0]);
	    for(i=0; i< nx; i++){
		n=i*2+1;
		gl.glArrayElement(side_indices[n]);
	    }
	    gl.glArrayElement(side_indices[n-1]);
	    gl.glEnd();
	    
	}
	gl.glDisableClientState(GL_VERTEX_ARRAY); 
	gl.glPopAttrib();
	
    }
    
    void displayFront(GLCanvas canvas, int drawing_mode, byte command, Color3f color)
    {
	GLFunc gl = canvas.gl;

	gl.glPushMatrix();
	gl.glTranslated(0,0, config.getPaperHeight());
	if (drawing_mode == GL_SELECT) gl.glLoadName(NONE);
	//displaySide(command, color, front_side_normal);
	int i, n=0;
	
	boolean ef= false, et= false;

	
	switch(command){
	case LINE:{ 
	    //System.out.println("line");
	    ef= false; et=false;
	    break;}
	case FILL:{
	    //System.out.println("fill" );
	    ef= true; et=false;
	    break;}
	case TEXTURE:{ 
	    //System.out.println("texture" );
	    // correct mapping will be hard
	    ef= true; et=true;
	    break;}
	}
	
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glEnableClientState(GL_VERTEX_ARRAY); 
	gl.glVertexPointer (3, GL_DOUBLE, 0, side_VA);
	gl.glColor3fv(color.get3fv());

	if(et){
	    //gl.glEnable(GL_TEXTURE_2D);
	    //gl.glBindTexture(GL_TEXTURE_2D, topTexture);
	    gl.glActiveTextureARB(GL_TEXTURE0_ARB);
	    gl.glEnable(GL_TEXTURE_2D);
	    gl.glBindTexture(GL_TEXTURE_2D, edgetexture);
   
   	}

	if(ef){
	    if(side == LEFT){
		gl.glFrontFace(GL_CW); 
	    }
	    double nx_intervals= nx;

	    gl.glBegin(GL_TRIANGLE_STRIP);
	    gl.glNormal3dv(front_side_normal.get3dv());
	    for(i=0; i< nx; i++){
		n=i*2;
		gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, i/nx_intervals, 0);
		gl.glArrayElement(side_indices[n]);
		gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, (i+1)/nx_intervals, 1);
		gl.glArrayElement(side_indices[n+1]);
	    }
	    gl.glEnd();
	}else{
	    
	    //top row 
	    gl.glBegin(GL_LINE_STRIP);
	    for(i=0; i< nx; i++){
		n=i*2;
		gl.glArrayElement(side_indices[n]);
	    }
	    gl.glEnd();
	    
	    //bottom row
	    gl.glBegin(GL_LINE_STRIP);
	    gl.glArrayElement(side_indices[0]);
	    for(i=0; i< nx; i++){
		n=i*2+1;
		gl.glArrayElement(side_indices[n]);
	    }
	    gl.glArrayElement(side_indices[n-1]);
	    gl.glEnd();
	    
	}
	gl.glDisableClientState(GL_VERTEX_ARRAY); 
	gl.glPopAttrib();


	gl.glPopMatrix();
    }

  
    /* Draw edges of the pages stack
     * @param canvas 
     * @param command
     * @param color
     */
    public void displayEdge(GLCanvas canvas, byte command, Color3f color)
    {
	GLFunc gl = canvas.gl;

	boolean ef= false, et= false;
	
	double [][] texpts= { {0,0},
			      {1,0},
			      {1,1},
			      {0,1} };

	switch(command){
	case LINE:{ 
	    //System.out.println("line");
	    ef= false; et=false;
	    break;}
	case FILL:{
	    //System.out.println("fill" );
	    ef= true; et=false;
	    break;}
	case TEXTURE:{ 
	    //System.out.println("texture" );
	    ef= true; et=true;
	    break;}
	}

	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	if(ef)
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	else
	    gl.glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);

	if(et){
	    //gl.glEnable(GL_TEXTURE_2D);
	    //gl.glBindTexture(GL_TEXTURE_2D, topTexture);
	    gl.glActiveTextureARB(GL_TEXTURE0_ARB);
	    gl.glEnable(GL_TEXTURE_2D);
	    gl.glBindTexture(GL_TEXTURE_2D, edgetexture);
	}
	
	int i;
	gl.glLoadName(edge_name);
	
	gl.glBegin(GL_QUADS);
	gl.glNormal3dv(edge_normal.get3dv());
	for(i=0; i<edge_vertex.length; i++){
	    gl.glMultiTexCoord2dvARB(GL_TEXTURE0_ARB, texpts[i]);
	    gl.glVertex3dv(edge_vertex[i].get3dv());
	}
	gl.glEnd();
	
	gl.glPopAttrib();
    }

    /*
      draw four corners of the edge 
      used for selectionDetail
     */
    public void displayEdgeSkeleton(GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("StaticPage.java: displayEdgeSkeleton()");
	}
	GLFunc gl = canvas.gl;
	int i; 
	float marker;

	for(i= 0, marker= 0.f; i<edge_vertex.length; i++, marker++){
	    gl.glPassThrough(marker);
	    gl.glBegin(GL_POINTS);
	    gl.glVertex3dv(edge_vertex[i].get3dv());
	    gl.glEnd();
	}
    }

    
    public void drawAnchors(GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("StaticPage.java: drawAnchors ");
	}
	GLFunc gl = canvas.gl;
	
	float [] red= {1.0f, 0.0f, 0.0f, 1.0f};
	gl.glPushAttrib(canvas.GL_ALL_ATTRIB_BITS); 
	gl.glMaterialfv(canvas.GL_FRONT_AND_BACK, canvas.GL_AMBIENT_AND_DIFFUSE, red);
	gl.glPointSize(5.0f);

	int i; 
	int anchorPage;
	int paper;
	double xi, yi; 
	Vector3d u, v;
	
	u= new Vector3d(0,0,0);
	v= new Vector3d(0,0,0);
	
	if(Ttp.commentslevel >= 3){
	    displayAnchorPages();
	    System.out.println("StaticPage.java: papers= " + totalpapers);
	    System.out.println("StaticPage.java: start page= " + page_num_Top );
	    System.out.println("StaticPage.java: finishe page= " + page_num_Bottom);
	    System.out.println("StaticPage.java: startAnchorIndex= " + startAnchorIndex);
	    System.out.println("StaticPage.java: endAnchorIndex= " + endAnchorIndex);
	}
	
  	i= startAnchorIndex ;
	gl.glLoadName(edge_name);

	if(Ttp.commentslevel >= 3){
	    System.out.println("StaticPage.java: Anchors are ");
	}
	
	while(i <= endAnchorIndex){
	    anchorPage= ((Integer)anchorPageList.get(i)).intValue() ;
	    
	    paper= anchorPage/2 + 1;

	    //if last anchorPage greater than total page of the book (later)
	    yi= (double)(paper- startPaper)/ (double)totalpapers * height;
	    xi= yi/m;
	    u.scale(xi, dx);
	    v.scale(yi, dy);
	    
	    if(Ttp.commentslevel >= 3){
		System.out.println( "anchorPage= " + anchorPage + "," +
				    "paper= " + paper +", "+
				    "xi= " + xi +", "+
				    "yi= " + yi );
	    }
	    //base + xi*dx + yi*dy
	    anchor_point.set(base.plus(u).plus(v));

	    gl.glBegin(GL_POINTS);
	    gl.glVertex3dv(anchor_point.get3dv());
	    gl.glEnd();

	    i++; //jump to next anchor page
	}
	gl.glPopAttrib();
    }

    /*
      debug
      Iterate through pages
     */
    protected void displayAnchorPages()
    {
	synchronized(anchorPageList) {
	    Iterator i = anchorPageList.iterator(); // Must be in synchronized block
	    while (i.hasNext()){
		System.out.print( ((Integer)(i.next())).intValue() + " ");
	    }
	}
	
	System.out.println();
    }
    
    void searchStartAnchorIndex()
    {
	int anchorPage;
	int anchorPaper;
	
	if(startPaper > lastanchorPaper){
	    startAnchorIndex= NONE;
	}else{
	    //search through until startPage >=  anchorPage
	    for(int i= 0; i < anchorPageList.size(); i++ ){
		anchorPage= ((Integer)anchorPageList.get(i)).intValue() ;
		anchorPaper= anchorPage/2 + 1;
		
		if(anchorPaper == startPaper){ 
		    startAnchorIndex= i;
		    break;
	    }
		
		if(anchorPaper > startPaper){ 
		    startAnchorIndex= i;
		    break;
		}
	    }
	}

    }

    
    void searchEndAnchorIndex()
    {
	int anchorPage;
	int anchorPaper;
	
	if(endPaper < firstanchorPaper){
	    endAnchorIndex= NONE;
	}else{
	    int last= anchorPageList.size()-1;
	    //search through until startPage >=  anchorPage
	    for(int i= last; i >= 0; i-- ){
		anchorPage= ((Integer)anchorPageList.get(i)).intValue();
		anchorPaper= anchorPage/2 + 1;
		
		if(anchorPaper == endPaper){ //coincide
		    endAnchorIndex= i;
		    break;
		}
		
		if(anchorPaper < endPaper){ //do not coincide
		    endAnchorIndex= i;
		    break;
		}
	    }
	}
    }

}
