package TTPproject;

import com.sun.image.codec.jpeg.*;
import java.io.*;


import gl4java.awt.GLCanvas;
import gl4java.utils.textures.*;
import gl4java.GLFunc;
import gl4java.GLUFunc;
import gl4java.GLEnum;


public class Texture
    implements GLEnum, CONSTANTS
{
    //JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(new FileInputStream(new String("Hello")));
    
    Configuration config= null;
    
    GLCanvas canvas= null;
    GLFunc gl= null;
    GLUFunc glu= null;

    String prefix= null;
    int page_no=0; 
    String [] suffix= {".png"};
    //fixed texture for the book
    String [] fixed_fname={"image",             
			   "bookfront_edge",     //1
			   "bookSide",           //2
			   "book_front_cover",   //3
			   "book_back_cover",
			   "book_spine",
			   "page_edge",
			   "pageMaterial400x400",
			   "cover_material",
			   "border"};    //9, do i need it ??? or just generating bitmaps

    //message board

    String texturepath= null;
    
    PublicPngTextureLoader pngtexLoader= null;
    //PublicJPEGTextureLoader jpegtexLoader= null;
    PublicTGATextureLoader tgatexLoader= null;
    
    

    public Texture(GLFunc gl, 
		   GLUFunc glu,
		   Configuration config)
    {
	this.canvas= canvas;
	this.gl= gl;
	this.glu= glu;
	this.config= config;

	/*
	  Initialize all the textureloaders
	 */
	pngtexLoader= new PublicPngTextureLoader(this.gl, this.glu);
	//jpegtexLoader= new PublicJPEGTextureLoader(this.gl, this.glu);
	tgatexLoader= new PublicTGATextureLoader(this.gl, this.glu);
	
	this.prefix= Ttp.prefix;
		
    }
    
    /*
      Given page_num, readPageTexture 
      reading from the file
     */
    public boolean readPageTextureFromFile(int page_num)
    { 	
	if(Ttp.commentslevel >= 2){
	    System.out.println("Texture.java: readPageTextureFromFile() ");
	}

	String digits= "000000" + page_num;
	String ebookfilename= Ttp.ebook_file_name;
	String pagePrefix= Ttp.pagePrefix;
	
	digits= digits.substring(digits.length()-4, digits.length());// max digits 
	texturepath= pagePrefix + ebookfilename + digits + suffix[0];

	if(Ttp.commentslevel >= 3){
	    System.out.println("Texture.java: texturepath=  " + texturepath);
	}
	

	if(config.imageformat == PNG){
	    return pngtexLoader.readTexture(texturepath);
	}else if(config.imageformat == JPEG){
	    return false;
	    //return jpegtexLoader.readTexture(texturepath);
	}else if(config.imageformat == TGA){
	    return tgatexLoader.readTexture(texturepath);
	}else{
	    return false;
	}
    }



    
    /*
      Given page_num
      reading from InputStream
    */
    public boolean readPageTextureFromPdfReader(int page_num, 
						int imageWidth, int imageHeight)
    { 
	if(Ttp.commentslevel >= 2){
	    System.out.println("readPageTextureFromPdfReader()");
	}
	
	boolean success= false;
	
	if(config.imageformat == PNG){
	    success= pngtexLoader.publicreadTexture(config.converter.getImagesFromPdf(page_num, 
										      imageWidth, imageHeight));
	}else if(config.imageformat == JPEG){
	    //success= jpegtexLoader.publicreadTexture(config.converter.getImagesFromPdf(page_num,
	    //								       imageWidth, imageHeight));
	}else if(config.imageformat == TGA){
	    success= tgatexLoader.publicreadTexture(config.converter.getImagesFromPdf(page_num, 
										      imageWidth, imageHeight));
	}else{
	    success= false;
	}
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("finish Reading image Data>> ");
	}
	
	return success;

    }

    
    public boolean readPageTextureFromBuffer(int page_num, 
					     int imageWidth, int imageHeight  )
    { 
	if(Ttp.commentslevel >= 2){
	    System.out.println("readPageTextureFromBuffer()");
	}
	
	boolean success= false;
	
	switch(config.bufferingOption){
	case WINDOWING:
	    if(Ttp.commentslevel >= 3){
		System.out.println("Windowing technique");
	    }
	    //success= texLoader.readTexture(config.converter.getImagesFromPdf(page_num));
	    success= readPageTextureFromPdfReader(page_num,
						  imageWidth, imageHeight);
	    break;
	    
	case DIRECT_ONE:
	    if(Ttp.commentslevel >= 3){
		System.out.println("Direct one"); 
	    }
	    //success= texLoader.readTexture(config.converter.getImagesFromPdf(page_num));
	    success= readPageTextureFromPdfReader(page_num,
						  imageWidth, imageHeight);
	    break;
	case DIRECT_TWO:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("Direct two"); 
	    }
	    //success= texLoader.readTexture(config.converter.getImageFromImageBuffer(page_num));
	    success= readPageTextureFromImageBuffer(page_num);
	    break;
	}
	//case ANCHORING:
	//System.out.println("Anchoring"); break;
	//default:     
	//System.out.println("Unknown buffering option"); 
	
	}
	
	return success; 
	
	
    }
    
    
    
    public boolean readPageTextureFromImageBuffer(int page_num)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("readPageTextureFromImageBuffer()");
	}
	
	if(config.imageformat == PNG){
	    return pngtexLoader.publicreadTexture(config.converter.getImageFromImageBuffer(page_num));
	}else if(config.imageformat == JPEG){
	    return false;
	    //return jpegtexLoader.publicreadTexture(config.converter.getImageFromImageBuffer(page_num));
	}else if(config.imageformat == TGA){
	    return tgatexLoader.publicreadTexture(config.converter.getImageFromImageBuffer(page_num));
	}else{
	    return false;
	}

    }

    public boolean readPageTextureFromInputStream(ByteArrayInputStream in)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("readPageTextureFromInputStream()");
	}
	
	if(config.imageformat == PNG){
	    return pngtexLoader.publicreadTexture(in);
	}else if(config.imageformat == JPEG){
	    return false;
	    //return jpegtexLoader.publicreadTexture(in);
	}else if(config.imageformat == TGA){
	    return tgatexLoader.publicreadTexture(in);
	}else{
	    return false;
	}

    }

    /*
      Read from the file
    */
    public boolean readFixedTexture(int i)//start from the page no. 1
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("readFixedTexture()");
	}
	
	if(i==0){
	    if(Ttp.commentslevel >= 3){
		System.out.println("image should not appear here");
	    }
	}

	texturepath= prefix + fixed_fname[i] + suffix[0];
	if(Ttp.commentslevel >= 3){
	    System.out.println("texture path" + texturepath);
	}
	return pngtexLoader.readTexture(texturepath);
    }

    public boolean readPageMaterial(int level)//starts from 01
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("readPageMaterial()");
	}
	
	String digits= "000000" + level;
	digits= digits.substring(digits.length()-2, digits.length());// max digits 
	
	texturepath= prefix + "pageMaterial" + digits + suffix[0];

	if(Ttp.commentslevel >= 3){
	    System.out.println("Page Material> " + texturepath);
	}

	return pngtexLoader.readTexture(texturepath);
    }



    public boolean readTextureFromFile(String fname)//start from the page no. 1
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("readTextureFromFile()");
	}

	texturepath= prefix + fname + suffix[0];
	if(Ttp.commentslevel >= 3){
	    System.out.println("texture path" + texturepath);
	}

	return pngtexLoader.readTexture(texturepath);
    }
    
    

    public boolean readBookTexture(int i)
    {
	if(i==0){
	    if(Ttp.commentslevel >= 2){
		System.out.println("image should not appear here");
	    }
	}

	texturepath= prefix + fixed_fname[i] + suffix[0];
	if(Ttp.commentslevel >= 3){
	    System.out.println("texture path" + texturepath);
	}
	return pngtexLoader.readTexture(texturepath);
    }
    

    public boolean isOk()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("IsOK");
	}

	if(config.imageformat == PNG){
	    return pngtexLoader.isOk();
	}else if(config.imageformat == JPEG){
	    return false;
	    //return jpegtexLoader.isOk();
	}else if(config.imageformat == TGA){
	    return tgatexLoader.isOk();
	}else{
	    return false;
	}
	
    }

    public final int getImageWidth()
    {
	if(config.imageformat == PNG){
	    return pngtexLoader.getImageWidth();
	}else if(config.imageformat == JPEG){
	    return 0;
	    //return jpegtexLoader.getImageWidth();
	}else if(config.imageformat == TGA){
	    return tgatexLoader.getImageWidth();
	}else{
	    return 0;
	}
    }

    public final int getImageHeight()
    {
	if(config.imageformat == PNG){
	    return pngtexLoader.getImageHeight();
	}else if(config.imageformat == JPEG){
	    return 0;
	    //return jpegtexLoader.getImageHeight();
	}else if(config.imageformat == TGA){
	    return tgatexLoader.getImageHeight();
	}else{
	    return 0;
	}
	
    }


    /*

     */
    public final byte[] getPNGTexture()
    {
	return pngtexLoader.getTexture();
    }

    public final byte[] getTGATexture()
    {
	return tgatexLoader.getTexture();
    } 
    

    public final byte[] getTexture()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Texture: getTexture()>>");
	}

	if(config.imageformat == PNG){
	    return getPNGTexture();
	}else if(config.imageformat == JPEG){
	    return null;
	    //return jpegtexLoader.getTexture1D();
	}else if(config.imageformat == TGA){
	    return getTGATexture();
	}else{
	    return null;
	}
    }


    void setupMipmapsTexturing(int texName)
    {
	//gl.glActiveTextureARB(GL_TEXTURE0_ARB);
	gl.glBindTexture(GL_TEXTURE_2D, texName);
	gl.glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

	
	int imageWidth= getImageWidth();
	int imageHeight= getImageHeight();
	
	switch(config.imageformat){
	case PNG:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("PNG");
	    } 
	    glu.gluBuild2DMipmaps(GL_TEXTURE_2D, 
				  3, 
				  pngtexLoader.getImageWidth(), 
				  pngtexLoader.getImageHeight(), 
				  GL_RGB, 
				  GL_UNSIGNED_BYTE, 
				  pngtexLoader.getTexture());
	    
	    break;}
	case JPEG:
	    if(Ttp.commentslevel >= 3){
		System.out.println("JPEG"); 
	    }
	    glu.gluBuild2DMipmaps( GL_TEXTURE_2D, 
				   GL_RGBA, 
				   imageWidth, 
				   imageHeight, 
				   GL_RGBA, 
				   GL_UNSIGNED_BYTE, 
				   getTexture() );   
	    break;
	case TGA:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("TGA"); 
	    }
	    glu.gluBuild2DMipmaps(GL_TEXTURE_2D, 
				  GL_RGB, 
				  imageWidth, 
				  imageHeight, 
				  GL_RGB, 
				  GL_UNSIGNED_BYTE, 
				  getTexture());
	    break;
	}
	}
    }


}
