package TTPproject;

import javax.swing.JFrame;
import java.awt.BorderLayout;
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

//data structure
import java.util.ArrayList;// anchorPageList
import java.util.List;//interface List
import java.util.Collections;
import java.util.Iterator;//traverse through anchorPageList

public class Ttp 
    extends JFrame 
    implements ActionListener, CONSTANTS {
    
    public static int commentslevel= 1;
    public static String prefix= null;
    public static String pdfprefix= null;
    public static String djvusprefix= null;
    public static String pagePrefix= null;
    public static String iconPrefix= null;
    public static String snapshotPrefix= null;

    public static String ebook_file_name= null;
    public static String full_ebook_file_name= null;
    public static String screen_file_name= null;
    public static boolean grabbing_initial_screen= false;

    //3d fonts
    public static int fonts3d_type= 0;
    public static String fonts3d_form= null;
    public static String fonts3d_format= null;

    public static int fonts3d_MAX_number= 30;
    public static String [] fonts3d_name= {
	"aksent1.glf",
	"alpine1.glf",
	"arbat.bmf",
	"arial.bmf",
	"arial1.glf",
	"broadway1.glf",
	"brushtype.bmf",
	"chicago.bmf",
	"chicago1.glf",
	"compact1.glf",
	"courier.bmf",
	"courier1.glf",
	"cricket.bmf",
	"cricket1.glf",
	"crystal.bmf",
	"crystal1.glf",
	"fixedsys.bmf",
	"gals.bmf",
	"garamond1.glf",
	"gothic1.glf",
	"greek.bmf",
	"impact.bmf",
	"penta1.glf",
	"present_script1.glf",
	"proun.bmf",
	"techno.bmf",
	"techno0.glf",
	"techno1.glf",
	"times_new.bmf",
	"times_new1.glf"
    };
    
    public static Dimension screen_size= Toolkit.getDefaultToolkit().getScreenSize();
    public static String [] main_menuMessage= {
	"Turn a single page",
	"    Mouse over the right hand page and", 
	"    apply Flick Gesture with left mouse botton pressed.",

	"Toggle on/off Help Menu",
	"    Key 'h' or click info button",

	"Close the visualizer",
	"    Key Esc"
    };

    public static String [] helpMenuMessage= {
	"Spin the book around",  
	"    Shift/Alt and move the mouse.",

	"Zooming", 
	"    In: wheel up or Ctrl and move mouse up ",
	"    Out: wheel down or Ctrl and move mouse down ",
	
	"Flipping through pages", 
	"    Forward: Click right arrow button or Mouse over the right hand page and",
	"      apply Flick Gesture with Right mouse button pressed.",
	"    Backward: Click left arrow button or Mouse over the left hand page and",
	"      apply Flick Gesture with Right mouse button pressed.",
	
	"Toggle on/off Help Menu",
	"    Key 'h' or click info button",

	"Toggle on/off markers",
	"    Key '1'",
	
	"Toggle on/off snap-to-marker", 
	"    Key '2'",
	
	"Toggle on/off progressive page update",
	"    Key 'p'",
	
	"Switch between 3D book mode and Reading mode",
	"    Space bar",
	
	"In Reading mode",
	"    Go to the next page: Page Up",
	"    Go to the preceeding page: Page Down",
    };
    
    public static int messagesState= 0;
    
    
    
    Parameters parameters= null;
    Configuration config= null;
    CursorManager cursorManager= null;
    TexturePools texturePools= null;
    InitializationThread initializedThread= null;
    ThreadA threadA= null;// perform progressive mode
    List anchorRight_hand_PageList= null;
    List anchorLeft_hand_PageList = null;
    
    
    private Scene scene= null;
    
    
    public Ttp(Parameters parameters) {
	//super("Ttp");
	if(Ttp.commentslevel >= 2){
	    System.out.println("Ttp.java: Ttp()");
	}
	
	this.parameters= parameters;

	//Responding to Window-Closing Events
	//Implement WindowListener interfaces
	addWindowListener( new WindowAdapter() {
		public void windowClosing( WindowEvent evt ) {
		    //Releases all of the native screen resources used by this Window, 
		    //its subcomponents, and all of its owned children. 
		    //That is, the resources for these Components will be destroyed, 
		    //any memory they consume will be returned to the OS, and they will 
		    //be marked as undisplayable. 
		    handleWindowClosing(evt);
		}
	    } );

	
	// Size and place the frame on the screen
	
	Rectangle windowbounds= parameters.getWindowBounds();
	Rectangle viewportbounds= parameters.getViewportBounds();
	Dimension size= windowbounds.getSize();
	//set title
	this.setTitle("Open The Book - " + Ttp.full_ebook_file_name);
	
	

	// Ensure width and height are reasonable
	/*size = windowbounds.getSize();
	if (size.width < 640) {
	    size.width = 640;
	}
	else if (size.width > screen_size.width) {
	    size.width = screen_size.width;
	}
	if (size.height < 480) {
	    size.height = 480;
	}
	else if (size.height > screen_size.height) {
	    size.height = screen_size.height;
	    }*/
	
	
	scene = new Scene(this,
			  windowbounds.width,
			  windowbounds.height,
			  viewportbounds);
	
	//returns "contentPane(Container)" , then sets the layout manager for this container
	getContentPane().setLayout(new BorderLayout());
        getContentPane().add( BorderLayout.CENTER, scene);
	
	//Causes this Window to be sized to fit the preferred size and layouts of its subcomponents
	pack();	
	
	//set the window in the middle 
	setLocation((screen_size.width - size.width) / 2, 
		    (screen_size.height - size.height) / 2);
	setSize(size);
	//Makes Window visible
	show();
	
	//starting animating scene 
	scene.start();
	
    }

    protected void handleWindowClosing(WindowEvent evt)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Ttp.java: handleWindowClosing()");
	}
	
	cleanupTTP();
    }

    protected void cleanupTTP()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("Ttp.java: cleanupTTP()");
	}
	
	if(threadA != null)
	    threadA.setStop();

	//stop animation thread
	scene.stop();
	scene.setVisible(false);
	//release "scene"
	scene.doCleanup();
	dispose();
	//Exit the application
	//System.exit( 0 );
    }


    public void actionPerformed(ActionEvent e) {
	
	if(e.getActionCommand().equals("INITIALIZATION")){
	    
	    if(Ttp.commentslevel >= 1){
		System.out.println("---------------------------");
		System.out.println("loading");
		System.out.println("---------------------------");
	    }
	    
	    config= new Configuration(parameters);
	    cursorManager= new CursorManager();
	    anchorRight_hand_PageList = Collections.synchronizedList(new ArrayList(0));
	    anchorLeft_hand_PageList = Collections.synchronizedList(new ArrayList(0));
	    texturePools= new TexturePools(10,
					   parameters,
					   anchorRight_hand_PageList,
					   anchorLeft_hand_PageList); // cache size

	    initializedThread= new InitializationThread(this,
							scene,
							config, 
							cursorManager,
							texturePools,
							anchorRight_hand_PageList,
							anchorLeft_hand_PageList
							);
	    initializedThread.start();
	}
	else if(e.getActionCommand().equals("INITIALIZATION_FINISHED")){
	    if(Ttp.commentslevel >= 1){
		System.out.println("---------------------------");
		System.out.println("change LOADING mode to RUNNING mode");
		System.out.println("---------------------------");
	    }

	    if(parameters.getfileType() == PDF){
		
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() PDF");
		}
		
		threadA= new ThreadA(scene,
				     cursorManager,
				     texturePools,
				     config.startingPage );
		
		if(config.progressiveUpate){
		    threadA.start();
		}
		
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }
	}

	else if(e.getActionCommand().equals("PAGE_SELECTED")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: PAGE_SELECTED");
	    }
	    
	    if(parameters.getfileType() == PDF){
		if(threadA.isAlive()){//good
		    if(Ttp.commentslevel >= 3){
			System.out.println("Ttp.java: threadA is alive");
		    }
		    threadA.setSuspend();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
		
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }
	    
	}else if(e.getActionCommand().equals("PAGE_UNSELECTED_UPDATE")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: PAGE_UNSELECTED_UPDATE");
	    }
	    if(parameters.getfileType() == PDF){
		int startPage;
		startPage= scene.bc.sp[0].getPage_num();
		
		
		if(threadA.isAlive()){ // threadA still running
		    if(Ttp.commentslevel >= 3){
			System.out.println("Ttp.java: PAGE_UNSELECTED_UPDATE is still alive");
		    }
		    //threadA.setSuspendflipflop();///suspended == false
		    threadA.setAwake(); //awaken threadA
		    threadA.setStop();// force threadA to finish &  awaken threadB
		    //create a new threadA
		    threadA= new ThreadA(scene,
					 cursorManager,
					 texturePools,
					 startPage);
		    threadA.start();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
		
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }
	    
	    

	}else if(e.getActionCommand().equals("PAGE_UNSELECTED_RESTORE")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: PAGE_UNSELECTED_RESTORE");
	    }
	    
	    if(parameters.getfileType() == PDF){
		if(threadA.isAlive()){
		    threadA.setAwake();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
		
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }
	    
	}else if(e.getActionCommand().equals("CLOSE_EDGE_SELECTED")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: CLOSE_EDGE_SELECTED");
	    }
	    
	    if(parameters.getfileType() == PDF){
		if(threadA.isAlive()){
		    threadA.setSuspend();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
		
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }
	    

	    
	}else if(e.getActionCommand().equals("CLOSE_EDGE_UNSELECTED_OPEN")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: CLOSE_EDGE_UNSELECTED_OPEN");
	    }
	    
	    //threadA.setSuspendflipflop();
	    //this is called after sp[0] and sp[1] have both been updated

	    if(parameters.getfileType() == PDF){
		int startPage;
		if(scene.bc.selected_side == RIGHT){
		startPage= scene.bc.sp[0].getPage_num(); // +  scene.bc.howmanyPagesRight;
		}else{
		    startPage= scene.bc.sp[1].getPage_num(); // -  scene.bc.howmanyPagesLeft;
		}
		
		if(threadA.isAlive()){
		    threadA= new ThreadA(scene,
					 cursorManager,
					 texturePools,
					 startPage);
		    threadA.start(); 
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }

	    
	}else if(e.getActionCommand().equals("CLOSE_EDGE_UNSELECTED_CLOSE")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: CLOSE_EDGE_UNSELECTED_CLOSE");
	    }
	    
	    if(parameters.getfileType() == PDF){
		if(threadA.isAlive()){
		    threadA.setAwake();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
		
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }

	}else if(e.getActionCommand().equals("CLOSE_COVER_SELECTED")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: CLOSE_COVER_SELECTED");
	    }

	    if(parameters.getfileType() == PDF){
		if(threadA.isAlive()){
		    threadA.setSuspend();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
		
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }

	}else if(e.getActionCommand().equals("CLOSE_COVER_UNSELECTED_OPEN")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: CLOSE_COVER_UNSELECTED_OPEN");
	    }
	    //this is called after sp[0] and sp[1] have both been updated

	    if(parameters.getfileType() == PDF){
		int startPage;
		if(scene.bc.selected_side == RIGHT){
		    startPage= scene.bc.sp[0].getPage_num(); // +  scene.bc.howmanyPagesRight;
		}else{
		    startPage= scene.bc.sp[1].getPage_num(); // -  scene.bc.howmanyPagesLeft;
		}
		
		if(threadA.isAlive()){
		    threadA.setAwake(); //awaken threadA
		    threadA.setStop();
		    
		    //create a new threadA
		    threadA= new ThreadA(scene,
					 cursorManager,
					 texturePools,
					 startPage);
		    threadA.start();
		    
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }


	}else if(e.getActionCommand().equals("CLOSE_COVER_UNSELECTED_CLOSE")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: CLOSE_COVER_UNSELECTED_CLOSE");
	    }
	    
	    if(parameters.getfileType() == PDF){
		if(threadA.isAlive()){
		    threadA.setAwake();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }

	}else if(e.getActionCommand().equals("OPEN_COVER_SELECTED")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: OPEN_COVER_SELECTED");
	    }

	    if(parameters.getfileType() == PDF){
		if(threadA.isAlive()){
		    threadA.setSuspend();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
		
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }

	    
	}else if(e.getActionCommand().equals("OPEN_COVER_UNSELECTED_OPEN")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: OPEN_COVER_UNSELECTED_OPEN");
	    }
	    
	    if(parameters.getfileType() == PDF){
		if(threadA.isAlive()){
		    threadA.setAwake();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
		
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }
	    

	}else if(e.getActionCommand().equals("OPEN_COVER_UNSELECTED_CLOSE")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: OPEN_COVER_UNSELECTED_CLOSE");
	    }
	    
	    if(parameters.getfileType() == PDF){
		int startPage;
		if(scene.bc.isFrontCoverFacingUP()){
		    startPage= config.firstPage; 
		}
		else{
		    startPage= config.lastPage; 
		}
		
		if(threadA.isAlive()){
		    threadA.setAwake(); //awaken threadA
		    threadA.setStop();  // force threadA to finish &  awaken threadB
		    
		    threadA= new ThreadA(scene,
					 cursorManager,
					 texturePools,
					 startPage);
		    threadA.start();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }
	    		

	}else if(e.getActionCommand().equals("OPEN_EDGE_SELECTED")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: OPEN_EDGE_SELECTED");
	    }

	    if(parameters.getfileType() == PDF){
		if(threadA.isAlive()){
		    threadA.setSuspend();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
		
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }
	    	    
	}else if(e.getActionCommand().equals("OPEN_EDGE_UNSELECTED_RESTORE")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: OPEN_EDGE_UNSELECTED_RESTORE");
	    }
	    
	    if(parameters.getfileType() == PDF){
		if(threadA.isAlive()){
		    threadA.setAwake();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }

	}else if(e.getActionCommand().equals("OPEN_EDGE_UNSELECTED_UPDATE")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: OPEN_EDGE_UNSELECTED_UPDATE");
	    }

	     //this is called after sp[0] and sp[1] have both been updated
	    
	    if(parameters.getfileType() == PDF){
		int startPage;
		startPage= scene.bc.sp[0].getPage_num();
		
		if(threadA.isAlive()){ // threadA still running
		    if(Ttp.commentslevel >= 3){
			System.out.println("Ttp.java: OPEN_EDGE_UNSELECTED_UPDATE is still alive");
		    }
		
		    threadA.setAwake(); //awaken threadA
		    threadA.setStop();// force threadA to finish &  awaken threadB
		    threadA= new ThreadA(scene,
					 cursorManager,
					 texturePools,
					 startPage);
		    threadA.start();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }

	}

	else if(e.getActionCommand().equals("RESUME_PROGRESSIVE_UPDATE")){
	    int startPage= 0;
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java:RESUME_PROGRESSIVE_UPDATE");
	    }
	    if(parameters.getfileType() == PDF){
		if(scene.bc.sp[1].getPage_num() < config.firstPage)
		    startPage= scene.bc.sp[0].getPage_num();
		else if(scene.bc.sp[0].getPage_num() > config.lastPage)
		    startPage= scene.bc.sp[1].getPage_num();
		else
		    startPage= scene.bc.sp[0].getPage_num();
		
		threadA= new ThreadA(scene,
				     cursorManager,
				     texturePools,
				     startPage);
		threadA.start();
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }
	}

	else if(e.getActionCommand().equals("STOP_PROGRESSIVE_UPDATE")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java:STOP_PROGRESSIVE_UPDATE");
	    }
	    
	    if(parameters.getfileType() == PDF){
		if(threadA.isAlive()){ 
		    if(threadA.isSuspended()){
			threadA.setAwake();
		    }
		    threadA.setStop();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }	
	    

	}

	else if(e.getActionCommand().equals("WINDOW_CLOSING")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: WINDOW_CLOSING");
	    }
	    cleanupTTP();
	}

	else if(e.getActionCommand().equals("START_FLIPPING")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: START_FLIPPING");
	    }
	    
	    if(parameters.getfileType() == PDF){
		if(threadA.isAlive()){ 
		    if(threadA.isSuspended()){
			threadA.setAwake();
		    }
		    threadA.setStop();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }
	}

	else if(e.getActionCommand().equals("STOP_FLIPPING")){
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: STOP_FLIPPING");
	    }
	    
	    if(parameters.getfileType() == PDF){
		if(config.progressiveUpate){
		    int startPage;
		    if(scene.bc.sp[1].getPage_num() < config.firstPage)
			startPage= scene.bc.sp[0].getPage_num();
		    else if(scene.bc.sp[0].getPage_num() > config.lastPage)
			startPage= scene.bc.sp[1].getPage_num();
		    else
			startPage= scene.bc.sp[0].getPage_num();
		    
		    threadA= new ThreadA(scene,
					 cursorManager,
					 texturePools,
					 startPage);
		    threadA.start();
		}
	    }else if(parameters.getfileType() == DJVU){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() DJVU");
		}
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Ttp.java: actionPerformed() illegal type");
		}
	    }
	    
	}

	else{
	    if(Ttp.commentslevel >= 3){
		System.out.println("Ttp.java: unknown action performed");
	    }
	}


    }


    /**
     * All starts here. 
     * @param args 
     */
    public static void main(String[] args) {


	Parameters parameter= new Parameters(args);
	Rectangle window_bounds= parameter.getWindowBounds();
	Ttp ttp = new Ttp(parameter);

    }

}
