/*
  progressively increase resolution
*/

package TTPproject;

import javax.vecmath.*;
import java.io.ByteArrayInputStream;

import gl4java.awt.GLCanvas;
import gl4java.GLContext;
import gl4java.GLFunc;
import gl4java.GLUFunc;
import gl4java.GLEnum;

import java.util.List;
import java.util.ArrayList;// anchorPageList

/*ImageMagick*/
import magick.MagickImage;
import magick.ImageInfo;
import magick.MagickException;

import geometry.Transformation;

public class BookConstructor 
    implements GLEnum, CONSTANTS{
    //int reading_plane_rightPageName= 0, reading_plane_leftPageName= 0;
    //int reading_plane_rightTexName= 0, reading_plane_leftTexName= 0;
    
    
    //experiment progressive update
    private int display=0;

    private Configuration config= null;
    private Scene scene= null;
    
    /*gl4java*/
    private GLContext glj;
    private GLFunc gl;
    private GLUFunc glu;

    // paper_no_lieOnLeft is numbers of paper
    // lies on the left hand side of
    // the double-page spread book
    private int paper_no_lieOnLeft;
    private int paper_no_lieOnRight;
        
    //private int initPageOnLeft;
    //private int initPageOnRight;

    private int selected_page;
    byte selected_side= RIGHT;
    
    //strip
    private Point3d [] strip= null;
    private int factor= 1;
    private short pattern= 0x0f0f;
    
    //window parameters
    private int cur_index;
    private int next_index;
    private int previous_index;
    private int tail_index;
    private int head_index;
    private int startPageName;

    private int howmanyWindows; 
    private int howmanyPages;

    private int rightPageName, leftPageName;
    private int rightTexName, leftTexName;

    //DIRECT_ONE
    private int curTexName [];
    private int nextTexName[];


    //book parameter
    //private int firstPageName, lastPageName;
    private int startfname= 3;
    

    //local inner class
    class TextureWindow{
	public int SR;// start_page_name_Right (page name form)
	public int SL; // start_page_name_Left (page name form)
	
	public int buffersize;
	//public int cp; //number of paper lie on the left 
	public int k; //threshold k value
	public int threshold;
	public int [] texName;

	public int leftBoundry; // left boundry
	public int rightBoundry; //right boundry
	
	public boolean filled= false;

		
	/*default constructor*/
	public TextureWindow()
	{
	    this.SR= 0;
	    this.SL= 0;
	    this.buffersize= 0;
	    this.k= 0;
	    this.texName= null;
	    this.threshold= 0;
	    this.leftBoundry= 0;
	    this.rightBoundry= 0;
	}
	
	/*
	  this is for the last window segment
	  be ware if we have odd lastPageName
	 */
	public TextureWindow(int standard_buffersize)
	{
	    if(Ttp.commentslevel >= 2){	
		System.out.println("TextureWindow");
	    }
	    int R, L;
	    if( (config.lastPage%2) == 0){ //if the last page is Right-hand page
		R= config.lastPage;
		config.lastPage++;
		L= R + 1;
	    }else{
		L= config.lastPage;
		R= L - 1;
	    }
	    
	    k=0;
	    int q= config.lastPage / standard_buffersize;
	    leftBoundry= q * standard_buffersize;
	    buffersize= config.lastPage - leftBoundry + 1;
	    rightBoundry= leftBoundry + buffersize - 1;

	    this.texName= new int[standard_buffersize];
	    init_texNames();
	    
	    if(Ttp.commentslevel >= 3){	
		System.out.println("Buffer size: " + buffersize);
		System.out.println("L: " + L);
		System.out.println("R: " + R);
		System.out.println("left Boundry page name: " + leftBoundry );
		System.out.println("right Boundry page name: " + rightBoundry );
		System.out.println();
	    }
	}
	
	
	/*this is used to initialize curWindow, previousWindow and nextWindow*/
	public TextureWindow(int buffersize, int k)
	{
	    this.SR= 0;
	    this.SL= 0;
	    this.buffersize= buffersize;
	    this.k= k;
	    this.texName= new int[buffersize];
	    init_texNames();
	}
	
	public void init_texNames()
	{
	    int i;
	    for(i=0; i< texName.length; i++){
		texName[i]= 0;
	    }
	}

	
	
	/*
	  initialize SR and SL
	  + startPageName & lastPageName has been initialised
	    in BookConstructor()
	  + does not deal with lastWindow case, so the rightBoundry sometimes is greater than 
	    lastWindow.rightBoundry
	 */
	public void setWindowAttribute(int pagename)
	{
	    int Q;

	    if((pagename%2) == 0){// even
		//right hand page
		SR= pagename;
		if(SR == 0)
		    SL= -1;
		else if(SR == config.lastPage){// unlikely ?
		    if(Ttp.commentslevel >= 2){
			System.out.println("rightPageName == lastPageName");
		    }
		    SL= SR - 1;
		}else 
		    SL= SR - 1;
		
		Q= SR/buffersize;
		
	    }else{//odd
		SL= pagename;
		//if(SL == config.lastPage)
		//  SR= SL - 1;
		//else
		SR= SL + 1;
		Q= SL/buffersize;
	    }


	    leftBoundry= Q * buffersize;
	    rightBoundry= leftBoundry + buffersize - 1;
	    setThreshold();
	}
	
	public void recedePageBoundry(int curLeft)
	{
	    rightBoundry= curLeft - 1;
	    leftBoundry= curLeft - buffersize;
	    setThreshold();
	}

	public void advancePageBoundry(int curRight)
	{
	    leftBoundry= curRight + 1;
	    rightBoundry= curRight + buffersize;
	    setThreshold();
	}
	

	/*
	  Call this only when SL SR has been updated
	 
	public void setLLLR()
	{
	    if( isOdd() ){ // odd
		if(SL > SR){
		    LR= SR + buffersize - 1;
		    LL= LR - 1;
		}
		else{ // SL < SR
		    LL= SL + buffersize - 1;
		    LR= LL - 1;
		}
	    }else{                       //buffersize == even
		if(SL > SR){
		    LL= SR + buffersize - 1;
		    LR= LL - 1;
		}
		else{ // SL < SR
		    LR= SL + buffersize - 1;
		    LL= LR - 1;
		}
	    }

	    }*/

	/*
	  Call this, only when SL SR has been updated
	 */
	public void setThreshold()
	{
	    this.threshold= this.leftBoundry + this.k;
	}
	
	/*public void advance(int oldLL, int oldLR)
	{
	    SR= oldLR + 2;
	    SL= oldLL + 2;
	    setLLLR();
	    setThreshold();
	    }*/
	
	/*
	  Copy private data from another TextureWindow object
	  to here.
	 */
	public void copy(TextureWindow obj)
	{
	    //this.SR= obj.SR;// start_page_name_Right (page name form)
	    //this.SL= obj.SL; // start_page_name_Left (page name form)
	    this.threshold= obj.threshold;
	    this.k= obj.k; //threshold k value
	    this.leftBoundry= obj.leftBoundry; 
	    this.rightBoundry= obj.rightBoundry; 
	    this.filled= obj.filled;

	    int i;
	    // copy buffersize for now, this may not needed because 
	    // window's buffersize has to be consistent 
	    this.buffersize= obj.buffersize;

	    copyTextureNames(obj.texName);
	}
	
	/*
	  Copy textureNames only
	 */
	public void copyTextureNames(int [] texNameFrom)
	{
	    if(Ttp.commentslevel >= 2){
		System.out.println("copyTextureNames()");
	    }
	    
	    int i;
	    
	    for(i=0; i< this.buffersize; i++){
		this.texName[i]= texNameFrom[i];
		if(Ttp.commentslevel >= 3){
		    System.out.println("\tindex: " + i );
		    System.out.println("\ttexName: " + this.texName[i] );
		}
	    }
	
	}

	public boolean isOdd()
	{
	    if( (buffersize % 2) == 1 )
		return true;
	    else
		return false;
	}
	
	/*
	  Call this, only when SL SR LL LR threashold has been initialized
	 */
	public void print()
	{
	    if(Ttp.commentslevel >= 3){
		System.out.println("Buffer size: " + buffersize);
		System.out.println("SR: " + SR);
		System.out.println("SL: " + SL);
		System.out.println("Threshold: " + this.threshold);
		System.out.println("Threshold: " + this.k);
		System.out.println("left Boundry page name: " + leftBoundry );
		System.out.println("right Boundry page name: " + rightBoundry );
		System.out.println("filled: " + filled);
		System.out.println();
	    }
	}
    }
    

    TextureWindow curWindow, nextWindow, previousWindow;
    TextureWindow firstWindow, lastWindow, secondlastWindow;
    
    //experiment progressively update
    TexturePools texturePools; //a reference
    List anchorPageList= null; //a reference
    
    // cover skeleton
    // based on cover skeleton 
    // build two base curve
    Point3d [] cover_skeleton;
    // control covers look
    double frontTurning;//in degree
    double backTurning;//in degree 
    double spineTurning;// in degree 

    //testing jumping
    Point3d [] cover_skeleton2;

    double frontTurning2;//in degree
    double backTurning2;//in degree 
    double spineTurning2;// in degree 
    
    //used for constructing interior_curve finishing position
    Point3d [] cover_skeleton3;
    double frontTurning3;//in degree
    double backTurning3;//in degree 
    double spineTurning3;// in degree 

    Point3d [] front_line;
    Point3d [] spine_line1;
    Point3d [] spine_line2;
    Point3d [] back_line;
    float [] front_line_color= {.0f, .7f , 1.0f, 1.0f};
    float [] spine_line_color= {.0f, .7f , 1.0f, 1.0f};
    float [] back_line_color= {.0f, .7f , 1.0f, 1.0f};
    float front_line_width= 3.0f;
    float back_line_width= 3.0f;
    
    double initial_turning_angle=0;
    double final_turning_angle=0;
    double howmuchTurningSpineAngle= 0;
    double howmuchTurningfrontCoverAngle= 0;
    double howmuchTurningbackCoverAngle= 0;
    
    // used for closing the book during phase2
    double howmuchTurningC0C1= 0; 
    double initialTurningC0C1= 0;
    double lenC0C1= 0;
    double init_spineAngle= 0;
    double shifting= 0;

    double initial_lh;
    double final_lh;
    double initial_rh;
    double final_rh;
    double jumping_distance= 0;
    double final_length;


    int howmanyPapers= 0;
    int howmanyPagesRight= 0;
    int howmanyPagesLeft= 0;
    
    

    //vector array
    /*
      RGB value
      glColor3f(0.0, 0.0, 0.0);          black 
      glColor3f(1.0, 0.0, 0.0);           red 
      glColor3f(0.0, 1.0, 0.0);           green 
      glColor3f(1.0, 1.0, 0.0);           yellow 
      glColor3f(0.0, 0.0, 1.0);           blue 
      glColor3f(1.0, 0.0, 1.0);           magenta 
      glColor3f(0.0, 1.0, 1.0);           cyan 
      glColor3f(1.0, 1.0, 1.0);           white
     */
    
    float [] cover_color= {
	1.0f, 0.0f, 0.0f,
	0.0f, 1.0f, 0.0f,
	1.0f, 1.0f, 0.0f,
	0.0f, 0.0f, 1.0f,
	1.0f, 0.0f, 1.0f,
	0.0f, 1.0f, 1.0f
    };
    
    double [] front_cover_pos_VA;
    Point3d [] front_cover_image_frame=null;
    Point3d [] inside_front_cover_image_frame=null; 
    byte [] front_cover_indices= {
	0, 1, 2, 3,
        5, 4, 7, 6,
	4, 5, 1, 0,
	6, 7, 3, 2,
	5, 6, 2, 1,
	7, 4, 0, 3
    };
    Vector3d [] front_cover_normals= null;
    byte [][] front_cover_command= {
	{ 
	    FILL, // top
	    FILL, // buttom
	    FILL, // front
	    FILL, // back
	    FILL, // right
	    FILL // left
	},
	
	{ 
 	    TEXTURE, // top
	    FILL, // buttom
	    FILL, // front
	    FILL, // back
	    FILL, // right
	    FILL // left
	},
	
	{
	    TEXTURE, // top
	    FILL, // buttom
	    FILL, // front
	    FILL, // back
	    FILL, // right
	    FILL // left
	}
    };
    int [] front_cover_texName= null;
    double [][][][] front_cover_texCoord={
	{
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}}
	},
	{
	    {{0,1}, {1,1}, {1,0}, {0,0}},
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}}
	},
	{
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}},
	    {{0,0}, {1,0}, {1,1}, {0,1}}
	}
    };

    int front_cover_level;
    int front_cover_imageWidth;
    int front_cover_imageHeight;
    boolean front_cover_initialized;
    
  

    double [] back_cover_pos_VA;
    int [] back_cover_texName= null;
    byte [] back_cover_indices= {
	1, 0, 3, 2,
	4, 5, 6, 7,
	0, 1, 5, 4,
	2, 3, 6, 7,
	1, 3, 6, 5,
	3, 0, 4, 7
    };
    Vector3d [] back_cover_normals= null;
    Point3d [] back_cover_image_frame=null;
    Point3d [] inside_back_cover_image_frame=null; 
    
    byte [][] back_cover_command= {
	{ 
	    FILL, // buttom
	    FILL, // top
	    FILL, // front
	    FILL, // back
	    FILL, // right
	    FILL // left
	},
	
	{ 
	    FILL, // buttom
	    FILL, // top
	    FILL, // front
	    FILL, // back
	    FILL, // right
	    FILL // left
	},
	
	{
	    FILL, // buttom
	    FILL, // top
	    FILL, // front
	    FILL, // back
	    FILL, // right
	    FILL // left
	}
    };
    
    
    Spine spine1= null;
    double [] spine_VA1;
        
    Spine spine2= null;
    double [] spine_VA2;
  
    
    public static final int NUM_COVER_SKELETON = 4;
    //selection name 
    //int FRONT_COVER, BACK_COVER, LEFT_EDGE, RIGHT_EDGE;// move to Configuration.java

    //cover turning parameters
    double angleO;
    double coverStartangle;
    double coverStopangle;
    double coverThreshold_1, coverThreshold_2;
    int coverState;
    //double phase4_disX;

    
    //check board texture
    int checkImageHeight= 64;
    int checkImageWidth= 64;
    byte [] checkImage_serial= new byte[checkImageHeight*checkImageWidth*4];
    /*byte [][] roygbi_images= {
	{Ox3f , Ox00, Ox3f},
	{Ox7f , Ox00, Ox7f},
	{0xbf, Ox}
	};*/

    static byte [] roygbiv_image = {
	(byte)0x3f, (byte)0x00, (byte)0x3f, /* Dark Violet (for 8 colors...) */
	(byte)0x7f, (byte)0x00, (byte)0x7f, /* Violet */
	(byte)0xbf, (byte)0x00, (byte)0xbf, /* Indigo */
	(byte)0x00, (byte)0x00, (byte)0xff, /* Blue */
	(byte)0x00, (byte)0xff, (byte)0x00, /* Green */
	(byte)0xff, (byte)0xff, (byte)0x00, /* Yellow */
	(byte)0xff, (byte)0x7f, (byte)0x00, /* Orange */
	(byte)0xff, (byte)0x00, (byte)0x00  /* Red */
    };
    
    int [] fixedTexName;
    int [] pageMaterial;

    Texture textureReader= null;

    //String prefix= "C:/TurningthePages/data/";
    String prefix= null;
    
    
    //static curve
    BezierCurve rightTop_d= null, leftTop_d= null;//display
    BezierCurve rightbottom_d= null;
    BezierCurve leftbottom_d= null;

        
    

    //testing interior curve
    BezierCurve leftTop_curve= null;
    BezierCurve leftLower_curve= null;
    BezierCurve interior_curveUP= null;
    BezierCurve interior_curveDOWN= null;
    BezierCurve interior_curveUP_finish= null;
    BezierCurve interior_curveDOWN_finish= null;
    BezierCurve rightTop_curve= null;
    BezierCurve rightLower_curve= null;
    float leftCurve_width= 3.0f;
    float rightCurve_width= 3.0f;
    float interiorCurve_width= 3.0f;

    //reading mode
    double [][] rightPage_texCoord= { {0,0},{1,0},{1,1},{0,1} };
    double [][] leftPage_texCoord= { {0,0},{1,0},{1,1},{0,1} };
    BezierCurve reading_rightPage_curve= null;

    Point3d [][] start_Right_Control_pts= null;
    Point3d [][] finish_Right_Control_pts= null;

    Point3d [][] start_Left_Control_pts= null;
    Point3d [][] finish_Left_Control_pts= null;

    
    
    
    
    
    //Right page control points
    
    
    
        
    int NUM_CONTROL_PTS= 4;
 
    //stage- this determines what displaying method
    //       is invoked first
    //int stage;
    StaticPage [] sp= null;
    DynamicPage dp= null;
    Pages dpBundle= null;
    StaticPage bundle= null;
    
    double lobb_rot_angle;
    double pageTurningAngle;
    double pageStopAngle;
    
    int startList, cylinder, disk;
    int bufferingOption;

    //page anchors
    double edge_height;// standard edge height
    double edge_width;// standard edge width
    double edge_m;
    double startXi, startYi;//right edge
    double endXi, endYi;//left edge
        

    
    public BookConstructor(Configuration config, 
			   Scene scene, 
			   TexturePools texturePools,
			   List anchorList )
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor()");
	}
		
	
	this.config= config;
	this.scene= scene;
	this.glj= scene.getGLContext();
	this.gl= scene.getGL();
	this.glu= scene.getGLU();
	
	this.texturePools= texturePools;
	this.anchorPageList= anchorList;

	//initial stagenTte set-up
	//stage= config.get_stage();
	setThreshold();
	
	//selection name
	selected_page= NONE;
		
	if(Ttp.commentslevel >= 3){
	    System.out.println("\tfirstPageName> " + config.firstPage);
	    System.out.println("\tlastPageName> " + config.lastPage);
	}
		
	Color3f [] testColor= new Color3f[4];
	testColor[0] = new Color3f();
	
	//right & left page curves
	rightTop_d= new BezierCurve(config.get_nx(), 1.f);
	leftTop_d= new BezierCurve(config.get_nx(), 1.f);
	rightbottom_d= new BezierCurve(config.get_nx(), 1.f);
	leftbottom_d= new BezierCurve(config.get_nx(), 1.f);

	//interior curves
	interior_curveUP= new BezierCurve(config.get_nx(), interiorCurve_width);
	interior_curveDOWN= new BezierCurve(config.get_nx(), interiorCurve_width);
	interior_curveUP_finish= new BezierCurve(config.get_nx(), interiorCurve_width);
	interior_curveDOWN_finish= new BezierCurve(config.get_nx(), interiorCurve_width);

	leftTop_curve= new BezierCurve(config.get_nx(), leftCurve_width);
	leftLower_curve= new BezierCurve(config.get_nx(), leftCurve_width);
	rightTop_curve= new BezierCurve(config.get_nx(), rightCurve_width);
	rightLower_curve= new BezierCurve(config.get_nx(), rightCurve_width);

	//reading mode
	reading_rightPage_curve= new BezierCurve(config.get_nx(), 1.f);
	//initialize four corners
	

	sp= new StaticPage[2];
	sp[0]= new StaticPage(config, config.RIGHT_EDGE); // right
	sp[1]= new StaticPage(config, config.LEFT_EDGE); // left
	bundle= new StaticPage(config, 0);
		

	dp= new DynamicPage(config);
	dpBundle= new Pages(config);//testing jumping
	
	spine1= new Spine(config);
	spine2= new Spine(config);
	
	//initialize startPageName
	startPageName= config.startingPage;
	//papers on left and right stacks
	if( (startPageName % 2) == 0){ //even
	    paper_no_lieOnLeft= startPageName/2;
	}else{ //odd
	    paper_no_lieOnLeft= startPageName/2 + 1;
	}
	
	paper_no_lieOnRight= config.get_total_papers()- paper_no_lieOnLeft;

	if(Ttp.commentslevel >= 3){	
	    System.out.println("paper_no_lieOnLeft: " + paper_no_lieOnLeft );
	    System.out.println("paper_no_lieOnRight: " + paper_no_lieOnRight );
	    System.out.println("BookConstructor.java: Init() starting page number : " 
			       + startPageName);
	}

	//update coverstate
	if(paper_no_lieOnLeft == 0 || 
	   paper_no_lieOnLeft == config.get_total_papers() )
	    coverState= CLOSE;
	else
	    coverState= OPEN;
    }

    /*
      initialize vertex arrays
      sp[0] is the right page
      sp[1] is the left page
      
      the initial right page number= paper_no_lieOnLeft * 2
      the initial left page number = right page number - 1
      
      where paper_no_lieOnLeft is initialized to 
      if stage == 0  paper_no_lieOnLeft= 0
      if stage == 1  paper_no_lieOnLeft= config.get_current_paper() @see 
      if stage == 2  paper_no_lieOnLeft= config.get_total_papers() @see 

      where config.get_current_paper() returns the current paper number, 
      corresponds to cp in the configuration file (testdata1.config)
      
     */
    public void init(GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor.java: init()");
	}
	
	GLFunc gl= canvas.gl;
	GLUFunc glu= canvas.glu;
	
	//texture info
	displayTextureSizeInfo(canvas);
	//System.out.println(gl.glGetString(GL_EXTENSIONS)); // print out all the extensions
	
	int [] numTexUnits= new int[1];
	int x= 0;
	
	if(!glj.gljMakeCurrent()) {
	    throw new RuntimeException("gljMakeCurrent failed");
	}

	//System.out.println("log of " + x + " = " + intFloorLog2(x) ); // ?
	//check textures functionalities
	gl.glGetIntegerv(GL_MAX_TEXTURE_UNITS_ARB, numTexUnits);
	gl.glGetIntegerv(GL_MAX_TEXTURE_UNITS, numTexUnits);
	int [] maxSize= new int[1];
	gl.glGetIntegerv(GL_MAX_TEXTURE_SIZE, maxSize);// tells you the largest dimension without border

	if(Ttp.commentslevel >= 3){	
	    System.out.println("the max texture units ARB> " + numTexUnits[0]);
	    System.out.println("the max texture units> " + numTexUnits[0]);
	    System.out.println("the max texture size> " + maxSize[0]);
	}
	
	tail_index= config.num_dynamic_tex_obj - 1;
	head_index= 0;
	
	//initialize pngtexture reader
	//texture= new Texture(canvas, config.param.getPrefix(), config);
	textureReader= new Texture(canvas.gl, canvas.glu, config);

	//generate fixed textures
	genFixedTexture(canvas);
	genPageMaterialTexture(canvas);
	glj.gljSwap(); 
	glj.gljCheckGL();
	glj.gljFree();// free the GL Context
		

	/*
	  here have drastically changed
	  * there is no bufferingOption testing, 
	  * initialize curTexName and nextTexName 
	  * identify boundry point i.e. firstWindow, secondlastWindow and lastWindow
	  * if we are in cover open state {
	      generate left and right current page textures
	      //we deal this later
	    }else{
	    }
	 */

	howmanyWindows= config.get_total_content_pages()/config.num_dynamic_tex_obj;
	howmanyPages= config.get_total_content_pages() % config.num_dynamic_tex_obj;
	
	//identify boundry points
	//firstWindow
	// TextureWindow is not in use
	// but we still keep them in here 
	if(Ttp.commentslevel >= 3){	
	    System.out.println("Initialize First Window> ");
	}

	firstWindow= new TextureWindow(config.num_dynamic_tex_obj, 
				       config.threasholdK);
	firstWindow.setWindowAttribute(config.firstPage);
	firstWindow.print();
	
	//lastWindow
	if(Ttp.commentslevel == 3){	
	    System.out.println("Initialize last Window> ");
	}
	
	lastWindow= new TextureWindow(config.num_dynamic_tex_obj);
	
	//secondlastWindow
	if(Ttp.commentslevel == 3){	
	    System.out.println("Initialize second last Window> ");
	}
	secondlastWindow= new TextureWindow( config.num_dynamic_tex_obj, 
					     config.threasholdK);
	secondlastWindow.recedePageBoundry( lastWindow.leftBoundry);
	secondlastWindow.print();
	
	//preload textures for firstWindow & lastWindow
	//genFirstORLastPageContent(canvas);

	//initialize windows' buffers
	//generate dynamic page name
	curWindow= new TextureWindow(config.num_dynamic_tex_obj, 
				     config.threasholdK); 
	nextWindow= new TextureWindow(config.num_dynamic_tex_obj, 
				      config.threasholdK);
	previousWindow= new TextureWindow(config.num_dynamic_tex_obj, 
					  config.threasholdK);
	

	//initializePageContent2(canvas, startPageName);
	//setRightandLeftPageName();	
	curTexName= new int[2];
	nextTexName= new int[2];
	
	for(int i=0 ; i<2; i++){
	    curTexName[i]= 0;
	    nextTexName[i]= 0;
	}
	
	//initialize rightPageName leftPageName 
	initialize_CurTwoPagesTexture(startPageName);
	
	rightTexName= 0;
	leftTexName= 0;

	
	//get texture level
	sp[0].setAll(rightPageName, 
		     rightTexName,
		     fixedTexName[PAGE_EDGE], 
		     pageMaterial[0],
		     new Color3f(1.0f, 0.0f, 0.0f), RIGHT);


	sp[1].setAll(leftPageName,
		     leftTexName,
		     fixedTexName[PAGE_EDGE], 
		     pageMaterial[0],
		     new Color3f(1.0f, 0.0f, 0.0f), LEFT);
	
	bundle.setMaterial(pageMaterial[0], 
			   fixedTexName[PAGE_EDGE]);
	
	
	//initialize standard edge 
	initialize_standard_edge_attribute();
	
	//vector arrays
	//initialize cover points
	init_coverANDpage();
	init_front_cover_pos();
	init_back_cover_pos();
	init_spine1_pos();
	init_spine2_pos();
	
	bufferingOption= DIRECT_ONE;

	
	
	
	//ctrl points
	start_Right_Control_pts= new Point3d[4][4];
	finish_Right_Control_pts= new Point3d[4][4];
	
	start_Left_Control_pts= new Point3d[4][4];
	finish_Left_Control_pts= new Point3d[4][4];
	
	//reading mode 
	double dvalue= config.readingplane_dvalue;
	double delta_x = config.paperWidth/3;
	double delta_y = config.paperHeight/3;
	
	//the last column
	finish_Right_Control_pts[0][0]= new Point3d(0, config.paperHeight/2, -dvalue); // top left
	finish_Right_Control_pts[0][1]= new Point3d(delta_x, config.paperHeight/2, -dvalue); 
	finish_Right_Control_pts[0][2]= new Point3d(config.paperWidth-delta_x, config.paperHeight/2, -dvalue); 
	finish_Right_Control_pts[0][3]= new Point3d(config.paperWidth, config.paperHeight/2, -dvalue); //top right
	
	finish_Left_Control_pts[0][0]= new Point3d(-config.paperWidth, config.paperHeight/2, -dvalue); // top left
	finish_Left_Control_pts[0][1]= new Point3d(-config.paperWidth + delta_x, config.paperHeight/2, -dvalue); 
	finish_Left_Control_pts[0][2]= new Point3d(-delta_x, config.paperHeight/2, -dvalue); 
	finish_Left_Control_pts[0][3]= new Point3d(0, config.paperHeight/2, -dvalue); //top right
	
	
	for(int i= 1; i<4; i++){
	    for(int j= 0; j<4; j++){
		finish_Right_Control_pts[i][j]= new Point3d(finish_Right_Control_pts[0][j].x, 
							    finish_Right_Control_pts[0][j].y - i*delta_y,
							    finish_Right_Control_pts[0][j].z);
		finish_Left_Control_pts[i][j]= new Point3d(finish_Left_Control_pts[0][j].x, 
							   finish_Left_Control_pts[0][j].y - i*delta_y,
							   finish_Left_Control_pts[0][j].z);
	    }
	}

	for(int i= 0; i<4; i++){
	    for(int j= 0; j<4; j++){
		start_Right_Control_pts[i][j]= new Point3d();
		start_Left_Control_pts[i][j]= new Point3d();
		
	    }
	}
	
	
	

    }

    
    void initialize_standard_edge_attribute()
    {
	this.edge_height= config.getBookThickness();
	this.edge_width= config.getPaperHeight();
	this.edge_m= edge_height/edge_width;
	

	if(coverState == OPEN){
	    startYi=(double)paper_no_lieOnLeft/(double)config.get_total_papers() * edge_height;
	    startXi= startYi/edge_m;
	    
	    endYi= 0;
	    endXi= 0;
	    
	    sp[0].setStartX(startXi);
	    sp[0].setEndX(endXi);// value unsure at moment, here might be redundant
	    sp[0].setPapers(paper_no_lieOnRight); // number of papers at Right hand stack

	    startYi= 0;
	    startXi= 0;
	    
	    endYi= (double)paper_no_lieOnRight/(double)config.get_total_papers() * edge_height;
	    endXi= endYi/edge_m;
	    
	    sp[1].setStartX(startXi);
	    sp[1].setEndX(endXi);// value unsure at moment
	    sp[1].setPapers(paper_no_lieOnLeft); // number of papers at left hand stack
	    
	    
	}else if(coverState == CLOSE){
	    //if front cover facing up
	    if(isFrontCoverFacingUP()){
		startYi= (double)paper_no_lieOnLeft/(double)config.get_total_papers() * edge_height;
		startXi= startYi/edge_m;

		endYi= 0;
		endXi= 0;

		sp[0].setStartX(startXi);
		sp[0].setEndX(endXi);// value unsure at moment, here might be redundant
		sp[0].setPapers(paper_no_lieOnRight); // number of papers at Right hand stack
		
	    }
	    //if back cover facing up
	    else if(isFrontCoverFacingDOWN()){
		startYi= 0;
		startXi= 0;
		
		endYi= (double)paper_no_lieOnRight/(double)config.get_total_papers() * edge_height;
		endXi= endYi/edge_m;

		sp[1].setStartX(startXi);
		sp[1].setEndX(endXi);// value unsure at moment
		sp[1].setPapers(paper_no_lieOnLeft); // number of papers at left hand stack
	    }
	}
	
    }



    public void initialize_staticPages()
    {
	//initialize rightPageName leftPageName 
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor.java: initialize_staticPages()");
	}
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("BookConstructor.java:  anchor Page List's initial capacity = "+ anchorPageList.size() );
	}

	//initialize anchor pages
	sp[0].setPageAnchors(anchorPageList);
	sp[1].setPageAnchors(anchorPageList);
	bundle.setPageAnchors(anchorPageList);

	initialize_CurTwoPagesTexture(startPageName);
	
	if(coverState == OPEN){
	    leftTexName= transform(texturePools.getImageBytes(leftPageName), leftPageName);
	    rightTexName= transform(texturePools.getImageBytes(rightPageName), rightPageName);
	   
	    if(Ttp.commentslevel >= 3){
		System.out.println("BookConstructor.java: initialize_staticPages() rightTexname=  " + rightTexName );
		System.out.println("BookConstructor.java: initialize_staticPages() leftTexname=  " + leftTexName );
	    }
	    
	    int pageLevel= texturePools.getPageMaterialLevel(rightPageName);
	    sp[0].setPageUPPageName(rightPageName);
	    sp[0].setPageUPTexture(rightTexName);
	    sp[0].setPageMaterialUP(pageMaterial[pageLevel]);
	    sp[0].setPageDOWNPageName(config.lastPage);

	    pageLevel= texturePools.getPageMaterialLevel(leftPageName);
	    sp[1].setPageUPPageName(leftPageName);
	    sp[1].setPageUPTexture(leftTexName);
	    sp[1].setPageMaterialUP(pageMaterial[pageLevel]);
	    sp[1].setPageDOWNPageName(config.firstPage);
	    
	}else{
	    //if front cover facing up
	    if(isFrontCoverFacingUP()){
		sp[0].setPageUPPageName(rightPageName);
		sp[0].setPageDOWNPageName(config.lastPage);
		sp[1].setPageUPPageName(leftPageName);
	    }
	    //if back cover facing up
	    else if(isFrontCoverFacingDOWN()){
		sp[1].setPageUPPageName(leftPageName);
		sp[1].setPageDOWNPageName(config.firstPage);
		sp[0].setPageUPPageName(rightPageName);
	    }
	    //rightTexName= 0;
	    //leftTexName= 0;
	}
    }

    


    /*void init_ledge_list()
    {
	double radius= config.getCoverThickness()/2;
	double height= config.get_zMax() + config.getCoverMargin();

	long qobj;
	startList = gl.glGenLists(4);
	cylinder= startList;
	qobj = glu.gluNewQuadric();

	if(startList != 0){
	    gl.glNewList(startList, GL_COMPILE);
	    glu.gluQuadricDrawStyle(qobj, glu.GLU_SMOOTH); // flat shading 
	      glu.gluQuadricNormals(qobj, glu.GLU_SMOOTH);
	      glu.gluCylinder(qobj, radius, radius, height, 6, 3);
	    gl.glEndList();
	   
	    disk = startList+1;
	    gl.glNewList(disk, GL_COMPILE);
	    glu.gluQuadricDrawStyle(qobj, glu.GLU_FLAT); // all polygons wireframe
	      glu.gluQuadricNormals(qobj, glu.GLU_FLAT);
	      glu.gluDisk(qobj, 0, radius, 6, 4);
	    gl.glEndList();
	    }

     }
    */

    void makeCheckboardImage()
    {
	int i, j;
	int I,J, K;
	int c;
	
	for (i = 0; i < checkImageHeight; i++) {
	    for (j = 0; j < checkImageWidth; j++) {
		
		//(( ((i&0x8)==0)^((j&0x8)) == 0 ))*255;
			
		if( ((i & 0x8) ^ (j & 0x8)) == 0)
		    K= 1;
		else
		    K= 0;
		
		if(K == 1)
		    c = (byte)255;
		else
		    c= 0;
		
		checkImage_serial[(checkImageWidth*i+j)*4]= (byte) c;
		checkImage_serial[(checkImageWidth*i+j)*4 + 1]= (byte) c;
		checkImage_serial[(checkImageWidth*i+j)*4 + 2]= (byte) c;
		checkImage_serial[ (checkImageWidth*i+j)*4 + 3]= (byte) 255;
	    }
	    
	}
	
	
    }
    


  private int intFloorLog2( int x)
  {
    int a= -1;
       
    do{
      x/=2;
      a++;
    }while(x>0);

    return a;
  }
  
    /*
      
     */
    private void find_MaxTexture(GLCanvas canvas,
				 int internalFormat, 
				 int dim,
				 int xAspect, int yAspect, 
				 int border, 
				 int maxMipmapLevel,
				 int [] dimOut)
  {
      if(Ttp.commentslevel >= 2){
	  System.out.println("BookConstructor.java: find_MaxTexture()");
      }
      
      GLFunc gl= canvas.gl;
      
      int level = 0, levelOffset = 0;
      int width = 1, height = 1;
      int maxLevel = 0, maxWidth = 0, maxHeight = 0;

    

      if (xAspect > yAspect) {
	  width = xAspect / yAspect;
	  levelOffset = intFloorLog2(width);
      } else {
	  height = yAspect / xAspect;
	  levelOffset = intFloorLog2(height);
      }
      
      while (true) {
	  int [] proxyComponents= new int[1];
	  
	  switch (dim) {
	  case 1:
	      gl.glTexImage1D(GL_PROXY_TEXTURE_1D,
			      level, internalFormat,
			      width+2*border, border,
			      GL_RGBA, GL_UNSIGNED_BYTE,(byte [])null );
	      
	      gl.glGetTexLevelParameteriv(GL_PROXY_TEXTURE_1D, level,
					  GL_TEXTURE_COMPONENTS, proxyComponents);
	      break;
	  case 2:
	      gl.glTexImage2D(GL_PROXY_TEXTURE_2D,
			      level, internalFormat,
			      width+2*border, height+2*border, border,
			      GL_RGBA, GL_UNSIGNED_BYTE, (byte [])null);
	      
	      gl.glGetTexLevelParameteriv(GL_PROXY_TEXTURE_2D,level,
					  GL_TEXTURE_COMPONENTS,proxyComponents);
	      break;
	  default:
	      dimOut[0]= 0;// *widthout = 0; 
	      dimOut[1]= 0;//*heightout = 0;
	      
	      return;
	  }
	  
	  if (proxyComponents[0] != internalFormat) {
	      /* proxy allocation failed -- we're done */
	      break;
	  } else {
	      
	      /* proxy allocation succeeded -- see how we did */
	      if (level>maxLevel || width>maxWidth || height>maxHeight){
		  maxLevel = level;
		  maxWidth = width << level;
		  maxHeight = height << level;
	      }
	  }
	  
	  if (maxMipmapLevel == 0) {
	  /* try the next larger image size at level zero */
	  width <<= 1;
	  height <<= 1;
        } else {
	  /* try same image size at next higher mipmap level */
	  ++level;
	  if (level+levelOffset > maxMipmapLevel) {
	    /* can't query levels which don't exist--we're done */
	    break;
	  }
        }
    }
    
    if (maxWidth>0 && maxHeight>0) {
	maxWidth += 2*border;
	maxHeight += 2*border;
    }
    
    dimOut[0]= maxWidth;// *widthout
    dimOut[1]= maxHeight;// *heightout

    if(Ttp.commentslevel >= 3){
	System.out.println();
	System.out.println();
    }
    
  }
    
  
    private void displayTextureSizeInfo(GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor.java: displayTextureSizeInfo()");
	}
	
	GLFunc gl= canvas.gl;
	
	int [] maxTextureSize = new int [1];
	int [] maxTextureLevel = new int [1];
	int [] dimensionOut= new int [2]; //maxwidth,  maxheight
	
	if(Ttp.commentslevel >= 3){
	    System.out.println();
	    System.out.println();
	}	
	
	gl.glGetIntegerv(GL_MAX_TEXTURE_SIZE, maxTextureSize);
	if(Ttp.commentslevel >= 3){
	    System.out.println("GL_MAX_TEXTURE_SIZE: " + maxTextureSize[0] );
	}
	
	

	maxTextureLevel[0] = intFloorLog2(maxTextureSize[0]);
	if(Ttp.commentslevel >= 3){
	    System.out.println("max Texture level: " + maxTextureLevel[0] );
	}
	
	find_MaxTexture(canvas,
			GL_RGB, 
			2, 
			1, 1, 
			0, 
			0, dimensionOut);
	
	find_MaxTexture(canvas, GL_RGBA, 2, 2, 1, 0, 0, dimensionOut);
	find_MaxTexture(canvas, GL_RGB, 2, 1, 1, 0, maxTextureLevel[0], dimensionOut); 
	find_MaxTexture(canvas, GL_LUMINANCE_ALPHA, 2, 1, 1, 1, 0, dimensionOut);
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("RGB 1:1: (" + dimensionOut[0] + ", " + dimensionOut[1] + ")");
	    System.out.println("RGBA 1:1: (" + dimensionOut[0] + ", " + dimensionOut[1] +")" );
	    System.out.println("RGBA 1:1: (" + dimensionOut[0] + ", " + dimensionOut[1] + ") mipmap" );
	    System.out.println("LUMINANCE_ARGBA 1:1: (" + dimensionOut[0] + ", " + dimensionOut[1] + ") border" );
	    }
	
    }

    //deprecated
    public void startFillingProcess()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor: startFillingProcess()");
	}
	//create FillingTexture object
	FillingTexture fillingTask= new FillingTexture(this,
						       selected_side,
						       selected_page);
	//FillingTexture fillingTask= new FillingTexture(this, selected_page); //should 
	fillingTask.start();
	//Record the starttime 
	//start the FillingTexture object thread
    }


    //deprecated
    public void startinitializingPageContent()
    {
	int page_no;
	if(paper_no_lieOnLeft == 0){
	    page_no= sp[0].getPage_num();
	}else if(paper_no_lieOnLeft == config.get_total_papers()){
	    page_no= sp[1].getPage_num();
	}else{
	    page_no= sp[0].getPage_num();
	}
	
	InitializeWindow window= new InitializeWindow(this, page_no);
	window.start();
    }
    
    /*
      update nextWindow textures
      at the moment, it updates sequentially
      
    */
    public void updateTextureObject(int selected_side,
				    int selected_page)
    {
	
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor: updateTextureObject()");
	}
	int fname, page_name;
	int buffersize;
	int difference= 0;
	int counter, index;
	
	if(selected_side == RIGHT){
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tStart filling nexWindow textures");
	    }
	    if( selected_page >= secondlastWindow.leftBoundry &&
		selected_page <= secondlastWindow.rightBoundry ){
		//if within the second last window
		buffersize= lastWindow.buffersize;
		difference=  nextWindow.buffersize - lastWindow.buffersize;//?
		
	    }else{
		buffersize= nextWindow.buffersize;
	    }
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tbuffersize= " + buffersize);
		System.out.println("\tdifference= " + difference);
	    }
	    
	    page_name= nextWindow.leftBoundry;
	    fname= page_name + config.get_thefirstPdfpage();
	    
	    counter=0; 
	   
	    while(counter < buffersize){
		index= page_name % config.num_dynamic_tex_obj;
		if(Ttp.commentslevel >= 3){
		    System.out.println("Current Fills texName[" + counter + "]" );
		    System.out.println("\tPage name: " + page_name );
		    System.out.println("\tfile name: " + fname );
		    System.out.println("\tindex: " + index );
		    System.out.println("\ttexName: " + nextWindow.texName[index] );
		}
		
		scene.performTexturefilling(textureReader,
					    fname,
					    nextWindow.texName[index]);
		
		counter++;
		page_name++;
		fname++;
	    }
	    
	    nextWindow.filled= true;
	    //if there is some difference
	}else{
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tStart filling previousWindow textures");
	    }
	    page_name= previousWindow.leftBoundry;
	    fname= page_name + config.get_thefirstPdfpage();

	    buffersize= config.num_dynamic_tex_obj;
	    counter=0; 
	    while(counter < buffersize){
		index= page_name % config.num_dynamic_tex_obj;
		if(Ttp.commentslevel >= 3){
		    System.out.println("Current Fills texName[" + counter + "]" );
		    System.out.println("\tPage name: " + page_name );
		    System.out.println("\tfile name: " + fname );
		    System.out.println("\tindex: " + index );
		    System.out.println("\ttexName: " + previousWindow.texName[index] );
		}
		
		scene.performTexturefilling(textureReader,
					    fname,
					    previousWindow.texName[index]);
		
		counter++;
		page_name++;
		fname++;
	    }
	    
	    previousWindow.filled= true; 

	}

	
    }
    

    void genFixedTexture(GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("genFixedTexture()");
	}
	fixedTexName= new int[num_fixed_tex_obj];//fixed texture name
	GLFunc gl= canvas.gl;
	GLUFunc glu= canvas.glu;
	
	/*
	  + glGenTextures(GLsizei n, GLuint *textureNames); 
	  Returns n currently unused names for texture objects in the array textureNames. 
	  The names returned in textureNames do not have to be a contiguous set of integers. 

	  The names in textureNames are marked as used, but they acquire texture state and 
	  dimensionality (1D or 2D) only when they are first bound. 
	  Zero is a reserved texture name and is never returned as a texture name by glGenTextures().

	*/
	//checkboard generated from the procedure
	gl.glGenTextures(num_fixed_tex_obj, fixedTexName);

	
	gl.glPixelStorei(GL_UNPACK_ALIGNMENT, 1);//???
	gl.glBindTexture(GL_TEXTURE_2D, fixedTexName[CHECKBOARD]); 
	gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, 
			   GL_NEAREST);
	gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, 
			   GL_NEAREST);
	makeCheckboardImage();
	gl.glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, checkImageWidth, 
			checkImageHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, 
			checkImage_serial);

	
	int n= 0, i= BOOKFRONT_EDGE; // i = 1
	 

	//read from the file
	while(i < num_fixed_tex_obj){ // i < 10
	    if(Ttp.commentslevel >= 3){
		System.out.println("\ti= " + i );
	    }

	    if(i == BOOK_FRONT_COVER ){ //ignore book front cover
		if(textureReader.readPageTextureFromFile(0)){ //given page number
		    front_cover_level= config.maxlevel;
		    front_cover_imageWidth= config.imageWidth_highresol;
		    front_cover_imageHeight= config.imageHeight_highresol;
		    front_cover_initialized= true;
		
		    if(textureReader.isOk()){
			setupMipmapsTexturing(canvas, fixedTexName[i]);
		    }
		}
	    }

	    if(config.parameters.getfileType() == DJVU){
		if(i == INSIDE_BOOK_FRONT_COVER ){ //ignore book front cover
		    if(textureReader.readPageTextureFromFile(1)){ //given page number
			if(textureReader.isOk()){
			    setupMipmapsTexturing(canvas, fixedTexName[i]);
			}
		    }
		}
	    }
	    
	    if(config.parameters.getfileType() == DJVU){
		if(i == BOOK_BACK_COVER ){ //ignore book front cover
		    if(textureReader.readPageTextureFromFile(config.pdf_total_pages-1)){ //given page number
			if(textureReader.isOk()){
			    setupMipmapsTexturing(canvas, fixedTexName[i]);
			}
		    }
		}
	    }

	    if(config.parameters.getfileType() == DJVU){
		if(i == INSIDE_BOOK_BACK_COVER ){ //ignore book front cover
		    if(textureReader.readPageTextureFromFile(config.pdf_total_pages-2)){ //given page number
			if(textureReader.isOk()){
			    setupMipmapsTexturing(canvas, fixedTexName[i]);
			}
		    }
		}
	    }
	    
	    
	    if(i == PAGE_MATERIAL){
		
		
	    }

	    if(i == BORDER){
		gl.glBindTexture(GL_TEXTURE_2D, fixedTexName[BORDER]); 
		gl.glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
		gl.glTexParameteri(GL_TEXTURE_1D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		gl.glTexParameteri(GL_TEXTURE_1D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		gl.glTexImage1D(GL_TEXTURE_1D, 0, 3, 8, 0, GL_RGB, GL_UNSIGNED_BYTE,
				roygbiv_image);
	    }
	    

	    if(i == PAGE_EDGE){
		textureReader.readFixedTexture(i);// read from image file
		if(textureReader.isOk()){
		    //if(i == BOOK_FRONT_COVER )
		    //setupMipmapsTexturing(canvas, fixedTexName[i]);
		    //else{
		    //all png format
		    gl.glBindTexture(GL_TEXTURE_2D, fixedTexName[i]);
		    gl.glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		    gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		    gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
		    gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		    gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		    
		    glu.gluBuild2DMipmaps(GL_TEXTURE_2D, 
					  3, 
					  textureReader.getImageWidth(), 
					  textureReader.getImageHeight(), 
					  GL_RGB, 
					  GL_UNSIGNED_BYTE, 
					  textureReader.getPNGTexture());
		    
		}
		
	    }

	    i++;
	    }
    }
    

    void genPageMaterialTexture(GLCanvas canvas)
    {
	//load in page textures
	int levels= 8; 
	pageMaterial= new int[levels]; // from 0 to 7
	
	GLFunc gl= canvas.gl;
	GLUFunc glu= canvas.glu;
	gl.glGenTextures(levels, pageMaterial);
	
	pageMaterial[0]= 0; //level 0: no texture
	
	int lvl= 1; // level: 1 to 7 read from the file
	while(lvl < levels){
	    textureReader.readPageMaterial(lvl);
	    if(textureReader.isOk()){
		setupMipmapsTexturing(canvas, pageMaterial[lvl]);
	    }
	    lvl++;
	}
    }
    
    

    /*
      used to be called 'genPageContent(GLCanvas canvas, int curPageName)'
      generating pages textures

      with lastWindow & firstWindow
     */
    void initializePageContent(GLCanvas canvas, int curPageName)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("initializePageContent()");
	}
	GLFunc gl= canvas.gl;
	
	if(config.bufferingOption == DIRECT_ONE ||
	   config.bufferingOption == DIRECT_TWO){
	    
	    
	}else if(config.bufferingOption == ANCHORING){
	    //not yet implemented
	    
	}else if(config.bufferingOption == WINDOWING){
	    //Preloading the textures
	    if( curPageName >= lastWindow.leftBoundry && 
		curPageName <= lastWindow.rightBoundry ){
		if(Ttp.commentslevel >= 3){
		    System.out.println("We start at the last segment");
		    System.out.println("Initialize Current Window> ");
		}
		
		//do not need to gen new texNames for curWindow and nextWindow
		//generating curWindow textures simply by copying from the lastWindow
		if(Ttp.commentslevel >= 3){
		    System.out.println("\tgenerating curWindow by copying from the lastWindow");
		}
		
		curWindow.setWindowAttribute(curPageName);//initialize setSRSL() & set left/right boundry
		curWindow.copyTextureNames(lastWindow.texName);
		curWindow.filled= true;
		
		if(Ttp.commentslevel >= 3){
		    System.out.println("Generate next Window pages by copying from the lastWindow ");
		}
		nextWindow.setWindowAttribute(curPageName);//nextWindow is set to curWindow
		nextWindow.copyTextureNames(lastWindow.texName);
		nextWindow.filled= true;
		
		if( (howmanyWindows == 1 && howmanyPages == 0) || //exactly 1 window
		    (howmanyWindows == 0 && howmanyPages > 0) ){
		    if(Ttp.commentslevel >= 3){
			System.out.println("1 window");
		    }
		    
		    if(Ttp.commentslevel >= 3){
			System.out.println("Generate previous Window pages by copying from the lastWindow ");
		    }
		    previousWindow.setWindowAttribute(curPageName);//previousWindow is set to curWindow
		    previousWindow.copyTextureNames(lastWindow.texName);
		    previousWindow.filled= true;
		    
		    //do not generate Page texture for previousWindow
		    
		
		}else if( (howmanyWindows == 2 && howmanyPages == 0) || //exactly 2 windows
			  (howmanyWindows == 1 && howmanyPages > 0) ){  
		    if(Ttp.commentslevel >= 3){
			System.out.println("2 windows");
		    }
		    
		    if(Ttp.commentslevel >= 3){
			System.out.println("Generate previous Window pages by copying from the firstWindow ");
		    }
		    previousWindow.recedePageBoundry( curWindow.leftBoundry );
		    previousWindow.copyTextureNames(firstWindow.texName);
		    previousWindow.filled= true;
		    
		}else{
		    if(Ttp.commentslevel >= 3){
			System.out.println("more than 2 windows");
		    }
		    
		    if(Ttp.commentslevel >= 3){
			System.out.println("\tAssigning new texNames for  previousWindow");
		    }
		    gl.glGenTextures(config.num_dynamic_tex_obj, previousWindow.texName);
		    
		    if(Ttp.commentslevel >= 3){
			System.out.println("filling previous Window pages> ");
		    }
		    
		    previousWindow.recedePageBoundry( curWindow.leftBoundry );
		    genPageTexture(canvas, 
				   previousWindow.leftBoundry,
				   previousWindow.texName,
				   previousWindow.buffersize);
		    previousWindow.filled= true;
		}
		
		
		
		
	    }else if( curPageName >= secondlastWindow.leftBoundry && 
		      curPageName <= secondlastWindow.rightBoundry  ){
		if(Ttp.commentslevel >= 3){
		    System.out.println("We start at the second last segment");
		}
		
		curWindow.setWindowAttribute(curPageName);//include setSRSL() & left/right boundry
		
		
		if( (howmanyWindows == 2 && howmanyPages == 0) || //exactly 2 windows
		    (howmanyWindows == 1 && howmanyPages > 0) ){
		    if(Ttp.commentslevel >= 3){
			System.out.println("2 windows");
			System.out.println("\tgenerating curWindow by copying from the firstWindow");
		    }
		    //generating curWindow textures simply by copying from the firstWindow
		    curWindow.copyTextureNames(firstWindow.texName);
		    curWindow.filled= true;

		    if(Ttp.commentslevel >= 3){
			System.out.println("Generate previous Window pages by copying from the firstWindow ");
		    }
		    
		    previousWindow.setWindowAttribute(curPageName);//include setSRSL() & left/right boundry
		    previousWindow.copyTextureNames(firstWindow.texName);
		    previousWindow.filled= true;
		}else{
		    if(Ttp.commentslevel >= 3){
			System.out.println("more than 2 windows");
			System.out.println("\tAssigning new texNames for curWindow");
		    }
		    gl.glGenTextures(config.num_dynamic_tex_obj, curWindow.texName);
		    
		    if(Ttp.commentslevel >= 3){
			System.out.println("filling curWindow pages");
		    }
		    genPageTexture(canvas, 
				   curWindow.leftBoundry,
				   curWindow.texName,
				   curWindow.buffersize);
		    curWindow.filled= true;
		    
		    previousWindow.recedePageBoundry( curWindow.leftBoundry );
		    if(previousWindow.leftBoundry == firstWindow.leftBoundry && 
		       previousWindow.rightBoundry == firstWindow.rightBoundry){
			if(Ttp.commentslevel >= 3){
			    System.out.println("\tgenerating textures of previousWindow by copying from the firstWindow");
			}
			previousWindow.copyTextureNames(firstWindow.texName);
		    }else{
			if(Ttp.commentslevel >= 3){
			    System.out.println("\tAssigning new texNames for  previousWindow");
			}
			gl.glGenTextures(config.num_dynamic_tex_obj, previousWindow.texName);
			
			if(Ttp.commentslevel >= 3){
			    System.out.println("filling previous Window pages> ");
			}
			genPageTexture(canvas, 
				       previousWindow.leftBoundry,
				       previousWindow.texName,
				       previousWindow.buffersize);
		    }
		    previousWindow.filled= true;
		}
		
		if(Ttp.commentslevel >= 3){
		    System.out.println("\tgenerating nextWindow by copying from the lastWindow");
		}
		nextWindow.advancePageBoundry(curWindow.rightBoundry);
		nextWindow.copyTextureNames(lastWindow.texName);
		nextWindow.filled= true;
		

	    }else if(curPageName >= firstWindow.leftBoundry && 
		     curPageName <= firstWindow.rightBoundry){
		if(Ttp.commentslevel >= 3){
		    System.out.println("We start at the first window");
		}
		
		curWindow.setWindowAttribute(curPageName);
		nextWindow.advancePageBoundry(curWindow.rightBoundry);
		previousWindow.setWindowAttribute(curPageName);
		
		if(Ttp.commentslevel >= 3){
		    System.out.println("\tgenerating curWindow by copying from the firstWindow");
		}
		curWindow.copyTextureNames(firstWindow.texName);
		curWindow.filled= true;
		
		if(Ttp.commentslevel >= 3){
		    System.out.println("\tAssigning new texNames for nextWindow");
		}
		gl.glGenTextures(config.num_dynamic_tex_obj, nextWindow.texName);
		
		if(Ttp.commentslevel >= 3){
		    System.out.println("filling next Window pages> ");
		}
		genPageTexture(canvas, 
			       nextWindow.leftBoundry,
			       nextWindow.texName,
			       nextWindow.buffersize);
		nextWindow.filled= true;
		
		if(Ttp.commentslevel >= 3){
		    System.out.println("\tgenerating previousWindow by copying from the firstWindow");
		}
		previousWindow.copyTextureNames(firstWindow.texName);
		previousWindow.filled= true;
		
	    }else{
		//if starting page locates in the preceding last window segment
		if(Ttp.commentslevel >= 3){
		    System.out.println("We start inbetween");
		}
		
		curWindow.setWindowAttribute(curPageName);
		nextWindow.advancePageBoundry( curWindow.rightBoundry);
		previousWindow.recedePageBoundry( curWindow.leftBoundry );
		
		if(Ttp.commentslevel >= 3){
		    System.out.println("\tAssigning new texNames for curWindow");
		}
		gl.glGenTextures(config.num_dynamic_tex_obj, curWindow.texName);
		
		if(Ttp.commentslevel >= 3){
		    System.out.println("\tfilling textures of curWindow ");
		}
		
		genPageTexture(canvas, 
			       curWindow.leftBoundry,
			       curWindow.texName,
			       curWindow.buffersize);
		curWindow.filled= true;
		
		if(previousWindow.leftBoundry == firstWindow.leftBoundry && 
		   previousWindow.rightBoundry == firstWindow.rightBoundry){
		    if(Ttp.commentslevel >= 3){
			System.out.println("\tgenerating textures of previousWindow by copying from the firstWindow");
		    }
		    previousWindow.copyTextureNames(firstWindow.texName);
		}else{
		    if(Ttp.commentslevel >= 3){
			System.out.println("\tAssigning new texNames for  previousWindow");
		    }
		    gl.glGenTextures(config.num_dynamic_tex_obj, previousWindow.texName);
		    if(Ttp.commentslevel >= 3){
			System.out.println("\tfilling textures of previousWindow ");
		    }
		    genPageTexture(canvas, 
				   previousWindow.leftBoundry,
				   previousWindow.texName,
				   previousWindow.buffersize);
		}
		previousWindow.filled= true;
		
		if(Ttp.commentslevel >= 3){
		    System.out.println("\tAssigning new texNames for  nextWindow");
		}
		gl.glGenTextures(config.num_dynamic_tex_obj, nextWindow.texName);
		if(Ttp.commentslevel >= 3){
		    System.out.println("\tfilling textures of nextWindow ");
		}
		genPageTexture(canvas, 
			       nextWindow.leftBoundry,
			       nextWindow.texName,
			       nextWindow.buffersize);
		nextWindow.filled= true;
		
	    }
	}else{
	    //do nothing
	    
	}
    }
    

    /*
      modified from '09_16_2003'
      without lastWindow & firstWindow
     */
    void initializePageContent2(int curPageName)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("initializePageContent2");
	}
	
	if( curPageName >= lastWindow.leftBoundry && 
	    curPageName <= lastWindow.rightBoundry ){
	    if(Ttp.commentslevel >= 3){
		System.out.println("We start at the last segment");
	    }

	    //gl.glGenTextures(lastWindow.buffersize, curWindow.texName);
	    scene.genNewTexNames(lastWindow.buffersize, curWindow.texName);
	    curWindow.setWindowAttribute(curPageName);//initialize setSRSL() & set left/right boundry
	    genPageTexture(curWindow.leftBoundry,
			   curWindow.texName,
			   lastWindow.buffersize); // only need to generate this much textures
	    curWindow.filled= true;

	    if( (howmanyWindows == 1 && howmanyPages == 0) || //exactly 1 window
		(howmanyWindows == 0 && howmanyPages > 0) ){ 
		if(Ttp.commentslevel >= 3){
		    System.out.println("One Window");
		}
		//one window
		previousWindow.setWindowAttribute(curPageName);//previousWindow is set to curWindow
		previousWindow.copyTextureNames(curWindow.texName);
		previousWindow.filled= true;

	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("2 Windows or more than 2 windows");
		}
		//2 windows or more than 2 windows
		previousWindow.recedePageBoundry( curWindow.leftBoundry );
		//gl.glGenTextures(config.num_dynamic_tex_obj, previousWindow.texName);
		scene.genNewTexNames(config.num_dynamic_tex_obj, previousWindow.texName);
		
		genPageTexture(previousWindow.leftBoundry,
			       previousWindow.texName,
			       previousWindow.buffersize);
		previousWindow.filled= true;
	    }

	    nextWindow.setWindowAttribute(curPageName);//nextWindow is set to curWindow
	    nextWindow.copyTextureNames(curWindow.texName);
	    nextWindow.filled= true;

	}else if( curPageName >= secondlastWindow.leftBoundry && 
		  curPageName <= secondlastWindow.rightBoundry  ){
	    if(Ttp.commentslevel >= 3){
		System.out.println("We start at the second last segment");
	    }

	    //curWindow
	    curWindow.setWindowAttribute(curPageName);//include setSRSL() & left/right boundry
	    //gl.glGenTextures(config.num_dynamic_tex_obj, curWindow.texName);
	    scene.genNewTexNames(config.num_dynamic_tex_obj, curWindow.texName);

	    genPageTexture(curWindow.leftBoundry,
			   curWindow.texName,
			   curWindow.buffersize);
	    curWindow.filled= true;

	    //previousWindow
	    if(curWindow.leftBoundry == firstWindow.leftBoundry && 
	       curWindow.rightBoundry == firstWindow.rightBoundry){
		if(Ttp.commentslevel >= 3){
		    System.out.println("\t2 windows");
		}
		
		previousWindow.setWindowAttribute(curPageName); // previousWindow is set to curWindow
		previousWindow.copyTextureNames(curWindow.texName);
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("\tMore than 2 windows");
		}
		
		previousWindow.recedePageBoundry( curWindow.leftBoundry );
		//gl.glGenTextures(config.num_dynamic_tex_obj, previousWindow.texName);
		scene.genNewTexNames(config.num_dynamic_tex_obj, previousWindow.texName);

		genPageTexture(previousWindow.leftBoundry,
			       previousWindow.texName,
			       previousWindow.buffersize);

	    }
	    previousWindow.filled= true;

	    //nextWindow
	    nextWindow.advancePageBoundry(curWindow.rightBoundry);
	    //gl.glGenTextures(config.num_dynamic_tex_obj, nextWindow.texName);
	    scene.genNewTexNames(config.num_dynamic_tex_obj, nextWindow.texName);

	    genPageTexture(nextWindow.leftBoundry,
			   nextWindow.texName,
			   lastWindow.buffersize);
	    
	    nextWindow.filled= true;

	}else if(curPageName >= firstWindow.leftBoundry && 
		 curPageName <= firstWindow.rightBoundry){
	    if(Ttp.commentslevel >= 3){
		System.out.println("We start at the first window");
	    }
	    
	    //curWindow
	    curWindow.setWindowAttribute(curPageName);
	    //gl.glGenTextures(config.num_dynamic_tex_obj, curWindow.texName);
	    scene.genNewTexNames(config.num_dynamic_tex_obj, curWindow.texName);
	    genPageTexture(curWindow.leftBoundry,
			   curWindow.texName,
			   curWindow.buffersize);
	    curWindow.filled= true;
	    
	    //previousWindow
	    previousWindow.setWindowAttribute(curPageName);
	    previousWindow.copyTextureNames(curWindow.texName);
	    previousWindow.filled= true;
	    
	    //nextWindow 
	    nextWindow.advancePageBoundry(curWindow.rightBoundry);
	    //gl.glGenTextures(config.num_dynamic_tex_obj, nextWindow.texName);
	    scene.genNewTexNames(config.num_dynamic_tex_obj, nextWindow.texName);
	    genPageTexture(nextWindow.leftBoundry,
			   nextWindow.texName,
			   nextWindow.buffersize);
	    nextWindow.filled= true;
	    
	
	}else{
	    if(Ttp.commentslevel >= 3){
		System.out.println("We start inbetween");
	    }
	    //curWindow
	    curWindow.setWindowAttribute(curPageName);
	    //gl.glGenTextures(config.num_dynamic_tex_obj, curWindow.texName);
	    scene.genNewTexNames(config.num_dynamic_tex_obj, curWindow.texName);

	    genPageTexture(curWindow.leftBoundry,
			   curWindow.texName,
			   curWindow.buffersize);
	    curWindow.filled= true;

	    //previousWindow
	    previousWindow.recedePageBoundry( curWindow.leftBoundry );
	    //gl.glGenTextures(config.num_dynamic_tex_obj, previousWindow.texName);
	    scene.genNewTexNames(config.num_dynamic_tex_obj, previousWindow.texName);

	    genPageTexture(previousWindow.leftBoundry,
			   previousWindow.texName,
			   previousWindow.buffersize);
	    previousWindow.filled= true;

	    //nextWindow
	    nextWindow.advancePageBoundry( curWindow.rightBoundry);
	    //gl.glGenTextures(config.num_dynamic_tex_obj, nextWindow.texName);
	    scene.genNewTexNames(config.num_dynamic_tex_obj, nextWindow.texName);
	    genPageTexture(nextWindow.leftBoundry,
			   nextWindow.texName,
			   nextWindow.buffersize);
	    nextWindow.filled= true;
	}

	
	setRightandLeftPageName();
	
	

    }


    /*
      given 'specified_window' 

      lastWindow.texName and firstWindow.texName stays perminent throughout the execution of the 
      program
     */
    void genFirstORLastPageContent(GLCanvas canvas)
    {
	GLFunc gl= canvas.gl;
	if(Ttp.commentslevel >= 2){
	    System.out.println("genFirstORLastPageContent()");
	}

	//there are two cases
	if( (howmanyWindows == 1 && howmanyPages == 0) || //exactly 1 window
	    (howmanyWindows == 0 && howmanyPages > 0) ){  
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tgenerating lastWindow");
	    }
	    
	    //lastWindow.texName= new int[config.num_dynamic_tex_obj];
	    
	    gl.glGenTextures(lastWindow.buffersize, lastWindow.texName);
	    // generating lastWindow
	    genPageTexture(canvas, 
			   lastWindow.leftBoundry,
			   lastWindow.texName,
			   lastWindow.buffersize);
	    
	}else{
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tgenerating firstWindow & lastWindow");
	    }
	    //firstWindow.texName= new int[config.num_dynamic_tex_obj];
	    //lastWindow.texName= new int[config.num_dynamic_tex_obj];

	    gl.glGenTextures(firstWindow.buffersize, firstWindow.texName);
	    gl.glGenTextures(lastWindow.buffersize, lastWindow.texName);
	    // generating firstWindow & lastWindow
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tgenerating firstWindow");
	    }
	    
	    genPageTexture(canvas, 
			   firstWindow.leftBoundry,
			   firstWindow.texName,
			   firstWindow.buffersize);
	    
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tgenerating lastWindow");
	    }

	    genPageTexture(canvas, 
			   lastWindow.leftBoundry,
			   lastWindow.texName,
			   lastWindow.buffersize);
	}

    }


    /*
      set left/rightPageName & left/rightTexName
     */
    void setRightandLeftPageName()
    {
	// assigning left & right page number
	int index;
	

	//extract the correct right & left page name & tex name
	if(curWindow.SL == config.lastPage){
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tThe last page");
	    }
	    rightPageName= NONE;
	    rightTexName= 0;
	    
	    leftPageName= curWindow.SL;
	    index= leftPageName % curWindow.buffersize;
	    leftTexName= curWindow.texName[index];
	    
	}else if(curWindow.SL == curWindow.rightBoundry){
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tWe start SL at boundry");
		System.out.println("\t\tlast element");
	    }
	    
	    
	    rightPageName= curWindow.SR;
	    index= rightPageName % nextWindow.buffersize;
	    rightTexName= nextWindow.texName[index];
	    
	    leftPageName= curWindow.SL;
	    index= leftPageName % curWindow.buffersize;
	    leftTexName= curWindow.texName[index];
		
	}else if(curWindow.SR == curWindow.leftBoundry){
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tWe start SR at boundry");
	    }
	    
	    if(curWindow.SR == 0){ //the first page
		if(Ttp.commentslevel >= 3){
		    System.out.println("\t\tfirst page");
		}
		rightPageName= curWindow.SR;//0
		index= curWindow.SR % curWindow.buffersize;
		rightTexName= curWindow.texName[index];
		
		leftPageName= NONE;//1
		leftTexName= curWindow.texName[0];
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("\t\tfirst element");
		}
		rightPageName= curWindow.SR;
		index= curWindow.SR % curWindow.buffersize;
		rightTexName= curWindow.texName[index];
		
		leftPageName= curWindow.SL;
		index= leftPageName % previousWindow.buffersize;
		leftTexName= previousWindow.texName[index];
	    }
	}else{
	    //we start inbetween of the window
	    rightPageName= curWindow.SR;
	    index= curWindow.SR % curWindow.buffersize;
	    rightTexName= curWindow.texName[index];
	    
	    leftPageName= curWindow.SL;
	    index= leftPageName % curWindow.buffersize;
	    leftTexName= curWindow.texName[index];
	}
	
	sp[0].setPage_num(rightTexName, rightPageName);
	sp[1].setPage_num(leftTexName, leftPageName);

	scene.repaint();
	if(Ttp.commentslevel >= 3){
	    System.out.println("\trighPageName= " + rightPageName);
	    System.out.println("\tleftPageName= " + leftPageName);
	    System.out.println("\trighTexName= " + rightTexName);
	    System.out.println("\tleftTexName= " + leftTexName);
	}
    }
    
    public void setRightStaticPage( int texName, int page_num)
    {
	sp[0].setPage_num(texName, page_num);
    }

    public void setDynaPage(int page_num_up, 
			    int page_num_down, 
			    int texName_up,
			    int texName_down)
    {
	dp.setPageContent(page_num_up, 
			  page_num_down, 
			  texName_up, 
			  texName_down);
    }

    public void setUpDynamicPage(int page_num_up, 
				 int texName_up)
    {
	dp.setPageUPContent(page_num_up, 
			    texName_up );

    }

    public void setDownDynamicPage(int page_num_down, 
				   int texName_down)
    {
	dp.setPageDOWNContent(page_num_down, 
			      texName_down );

    }

    public void setLeftStaticPage(int texName, int page_num)
    {
	sp[1].setPage_num(texName, page_num);
    }
    
    void gen2PagesTexture(GLCanvas canvas,
			  int startPageName,
			  int [] texName)
    {
	int pdf_name, page_name, index; 
	long starttime= 0;

	page_name= startPageName;
	pdf_name= page_name + config.get_thefirstPdfpage();
	
	index= 0;
	
	while(index < 2){
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tPage name: " + page_name );
		System.out.println("\tpdf name: " + pdf_name );
		System.out.println("\ttexture name: " + texName[index] );
		starttime = System.currentTimeMillis();
	    }

	    if(textureReader.readPageTextureFromPdfReader(pdf_name, 64, 64)){
		setupMipmapsTexturing(canvas, texName[index]);
	    }else{
		System.out.println("****BookConstructor.java: gen2PagesTexture() Fail to read from the pdf, Continue to read the next one" );
		//break;
	    }
	   
	    if(Ttp.commentslevel >= 3){
		System.out.println("Current page takes >  " +
				   (System.currentTimeMillis() - starttime) + " milli scs to render." );
	    }
	    
	    pdf_name++;
	    page_name++; 
	    index++;

	}
	
	
    }



    /*
      It is called during init()
      generate the page content
    */
    void genPageTexture(GLCanvas canvas,
			int startPageName,
			int [] texName,
			int buffersize)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("genPageTexture" );
	}
	//two buffers
	int pdf_name, page_name, counter, index;
		
	page_name= startPageName;
	pdf_name= page_name + config.get_thefirstPdfpage();
	
	counter= 0;
	long starttime= System.currentTimeMillis();

	while(counter < buffersize){ // reading n pages
	    index= page_name % config.num_dynamic_tex_obj;
	    //System.out.println("Current Fills texName[" + counter + "]" );
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tPage name: " + page_name );
		System.out.println("\tpdf name: " + pdf_name );
		//System.out.println("\tindex: " + index );
		System.out.println("\ttexName: " + texName[index] );
	    }

	    //textureReader.readPageTextureFromPdfReader(pdf_name);
	    //if(textureReader.isOk()){

	    
	    if(textureReader.readPageTextureFromPdfReader(pdf_name, 64, 64)){
		setupMipmapsTexturing(canvas, texName[index]);
	    }else{
		if(Ttp.commentslevel >= 3){
		    System.out.println("Fail to read from the pdf, Continue to read the next one" );
		}
		//break;
	    }

	    pdf_name++;
	    page_name++; 
	    counter++;
	}

	if(Ttp.commentslevel >= 3){
	    System.out.println("Reading "+ buffersize +" pages completes and takes : " +
			       (System.currentTimeMillis() - starttime)/1000 + "scs." );
	}
	
    }

    

    /*
      overload method
     */
    void genPageTexture(int startPageName,
			int [] texName,
			int buffersize)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("genPageTexture overloaded" );
	}
	//two buffers
	int pdf_name, page_name, counter, index;
	
	page_name= startPageName;
	pdf_name= page_name + config.get_thefirstPdfpage();
	
	counter= 0;
	long starttime= System.currentTimeMillis();

	while(counter < buffersize){ // reading n pages
	    index= page_name % config.num_dynamic_tex_obj;
	    if(Ttp.commentslevel >= 3){
		//System.out.println("Current Fills texName[" + counter + "]" );
		System.out.println("\tPage name: " + page_name );
		System.out.println("\tpdf name: " + pdf_name );
		//System.out.println("\tindex: " + index );
		System.out.println("\ttexName: " + texName[index] );
	    }

	    scene.performTexturefilling(textureReader, //reader
					pdf_name,
					texName[index]);
		
	    pdf_name++;
	    page_name++; 
	    counter++;
	}

	if(Ttp.commentslevel >= 3){
	    System.out.println("Reading "+ buffersize +" pages completes and takes : " +
			       (System.currentTimeMillis() - starttime)/1000 + "scs." );
	}
	
	
    }

    
    public void setupMipmapsTexturing(GLCanvas canvas, int texName)
    {
	if(Ttp.commentslevel >= 2){
		System.out.println("BookConstructor.java: setupMipmapsTexturing()"); 
	}
	GLFunc gl= canvas.gl;
	GLUFunc glu= canvas.glu;
	
	gl.glBindTexture(GL_TEXTURE_2D, texName);
	gl.glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	gl.glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);

	switch(config.imageformat){
	case PNG:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("PNG"); 
	    }
	    glu.gluBuild2DMipmaps(GL_TEXTURE_2D, 
				  3, textureReader.getImageWidth(), 
				  textureReader.getImageHeight(), 
				  GL_RGB, 
				  GL_UNSIGNED_BYTE, 
				  textureReader.getTexture());
	    
	    break;}
	case JPEG:
	    if(Ttp.commentslevel >= 3){
		System.out.println("JPEG"); 
	    }
	    glu.gluBuild2DMipmaps( GL_TEXTURE_2D, 
				   GL_RGBA, 
				   textureReader.getImageWidth(), 
				   textureReader.getImageHeight(), 
				   GL_RGBA, 
				   GL_UNSIGNED_BYTE, 
				   textureReader.getTexture() );   
	    break;
	case TGA:{
	    if(Ttp.commentslevel >= 3){
		System.out.println("TGA"); 
	    }
	    glu.gluBuild2DMipmaps(GL_TEXTURE_2D, 
				  GL_RGB, 
				  textureReader.getImageWidth(), 
				  textureReader.getImageHeight(), 
				  GL_RGB, 
				  GL_UNSIGNED_BYTE, 
				  textureReader.getTexture());
	    break;
	}
	}

    }
    
    
    public void pageReconstruction()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor: pageReconstruction()");
	}
	coverState= OPEN;
	double lh=0, rh=0, turning=0;
	
	if( paper_no_lieOnLeft == 0){
	    if(Ttp.commentslevel >= 3){
		System.out.println("paper_no_lieOnLeft == 0");
	    }
	    lh= paper2h(1);
	    rh= config.getBookThickness(); 
	    turning= 0;
	    phase2bookconstruction(lh, rh, turning, 0);

	}else if( paper_no_lieOnLeft == config.get_total_papers()){
	    if(Ttp.commentslevel >= 3){
		System.out.println("paper_no_lieOnLeft == lastPage");
	    }
	    lh= config.getBookThickness();
	    rh= paper2h(1);
	    turning= 90;
	    phase3bookconstruction(lh, rh, turning, 0);

	}else if( paper_no_lieOnLeft > 0 && paper_no_lieOnLeft <= config.get_total_papers()){
	    /*
	      the orientation of the spine and rest of the cover skeleton is
	      is determined by the variable "paper_no_lieOnLeft" 
	    */
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tin between");
	    }

	    lh= paper2h(paper_no_lieOnLeft);
	    rh= config.getBookThickness()- lh;
	    turning= h2turning(lh); // testing 
	    //debug
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tlh "+ lh);
		System.out.println("\trh "+ rh);
		System.out.println("\tturning "+ turning);
	    }
	    
	    if(turning <= 90.0){
		//System.out.println("\tphase2");
		phase2bookconstruction(lh, rh, turning, lh);
	    }
	    else{
		//System.out.println("\tphase3");
		phase3bookconstruction(lh,rh, turning-90, rh ); 
	    }

	}else{
	    if(Ttp.commentslevel >= 3){
		System.out.println("BookConstructor error:unknown value of paper_no_lieOnLeft  ");
	    }
	}
	

	double unit_len= config.get_elementLength();
	leftTop_d.setAll(unit_len, LEFT);
	rightTop_d.setAll(unit_len, RIGHT);
	leftTop_d.evaluate();
	rightTop_d.evaluate();

	//bottom
	leftbottom_d.setAll(unit_len, LEFT);
	leftbottom_d.evaluate();
	rightbottom_d.setAll(unit_len, LEFT);
	rightbottom_d.evaluate();
	

	sp[0].genModel(rightTop_d.getPts(1),
		       rightbottom_d.getPts(1));
	sp[1].genModel(leftTop_d.getPts(1),
		       leftbottom_d.getPts(1));
	
	
    }

    
    /*
      testing jumping
      paper_no_lieOnLeft must be initialized
    
    */
    public void pageReconstruction2()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor: pageReconstruction2()");
	}

	double lh=0, rh=0, turning=0;
	lh= paper2h(paper_no_lieOnLeft);
	rh= config.getBookThickness()- lh;
	turning= h2turning(lh); // testing 
	//debug
	if(Ttp.commentslevel >= 3){
	    System.out.println("\tpaper_no_lieOnLeft "+ paper_no_lieOnLeft);
	    System.out.println("\tlh "+ lh);
	    System.out.println("\trh "+ rh);
	    System.out.println("\tturning "+ turning);
	}
	
	//update cover_line
	if(turning <= 90.0){
	    phase2bookconstruction3type1(lh, 
					 rh, 
					 turning,
					 lh,   //midLeft
					 lh);  //midRight= lh+0
	}else{
	    phase3bookconstruction3type1(lh, 
					 rh,
					 turning-90,
					 lh,
					 lh);
	}
	

	

	//generate static pages
	sp[0].genModel(rightTop_curve.getPts(1),
		       rightLower_curve.getPts(1));
	sp[1].genModel(leftTop_curve.getPts(1),
		       leftLower_curve.getPts(1));
	
	
	Point3d left , right;
	if(coverState == CLOSE){
	    if(isFrontCoverFacingUP()){
		left= rightTop_curve.getPoint();
		right= rightLower_curve.getPoint();
	    }else{
		left= leftTop_curve.getPoint();
		right= leftLower_curve.getPoint();
	    }
	}else{
	    left= leftLower_curve.getPoint();
	    right= rightLower_curve.getPoint();
	}
	//construct strip
	genStrip(left, right);
	
	//reading mode
	/*for(int i= 0; i < 4; i++){
	    reading_rightPage_curve.setKnots(i ,rightTop_curve.ctrl_points[i]);
	    }*/

	//start_right[0].set(rightTop_curve.ctrl_points[0]);
	
	
    }

    public void extract_page_starting_position(double [][] viewingMatrices)
    {
	double delta_x = config.paperWidth/3;
	double delta_y = config.paperHeight/3;

	
	int right_page_num=  sp[0].getPage_num();
	
	if(right_page_num > config.lastPage && coverState == OPEN){
	    start_Right_Control_pts[0][0].set(cover_skeleton2[1]);
	   
	    Vector3d  v10= new Vector3d(0,0,0);
	    v10.sub(cover_skeleton2[0], cover_skeleton2[1]);
	    v10.normalize();
	    start_Right_Control_pts[0][1].scaleAdd(delta_x, v10, cover_skeleton2[1]);
	    start_Right_Control_pts[0][2].scaleAdd(delta_x+delta_x, v10, cover_skeleton2[1]);
	    start_Right_Control_pts[0][3].set(cover_skeleton2[0]);
	    
	    
	}
	else if( right_page_num <= config.lastPage && coverState == OPEN){
	    //first row
	    start_Right_Control_pts[0][0].set(rightTop_curve.ctrl_points[0].x,
					      rightTop_curve.ctrl_points[0].y, 
					      rightTop_curve.ctrl_points[0].z);
	    start_Right_Control_pts[0][1].set(rightTop_curve.ctrl_points[1].x,
					      rightTop_curve.ctrl_points[1].y, 
					      rightTop_curve.ctrl_points[1].z);
	    start_Right_Control_pts[0][2].set(rightTop_curve.ctrl_points[2].x,
					      rightTop_curve.ctrl_points[2].y, 
					      rightTop_curve.ctrl_points[2].z);
	    start_Right_Control_pts[0][3].set(rightTop_curve.ctrl_points[3].x,
					      rightTop_curve.ctrl_points[3].y, 
					      rightTop_curve.ctrl_points[3].z);
	    
	}
	
	else if( right_page_num == config.firstPage && coverState == CLOSE){

	    start_Right_Control_pts[0][0].set(cover_skeleton2[2]);
	   
	    Vector3d  v23= new Vector3d(0,0,0);
	    v23.sub(cover_skeleton2[3], cover_skeleton2[2]);
	    v23.normalize();
	    start_Right_Control_pts[0][1].scaleAdd(delta_x, v23, cover_skeleton2[2]);
	    start_Right_Control_pts[0][2].scaleAdd(delta_x+delta_x, v23, cover_skeleton2[2]);
	    start_Right_Control_pts[0][3].set(cover_skeleton2[3]);

	}
	else{
	    //donothing
	}
	
	
	

	int left_page_num=  sp[1].getPage_num();
	if(left_page_num == -1 && coverState == OPEN){
	    start_Left_Control_pts[0][0].set(cover_skeleton2[3]);
	   
	    Vector3d  v32= new Vector3d(0,0,0);
	    v32.sub(cover_skeleton2[2], cover_skeleton2[3]);
	    v32.normalize();
	    start_Left_Control_pts[0][1].scaleAdd(delta_x, v32, cover_skeleton2[3]);
	    start_Left_Control_pts[0][2].scaleAdd(delta_x+delta_x, v32, cover_skeleton2[3]);
	    start_Left_Control_pts[0][3].set(cover_skeleton2[2]);
	    
	}
	
	else if( left_page_num > config.firstPage && coverState == OPEN){
	    start_Left_Control_pts[0][3].set(leftTop_curve.ctrl_points[0].x,
					     leftTop_curve.ctrl_points[0].y, 
					     leftTop_curve.ctrl_points[0].z);
	    start_Left_Control_pts[0][2].set(leftTop_curve.ctrl_points[1].x,
					     leftTop_curve.ctrl_points[1].y, 
					     leftTop_curve.ctrl_points[1].z);
	    start_Left_Control_pts[0][1].set(leftTop_curve.ctrl_points[2].x,
					     leftTop_curve.ctrl_points[2].y, 
					     leftTop_curve.ctrl_points[2].z);
	    start_Left_Control_pts[0][0].set(leftTop_curve.ctrl_points[3].x,
					     leftTop_curve.ctrl_points[3].y, 
					     leftTop_curve.ctrl_points[3].z);
	    
	}else if(left_page_num == config.lastPage && coverState == CLOSE){
	    start_Left_Control_pts[0][0].set(cover_skeleton2[0]);
	   
	    Vector3d  v01= new Vector3d(0,0,0);
	    v01.sub(cover_skeleton2[1], cover_skeleton2[0]);
	    v01.normalize();
	    start_Left_Control_pts[0][1].scaleAdd(delta_x, v01, cover_skeleton2[0]);
	    start_Left_Control_pts[0][2].scaleAdd(delta_x+delta_x, v01, cover_skeleton2[0]);
	    start_Left_Control_pts[0][3].set(cover_skeleton2[1]);
	    
	}
	else{

	}

	
	for(int i= 1; i<4; i++){
	    for(int j= 0; j<4; j++){
		start_Right_Control_pts[i][j].set(start_Right_Control_pts[0][j].x, 
						  start_Right_Control_pts[0][j].y ,
						  start_Right_Control_pts[0][j].z + i*delta_y);
		start_Left_Control_pts[i][j].set(start_Left_Control_pts[0][j].x, 
						 start_Left_Control_pts[0][j].y ,
						 start_Left_Control_pts[0][j].z + i*delta_y);
	    }
	}
	
	Matrix4d modelviewmatrix= new Matrix4d(viewingMatrices);
	
	for(int i= 0; i<4; i++){
	    for(int j= 0; j<4; j++){
		modelviewmatrix.transform(start_Right_Control_pts[i][j]);
		modelviewmatrix.transform(start_Left_Control_pts[i][j]);
	    }
	}
	
    }


    void genStrip(Point3d left, Point3d right)
    {
	strip[0].set(left);
	strip[1].set(right);
    }
    
    void init_coverANDpage()
    {
	int i;
	cover_skeleton= new Point3d[NUM_COVER_SKELETON];
	//testing jumping
	cover_skeleton2= new Point3d[NUM_COVER_SKELETON];
	cover_skeleton3= new Point3d[NUM_COVER_SKELETON];

	front_line= new Point3d[2];
	spine_line1= new Point3d[2];
	spine_line2= new Point3d[2];
	back_line= new Point3d[2];

	front_line[0]= new Point3d(0,0,0);
	front_line[1]= new Point3d(config.getCoverWidth(),0, 0);
	back_line[0]= new Point3d(0,0,0);
	back_line[1]= new Point3d(config.getCoverWidth(),0, 0);
	double ct= config.getCoverThickness();
	double bt= config.getBookThickness();
	double cratio= config.getCoverRatio();
	double len= ct*cratio;
	spine_line1[0]= new Point3d(len,0,0);
	spine_line1[1]= new Point3d(-bt-len,0, 0);
	
	spine_line2[0]= new Point3d(-len,0,0);
	spine_line2[1]= new Point3d(bt+len,0, 0);

	for(i=0; i<cover_skeleton.length; i++){
	    cover_skeleton[i]= new Point3d(0,0,0);
	    cover_skeleton2[i]= new Point3d(0,0,0);
	    cover_skeleton3[i]= new Point3d(0,0,0);
	}

	strip= new Point3d[2];
	strip[0]= new Point3d(0,0,0);
	strip[1]= new Point3d(0,0,0);
	
	pageReconstruction2();
	
	
	//if( paper_no_lieOnLeft == 0 ){
	//  System.out.println("\tpaper_no_lieOnLeft == 0");
//  	    if(coverState==CLOSE ){
//  		System.out.println("\t\tphase1bookconstruction();");
//  		phase1bookconstruction();
//  	    }else{
//  	    System.out.println("\t\tpageReconstruction2()");
	//  pageReconstruction2();
//  	    }
	//}else if(paper_no_lieOnLeft == config.get_total_papers()){
	//  System.out.println("\tpaper_no_lieOnLeft == total_papers");
//  	    if(coverState==CLOSE ){
//  		System.out.println("\t\tphase4bookconstruction();");
//  		phase4bookconstruction();
//  	    }else{
//  		System.out.println("\t\tpageReconstruction2()");
	//  pageReconstruction2();//testing jumping
//  	    }

	//}else{
	//  coverState= OPEN;
	//  pageReconstruction2();//testing jumping
	//}
    }
    
    void init_front_cover_pos()
    {
	double ct= config.getCoverThickness();
	double cover_margin= config.getCoverMargin();
	double cw= config.getCoverWidth();
	double lift= 0.01;
	front_cover_pos_VA= new double[8*3];
	front_cover_image_frame= new Point3d[4];
	inside_front_cover_image_frame= new Point3d[4];

	front_cover_pos_VA[0]= 0; 
	front_cover_pos_VA[1]= ct; 
	front_cover_pos_VA[2]= config.get_zMax();// 0
	
	front_cover_pos_VA[3]= config.getCoverWidth(); 
	front_cover_pos_VA[4]= ct; 
	front_cover_pos_VA[5]= config.get_zMax();//1
	
	front_cover_pos_VA[6]= config.getCoverWidth(); 
	front_cover_pos_VA[7]= ct; 
	front_cover_pos_VA[8]= -config.getCoverMargin();//2
	
	front_cover_pos_VA[9]= 0; 
	front_cover_pos_VA[10]= ct; 
	front_cover_pos_VA[11]= -config.getCoverMargin();//3

	front_cover_image_frame[0]= new Point3d(cover_margin, 
						ct + lift, 
						config.get_zMax()-cover_margin );
	front_cover_image_frame[1]= new Point3d(cw-cover_margin, 
						ct + lift,
						config.get_zMax()-cover_margin );
	front_cover_image_frame[2]= new Point3d(cw-cover_margin,
						ct + lift,
						0);
	front_cover_image_frame[3]= new Point3d(cover_margin, 
						ct + lift, 
						0);

	inside_front_cover_image_frame[0]= new Point3d(0, 
						       -lift, 
						       config.get_zMax()-cover_margin );
	inside_front_cover_image_frame[1]= new Point3d(cw-cover_margin*2, 
						       -lift,
						       config.get_zMax()-cover_margin );
	inside_front_cover_image_frame[2]= new Point3d(cw-cover_margin*2,
						       -lift,
						       0);
	inside_front_cover_image_frame[3]= new Point3d(0, 
						       -lift, 
						       0);
	
	int i, n;
	for( i=0; i<4; i++){//4 5 6 7
	    n= i*3;
	    front_cover_pos_VA[n + 12]= front_cover_pos_VA[n]; 
	    front_cover_pos_VA[n + 12 + 1]= 0; 
	    front_cover_pos_VA[n + 12 + 2]= front_cover_pos_VA[n+2];
	}
	
	front_cover_normals= new Vector3d[6];
	front_cover_normals[0]= new Vector3d(0,1,0);// top
	front_cover_normals[1]= new Vector3d(0,-1,0);// buttom
	front_cover_normals[2]= new Vector3d(0,0,1);// front 
	front_cover_normals[3]= new Vector3d(0,0,-1);// back 
	front_cover_normals[4]= new Vector3d(1,0,0);// right 
	front_cover_normals[5]= new Vector3d(-1,0,0);// left 

	front_cover_texName= new int[6];
	front_cover_texName[0]= fixedTexName[BOOK_FRONT_COVER]; //top
	front_cover_texName[1]= fixedTexName[INSIDE_BOOK_FRONT_COVER];//top
	front_cover_texName[2]= 1;
	front_cover_texName[3]= 1;
	front_cover_texName[4]= 1;
	front_cover_texName[5]= 1;
	
    }

    
  
    void init_back_cover_pos()
    {
	double ct= config.getCoverThickness();
	double cover_margin= config.getCoverMargin();
	double cw= config.getCoverWidth();
	double lift= 0.01;
	
	back_cover_image_frame= new Point3d[4];
	inside_back_cover_image_frame= new Point3d[4];

	back_cover_pos_VA= new double[8*3];
	int i= 0;
	for(i= 0; i<12; i++){
	    if( (i % 3) == 1 )
		back_cover_pos_VA[i]= -ct; 
	    else
		back_cover_pos_VA[i]= front_cover_pos_VA[ i ];

	    back_cover_pos_VA[i+12]= front_cover_pos_VA[i+12];
	}

	back_cover_image_frame[0]= new Point3d(cover_margin, 
					       -ct -lift, 
					       config.get_zMax()-cover_margin );
	back_cover_image_frame[1]= new Point3d(cw-cover_margin, 
					       -ct -lift,
					       config.get_zMax()-cover_margin );
	back_cover_image_frame[2]= new Point3d(cw-cover_margin,
					       -ct -lift,
					       0);
	back_cover_image_frame[3]= new Point3d(cover_margin, 
					       -ct-lift, 
						0);

	inside_back_cover_image_frame[0]= new Point3d(0, 
						      lift, 
						      config.get_zMax()-cover_margin );
	inside_back_cover_image_frame[1]= new Point3d(cw-cover_margin*2, 
						      lift,
						      config.get_zMax()-cover_margin );
	inside_back_cover_image_frame[2]= new Point3d(cw-cover_margin*2,
						      lift,
						      0);
	inside_back_cover_image_frame[3]= new Point3d(0, 
						      lift, 
						      0);

	
	back_cover_normals= new Vector3d[6];
	back_cover_normals[0]= new Vector3d(0,-1,0);// buttom 
	back_cover_normals[1]= new Vector3d(0,1,0);// top 
	back_cover_normals[2]= new Vector3d(0,0,1);// front 
	back_cover_normals[3]= new Vector3d(0,0,-1);// back 
	back_cover_normals[4]= new Vector3d(1,0,0);// right 
	back_cover_normals[5]= new Vector3d(-1,0,0);// left 

	back_cover_texName= new int[6];
	back_cover_texName[0]= fixedTexName[BOOK_BACK_COVER]; //top
	back_cover_texName[1]= fixedTexName[INSIDE_BOOK_BACK_COVER];//bottom
	back_cover_texName[2]= 1;
	back_cover_texName[3]= 1;
	back_cover_texName[4]= 1;
	back_cover_texName[5]= 1;
	
	
    }

    void init_spine1_pos()
    {
	double zMax= config.get_zMax();
	double bt= config.getBookThickness();
	double cm= config.getCoverMargin();
	double ct= config.getCoverThickness();
	double cratio= config.getCoverRatio();
	double len= ct*cratio;

	spine_VA1= new double[8*3];
	spine_VA1[0]= len; 
	spine_VA1[1]= 0; 
	spine_VA1[2]= zMax; // 0
	spine_VA1[3]= len; 
	spine_VA1[4]= 0; 
	spine_VA1[5]= -cm; //1
	spine_VA1[6]= -bt-len; 
	spine_VA1[7]= 0; 
	spine_VA1[8]= -cm; // 2
	spine_VA1[9]= -bt-len; 
	spine_VA1[10]= 0; 
	spine_VA1[11]= zMax; // 3

	int i;
	for(i= 0; i<12; i++){
	    if( (i % 3) == 1 )
		spine_VA1[i+12]= spine_VA1[i] - ct; 
	    else
		spine_VA1[i+12]= spine_VA1[i]; 
	}
	spine1.setOrientation(POSITIVE);
	spine1.setTextureName(fixedTexName[0]);
	spine1.setVertex(spine_VA1, len);
	
    }

    
    void init_spine2_pos()
    {
	double zMax= config.get_zMax();
	double bt= config.getBookThickness();
	double cm= config.getCoverMargin();
	double ct= config.getCoverThickness();
	double cratio= config.getCoverRatio();
	double len= ct*cratio;
	
	spine_VA2= new double[8*3];
	spine_VA2[0]= -len; 
	spine_VA2[1]= 0; 
	spine_VA2[2]= zMax; // 0
	spine_VA2[3]= -len; 
	spine_VA2[4]= 0; 
	spine_VA2[5]= -cm; //1
	spine_VA2[6]= bt+len; 
	spine_VA2[7]= 0; 
	spine_VA2[8]= -cm; // 2
	spine_VA2[9]= bt+len; 
	spine_VA2[10]= 0; 
	spine_VA2[11]= zMax; // 3

	int i;
	for(i= 0; i<12; i++){
	    if( (i % 3) == 1 )
		spine_VA2[i+12]= spine_VA2[i] - ct; 
	    else
		spine_VA2[i+12]= spine_VA2[i]; 
	}
	
	spine2.setOrientation(NEGATIVE);
	spine2.setTextureName(fixedTexName[0]);
	spine2.setVertex(spine_VA2, len);
    }

    
    
    void setThreshold()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor.java: setThreshold()");
	}
	double cw= config.getCoverWidth();
	double bt= config.getBookThickness();
	double tmp;
	tmp= Utilities.rad2degree( Math.acos(bt/cw) );
	angleO= 90-tmp;
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("angleO: " + angleO);
	    coverThreshold_1= 10;
	    coverThreshold_2= 0;
	    //phase4_disX= Math.cos(  Utilities.degree2rad(angleO) );
	}
		
    }



    double  paper2h( int paper_no)
    {
      	return paper_no /(double) config.get_total_papers() * config.getBookThickness();
    }


    // return in degree
    double  h2turning( double h )
    {
	return h * 180 / config.getBookThickness();

    }
   
    void phase1bookconstruction()
    {
	frontTurning2= 0;
	backTurning2= 0;
	spineTurning2= -90; 
	
	cover_skeleton2[0].set( config.getCoverWidth(), 0, 0 );
	cover_skeleton2[1].set( 0, 0, 0 );
	cover_skeleton2[2].set( 0, config.getBookThickness(), 0);
	cover_skeleton2[3].set( config.getCoverWidth(),
				config.getBookThickness(), 
				0 );
    }


    

    double sineRules(double cw, double bt, double pr )
    {
	return Math.asin(bt *  Math.sin(pr)/ cw);
    }

    /*
      angle is in degree
     */
    double distanceC0C1(double angle)
    {
	double bt= config.getBookThickness();
	return (bt - (angle/180*bt));
    }
     

    /*
      angle is in degree
     */
    double distanceC0C1type2(double angle)
    {
	double bt= config.getBookThickness();
	double ratio;
	double range_angle= Utilities.abs( angle - initial_turning_angle );
	if( selected_side == RIGHT ){
	    ratio= range_angle/howmuchTurningSpineAngle;// possibly howmuchTurningSpineAngle == 0
	}else{
	    ratio= 1.0 - range_angle/howmuchTurningSpineAngle;// possibly howmuchTurningSpineAngle == 0
	}
	//System.out.println("\ttype 2 ratio= " + ratio );

	return bt-(bt-final_length)*ratio;
    }

    
    double phase3distanceC0C1(double angle)
    {
	double bt= config.getBookThickness();
	return angle/180*bt;
    }


    
    /*
      angle is in degree
    */
    double phase3distanceC0C1type2(double angle)
    {
	double bt= config.getBookThickness();
	double ratio;
	double range_angle= Utilities.abs( angle - initial_turning_angle );
	if(howmuchTurningSpineAngle == 0){
	    if(Ttp.commentslevel >= 3){
		System.out.println("\ttype howmuchTurningSpineAngle= 0");
	    }
	    howmuchTurningSpineAngle= 0.01;
	} 

	if( selected_side == LEFT ){
	    ratio= range_angle/howmuchTurningSpineAngle;
	}else{
	    ratio= 1.0 - range_angle/howmuchTurningSpineAngle;
	}
	if(Ttp.commentslevel >= 3){
	    System.out.println("\ttype 2 ratio= " + ratio );
	}

	return bt-(bt-final_length)*ratio;
    }

    /*
      update
      cover_skeleton[3]
      cover_skeleton[2]
    */
    void phase2bookconstruction(double lh, double rh,
				double rotAround_CK1,
				double mid)
    {
	int i;
	double cw, bt, qr, pr, a, b, rotCK1_r, pw; 


	//testing interior curve
		
	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	rotCK1_r= Utilities.degree2rad( rotAround_CK1 );//radian for rotAround_CK1
	pr=  Utilities.degree2rad(90-rotAround_CK1);
	qr= sineRules(cw, bt, pr);
	
	//control the look
	frontTurning= 180 + Utilities.rad2degree(qr);
	backTurning= 0.0;
	spineTurning= rotAround_CK1-90;

	if(Ttp.commentslevel >= 3){
	    System.out.println("q : " + Utilities.rad2degree(qr) );
	    System.out.println("frontTurning: " + frontTurning);
	}
	
	a= bt * Math.cos(pr);
	b= cw * Math.cos(qr);

	//update ck0 ck1 ck2 ck3
	cover_skeleton[0].set(cw, 0, 0);
	cover_skeleton[1].set(0, 0, 0);
	Matrix4d.rotAroundZ(-pr).
	    transform( new Point3d(-bt,0,0), cover_skeleton[2]);// rotate around z Axis about -pr(clockwise direction)

	cover_skeleton[3].set(-a-b, 0, 0);
	

	Point3d [] left_ctrlpts= new Point3d[NUM_CONTROL_PTS];
	Point3d [] right_ctrlpts= new Point3d[NUM_CONTROL_PTS];
	Point3d [] left_ctrlpts_bottom= new Point3d[NUM_CONTROL_PTS];
	Point3d [] right_ctrlpts_bottom= new Point3d[NUM_CONTROL_PTS];

	for ( i = 0; i < NUM_CONTROL_PTS; i++){
	    left_ctrlpts[i]= new Point3d();
	    right_ctrlpts[i]= new Point3d();
	    left_ctrlpts_bottom[i]= new Point3d();
	    right_ctrlpts_bottom[i]= new Point3d();
	} 
	
	//page construction
	left_ctrlpts[0].set( -bt+mid,0,0);// ctrl pts 0
	right_ctrlpts[0].set( -bt+mid,0,0);
	left_ctrlpts_bottom[0].set( -bt,0,0);// bottom ctrl pts 0
	right_ctrlpts_bottom[0].set( 0,0,0);
	
	double disX, disY;
	disX= bt * Math.cos(rotCK1_r);
	disY= bt * Math.sin(rotCK1_r);
	left_ctrlpts[1].set(-disX-bt+mid, disY, 0); // ctrl pts 1
	right_ctrlpts[1].set( -bt+mid,bt,0);
	

	//from proposed 1
	//double half_bt= bt/2;
	//disX= half_bt * Math.cos(rotCK1_r);
	//disY= half_bt * Math.sin(rotCK1_r);
	//left_ctrlpts_bottom[1].set( -bt-disX, disY,0);//bottom ctrl pts 1
	
	// from proposed 2
	double len= distanceC0C1(rotAround_CK1);
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("disX : " + disX );
	    System.out.println("bt : " + bt );
	}
	
	disX= len * Math.cos(rotCK1_r);
	disY= len * Math.sin(rotCK1_r);
	
	left_ctrlpts_bottom[1].set( -bt-disX, disY, 0);

	right_ctrlpts_bottom[1].set( 0,disY,0);
	
	double disC2C3= pw/3;
	right_ctrlpts[3].set(pw, rh, 0); 
	right_ctrlpts[2].set(right_ctrlpts[3].x - disC2C3, rh, 0); 
	right_ctrlpts_bottom[3].set(pw, 0, 0); 
	right_ctrlpts_bottom[2].set(right_ctrlpts_bottom[3].x - disC2C3, 0, 0); 
	
	
	//proposed 1
	left_ctrlpts[3].set( cw - pw, lh, 0);  
	left_ctrlpts[2].set( left_ctrlpts[3].x + disC2C3, lh, 0);
	left_ctrlpts_bottom[3].set(cw-pw, 0, 0); 
	left_ctrlpts_bottom[2].set(left_ctrlpts_bottom[3].x + disC2C3 , 0, 0);
	
	//m1 system is used on transforming ctrl pts 0 & ctrl pts 1
	Matrix4d m1=	 
	    //  Matrix4d.shift( -bt+mid,0,0 )
	    //  	    .then(Matrix4d.rotAroundZ(-pr));
	    Matrix4d.rotAroundZ(-pr);
		
	//m2 system is used on transforming left page ctrl pts 2 & ctrl pts 3 
	Matrix4d m2= 
	    Matrix4d.rotAroundZ(qr)
	    .then( Matrix4d.shift(cover_skeleton[3].x, cover_skeleton[3].y, cover_skeleton[3].z ));
	
	for(i=0; i<2; i++){ 
	    m1.transform(left_ctrlpts[i]);
	    leftTop_d.setKnots(i, left_ctrlpts[i]);// set control pts
	    m1.transform(right_ctrlpts[i]);
	    rightTop_d.setKnots(i, right_ctrlpts[i]);//set control pts
	    	    
	    m1.transform(left_ctrlpts_bottom[i]);
	    m1.transform(right_ctrlpts_bottom[i]);
	    leftbottom_d.setKnots(i, left_ctrlpts_bottom[i]);
	    rightbottom_d.setKnots(i, right_ctrlpts_bottom[i]);
	}
	
	for(i=2; i<4; i++){
	    m2.transform(left_ctrlpts[i]);
	    leftTop_d.setKnots(i, left_ctrlpts[i]);
	    rightTop_d.setKnots(i, right_ctrlpts[i]);

	    m2.transform(left_ctrlpts_bottom[i]);
	    leftbottom_d.setKnots(i, left_ctrlpts_bottom[i]);
	    rightbottom_d.setKnots(i, right_ctrlpts_bottom[i]);
	}
	
	
    }



    /*
      testing jumping
      update 
        cover_skeleton2
	frontTurning2
	backTurning2
	spineTurning2
	curves
      generate 
        leftTop_curve
	leftLower_curve
	rightTop_curve
	rightLower_curve
      and
        interior_curveUp
	interior_curveDown

      and 
        perform refitting

      This function is called only when setSelectedEdge is invoked
    */

    /*
    public void phase2bookconstruction2(double lh, double rh, double rotAround_CK1,
					double mid,
					double k)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("phase2bookconstruction2");
	}

	double cw, bt, pw, rotCK1_r, pr, qr; 
	double a, b;

	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	rotCK1_r= Utilities.degree2rad( rotAround_CK1 );//radian for rotAround_CK1
	pr=  Utilities.degree2rad(90-rotAround_CK1);// corresponds to theta in the thesis
	qr= sineRules(cw, bt, pr);
	
	frontTurning2= 180 + Utilities.rad2degree(qr);// r2 in the thesis
	backTurning2= 0.0;
	spineTurning2= rotAround_CK1-90;
	a= bt * Math.cos(pr);
	b= cw * Math.cos(qr);

	//update ck2 ck3
	cover_skeleton2[0].set(cw, 0, 0);
	cover_skeleton2[1].set(0, 0, 0);
	
	Matrix4d.rotAroundZ(-pr).
	    transform( new Point3d(-bt,0,0), cover_skeleton2[2]);// rotate around z Axis about -pr(clockwise direction)
	cover_skeleton2[3].set(-a-b, 0, 0);


	double c2mid= -bt+mid;
	if(selected_side == RIGHT){
	    interior_curveDOWN.setKnots( 0, new Point3d(c2mid+k, 0,0));
	}else{
	    interior_curveDOWN.setKnots( 0, new Point3d(c2mid-k, 0,0));
	}
	
	double disX, disY, len;
	if(selected_side == RIGHT){
	    interior_curveDOWN.setKnots( 1, new Point3d(c2mid+k, bt,0));
	}else{
	    disX= final_length * Math.cos(rotCK1_r);
	    disY= final_length * Math.sin(rotCK1_r);
	    double midLeft= c2mid-k;
	    interior_curveDOWN.setKnots( 1, new Point3d(-disX+midLeft, disY, 0)); // ctrl pts 1
	}
	

	double disC2C3= pw/3;
	if(selected_side == RIGHT){
	    interior_curveDOWN.setKnots(3, new Point3d(pw, rh-k,0));
	    interior_curveDOWN.setKnots(2, new Point3d(interior_curveDOWN.ctrl_points[3].x - disC2C3, 
						       interior_curveDOWN.ctrl_points[3].y, 
						       interior_curveDOWN.ctrl_points[3].z ));
	}else{
	    interior_curveDOWN.setKnots(3, new Point3d(cw-pw, lh-k,0));
	    interior_curveDOWN.setKnots(2, new Point3d(interior_curveDOWN.ctrl_points[3].x + disC2C3, 
						       interior_curveDOWN.ctrl_points[3].y, 
						       interior_curveDOWN.ctrl_points[3].z ));
	}
	

	Matrix4d m1= Matrix4d.rotAroundZ(-pr);//rotateZ around the origin of the local coordinate system
  	Matrix4d m2= 
  	    Matrix4d.rotAroundZ(qr)
  	    .then( Matrix4d.shift(cover_skeleton2[3].x, cover_skeleton2[3].y, cover_skeleton2[3].z ));

	int i;

	for(i=0; i<4; i++){ 
	    if(i<2){
		m1.transform(interior_curveDOWN.ctrl_points[i]);
	    }else{
		if(selected_side == LEFT){
		    m2.transform(interior_curveDOWN.ctrl_points[i]);
		}
	    }
	}


	double unit_len= config.get_elementLength();
	if(selected_side == RIGHT){
	    interior_curveUP.setAll(unit_len, RIGHT); // associate with genVectors
	    interior_curveDOWN.setAll(unit_len, RIGHT);
	    interior_curveUP.evaluate3(rightTop_curve.points(1), 1); // copy from 'rightTop_curve'
	}else{
	    interior_curveUP.setAll(unit_len, LEFT); // associate with genVectors
	    interior_curveDOWN.setAll(unit_len, LEFT);
	    interior_curveUP.evaluate3(leftTop_curve.points(1), 1); // copy from 'leftTop_curve'
	}
	
	interior_curveDOWN.evaluate();
	if(Ttp.commentslevel >= 3){
	    System.out.println("\tThe 1st interior_curveDOWN > " + interior_curveDOWN.pts[1][0].toString() );
	}
	}*/

    public void phase2bookconstruction2(double lh, double rh, double rotAround_CK1,
					double mid,
					double k)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("phase2bookconstruction2");
	}
	
	double cw, bt, pw, rotCK1_r, pr, qr; 
	double a, b;

	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	rotCK1_r= Utilities.degree2rad( rotAround_CK1 );//radian for rotAround_CK1
	pr=  Utilities.degree2rad(90-rotAround_CK1);
	qr= sineRules(cw, bt, pr);
	
	frontTurning2= 180 + Utilities.rad2degree(qr);
	backTurning2= 0.0;
	spineTurning2= rotAround_CK1-90;
	a= bt * Math.cos(pr);
	b= cw * Math.cos(qr);

	//update ck2 ck3
	cover_skeleton2[0].set(cw, 0, 0);
	cover_skeleton2[1].set(0, 0, 0);
	
	Matrix4d.rotAroundZ(-pr).
	    transform( new Point3d(-bt,0,0), cover_skeleton2[2]);// rotate around z Axis about -pr(clockwise direction)
	cover_skeleton2[3].set(-a-b, 0, 0);


	double c2mid= -bt+mid;
	if(selected_side == RIGHT){
	    interior_curveDOWN.setKnots( 0, new Point3d(c2mid+k, 0,0));
	}else{
	    interior_curveDOWN.setKnots( 0, new Point3d(c2mid-k, 0,0));
	}
	
	double disX, disY, len;
	if(selected_side == RIGHT){
	    interior_curveDOWN.setKnots( 1, new Point3d(c2mid+k, final_length,0));
	}else{
	    //len= distanceC0C1type2(rotAround_CK1);
	    //System.out.println("\ttype 2 len= " + len );
	    disX= final_length * Math.cos(rotCK1_r);
	    disY= final_length * Math.sin(rotCK1_r);
	    double midLeft= c2mid-k;
	    interior_curveDOWN.setKnots( 1, new Point3d(-disX+midLeft, disY, 0)); // ctrl pts 1
	}
	

	double disC2C3= pw/3;
	if(selected_side == RIGHT){
	    interior_curveDOWN.setKnots(3, new Point3d(pw, rh-k,0));
	    interior_curveDOWN.setKnots(2, new Point3d(interior_curveDOWN.ctrl_points[3].x - disC2C3, 
						       interior_curveDOWN.ctrl_points[3].y, 
						       interior_curveDOWN.ctrl_points[3].z ));
	}else{
	    interior_curveDOWN.setKnots(3, new Point3d(cw-pw, lh-k,0));
	    interior_curveDOWN.setKnots(2, new Point3d(interior_curveDOWN.ctrl_points[3].x + disC2C3, 
						       interior_curveDOWN.ctrl_points[3].y, 
						       interior_curveDOWN.ctrl_points[3].z ));
	}
	

	Matrix4d m1= Matrix4d.rotAroundZ(-pr);//rotateZ around the origin of the local coordinate system
  	Matrix4d m2= 
  	    Matrix4d.rotAroundZ(qr)
  	    .then( Matrix4d.shift(cover_skeleton2[3].x, cover_skeleton2[3].y, cover_skeleton2[3].z ));

	int i;

	for(i=0; i<4; i++){ 
	    if(i<2){
		m1.transform(interior_curveDOWN.ctrl_points[i]);
	    }else{
		if(selected_side == LEFT){
		    m2.transform(interior_curveDOWN.ctrl_points[i]);
		}
	    }
	}


	double unit_len= config.get_elementLength();
	if(selected_side == RIGHT){
	    interior_curveUP.setAll(unit_len, RIGHT); // associate with genVectors
	    interior_curveDOWN.setAll(unit_len, RIGHT);
	    interior_curveUP.evaluate3(rightTop_curve.points(1), 1); // copy from 'rightTop_curve'
	}else{
	    interior_curveUP.setAll(unit_len, LEFT); // associate with genVectors
	    interior_curveDOWN.setAll(unit_len, LEFT);
	    interior_curveUP.evaluate3(leftTop_curve.points(1), 1); // copy from 'rightTop_curve'
	}
	
	interior_curveDOWN.evaluate();
	if(Ttp.commentslevel >= 2){
	    System.out.println("\tThe 1st interior_curveDOWN > " + interior_curveDOWN.pts[1][0].toString() );
	}
    }

    

    /*
      perform similar kind of job as phase2bookconstruction2
      except that here we do not create interior curves
      
      here, we must be careful with rh(at moment, we only concern about turning anti-clockwise)

      This is called in the initialization phase and when performing 
      rotateSpine
      
      type 1 has constant distance (bt) between ctrlpts 0 and 1
     */
    /*public void phase2bookconstruction3type1(double lh, double rh, double rotAround_CK1,
					     double midLeft,
					     double midRight)
    {
	double cw, bt, pw, rotCK1_r, pr, qr; 
	double a, b;

	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	rotCK1_r= Utilities.degree2rad( rotAround_CK1 );//radian for rotAround_CK1
	pr=  Utilities.degree2rad(90-rotAround_CK1); // theta 
	qr= sineRules(cw, bt, pr);// phi
	
	//testing jumping
	if(coverState==CLOSE ){
	    frontTurning2= 0;
	}

	if(coverState== OPEN){
	    frontTurning2= 180 + Utilities.rad2degree(qr);
	}

	    
	backTurning2= 0.0;
	spineTurning2= rotAround_CK1-90;
	
	a= bt * Math.cos(pr);
	b= cw * Math.cos(qr);

	//update ck2 ck3
	cover_skeleton2[0].set(cw, 0, 0);
	cover_skeleton2[1].set(0, 0, 0);
	
	if(coverState==CLOSE ){
	    cover_skeleton2[3].set( cw, bt, 0 );
	}

	if(coverState==OPEN ){
	    cover_skeleton2[3].set(-a-b, 0, 0);
	}
	
		
	Matrix4d.rotAroundZ(-pr).
	    transform( new Point3d(-bt,0,0), cover_skeleton2[2]);// rotate around z Axis about -pr(clockwise direction)
	
	leftTop_curve.setKnots(0, new Point3d(-bt+midLeft,0,0));// ctrl pts 0
	leftLower_curve.setKnots(0, new Point3d(-bt,0,0));// start at cover skeleton [2]
	rightTop_curve.setKnots( 0, new Point3d(-bt+midRight,0,0));
	rightLower_curve.setKnots( 0, new Point3d(0,0,0));// start at cover skeleton [1], which is at the origin of local coordinate system
	
	
	double disX, disY;
	double len= distanceC0C1(rotAround_CK1);
	disX= len * Math.cos(rotCK1_r);
	disY= len * Math.sin(rotCK1_r);
	leftLower_curve.setKnots(1, new Point3d(-bt-disX, disY, 0)); // ctrl pts 1
	rightLower_curve.setKnots(1, new Point3d(0,disY,0));
	rightTop_curve.setKnots( 1, new Point3d(-bt+midRight,bt,0));
	
	
	
	//disX= (bt+len)/2 * Math.cos(rotCK1_r);
	//disY= (bt+len)/2 * Math.sin(rotCK1_r);
	disX= bt * Math.cos(rotCK1_r);
	disY= bt * Math.sin(rotCK1_r);
	leftTop_curve.setKnots(1, new Point3d(-disX-bt+midLeft, disY, 0)); // ctrl pts 1


	double disC2C3= pw/3;
	leftTop_curve.setKnots(3, new Point3d(cw-pw, lh, 0)); // ctrl pts 3
	leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x + disC2C3, 
					      leftTop_curve.ctrl_points[3].y,
					      leftTop_curve.ctrl_points[3].z)); // ctrl pts 2
	leftLower_curve.setKnots(3, new Point3d(cw-pw, 0, 0)); // ctrl pts 3
	leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x + disC2C3,
						leftLower_curve.ctrl_points[3].y,
						leftLower_curve.ctrl_points[3].z)); // ctrl pts 2

	rightTop_curve.setKnots(3, new Point3d(pw, rh, 0));
	rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3, 
					       rightTop_curve.ctrl_points[3].y, 
					       rightTop_curve.ctrl_points[3].z ));
	
	rightLower_curve.setKnots(3, new Point3d(pw, 0, 0));
	rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3, 
						 rightLower_curve.ctrl_points[3].y, 
						 rightLower_curve.ctrl_points[3].z ));
	
	//transformation
	Matrix4d m1= Matrix4d.rotAroundZ(-pr);//rotateZ around the origin of the local coordinate system
	Matrix4d m2= 
	    Matrix4d.rotAroundZ(qr)
	    .then( Matrix4d.shift(cover_skeleton2[3].x, cover_skeleton2[3].y, cover_skeleton2[3].z ));
	int i;
	
	for(i=0; i<2; i++){ 
	    m1.transform(leftTop_curve.ctrl_points[i]);
	    m1.transform(leftLower_curve.ctrl_points[i]);
	    m1.transform(rightTop_curve.ctrl_points[i]);
	    m1.transform(rightLower_curve.ctrl_points[i]);
	}
	
	for(i=2; i<4; i++){
	    m2.transform(leftTop_curve.ctrl_points[i]);
	    m2.transform(leftLower_curve.ctrl_points[i]);
	}
	
	 double unit_len= config.get_elementLength();
	 leftTop_curve.setAll(unit_len, LEFT);
	 leftLower_curve.setAll(unit_len, LEFT);
	 rightTop_curve.setAll(unit_len, RIGHT);
	 rightLower_curve.setAll(unit_len, RIGHT);

	 //generate points on the curve
	 if(coverState == OPEN){
	     leftTop_curve.evaluate();
	     leftLower_curve.evaluate2(); //without generating vectors
	 }
	 rightTop_curve.evaluate();
	 rightLower_curve.evaluate2();

	 }*/
    
    public void phase2bookconstruction3type1(double lh, double rh, double rotAround_CK1,
					     double midLeft,
					     double midRight)
    {
	double cw, bt, pw, rotCK1_r, pr, qr; 
	double a, b;

	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	rotCK1_r= Utilities.degree2rad( rotAround_CK1 );//radian for rotAround_CK1
	pr=  Utilities.degree2rad(90-rotAround_CK1);
	qr= sineRules(cw, bt, pr);
	
	//testing jumping
	if(coverState==CLOSE ){
	    frontTurning2= 0;
	}

	if(coverState== OPEN){
	    frontTurning2= 180 + Utilities.rad2degree(qr);
	}

	    
	backTurning2= 0.0;
	spineTurning2= rotAround_CK1-90;
	
	a= bt * Math.cos(pr);
	b= cw * Math.cos(qr);

	//update ck2 ck3
	cover_skeleton2[0].set(cw, 0, 0);
	cover_skeleton2[1].set(0, 0, 0);
	
	if(coverState==CLOSE ){
	    cover_skeleton2[3].set( cw, bt, 0 );
	}

	if(coverState==OPEN ){
	    cover_skeleton2[3].set(-a-b, 0, 0);
	}
	
		
	Matrix4d.rotAroundZ(-pr).
	    transform( new Point3d(-bt,0,0), cover_skeleton2[2]);// rotate around z Axis about -pr(clockwise direction)
	
	leftTop_curve.setKnots(0, new Point3d(-bt+midLeft,0,0));// ctrl pts 0
	leftLower_curve.setKnots(0, new Point3d(-bt,0,0));// start at cover skeleton [2]
	rightTop_curve.setKnots( 0, new Point3d(-bt+midRight,0,0));
	rightLower_curve.setKnots( 0, new Point3d(0,0,0));// start at cover skeleton [1], which is at the origin of local coordinate system
	
	
	double disX, disY;
	double len= distanceC0C1(rotAround_CK1);
	disX= len * Math.cos(rotCK1_r);
	disY= len * Math.sin(rotCK1_r);
	leftLower_curve.setKnots(1, new Point3d(-bt-disX, disY, 0)); // ctrl pts 1
	rightLower_curve.setKnots(1, new Point3d(0,disY,0));
	rightTop_curve.setKnots( 1, new Point3d(-bt+midRight,bt,0));
	
	
	
	//disX= (bt+len)/2 * Math.cos(rotCK1_r);
	//disY= (bt+len)/2 * Math.sin(rotCK1_r);
	disX= bt * Math.cos(rotCK1_r);
	disY= bt * Math.sin(rotCK1_r);
	leftTop_curve.setKnots(1, new Point3d(-disX-bt+midLeft, disY, 0)); // ctrl pts 1


	double disC2C3= pw/3;
	leftTop_curve.setKnots(3, new Point3d(cw-pw, lh, 0)); // ctrl pts 3
	leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x + disC2C3, 
					      leftTop_curve.ctrl_points[3].y,
					      leftTop_curve.ctrl_points[3].z)); // ctrl pts 2
	leftLower_curve.setKnots(3, new Point3d(cw-pw, 0, 0)); // ctrl pts 3
	leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x + disC2C3,
						leftLower_curve.ctrl_points[3].y,
						leftLower_curve.ctrl_points[3].z)); // ctrl pts 2

	rightTop_curve.setKnots(3, new Point3d(pw, rh, 0));
	rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3, 
					       rightTop_curve.ctrl_points[3].y, 
					       rightTop_curve.ctrl_points[3].z ));
	
	rightLower_curve.setKnots(3, new Point3d(pw, 0, 0));
	rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3, 
						 rightLower_curve.ctrl_points[3].y, 
						 rightLower_curve.ctrl_points[3].z ));
	
	//transformation
	Matrix4d m1= Matrix4d.rotAroundZ(-pr);//rotateZ around the origin of the local coordinate system
	Matrix4d m2= 
	    Matrix4d.rotAroundZ(qr)
	    .then( Matrix4d.shift(cover_skeleton2[3].x, cover_skeleton2[3].y, cover_skeleton2[3].z ));
	int i;
	
	for(i=0; i<2; i++){ 
	    m1.transform(leftTop_curve.ctrl_points[i]);
	    m1.transform(leftLower_curve.ctrl_points[i]);
	    m1.transform(rightTop_curve.ctrl_points[i]);
	    m1.transform(rightLower_curve.ctrl_points[i]);
	}
	
	for(i=2; i<4; i++){
	    m2.transform(leftTop_curve.ctrl_points[i]);
	    m2.transform(leftLower_curve.ctrl_points[i]);
	}
	
	 double unit_len= config.get_elementLength();
	 leftTop_curve.setAll(unit_len, LEFT);
	 leftLower_curve.setAll(unit_len, LEFT);
	 rightTop_curve.setAll(unit_len, RIGHT);
	 rightLower_curve.setAll(unit_len, RIGHT);

	 //generate points on the curve
	 if(coverState == OPEN){
	     leftTop_curve.evaluate();
	     leftLower_curve.evaluate2(); //without generating vectors
	 }
	 rightTop_curve.evaluate();
	 rightLower_curve.evaluate2();

     }


	/*
       perform similar kind of job as phase2bookconstruction2
       except that here we do not create interior curves

       here, we must be careful with rh(at moment, we only concern about turning anti-clockwise)

       This is called hen performing rotateSpine

       type 2 has distance between ctrlpts 0 and 1 changing
      */
    /*
    public void phase2bookconstruction3type2(double lh, double rh, double rotAround_CK1,
					      double midLeft,
					      double midRight)
     {
	 double cw, bt, pw, rotCK1_r, pr, qr; 
	 double a, b;

	 cw= config.getCoverWidth();
	 bt= config.getBookThickness();
	 pw= config.getPaperWidth(); 
	 rotCK1_r= Utilities.degree2rad( rotAround_CK1 );//radian for rotAround_CK1
	 pr=  Utilities.degree2rad(90-rotAround_CK1);
	 qr= sineRules(cw, bt, pr);

	 frontTurning2= 180 + Utilities.rad2degree(qr);
	 backTurning2= 0.0;
	 spineTurning2= rotAround_CK1-90;

	 a= bt * Math.cos(pr);
	 b= cw * Math.cos(qr);

	 //update ck2 ck3
	 cover_skeleton2[0].set(cw, 0, 0);
	 cover_skeleton2[1].set(0, 0, 0);
	 cover_skeleton2[3].set(-a-b, 0, 0);
	 Matrix4d.rotAroundZ(-pr).
	     transform( new Point3d(-bt,0,0), cover_skeleton2[2]);// rotate around z Axis about -pr(clockwise direction)

	 leftTop_curve.setKnots(0, new Point3d(-bt+midLeft,0,0));// ctrl pts 0
	 leftLower_curve.setKnots(0, new Point3d(-bt,0,0));// start at cover skeleton [2]
	 rightTop_curve.setKnots( 0, new Point3d(-bt+midRight,0,0));
	 rightLower_curve.setKnots( 0, new Point3d(0,0,0));// start at cover skeleton [1], which is at the origin of local coordinate system

	 double disX, disY;
	 double len= distanceC0C1(rotAround_CK1);
	 disX= len * Math.cos(rotCK1_r);
	 disY= len * Math.sin(rotCK1_r);
	 leftLower_curve.setKnots(1, new Point3d(-bt-disX, disY, 0)); // ctrl pts 1
	 rightLower_curve.setKnots(1, new Point3d(0,disY,0));
	 rightTop_curve.setKnots( 1, new Point3d(-bt+midRight,bt,0));

	 len= distanceC0C1type2(rotAround_CK1);
	 if(Ttp.commentslevel >= 3){
	     System.out.println("\ttype 2 len= " + len );
	 }
	 
	 disX= len * Math.cos(rotCK1_r);
	 disY= len * Math.sin(rotCK1_r);
	 leftTop_curve.setKnots(1, new Point3d(-disX-bt+midLeft, disY, 0)); // ctrl pts 1

	 double disC2C3= pw/3;
	 leftTop_curve.setKnots(3, new Point3d(cw-pw, lh, 0)); // ctrl pts 3
	 leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x + disC2C3, 
					       leftTop_curve.ctrl_points[3].y,
					       leftTop_curve.ctrl_points[3].z)); // ctrl pts 2
	 leftLower_curve.setKnots(3, new Point3d(cw-pw, 0, 0)); // ctrl pts 3
	 leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x + disC2C3,
						 leftLower_curve.ctrl_points[3].y,
						 leftLower_curve.ctrl_points[3].z)); // ctrl pts 2

	 rightTop_curve.setKnots(3, new Point3d(pw, rh, 0));
	 rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3, 
						rightTop_curve.ctrl_points[3].y, 
						rightTop_curve.ctrl_points[3].z ));

	 rightLower_curve.setKnots(3, new Point3d(pw, 0, 0));
	 rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3, 
						  rightLower_curve.ctrl_points[3].y, 
						  rightLower_curve.ctrl_points[3].z ));

	 //transformation
	 Matrix4d m1= Matrix4d.rotAroundZ(-pr);//rotateZ around the origin of the local coordinate system
	 Matrix4d m2= 
	     Matrix4d.rotAroundZ(qr)
	     .then( Matrix4d.shift(cover_skeleton2[3].x, cover_skeleton2[3].y, cover_skeleton2[3].z ));
	 int i;

	 for(i=0; i<2; i++){ 
	     m1.transform(leftTop_curve.ctrl_points[i]);
	     m1.transform(leftLower_curve.ctrl_points[i]);
	     m1.transform(rightTop_curve.ctrl_points[i]);
	     m1.transform(rightLower_curve.ctrl_points[i]);
	 }

	 for(i=2; i<4; i++){
	     m2.transform(leftTop_curve.ctrl_points[i]);
	     m2.transform(leftLower_curve.ctrl_points[i]);
	 }

	 double unit_len= config.get_elementLength();
	 leftTop_curve.setAll(unit_len, LEFT);
	 leftLower_curve.setAll(unit_len, LEFT);
	 rightTop_curve.setAll(unit_len, RIGHT);
	 rightLower_curve.setAll(unit_len, RIGHT);

	 //generate points on the curve
	 leftTop_curve.evaluate2();
	 leftLower_curve.evaluate2();
	 rightTop_curve.evaluate2();
	 rightLower_curve.evaluate2();

	 }*/
    public void phase2bookconstruction3type2(double lh, double rh, double rotAround_CK1,
					      double midLeft,
					      double midRight,
					      double right_length,
					      double left_length,
					      double lower_length)
     {
	 double cw, bt, pw, rotCK1_r, pr, qr; 
	 double a, b;

	 cw= config.getCoverWidth();
	 bt= config.getBookThickness();
	 pw= config.getPaperWidth(); 
	 rotCK1_r= Utilities.degree2rad( rotAround_CK1 );//radian for rotAround_CK1
	 pr=  Utilities.degree2rad(90-rotAround_CK1);
	 qr= sineRules(cw, bt, pr);

	 frontTurning2= 180 + Utilities.rad2degree(qr);
	 backTurning2= 0.0;
	 spineTurning2= rotAround_CK1-90;

	 a= bt * Math.cos(pr);
	 b= cw * Math.cos(qr);

	 //update ck2 ck3
	 cover_skeleton2[0].set(cw, 0, 0);
	 cover_skeleton2[1].set(0, 0, 0);
	 cover_skeleton2[3].set(-a-b, 0, 0);
	 Matrix4d.rotAroundZ(-pr).
	     transform( new Point3d(-bt,0,0), cover_skeleton2[2]);// rotate around z Axis about -pr(clockwise direction)

	 leftTop_curve.setKnots(0, new Point3d(-bt+midLeft,0,0));// ctrl pts 0
	 leftLower_curve.setKnots(0, new Point3d(-bt,0,0));// start at cover skeleton [2]
	 rightTop_curve.setKnots( 0, new Point3d(-bt+midRight,0,0));
	 rightLower_curve.setKnots( 0, new Point3d(0,0,0));// start at cover skeleton [1], which is at the origin of local coordinate system

	 double disX, disY;
	 disX= lower_length * Math.cos(rotCK1_r);
	 disY= lower_length * Math.sin(rotCK1_r);
	 leftLower_curve.setKnots(1, new Point3d(-bt-disX, disY, 0)); // ctrl pts 1
	 rightLower_curve.setKnots(1, new Point3d(0,disY,0));

	 
	 //right side selected
	 rightTop_curve.setKnots( 1, new Point3d(-bt+midRight, right_length,0));
	 

	 //len= distanceC0C1type2(rotAround_CK1);
	 //System.out.println("\ttype 2 len= " + len );
	 disX= left_length * Math.cos(rotCK1_r);
	 disY= left_length * Math.sin(rotCK1_r);
	 leftTop_curve.setKnots(1, new Point3d(-disX-bt+midLeft, disY, 0)); // ctrl pts 1

	 double disC2C3= pw/3;
	 leftTop_curve.setKnots(3, new Point3d(cw-pw, lh, 0)); // ctrl pts 3
	 leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x + disC2C3, 
					       leftTop_curve.ctrl_points[3].y,
					       leftTop_curve.ctrl_points[3].z)); // ctrl pts 2
	 leftLower_curve.setKnots(3, new Point3d(cw-pw, 0, 0)); // ctrl pts 3
	 leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x + disC2C3,
						 leftLower_curve.ctrl_points[3].y,
						 leftLower_curve.ctrl_points[3].z)); // ctrl pts 2

	 rightTop_curve.setKnots(3, new Point3d(pw, rh, 0));
	 rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3, 
						rightTop_curve.ctrl_points[3].y, 
						rightTop_curve.ctrl_points[3].z ));

	 rightLower_curve.setKnots(3, new Point3d(pw, 0, 0));
	 rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3, 
						  rightLower_curve.ctrl_points[3].y, 
						  rightLower_curve.ctrl_points[3].z ));

	 //transformation
	 Matrix4d m1= Matrix4d.rotAroundZ(-pr);//rotateZ around the origin of the local coordinate system
	 Matrix4d m2= 
	     Matrix4d.rotAroundZ(qr)
	     .then( Matrix4d.shift(cover_skeleton2[3].x, cover_skeleton2[3].y, cover_skeleton2[3].z ));
	 int i;

	 for(i=0; i<2; i++){ 
	     m1.transform(leftTop_curve.ctrl_points[i]);
	     m1.transform(leftLower_curve.ctrl_points[i]);
	     m1.transform(rightTop_curve.ctrl_points[i]);
	     m1.transform(rightLower_curve.ctrl_points[i]);
	 }

	 for(i=2; i<4; i++){
	     m2.transform(leftTop_curve.ctrl_points[i]);
	     m2.transform(leftLower_curve.ctrl_points[i]);
	 }

	 double unit_len= config.get_elementLength();
	 leftTop_curve.setAll(unit_len, LEFT);
	 leftLower_curve.setAll(unit_len, LEFT);
	 rightTop_curve.setAll(unit_len, RIGHT);
	 rightLower_curve.setAll(unit_len, RIGHT);

	 //generate points on the curve
	 leftTop_curve.evaluate2();
	 leftLower_curve.evaluate2();
	 rightTop_curve.evaluate2();
	 rightLower_curve.evaluate2();

     }

    
    void phase2bookconstruction3type3(double lh, double rh, double rotAround_CK1, double coverTurning,
				      double c0c1TurningAngle,
				      double mid,
				      double len)
    {
	double cw, bt, pw, rotCK1_r, pr, qr, cr, c0c1r; 
	double a, b;
	int i;
	
	cw= config.getCoverWidth();
	pw= config.getPaperWidth(); 
	bt= config.getBookThickness();
	 rotCK1_r= Utilities.degree2rad(rotAround_CK1);
	 c0c1r= Utilities.degree2rad(c0c1TurningAngle);
	 if(Ttp.commentslevel >= 3){
	     System.out.println("\tcoverTurning= " + coverTurning);
	 }
	 
	 cr= Utilities.degree2rad(coverTurning);
	 pr=  Utilities.degree2rad(90-rotAround_CK1);
	 qr= sineRules(cw, bt, pr);
	 
	 if(scene.selected_name == config.FRONT_COVER ||
	    scene.selected_name == config.RIGHT_EDGE || 
	    scene.selected_name == config.FORWARD_BUTTON || 
	    scene.selected_name == config.TURN_LEFT
	    ){ 
	     backTurning2= 0.0;
	 }
	 if(scene.selected_name == config.BACK_COVER || 
	    scene.selected_name == config.LEFT_EDGE  || 
	    scene.selected_name == config.BACKWARD_BUTTON ||
	    scene.selected_name == config.TURN_RIGHT
	    ){ 
	     frontTurning2= 180 + Utilities.rad2degree(qr);
	 }
	 spineTurning2= rotAround_CK1-90;

	 
	 
	 if(scene.selected_name == config.FRONT_COVER || 
	    scene.selected_name == config.RIGHT_EDGE ||
	    scene.selected_name == config.FORWARD_BUTTON ||
	    scene.selected_name == config.TURN_LEFT
	    ){ //FRONT_COVER
	     cover_skeleton2[0].set(cw, 0, 0);
	     cover_skeleton2[1].set(0, 0, 0);
	     Matrix4d.rotAroundZ(-pr).
		 transform( new Point3d(-bt,0,0), cover_skeleton2[2]);// rotate around z Axis about -pr(clockwise direction)
	     //transform cover_skeleton2[3] not yet implemented
	
	 }else{
	     //transform cover_skeleton2[0] not yet implemented
	     cover_skeleton2[1].set(0, 0, 0);
	     Matrix4d.rotAroundZ(-pr).
		 transform( new Point3d(-bt,0,0), cover_skeleton2[2]);// rotate around z Axis about -pr(clockwise direction)
	     a= bt * Math.cos(pr);
	     b= cw * Math.cos(qr);
	     cover_skeleton2[3].set(-a-b, 0, 0);
	 }
	 
	 Matrix4d m1= Matrix4d.rotAroundZ(-pr);//rotateZ around the origin of the local coordinate system
	 Matrix4d m2;
	 
	 if(scene.selected_name == config.FRONT_COVER || 
	    scene.selected_name == config.RIGHT_EDGE || 
	    scene.selected_name == config.FORWARD_BUTTON ||
	    scene.selected_name == config.TURN_LEFT
	    ){ //FRONT_COVER
	     m2= Matrix4d.rotAroundZ(cr)
		 .then( Matrix4d.shift(cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z ));
	 }else{
	     m2= Matrix4d.rotAroundZ(qr)
		 .then( Matrix4d.shift(cover_skeleton2[3].x, cover_skeleton2[3].y, cover_skeleton2[3].z ));
	 }
	 
	 
	 Matrix4d m3= Matrix4d.rotAroundZ(cr);
	     //.then( Matrix4d.shift(cover_skeleton2[1].x, cover_skeleton2[1].y, cover_skeleton2[1].z ));
	 

	 double disX, disY;
	 leftTop_curve.setKnots(0, new Point3d(-bt+mid,0,0));// ctrl pts 0
	 leftLower_curve.setKnots(0, new Point3d(-bt,0,0));// start at cover skeleton [2]
	 rightTop_curve.setKnots( 0, new Point3d(-bt+mid,0,0));
	 rightLower_curve.setKnots( 0, new Point3d(0,0,0));

	 disX= bt * Math.cos(c0c1r);
	 disY= bt * Math.sin(c0c1r);
	 leftTop_curve.setKnots(1, new Point3d(-disX-bt+mid, disY, 0)); // ctrl pts 1

	 disX= len * Math.cos(c0c1r);
	 disY= len * Math.sin(c0c1r);
	 leftLower_curve.setKnots(1, new Point3d(-bt-disX, disY, 0)); // ctrl pts 1
	 rightTop_curve.setKnots( 1, new Point3d(-bt+mid,bt,0));
	 rightLower_curve.setKnots(1, new Point3d(0,disY,0));

	 
	 double disC2C3= pw/3;
	 if(scene.selected_name == config.FRONT_COVER || 
	    scene.selected_name == config.RIGHT_EDGE || 
	    scene.selected_name == config.FORWARD_BUTTON || 
	    scene.selected_name == config.TURN_LEFT){ //FRONT_COVER
	     leftTop_curve.setKnots(3, new Point3d(pw, -lh, 0));
	     leftLower_curve.setKnots(3, new Point3d(pw, 0, 0)); // ctrl pts 3
	     leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x - disC2C3, 
						   leftTop_curve.ctrl_points[3].y,
						   leftTop_curve.ctrl_points[3].z)); // ctrl pts 2
	     leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x - disC2C3, 
						     leftLower_curve.ctrl_points[3].y,
						     leftLower_curve.ctrl_points[3].z)); // ctrl pts 2

	 }else{
	     leftTop_curve.setKnots(3, new Point3d(cw-pw, lh, 0)); // ctrl pts 3
	     leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x + disC2C3, 
						   leftTop_curve.ctrl_points[3].y,
						   leftTop_curve.ctrl_points[3].z)); // ctrl pts 2
	     
	     leftLower_curve.setKnots(3, new Point3d(cw-pw, 0, 0)); // ctrl pts 3
	     leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x + disC2C3,
						     leftLower_curve.ctrl_points[3].y,
						     leftLower_curve.ctrl_points[3].z)); // ctrl pts 2
	 }
	 
	 rightTop_curve.setKnots(3, new Point3d(pw, rh, 0));
	 rightLower_curve.setKnots(3, new Point3d(pw, 0, 0));
	 
	 rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3, 
						rightTop_curve.ctrl_points[3].y, 
						rightTop_curve.ctrl_points[3].z ));
	 rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3, 
						  rightLower_curve.ctrl_points[3].y, 
						  rightLower_curve.ctrl_points[3].z ));
	 
	 for(i=0; i<4; i++){ 
	     if(i < 2){
		 m1.transform(leftTop_curve.ctrl_points[i]);
		 m1.transform(leftLower_curve.ctrl_points[i]);
		 m1.transform(rightTop_curve.ctrl_points[i]);
		 m1.transform(rightLower_curve.ctrl_points[i]);
	     }else{
		 if(scene.selected_name == config.FRONT_COVER || 
		    scene.selected_name == config.RIGHT_EDGE || 
		    scene.selected_name == config.FORWARD_BUTTON || 
		    scene.selected_name == config.TURN_LEFT ){ //FRONT_COVER
		     m2.transform(leftTop_curve.ctrl_points[i]);
		     m2.transform(leftLower_curve.ctrl_points[i]);
		 }else{
		     m2.transform(leftTop_curve.ctrl_points[i]);
		     m2.transform(leftLower_curve.ctrl_points[i]);
		     m3.transform(rightTop_curve.ctrl_points[i]);
		     m3.transform(rightLower_curve.ctrl_points[i]);
		 }
	     }
	 }

	 double unit_len= config.get_elementLength();
	 leftTop_curve.setAll(unit_len, LEFT);
	 leftLower_curve.setAll(unit_len, LEFT);
	 rightTop_curve.setAll(unit_len, RIGHT);
	 rightLower_curve.setAll(unit_len, RIGHT);

	 leftTop_curve.evaluate2();
	 leftLower_curve.evaluate2();
	 rightTop_curve.evaluate2();
	 rightLower_curve.evaluate2();
	 

     }


    void phase2bookconstruction3type4(double lh, double rh, double rotAround_CK1, double frontcoverTurning,
				      double mid,
				      double len)
    {
	double pr, fr, cw, bt, pw; 
	int i;

	 backTurning2= 0.0;
	 spineTurning2= rotAround_CK1-90;

	 pr=  Utilities.degree2rad(90-rotAround_CK1);
	 bt= config.getBookThickness();
	 cw= config.getCoverWidth();
	 pw= config.getPaperWidth(); 
	 fr= Utilities.degree2rad(frontcoverTurning);

	 //update cover_skeletons
	 cover_skeleton2[0].set(cw, 0, 0);
	 cover_skeleton2[1].set(0, 0, 0);
	 Matrix4d.rotAroundZ(-pr).
	     transform( new Point3d(-bt,0,0), cover_skeleton2[2]);
	 Matrix4d m1= Matrix4d.rotAroundZ(-pr);//rotateZ around the origin of the local coordinate system
	 Matrix4d m2= 
	     Matrix4d.rotAroundZ(fr)
	     .then( Matrix4d.shift(cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z ));

	 leftTop_curve.setKnots(0, new Point3d(-bt+mid, 0, 0));
	 rightTop_curve.setKnots(0, new Point3d(-bt+mid, 0, 0));
	 leftLower_curve.setKnots(0, new Point3d(-bt,0,0));// start at cover skeleton [2]
	 rightLower_curve.setKnots( 0, new Point3d(0,0,0));// start at cover skeleton [1], which is at the origin of local coordinate system

	 leftTop_curve.setKnots(1, new Point3d(-bt+mid, bt, 0));
	 rightTop_curve.setKnots(1, new Point3d(-bt+mid, bt, 0));
	 leftLower_curve.setKnots(1, new Point3d(-bt,len,0));// 
	 rightLower_curve.setKnots(1, new Point3d(0,len,0));//
	 

	 leftTop_curve.setKnots(3, new Point3d(pw, -lh, 0));
	 rightTop_curve.setKnots(3, new Point3d(pw, rh, 0));
	 leftLower_curve.setKnots(3, new Point3d(pw, 0, 0));
	 rightLower_curve.setKnots(3, new Point3d(pw, 0, 0));

	 double disC2C3= pw/3;
	 leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x - disC2C3, 
					       leftTop_curve.ctrl_points[3].y,
					       leftTop_curve.ctrl_points[3].z)); // ctrl pts 2
	 rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3, 
						rightTop_curve.ctrl_points[3].y, 
						rightTop_curve.ctrl_points[3].z ));
	 leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x - disC2C3,
						 leftLower_curve.ctrl_points[3].y,
						 leftLower_curve.ctrl_points[3].z)); // ctrl pts 2
	 rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3, 
						  rightLower_curve.ctrl_points[3].y, 
						  rightLower_curve.ctrl_points[3].z ));



	 for(i=0; i<4; i++){ 
	     if(i < 2){
		 m1.transform(leftTop_curve.ctrl_points[i]);
		 m1.transform(rightTop_curve.ctrl_points[i]);
		 m1.transform(leftLower_curve.ctrl_points[i]);
		 m1.transform(rightLower_curve.ctrl_points[i]);
	    }else{
		m2.transform(leftTop_curve.ctrl_points[i]);
		m2.transform(leftLower_curve.ctrl_points[i]);
	    }
	}

	double unit_len= config.get_elementLength();
	leftTop_curve.setAll(unit_len, LEFT);
	rightTop_curve.setAll(unit_len, LEFT);
	leftLower_curve.setAll(unit_len, LEFT);
	rightLower_curve.setAll(unit_len, LEFT);
	
	leftTop_curve.evaluate2();
	rightTop_curve.evaluate2();
	leftLower_curve.evaluate2();
	rightLower_curve.evaluate2();
    }

    /*
      Used for flipping over
    */
    void phase2bookconstruction3type5(double lh, double rh, double rotAround_CK1,
				      double mid)
    {
	double pr, cr, bt, pw;
	int i;
	
	pr= Utilities.degree2rad(90-rotAround_CK1);
	cr= Utilities.degree2rad(rotAround_CK1);
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	
	if(scene.selected_name == config.BACK_COVER){
	    frontTurning2= rotAround_CK1;
	}

	if(scene.selected_name == config.FRONT_COVER){
	    backTurning2= rotAround_CK1;
	}

	spineTurning2= rotAround_CK1-90;
	
	//transform cover_skeleton2[0] not yet implemented
	cover_skeleton2[1].set(0, 0, 0);
	Matrix4d.rotAroundZ(-pr).
		 transform( new Point3d(-bt,0,0), cover_skeleton2[2]);// rotate around z Axis about -pr(clockwise direction)
	//transform cover_skeleton2[3] not yet implemented

	Matrix4d m1= Matrix4d.rotAroundZ(-pr);//rotateZ around the origin of the local coordinate system
	Matrix4d m2;

	double disC2C3= pw/3;
	double unit_len= config.get_elementLength();
	if(scene.selected_name == config.BACK_COVER){
	    m2= Matrix4d.rotAroundZ(cr);
	    //construct right curves
	    rightTop_curve.setKnots( 0, new Point3d(-bt+mid,0,0));
	    rightLower_curve.setKnots( 0, new Point3d(0,0,0));
	    rightTop_curve.setKnots( 1, new Point3d(-bt+mid,bt,0));
	    rightLower_curve.setKnots(1, new Point3d(0,0,0));
	    
	    rightTop_curve.setKnots(3, new Point3d(pw, rh, 0));
	    rightLower_curve.setKnots(3, new Point3d(pw, 0, 0));
	    
	    rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3, 
						   rightTop_curve.ctrl_points[3].y, 
						   rightTop_curve.ctrl_points[3].z ));
	    rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3, 
						     rightLower_curve.ctrl_points[3].y, 
						     rightLower_curve.ctrl_points[3].z ));
	    
	    for(i=0; i<4; i++){ 
		if(i < 2){
		    m1.transform(rightTop_curve.ctrl_points[i]);
		    m1.transform(rightLower_curve.ctrl_points[i]);
		}else{
		    m2.transform(rightTop_curve.ctrl_points[i]);
		    m2.transform(rightLower_curve.ctrl_points[i]);
		}
	    }
	    
	    
	    rightTop_curve.setAll(unit_len, RIGHT);
	    rightLower_curve.setAll(unit_len, RIGHT);
	    
	    rightTop_curve.evaluate2();
	    rightLower_curve.evaluate2();
	}else{ //scene.selected_name == config.FRONT_COVER
	    m2= Matrix4d.rotAroundZ(cr)
		.then( Matrix4d.shift(cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z ));

	    leftTop_curve.setKnots(0, new Point3d(-bt+mid,0,0));// ctrl pts 0
	    leftLower_curve.setKnots(0, new Point3d(-bt,0,0));// start at cover skeleton [2]

	    leftTop_curve.setKnots(1, new Point3d(-bt+mid, bt, 0)); // ctrl pts 1
	    leftLower_curve.setKnots(1, new Point3d(-bt, bt, 0)); // ctrl pts 1

	    leftTop_curve.setKnots(3, new Point3d(pw, -lh, 0));
	    leftLower_curve.setKnots(3, new Point3d(pw, 0, 0)); // ctrl pts 3
	    leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x - disC2C3, 
						  leftTop_curve.ctrl_points[3].y,
						  leftTop_curve.ctrl_points[3].z)); // ctrl pts 2
	    leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x - disC2C3, 
						    leftLower_curve.ctrl_points[3].y,
						    leftLower_curve.ctrl_points[3].z)); // ctrl pts 2

	    for(i=0; i<4; i++){ 
		if(i < 2){
		    m1.transform(leftTop_curve.ctrl_points[i]);
		    m1.transform(leftLower_curve.ctrl_points[i]);
		}else{
		    m2.transform(leftTop_curve.ctrl_points[i]);
		    m2.transform(leftLower_curve.ctrl_points[i]);
		}
	    }
	     leftTop_curve.setAll(unit_len, LEFT);
	     leftLower_curve.setAll(unit_len, LEFT);

	     leftTop_curve.evaluate2();
	     leftLower_curve.evaluate2();
	}
	
    }    
    
    
    /*
      Only build two stopping position of two interior curves
      interior_curveUP_finish
      interior_curveDOWN_finish

      h1: initial_lh
      h2: final_lh
      midLeft: initial_lh
      midRight: final_lh or initial_lh+jumping_distance
     */
    
    //deprecated
    /*public void phase2bookconstruction4(double h1, double h2, double rotAround_CK1,
					double midLeft,
					double midRight)
    {
	double cw, bt, pw, rotCK1_r, pr, qr; 
	double a, b;
	double disC2C3;

	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	disC2C3= pw/3;
	rotCK1_r= Utilities.degree2rad( rotAround_CK1 );//radian for rotAround_CK1
	pr= Utilities.degree2rad(90-rotAround_CK1);
	qr= sineRules(cw, bt, pr);

	frontTurning3= 180 + Utilities.rad2degree(qr);
	backTurning3= 0.0;
	spineTurning3= rotAround_CK1-90;

	a= bt * Math.cos(pr);
	b= cw * Math.cos(qr);
	
	//update cover_skeleton3
	cover_skeleton3[3].set(-a-b, 0, 0);
	Matrix4d.rotAroundZ(-pr).
	    transform( new Point3d(-bt,0,0), cover_skeleton3[2]);
	

	if(selected_side == RIGHT){
	    interior_curveUP_finish.setKnots(0, new Point3d(-bt+midLeft,0,0));// ctrl pts 0
	    interior_curveDOWN_finish.setKnots(0, new Point3d(-bt+midRight,0,0));// ctrl pts 0

	    double disX, disY;
	    //double len= distanceC0C1(rotAround_CK1);
	    //double averageLen= (len+bt)/2;
	    double len= distanceC0C1type2(rotAround_CK1);
	    // ctrl pts 1
	    disX= len * Math.cos(rotCK1_r);
	    disY= len * Math.sin(rotCK1_r);
	    interior_curveUP_finish.setKnots(1, new Point3d( -disX-bt+midLeft,disY,0));
	    
	    disX= bt * Math.cos(rotCK1_r);
	    disY= bt * Math.sin(rotCK1_r);
	    interior_curveDOWN_finish.setKnots(1, new Point3d(-disX-bt+midRight ,disY,0));

	    
	    interior_curveUP_finish.setKnots(3, new Point3d(cw-pw, h1, 0));// ctrl pts 3
	    interior_curveDOWN_finish.setKnots(3, new Point3d(cw-pw, h2, 0));// ctrl pts 3
	    interior_curveUP_finish.setKnots(2, new Point3d(interior_curveUP_finish.ctrl_points[3].x + disC2C3, 
							    interior_curveUP_finish.ctrl_points[3].y,
							    interior_curveUP_finish.ctrl_points[3].z)); // ctrl pts 2
	    interior_curveDOWN_finish.setKnots(2, new Point3d(interior_curveDOWN_finish.ctrl_points[3].x + disC2C3, 
							      interior_curveDOWN_finish.ctrl_points[3].y,
							      interior_curveDOWN_finish.ctrl_points[3].z)); // ctrl pts 2
	}else{
	    interior_curveUP_finish.setKnots(0, new Point3d(-bt+midLeft,0,0));// ctrl pts 0
	    interior_curveDOWN_finish.setKnots(0, new Point3d(-bt+midRight,0,0));// final_lh
	    
	    interior_curveUP_finish.setKnots(1, new Point3d(-bt+midLeft,bt,0));
	    interior_curveDOWN_finish.setKnots(1, new Point3d(-bt+midRight,bt,0));
	    
	    interior_curveUP_finish.setKnots(3, new Point3d(pw, h1, 0));// ctrl pts 3
	    interior_curveDOWN_finish.setKnots(3, new Point3d(pw, h2, 0));// ctrl pts 3
	    
	    interior_curveUP_finish.setKnots(2, new Point3d(interior_curveUP_finish.ctrl_points[3].x-disC2C3, 
							    interior_curveUP_finish.ctrl_points[3].y, 
							    interior_curveUP_finish.ctrl_points[3].z));// ctrl pts 2
	    interior_curveDOWN_finish.setKnots(2, new Point3d(interior_curveDOWN_finish.ctrl_points[3].x-disC2C3, 
							      interior_curveDOWN_finish.ctrl_points[3].y, 
							      interior_curveDOWN_finish.ctrl_points[3].z));// ctrl pts 2
	}
	

	Matrix4d m1= Matrix4d.rotAroundZ(-pr);//rotateZ around the origin of the local coordinate system
	Matrix4d m2= 
	    Matrix4d.rotAroundZ(qr)
	    .then( Matrix4d.shift(cover_skeleton3[3].x, cover_skeleton3[3].y, cover_skeleton3[3].z ));

	int i;

	for(i=0; i<4; i++){ 
	    if(i<2){
		m1.transform(interior_curveUP_finish.ctrl_points[i]);
		m1.transform(interior_curveDOWN_finish.ctrl_points[i]);
	    }else{
		if(selected_side == RIGHT){
		    m2.transform(interior_curveUP_finish.ctrl_points[i]);
		    m2.transform(interior_curveDOWN_finish.ctrl_points[i]);
		}
	    }
	}
	
	double unit_len= config.get_elementLength();
	
	if(selected_side == RIGHT){
	    interior_curveUP_finish.setAll(unit_len, LEFT);
	    interior_curveDOWN_finish.setAll(unit_len, LEFT);
	}else{
	    interior_curveUP_finish.setAll(unit_len, RIGHT);
	    interior_curveDOWN_finish.setAll(unit_len, RIGHT);
	}
	
	interior_curveUP_finish.evaluate();
	interior_curveDOWN_finish.evaluate();
    }
    */
    public void phase2bookconstruction4(double h1, double h2, double rotAround_CK1,
					double midLeft,
					double midRight)
    {
	double cw, bt, pw, rotCK1_r, pr, qr; 
	double a, b;
	double disC2C3;
	double disX, disY;

	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	disC2C3= pw/3;
	rotCK1_r= Utilities.degree2rad( rotAround_CK1 );//radian for rotAround_CK1
	pr= Utilities.degree2rad(90-rotAround_CK1);
	qr= sineRules(cw, bt, pr);

	frontTurning3= 180 + Utilities.rad2degree(qr);
	backTurning3= 0.0;
	spineTurning3= rotAround_CK1-90;

	a= bt * Math.cos(pr);
	b= cw * Math.cos(qr);
	
	//update cover_skeleton3
	cover_skeleton3[3].set(-a-b, 0, 0);
	Matrix4d.rotAroundZ(-pr).
	    transform( new Point3d(-bt,0,0), cover_skeleton3[2]);
	

	if(selected_side == RIGHT){
	    interior_curveUP_finish.setKnots(0, new Point3d(-bt+midLeft,0,0));// ctrl pts 0
	    interior_curveDOWN_finish.setKnots(0, new Point3d(-bt+midRight,0,0));// ctrl pts 0

	    
	    disX= final_length * Math.cos(rotCK1_r);
	    disY= final_length * Math.sin(rotCK1_r);
	    interior_curveUP_finish.setKnots(1, new Point3d( -disX-bt+midLeft,disY,0));
	    
	    disX= bt * Math.cos(rotCK1_r);
	    disY= bt * Math.sin(rotCK1_r);
	    interior_curveDOWN_finish.setKnots(1, new Point3d(-disX-bt+midRight ,disY,0));

	    
	    interior_curveUP_finish.setKnots(3, new Point3d(cw-pw, h1, 0));// ctrl pts 3
	    interior_curveDOWN_finish.setKnots(3, new Point3d(cw-pw, h2, 0));// ctrl pts 3
	    interior_curveUP_finish.setKnots(2, new Point3d(interior_curveUP_finish.ctrl_points[3].x + disC2C3, 
							    interior_curveUP_finish.ctrl_points[3].y,
							    interior_curveUP_finish.ctrl_points[3].z)); // ctrl pts 2
	    interior_curveDOWN_finish.setKnots(2, new Point3d(interior_curveDOWN_finish.ctrl_points[3].x + disC2C3, 
							      interior_curveDOWN_finish.ctrl_points[3].y,
							      interior_curveDOWN_finish.ctrl_points[3].z)); // ctrl pts 2
	}else{
	    interior_curveUP_finish.setKnots(0, new Point3d(-bt+midLeft,0,0));// ctrl pts 0
	    interior_curveDOWN_finish.setKnots(0, new Point3d(-bt+midRight,0,0));// final_lh
	    
	    //disY= final_length * Math.sin(rotCK1_r);
	    interior_curveUP_finish.setKnots(1, new Point3d(-bt+midLeft, final_length,0));
	    interior_curveDOWN_finish.setKnots(1, new Point3d(-bt+midRight,bt,0));
	    
	    interior_curveUP_finish.setKnots(3, new Point3d(pw, h1, 0));// ctrl pts 3
	    interior_curveDOWN_finish.setKnots(3, new Point3d(pw, h2, 0));// ctrl pts 3
	    
	    interior_curveUP_finish.setKnots(2, new Point3d(interior_curveUP_finish.ctrl_points[3].x-disC2C3, 
							    interior_curveUP_finish.ctrl_points[3].y, 
							    interior_curveUP_finish.ctrl_points[3].z));// ctrl pts 2
	    interior_curveDOWN_finish.setKnots(2, new Point3d(interior_curveDOWN_finish.ctrl_points[3].x-disC2C3, 
							      interior_curveDOWN_finish.ctrl_points[3].y, 
							      interior_curveDOWN_finish.ctrl_points[3].z));// ctrl pts 2
	}

	
	

	Matrix4d m1= Matrix4d.rotAroundZ(-pr);//rotateZ around the origin of the local coordinate system
	Matrix4d m2= 
	    Matrix4d.rotAroundZ(qr)
	    .then( Matrix4d.shift(cover_skeleton3[3].x, cover_skeleton3[3].y, cover_skeleton3[3].z ));

	int i;

	for(i=0; i<4; i++){ 
	    if(i<2){
		m1.transform(interior_curveUP_finish.ctrl_points[i]);
		m1.transform(interior_curveDOWN_finish.ctrl_points[i]);
	    }else{
		if(selected_side == RIGHT){
		    m2.transform(interior_curveUP_finish.ctrl_points[i]);
		    m2.transform(interior_curveDOWN_finish.ctrl_points[i]);
		}
	    }
	}
	
	double unit_len= config.get_elementLength();
	
	if(selected_side == RIGHT){
	    interior_curveUP_finish.setAll(unit_len, LEFT);
	    interior_curveDOWN_finish.setAll(unit_len, LEFT);
	}else{
	    interior_curveUP_finish.setAll(unit_len, RIGHT);
	    interior_curveDOWN_finish.setAll(unit_len, RIGHT);
	}
	
	interior_curveUP_finish.evaluate();
	interior_curveDOWN_finish.evaluate();
    }



    void phase3bookconstruction(double lh, double rh,
				 double rotAround_CK2,
				 double mid)
     {
	 int i;
	 double cw, bt, pw, qr, pr, sr, a, b;

	 cw= config.getCoverWidth();
	 bt= config.getBookThickness();
	 pw= config.getPaperWidth(); 

	 //update ck2 ck3
	 cover_skeleton[2].set(-bt, 0, 0);
	 cover_skeleton[3].set(-bt-cw, 0, 0);
	 frontTurning= 180.0;
	 
	 pr= Utilities.degree2rad(rotAround_CK2);
	 qr= sineRules(cw, bt, pr);
	 sr= Utilities.degree2rad(90-rotAround_CK2);
	 
	 backTurning= -Utilities.rad2degree(qr);
	 spineTurning= rotAround_CK2;

	 a= bt * Math.cos(pr);
	 b= cw * Math.cos(qr);

	 //update ck0 ck1
	 cover_skeleton[0].set(a+b - bt, 0 ,0); 
	 Matrix4d.rotAroundZ(pr).
	     then(Matrix4d.shift(-bt,0,0))
	     .transform(new Point3d(bt,0,0), cover_skeleton[1]);

	 Point3d [] left_ctrlpts= new Point3d[NUM_CONTROL_PTS];
	 Point3d [] right_ctrlpts= new Point3d[NUM_CONTROL_PTS];
	 Point3d [] left_ctrlpts_bottom= new Point3d[NUM_CONTROL_PTS];
	 Point3d [] right_ctrlpts_bottom= new Point3d[NUM_CONTROL_PTS];
	 for ( i = 0; i < NUM_CONTROL_PTS; i++){
	     left_ctrlpts[i]= new Point3d();
	     right_ctrlpts[i]= new Point3d();
	     left_ctrlpts_bottom[i]= new Point3d();
	     right_ctrlpts_bottom[i]= new Point3d();
	 } 

	 //page construction
	 //L0 & R0
	 double shift_down= bt-mid;
	 left_ctrlpts[0].set(shift_down,0,0);
	 right_ctrlpts[0].set(shift_down,0,0);
	 left_ctrlpts_bottom[0].set( 0,0,0);// bottom ctrl pts 0
	 right_ctrlpts_bottom[0].set( bt,0,0);
	 double disX, disY;
	 //L1 & R1
	 left_ctrlpts[1].set(shift_down,bt,0);
	 disX= bt * Math.cos(sr);
	 disY= bt * Math.sin(sr);
	 right_ctrlpts[1].set(shift_down+disX,disY,0);
	 
	 //proposed 1
	 //double half_bt= bt/2;
	 //left_ctrlpts_bottom[1].set( 0,half_bt,0);//bottom ctrl pts 1
	 //right_ctrlpts_bottom[1].set( bt+half_bt,0,0);
	 
	 //proposed 2
	 //double half_bt= bt/2;
	 double len= distanceC0C1(90-rotAround_CK2);
	 disX= len * Math.cos(sr);
	 disY= len * Math.sin(sr);
	 if(Ttp.commentslevel >= 3){
	     System.out.println("disX : " + disX );
	 }
	 
	 right_ctrlpts_bottom[1].set( bt+disX,disY,0);
	 left_ctrlpts_bottom[1].set( 0,disY,0);
	 	 
	 double disC2C3= pw/3; 
	 //L2 L3
	 //left_ctrlpts[3].set(-pw+rh-bt, lh, 0);
	 left_ctrlpts[3].set(-pw-bt, lh, 0);
	 left_ctrlpts[2].set( left_ctrlpts[3].x+ disC2C3 , lh, 0);
	 left_ctrlpts_bottom[3].set(-pw-bt, 0, 0);
	 left_ctrlpts_bottom[2].set( left_ctrlpts_bottom[3].x+ disC2C3 , 0, 0);
	 //R2 R3
	 //right_ctrlpts[3].set(pw-cw-rh, rh, 0.0);
	 right_ctrlpts[3].set(pw-cw, rh, 0.0);
	 right_ctrlpts[2].set(right_ctrlpts[3].x - disC2C3,
			      rh,  0.0);
	 right_ctrlpts_bottom[3].set(pw-cw, 0, 0); 
	 right_ctrlpts_bottom[2].set(right_ctrlpts_bottom[3].x - disC2C3, 0, 0); 
	

	 //m1
	 Matrix4d m1=	 
	     Matrix4d.rotAroundZ(pr)
	     //   Matrix4d.shift( bt-mid,0,0 )
	     //  	     .then(Matrix4d.rotAroundZ(pr))
	     .then(Matrix4d.shift( cover_skeleton[2].x, cover_skeleton[2].y, cover_skeleton[2].z  ) );
	     
	 //m2
	 Matrix4d m2=
	     Matrix4d.rotAroundZ( -qr)
	     .then(Matrix4d.shift( cover_skeleton[0].x, cover_skeleton[0].y, cover_skeleton[0].z));
	 
	 //m3
	 //Matrix4d m3=
	 //Matrix4d.shift(cover_skeleton[2].x, cover_skeleton[2].y, cover_skeleton[2].z);

	 //transform local pts to its corresponding coordinate system
	 for(i=0; i<2; i++){
	     m1.transform(left_ctrlpts[i]);
	     m1.transform(right_ctrlpts[i]);
	     leftTop_d.setKnots(i, left_ctrlpts[i]);
	     rightTop_d.setKnots(i, right_ctrlpts[i]);

	     m1.transform(left_ctrlpts_bottom[i]);
	     m1.transform(right_ctrlpts_bottom[i]);
	     leftbottom_d.setKnots(i, left_ctrlpts_bottom[i]);
	     rightbottom_d.setKnots(i, right_ctrlpts_bottom[i]);
	 }

	 for(i=2; i<4; i++){
	     m2.transform(right_ctrlpts[i]);
	     rightTop_d.setKnots(i, right_ctrlpts[i]);
	     leftTop_d.setKnots(i, left_ctrlpts[i]);
	     m2.transform(right_ctrlpts_bottom[i]);
	     rightbottom_d.setKnots(i, right_ctrlpts_bottom[i]);
	     leftbottom_d.setKnots(i, left_ctrlpts_bottom[i]);
	 }
	 
	 
     }

    
    



    /*void phase3bookconstruction3type1(double lh, double rh, 
				      double rotAround_CK2,
				      double midLeft,
				      double midRight )
    {
	int i;
	double cw, bt, pw, qr, pr, sr, a, b;
	
	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	
	//update ck2 ck3
	 cover_skeleton2[2].set(-bt, 0, 0);
	 cover_skeleton2[3].set(-bt-cw, 0, 0);
	 frontTurning2= 180.0;
	 
	 pr= Utilities.degree2rad(rotAround_CK2);
	 qr= sineRules(cw, bt, pr);
	 sr= Utilities.degree2rad(90-rotAround_CK2);
	 double rotCK2_r= Utilities.degree2rad(rotAround_CK2);
	 
	 if(coverState == CLOSE){
	     backTurning2= 180;
	 }

	 if(coverState == OPEN){
	     backTurning2= -Utilities.rad2degree(qr);
	 }

	 spineTurning2= rotAround_CK2;

	 a= bt * Math.cos(pr);
	 b= cw * Math.cos(qr);
	 //update ck0 ck1
	 if(coverState==OPEN ){
	     cover_skeleton2[0].set(a+b - bt, 0 ,0); 
	 }

	 if(coverState==CLOSE ){
	     cover_skeleton2[0].set( -bt-cw, bt, 0);
	 }

	 Matrix4d.rotAroundZ(pr)
	     .then(Matrix4d.shift(-bt,0,0))
	     .transform(new Point3d(bt,0,0), cover_skeleton2[1]);
	 
	 double disC2C3= pw/3; 
	 double disX, disY, len;
	 
	 
	 //ctrl_pts 0
	 leftTop_curve.setKnots(0, new Point3d(midLeft, 0, 0));
	 leftLower_curve.setKnots(0, new Point3d(0, 0, 0));
	 rightTop_curve.setKnots(0, new Point3d(midRight, 0, 0));
	 rightLower_curve.setKnots(0, new Point3d(bt, 0, 0));

	 //ctrl_pts 1
	 leftTop_curve.setKnots(1, new Point3d(midLeft, bt, 0));

	 len= phase3distanceC0C1(rotAround_CK2+90);
	 disX= len * Math.cos(sr);
	 disY= len * Math.sin(sr);
	 leftLower_curve.setKnots(1, new Point3d(0, disY, 0));

	 //len= phase3distanceC0C1type2(rotAround_CK2+90);
	 if(Ttp.commentslevel >= 3){
	     System.out.println("\ttype 2 len= " + len );
	 }
	 disX= bt * Math.cos(sr);
	 disY= bt * Math.sin(sr);
	 rightTop_curve.setKnots(1, new Point3d(midRight+disX, disY, 0));

	 len= phase3distanceC0C1(rotAround_CK2+90);
	 disX= len * Math.cos(sr);
	 disY= len * Math.sin(sr);
	 rightLower_curve.setKnots(1, new Point3d(bt+disX, disY, 0));
	 
	 
	 //ctrl_pts 3
	 leftTop_curve.setKnots(3, new Point3d(-pw-bt, lh, 0));
	 leftLower_curve.setKnots(3, new Point3d(-pw-bt, 0, 0));
	 rightTop_curve.setKnots(3, new Point3d(pw-cw, rh, 0));
	 rightLower_curve.setKnots(3, new Point3d(pw-cw, 0, 0));

	 //ctrl_pts 2
	 leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x + disC2C3,
					       leftTop_curve.ctrl_points[3].y, 
					       leftTop_curve.ctrl_points[3].z));
	 leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x + disC2C3,
						 leftLower_curve.ctrl_points[3].y, 
						 leftLower_curve.ctrl_points[3].z));
	 rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3,
						rightTop_curve.ctrl_points[3].y, 
						rightTop_curve.ctrl_points[3].z));
	 rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3,
						  rightLower_curve.ctrl_points[3].y, 
						  rightLower_curve.ctrl_points[3].z));
	 
	 Matrix4d m1=	 
	     Matrix4d.rotAroundZ(pr)
	     //   Matrix4d.shift( bt-mid,0,0 )
	     //  	     .then(Matrix4d.rotAroundZ(pr))
	     .then(Matrix4d.shift( cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z));
	 
	 Matrix4d m2=
	     Matrix4d.rotAroundZ( -qr)
	     .then(Matrix4d.shift( cover_skeleton2[0].x, cover_skeleton2[0].y, cover_skeleton2[0].z));


	 for(i=0; i<2; i++){
	     m1.transform(leftTop_curve.ctrl_points[i]);
	     m1.transform(leftLower_curve.ctrl_points[i]);
	     m1.transform(rightTop_curve.ctrl_points[i]);
	     m1.transform(rightLower_curve.ctrl_points[i]);
	 }
	 
	 for(i=2; i<4; i++){
	     m2.transform(rightTop_curve.ctrl_points[i]);
	     m2.transform(rightLower_curve.ctrl_points[i]);
	 }

	 double unit_len= config.get_elementLength();
	 leftTop_curve.setAll(unit_len, LEFT);
	 leftLower_curve.setAll(unit_len, LEFT);
	 rightTop_curve.setAll(unit_len, RIGHT);
	 rightLower_curve.setAll(unit_len, RIGHT);
	 
	 leftTop_curve.evaluate();
	 leftLower_curve.evaluate2();
	 
	 if(coverState == OPEN){
	     rightTop_curve.evaluate();
	     rightLower_curve.evaluate2();
	 }
	 }*/

    void phase3bookconstruction3type1(double lh, double rh, 
				      double rotAround_CK2,
				      double midLeft,
				      double midRight )
    {
	int i;
	double cw, bt, pw, qr, pr, sr, a, b;
	
	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	
	//update ck2 ck3
	 cover_skeleton2[2].set(-bt, 0, 0);
	 cover_skeleton2[3].set(-bt-cw, 0, 0);
	 frontTurning2= 180.0;
	 
	 pr= Utilities.degree2rad(rotAround_CK2);
	 qr= sineRules(cw, bt, pr);
	 sr= Utilities.degree2rad(90-rotAround_CK2);
	 double rotCK2_r= Utilities.degree2rad(rotAround_CK2);
	 
	 if(coverState == CLOSE){
	     backTurning2= 180;
	 }

	 if(coverState == OPEN){
	     backTurning2= -Utilities.rad2degree(qr);
	 }

	 spineTurning2= rotAround_CK2;

	 a= bt * Math.cos(pr);
	 b= cw * Math.cos(qr);
	 //update ck0 ck1
	 if(coverState==OPEN ){
	     cover_skeleton2[0].set(a+b - bt, 0 ,0); 
	 }

	 if(coverState==CLOSE ){
	     cover_skeleton2[0].set( -bt-cw, bt, 0);
	 }

	 Matrix4d.rotAroundZ(pr)
	     .then(Matrix4d.shift(-bt,0,0))
	     .transform(new Point3d(bt,0,0), cover_skeleton2[1]);
	 
	 double disC2C3= pw/3; 
	 double disX, disY, len;
	 
	 
	 //ctrl_pts 0
	 leftTop_curve.setKnots(0, new Point3d(midLeft, 0, 0));
	 leftLower_curve.setKnots(0, new Point3d(0, 0, 0));
	 rightTop_curve.setKnots(0, new Point3d(midRight, 0, 0));
	 rightLower_curve.setKnots(0, new Point3d(bt, 0, 0));

	 //ctrl_pts 1
	 leftTop_curve.setKnots(1, new Point3d(midLeft, bt, 0));

	 len= phase3distanceC0C1(rotAround_CK2+90);
	 disX= len * Math.cos(sr);
	 disY= len * Math.sin(sr);
	 leftLower_curve.setKnots(1, new Point3d(0, disY, 0));

	 //len= phase3distanceC0C1type2(rotAround_CK2+90);
	//System.out.println("\ttype 2 len= " + len );
	 disX= bt * Math.cos(sr);
	 disY= bt * Math.sin(sr);
	 rightTop_curve.setKnots(1, new Point3d(midRight+disX, disY, 0));

	 len= phase3distanceC0C1(rotAround_CK2+90);
	 disX= len * Math.cos(sr);
	 disY= len * Math.sin(sr);
	 rightLower_curve.setKnots(1, new Point3d(bt+disX, disY, 0));
	 
	 
	 //ctrl_pts 3
	 leftTop_curve.setKnots(3, new Point3d(-pw-bt, lh, 0));
	 leftLower_curve.setKnots(3, new Point3d(-pw-bt, 0, 0));
	 rightTop_curve.setKnots(3, new Point3d(pw-cw, rh, 0));
	 rightLower_curve.setKnots(3, new Point3d(pw-cw, 0, 0));

	 //ctrl_pts 2
	 leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x + disC2C3,
					       leftTop_curve.ctrl_points[3].y, 
					       leftTop_curve.ctrl_points[3].z));
	 leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x + disC2C3,
						 leftLower_curve.ctrl_points[3].y, 
						 leftLower_curve.ctrl_points[3].z));
	 rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3,
						rightTop_curve.ctrl_points[3].y, 
						rightTop_curve.ctrl_points[3].z));
	 rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3,
						  rightLower_curve.ctrl_points[3].y, 
						  rightLower_curve.ctrl_points[3].z));
	 
	 Matrix4d m1=	 
	     Matrix4d.rotAroundZ(pr)
	     //   Matrix4d.shift( bt-mid,0,0 )
	     //  	     .then(Matrix4d.rotAroundZ(pr))
	     .then(Matrix4d.shift( cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z));
	 
	 Matrix4d m2=
	     Matrix4d.rotAroundZ( -qr)
	     .then(Matrix4d.shift( cover_skeleton2[0].x, cover_skeleton2[0].y, cover_skeleton2[0].z));


	 for(i=0; i<2; i++){
	     m1.transform(leftTop_curve.ctrl_points[i]);
	     m1.transform(leftLower_curve.ctrl_points[i]);
	     m1.transform(rightTop_curve.ctrl_points[i]);
	     m1.transform(rightLower_curve.ctrl_points[i]);
	 }
	 
	 for(i=2; i<4; i++){
	     m2.transform(rightTop_curve.ctrl_points[i]);
	     m2.transform(rightLower_curve.ctrl_points[i]);
	 }

	 double unit_len= config.get_elementLength();
	 leftTop_curve.setAll(unit_len, LEFT);
	 leftLower_curve.setAll(unit_len, LEFT);
	 rightTop_curve.setAll(unit_len, RIGHT);
	 rightLower_curve.setAll(unit_len, RIGHT);
	 
	 leftTop_curve.evaluate();
	 leftLower_curve.evaluate2();
	 
	 if(coverState == OPEN){
	     rightTop_curve.evaluate();
	     rightLower_curve.evaluate2();
	 }
    }


    /*
    void phase3bookconstruction3type2(double lh, double rh, 
				      double rotAround_CK2,
				      double midLeft,
				      double midRight )
    {
	int i;
	double cw, bt, pw, qr, pr, sr, a, b;
	
	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	
	//update ck2 ck3
	cover_skeleton2[2].set(-bt, 0, 0);
	cover_skeleton2[3].set(-bt-cw, 0, 0);
	frontTurning2= 180.0;
	 
	 pr= Utilities.degree2rad(rotAround_CK2);
	 qr= sineRules(cw, bt, pr);
	 sr= Utilities.degree2rad(90-rotAround_CK2);
	 double rotCK2_r= Utilities.degree2rad(rotAround_CK2);
	 
	 backTurning2= -Utilities.rad2degree(qr);
	 spineTurning2= rotAround_CK2;

	 a= bt * Math.cos(pr);
	 b= cw * Math.cos(qr);

	 //update ck0 ck1
	 cover_skeleton2[0].set(a+b - bt, 0 ,0); 
	 Matrix4d.rotAroundZ(pr)
	     .then(Matrix4d.shift(-bt,0,0))
	     .transform(new Point3d(bt,0,0), cover_skeleton2[1]);
	 
	 double disC2C3= pw/3; 
	 double disX, disY, len;
	 
	 
	 //ctrl_pts 0
	 leftTop_curve.setKnots(0, new Point3d(midLeft, 0, 0));
	 leftLower_curve.setKnots(0, new Point3d(0, 0, 0));
	 rightTop_curve.setKnots(0, new Point3d(midRight, 0, 0));
	 rightLower_curve.setKnots(0, new Point3d(bt, 0, 0));

	 //ctrl_pts 1
	 leftTop_curve.setKnots(1, new Point3d(midLeft, bt, 0));

	 len= phase3distanceC0C1(rotAround_CK2+90);
	 disX= len * Math.cos(sr);
	 disY= len * Math.sin(sr);
	 leftLower_curve.setKnots(1, new Point3d(0, disY, 0));

	 len= phase3distanceC0C1type2(rotAround_CK2+90);
	 disX= len * Math.cos(sr);
	 disY= len * Math.sin(sr);
	 rightTop_curve.setKnots(1, new Point3d(midRight+disX, disY, 0));

	 len= phase3distanceC0C1(rotAround_CK2+90);
	 disX= len * Math.cos(sr);
	 disY= len * Math.sin(sr);
	 rightLower_curve.setKnots(1, new Point3d(bt+disX, disY, 0));
	 
	 
	 //ctrl_pts 3
	 leftTop_curve.setKnots(3, new Point3d(-pw-bt, lh, 0));
	 leftLower_curve.setKnots(3, new Point3d(-pw-bt, 0, 0));
	 rightTop_curve.setKnots(3, new Point3d(pw-cw, rh, 0));
	 rightLower_curve.setKnots(3, new Point3d(pw-cw, 0, 0));

	 //ctrl_pts 2
	 leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x + disC2C3,
					       leftTop_curve.ctrl_points[3].y, 
					       leftTop_curve.ctrl_points[3].z));
	 leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x + disC2C3,
						 leftLower_curve.ctrl_points[3].y, 
						 leftLower_curve.ctrl_points[3].z));
	 rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3,
						rightTop_curve.ctrl_points[3].y, 
						rightTop_curve.ctrl_points[3].z));
	 rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3,
						  rightLower_curve.ctrl_points[3].y, 
						  rightLower_curve.ctrl_points[3].z));
	 
	 Matrix4d m1=	 
	     Matrix4d.rotAroundZ(pr)
	     //   Matrix4d.shift( bt-mid,0,0 )
	     //  	     .then(Matrix4d.rotAroundZ(pr))
	     .then(Matrix4d.shift( cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z));
	 
	 Matrix4d m2=
	     Matrix4d.rotAroundZ( -qr)
	     .then(Matrix4d.shift( cover_skeleton2[0].x, cover_skeleton2[0].y, cover_skeleton2[0].z));

	 
	 for(i=0; i<2; i++){
	     m1.transform(leftTop_curve.ctrl_points[i]);
	     m1.transform(leftLower_curve.ctrl_points[i]);
	     m1.transform(rightTop_curve.ctrl_points[i]);
	     m1.transform(rightLower_curve.ctrl_points[i]);
	 }
	 
	 for(i=2; i<4; i++){
	     m2.transform(rightTop_curve.ctrl_points[i]);
	     m2.transform(rightLower_curve.ctrl_points[i]);
	 }

	 double unit_len= config.get_elementLength();
	 leftTop_curve.setAll(unit_len, LEFT);
	 leftLower_curve.setAll(unit_len, LEFT);
	 rightTop_curve.setAll(unit_len, RIGHT);
	 rightLower_curve.setAll(unit_len, RIGHT);
	 
	 leftTop_curve.evaluate2();
	 leftLower_curve.evaluate2();
	 rightTop_curve.evaluate2();
	 rightLower_curve.evaluate2();
	 }*/

    void phase3bookconstruction3type2(double lh, double rh, 
				      double rotAround_CK2,
				      double midLeft,
				      double midRight, 
				      double right_length,
				      double left_length)
    {
	int i;
	double cw, bt, pw, qr, pr, sr, a, b;
	
	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	
	//update ck2 ck3
	cover_skeleton2[2].set(-bt, 0, 0);
	cover_skeleton2[3].set(-bt-cw, 0, 0);
	frontTurning2= 180.0;
	 
	 pr= Utilities.degree2rad(rotAround_CK2);
	 qr= sineRules(cw, bt, pr);
	 sr= Utilities.degree2rad(90-rotAround_CK2);
	 double rotCK2_r= Utilities.degree2rad(rotAround_CK2);
	 
	 backTurning2= -Utilities.rad2degree(qr);
	 spineTurning2= rotAround_CK2;

	 a= bt * Math.cos(pr);
	 b= cw * Math.cos(qr);

	 //update ck0 ck1
	 cover_skeleton2[0].set(a+b - bt, 0 ,0); 
	 Matrix4d.rotAroundZ(pr)
	     .then(Matrix4d.shift(-bt,0,0))
	     .transform(new Point3d(bt,0,0), cover_skeleton2[1]);
	 
	 double disC2C3= pw/3; 
	 double disX, disY, len;
	 
	 
	 //ctrl_pts 0
	 leftTop_curve.setKnots(0, new Point3d(midLeft, 0, 0));
	 leftLower_curve.setKnots(0, new Point3d(0, 0, 0));
	 rightTop_curve.setKnots(0, new Point3d(midRight, 0, 0));
	 rightLower_curve.setKnots(0, new Point3d(bt, 0, 0));

	 //ctrl_pts 1
	 disY= left_length * Math.sin(sr);
	 leftTop_curve.setKnots(1, new Point3d(midLeft,disY,0));
	 //leftTop_curve.setKnots(1, new Point3d(midLeft, bt, 0));

	 len= phase3distanceC0C1(rotAround_CK2+90);
	 disX= len * Math.cos(sr);
	 disY= len * Math.sin(sr);
	 leftLower_curve.setKnots(1, new Point3d(0, disY, 0));

	 //len= phase3distanceC0C1type2(rotAround_CK2+90);
	 disX= right_length * Math.cos(sr);
	 disY= right_length * Math.sin(sr);
	 rightTop_curve.setKnots(1, new Point3d(midRight+disX, disY, 0));

	 len= phase3distanceC0C1(rotAround_CK2+90);
	 disX= len * Math.cos(sr);
	 disY= len * Math.sin(sr);
	 rightLower_curve.setKnots(1, new Point3d(bt+disX, disY, 0));
	 
	 
	 //ctrl_pts 3
	 leftTop_curve.setKnots(3, new Point3d(-pw-bt, lh, 0));
	 leftLower_curve.setKnots(3, new Point3d(-pw-bt, 0, 0));
	 rightTop_curve.setKnots(3, new Point3d(pw-cw, rh, 0));
	 rightLower_curve.setKnots(3, new Point3d(pw-cw, 0, 0));

	 //ctrl_pts 2
	 leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x + disC2C3,
					       leftTop_curve.ctrl_points[3].y, 
					       leftTop_curve.ctrl_points[3].z));
	 leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x + disC2C3,
						 leftLower_curve.ctrl_points[3].y, 
						 leftLower_curve.ctrl_points[3].z));
	 rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3,
						rightTop_curve.ctrl_points[3].y, 
						rightTop_curve.ctrl_points[3].z));
	 rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3,
						  rightLower_curve.ctrl_points[3].y, 
						  rightLower_curve.ctrl_points[3].z));
	 
	 Matrix4d m1=	 
	     Matrix4d.rotAroundZ(pr)
	     //   Matrix4d.shift( bt-mid,0,0 )
	     //  	     .then(Matrix4d.rotAroundZ(pr))
	     .then(Matrix4d.shift( cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z));
	 
	 Matrix4d m2=
	     Matrix4d.rotAroundZ( -qr)
	     .then(Matrix4d.shift( cover_skeleton2[0].x, cover_skeleton2[0].y, cover_skeleton2[0].z));

	 
	 for(i=0; i<2; i++){
	     m1.transform(leftTop_curve.ctrl_points[i]);
	     m1.transform(leftLower_curve.ctrl_points[i]);
	     m1.transform(rightTop_curve.ctrl_points[i]);
	     m1.transform(rightLower_curve.ctrl_points[i]);
	 }
	 
	 for(i=2; i<4; i++){
	     m2.transform(rightTop_curve.ctrl_points[i]);
	     m2.transform(rightLower_curve.ctrl_points[i]);
	 }

	 double unit_len= config.get_elementLength();
	 leftTop_curve.setAll(unit_len, LEFT);
	 leftLower_curve.setAll(unit_len, LEFT);
	 rightTop_curve.setAll(unit_len, RIGHT);
	 rightLower_curve.setAll(unit_len, RIGHT);
	 
	 leftTop_curve.evaluate2();
	 leftLower_curve.evaluate2();
	 rightTop_curve.evaluate2();
	 rightLower_curve.evaluate2();
    }



    
    void phase3bookconstruction3type3(double lh, double rh, double rotAround_CK2, double coverTurning, double c0c1TurningAngle,
				      double mid, 
				      double len ) // used for lower curves
    {
	double cw, bt, pr, qr, cr, a, b, pw, c0clr;
	int i;

	cw= config.getCoverWidth();
	pw= config.getPaperWidth(); 
	bt= config.getBookThickness();
	pr= Utilities.degree2rad(rotAround_CK2);
	cr= Utilities.degree2rad(coverTurning);
	qr= sineRules(cw, bt, pr);
	c0clr= Utilities.degree2rad(c0c1TurningAngle);

	if(scene.selected_name == config.FRONT_COVER || 
	   scene.selected_name == config.RIGHT_EDGE || 
	   scene.selected_name == config.TURN_LEFT ){ //temporary
	    backTurning2= -Utilities.rad2degree(qr);
	}

	if(scene.selected_name == config.BACK_COVER || 
	   scene.selected_name == config.LEFT_EDGE || 
	   scene.selected_name == config.TURN_RIGHT){
	    frontTurning2= 180;
	}

	spineTurning2= rotAround_CK2;
	
	//update cover_skeleton2s
	a= bt * Math.cos(pr);
	b= cw * Math.cos(qr);
	cover_skeleton2[0].set(a+b - bt, 0 ,0); 
	Matrix4d.rotAroundZ(pr)
	    .then(Matrix4d.shift(-bt,0,0))
	    .transform(new Point3d(bt,0,0), cover_skeleton2[1]);
	cover_skeleton2[2].set(-bt, 0, 0);
	cover_skeleton2[3].set(-bt-cw, 0, 0);
	
	Matrix4d m1=	 
	    Matrix4d.rotAroundZ(pr)
	    .then(Matrix4d.shift( cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z));
	
	Matrix4d m2; // used to transform ctrl points of right hand curve
	if(scene.selected_name == config.FRONT_COVER || scene.selected_name == config.RIGHT_EDGE || 
	   scene.selected_name == config.TURN_LEFT){ //FRONT_COVER
	    m2= Matrix4d.rotAroundZ(-qr)
		.then(Matrix4d.shift( cover_skeleton2[0].x, cover_skeleton2[0].y, cover_skeleton2[0].z));
	}else{                            //BACK_COVER || LEFT_EDGE
	    m2= Matrix4d.rotAroundZ(cr)
		.then( Matrix4d.shift(cover_skeleton2[1].x, cover_skeleton2[1].y, cover_skeleton2[1].z ));
	}
	
	
	Matrix4d m3 = Matrix4d.rotAroundZ(cr)
	    .then( Matrix4d.shift(cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z ));
	
	
	leftTop_curve.setKnots(0, new Point3d(mid, 0, 0));
	rightTop_curve.setKnots(0, new Point3d(mid, 0, 0));
	leftLower_curve.setKnots(0, new Point3d(0, 0, 0));
	rightLower_curve.setKnots(0, new Point3d(bt, 0, 0));

	leftTop_curve.setKnots(1, new Point3d(mid, bt, 0));

	double disX, disY;
	disX= bt * Math.cos(c0clr);
	disY= bt * Math.sin(c0clr);
	rightTop_curve.setKnots(1, new Point3d(mid+disX, disY, 0));

	disX= len * Math.cos(c0clr);
	disY= len * Math.sin(c0clr);
	rightLower_curve.setKnots(1, new Point3d(bt+disX, disY, 0));
	leftLower_curve.setKnots(1, new Point3d(0, disY, 0));
	
	double disC2C3= pw/3;
	if(scene.selected_name == config.FRONT_COVER || scene.selected_name == config.RIGHT_EDGE || 
	   scene.selected_name == config.TURN_LEFT ){ //FRONT_COVER
	    leftTop_curve.setKnots(3, new Point3d(pw, -lh, 0));
	    leftLower_curve.setKnots(3, new Point3d(pw, 0, 0));
	    rightTop_curve.setKnots(3, new Point3d(pw-cw, rh, 0));
	    rightLower_curve.setKnots(3, new Point3d(pw-cw, 0, 0));

	    leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x - disC2C3, 
						  leftTop_curve.ctrl_points[3].y,
						  leftTop_curve.ctrl_points[3].z)); // ctrl pts 2
	    rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3,
						   rightTop_curve.ctrl_points[3].y, 
						   rightTop_curve.ctrl_points[3].z));
	    leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x - disC2C3,
						    leftLower_curve.ctrl_points[3].y, 
						    leftLower_curve.ctrl_points[3].z));
	    rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3,
						     rightLower_curve.ctrl_points[3].y, 
						     rightLower_curve.ctrl_points[3].z));
	}else{ //back_COVER
	    leftTop_curve.setKnots(3, new Point3d(-pw-bt, lh, 0));
	    leftLower_curve.setKnots(3, new Point3d(-pw-bt, 0, 0));
	    rightTop_curve.setKnots(3, new Point3d(pw, rh, 0));
	    rightLower_curve.setKnots(3, new Point3d(pw, 0, 0));
	    
	    leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x + disC2C3,
						  leftTop_curve.ctrl_points[3].y, 
						  leftTop_curve.ctrl_points[3].z));
	    leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x + disC2C3,
						    leftLower_curve.ctrl_points[3].y, 
						    leftLower_curve.ctrl_points[3].z));
	    rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3,
						   rightTop_curve.ctrl_points[3].y, 
						   rightTop_curve.ctrl_points[3].z));
	    rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3,
						     rightLower_curve.ctrl_points[3].y, 
						     rightLower_curve.ctrl_points[3].z));
	}
	
  	
	for(i=0; i<4; i++){ 
	    if(i < 2){
		m1.transform(leftTop_curve.ctrl_points[i]);
		m1.transform(rightTop_curve.ctrl_points[i]);
		m1.transform(leftLower_curve.ctrl_points[i]);
		m1.transform(rightLower_curve.ctrl_points[i]);
	    }else{
		if(scene.selected_name == config.FRONT_COVER || scene.selected_name == config.RIGHT_EDGE || 
		   scene.selected_name == config.TURN_LEFT ){ //FRONT_COVER
		    m3.transform(leftTop_curve.ctrl_points[i]);
		    m3.transform(leftLower_curve.ctrl_points[i]);
		    m2.transform(rightTop_curve.ctrl_points[i]);
		    m2.transform(rightLower_curve.ctrl_points[i]);
		}else{
		    m2.transform(rightTop_curve.ctrl_points[i]);
		    m2.transform(rightLower_curve.ctrl_points[i]);
		}
	    }
	}
	
	double unit_len= config.get_elementLength();
	leftTop_curve.setAll(unit_len, LEFT);
	rightTop_curve.setAll(unit_len, RIGHT);
	leftLower_curve.setAll(unit_len, LEFT);
	rightLower_curve.setAll(unit_len, RIGHT);

	leftTop_curve.evaluate2();
	rightTop_curve.evaluate2();
	leftLower_curve.evaluate2();
	rightLower_curve.evaluate2();
	
    }
    
    
    void phase3bookconstruction3type4(double lh, double rh, double rotAround_CK2, double backcoverTurning,
				      double mid,
				      double len)
    {
	double cw, bt, pr, qr, a, b, pw, br, c0clr;
	int i;

	cw= config.getCoverWidth();
	pw= config.getPaperWidth(); 
	bt= config.getBookThickness();
	pr= Utilities.degree2rad(rotAround_CK2);
	br= Utilities.degree2rad(backcoverTurning);
	qr= sineRules(cw, bt, pr);
	//c0clr= Utilities.degree2rad(c0c1TurningAngle);

	//update cover_skeleton2s
	//a= bt * Math.cos(pr);
	//b= cw * Math.cos(qr);
	//cover_skeleton2[0].set(a+b - bt, 0 ,0); 
	
	Matrix4d.rotAroundZ(pr)
	    .then(Matrix4d.shift(-bt,0,0))
	    .transform(new Point3d(bt,0,0), cover_skeleton2[1]);
	cover_skeleton2[2].set(-bt, 0, 0);
	cover_skeleton2[3].set(-bt-cw, 0, 0);

	if(scene.selected_name == config.FRONT_COVER){ //temporary
	    backTurning2= -Utilities.rad2degree(qr);
	}

	if(scene.selected_name == config.BACK_COVER){
	    frontTurning2= 180;
	}

	spineTurning2= rotAround_CK2;

	Matrix4d m1=	 
	     Matrix4d.rotAroundZ(pr)
	    .then(Matrix4d.shift( cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z));

	Matrix4d m2= Matrix4d.rotAroundZ(br)
	    .then( Matrix4d.shift(cover_skeleton2[1].x, cover_skeleton2[1].y, cover_skeleton2[1].z ));

	leftTop_curve.setKnots(0, new Point3d(mid, 0, 0));
	rightTop_curve.setKnots(0, new Point3d(mid, 0, 0));
	leftLower_curve.setKnots(0, new Point3d(0, 0, 0));
	rightLower_curve.setKnots(0, new Point3d(bt, 0, 0));

	leftTop_curve.setKnots(1, new Point3d(mid, bt, 0));
	rightTop_curve.setKnots(1, new Point3d(mid, bt, 0));
	leftLower_curve.setKnots(1, new Point3d(0, len, 0));
	rightLower_curve.setKnots(1, new Point3d(bt, len, 0));

	leftTop_curve.setKnots(3, new Point3d(-pw-bt, lh, 0));
	leftLower_curve.setKnots(3, new Point3d(-pw-bt, 0, 0));
	rightTop_curve.setKnots(3, new Point3d(pw, rh, 0));
	rightLower_curve.setKnots(3, new Point3d(pw, 0, 0));
	
	double disC2C3= pw/3;    
	leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x + disC2C3,
					      leftTop_curve.ctrl_points[3].y, 
					      leftTop_curve.ctrl_points[3].z));
	leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x + disC2C3,
						leftLower_curve.ctrl_points[3].y, 
						leftLower_curve.ctrl_points[3].z));
	rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3,
					       rightTop_curve.ctrl_points[3].y, 
					       rightTop_curve.ctrl_points[3].z));
	rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3,
						 rightLower_curve.ctrl_points[3].y, 
						 rightLower_curve.ctrl_points[3].z));
	

	for(i=0; i<4; i++){ 
	    if(i < 2){
		m1.transform(leftTop_curve.ctrl_points[i]);
		m1.transform(rightTop_curve.ctrl_points[i]);
		m1.transform(leftLower_curve.ctrl_points[i]);
		m1.transform(rightLower_curve.ctrl_points[i]);
	    }else{
		m2.transform(rightTop_curve.ctrl_points[i]);
		m2.transform(rightLower_curve.ctrl_points[i]);
	    }
	}

	double unit_len= config.get_elementLength();
	leftTop_curve.setAll(unit_len, LEFT);
	rightTop_curve.setAll(unit_len, RIGHT);
	leftLower_curve.setAll(unit_len, LEFT);
	rightLower_curve.setAll(unit_len, RIGHT);

	leftTop_curve.evaluate2();
	rightTop_curve.evaluate2();
	leftLower_curve.evaluate2();
	rightLower_curve.evaluate2();
    }

    /*
      Used for flipping over
    */
    void phase3bookconstruction3type5(double lh, double rh, double spineTurningAngle,
				      double mid)
    {
	double pr, cr, bt, pw, rotAround_CK2;
	int i;

	rotAround_CK2= spineTurningAngle-90;

	pr= Utilities.degree2rad(rotAround_CK2);
	pw= config.getPaperWidth(); 
	bt= config.getBookThickness();
	cr= Utilities.degree2rad(spineTurningAngle);
	
	if(scene.selected_name == config.BACK_COVER){
	    frontTurning2= spineTurningAngle;// from 90 to 180
	}
	
	if(scene.selected_name == config.FRONT_COVER){
	    backTurning2= spineTurningAngle;// from 90 to 180
	}

	spineTurning2= rotAround_CK2;

	//transform cover_skeleton2[0] has not yet implemented
	Matrix4d.rotAroundZ(pr)
	    .then(Matrix4d.shift(-bt,0,0))
	    .transform(new Point3d(bt,0,0), cover_skeleton2[1]);
	cover_skeleton2[2].set(-bt, 0, 0);// pivot point
	//transform cover_skeleton2[3] has not yet implemented

	Matrix4d m1=	 
	    Matrix4d.rotAroundZ(pr)
	    .then(Matrix4d.shift( cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z));
	
	Matrix4d m2; 
	
	double disC2C3= pw/3;
	double unit_len= config.get_elementLength();

	if(scene.selected_name == config.BACK_COVER){
	    m2= Matrix4d.rotAroundZ(cr)
		.then( Matrix4d.shift(cover_skeleton2[1].x, cover_skeleton2[1].y, cover_skeleton2[1].z ));
	    rightTop_curve.setKnots(0, new Point3d(mid, 0, 0));
	    rightLower_curve.setKnots(0, new Point3d(bt, 0, 0));
	    rightTop_curve.setKnots(1, new Point3d(mid, bt, 0));
	    rightLower_curve.setKnots(1, new Point3d(bt, 0, 0));
	    
	    rightTop_curve.setKnots(3, new Point3d(pw, rh, 0));
	    rightLower_curve.setKnots(3, new Point3d(pw, 0, 0));
	    
	    rightTop_curve.setKnots(2, new Point3d(rightTop_curve.ctrl_points[3].x - disC2C3,
						   rightTop_curve.ctrl_points[3].y, 
						   rightTop_curve.ctrl_points[3].z));
	    rightLower_curve.setKnots(2, new Point3d(rightLower_curve.ctrl_points[3].x - disC2C3,
						     rightLower_curve.ctrl_points[3].y, 
						     rightLower_curve.ctrl_points[3].z));
	    for(i=0; i<4; i++){ 
		if(i < 2){
		    m1.transform(rightTop_curve.ctrl_points[i]);
		    m1.transform(rightLower_curve.ctrl_points[i]);
		}else{
		    m2.transform(rightTop_curve.ctrl_points[i]);
		    m2.transform(rightLower_curve.ctrl_points[i]);
		}
	    }

	    rightTop_curve.setAll(unit_len, RIGHT);
	    rightLower_curve.setAll(unit_len, RIGHT);
	    rightTop_curve.evaluate2();
	    rightLower_curve.evaluate2();
	}else{
	    m2= Matrix4d.rotAroundZ(cr)
		.then( Matrix4d.shift(cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z ));
	    //scene.selected_name == config.FRONT_COVER
	    leftTop_curve.setKnots(0, new Point3d(mid, 0, 0));
	    leftLower_curve.setKnots(0, new Point3d(0, 0, 0));
	    leftTop_curve.setKnots(1, new Point3d(mid, bt, 0));
	    leftLower_curve.setKnots(1, new Point3d(0, bt, 0));
	    
	    leftTop_curve.setKnots(3, new Point3d(pw, -lh, 0));
	    leftLower_curve.setKnots(3, new Point3d(pw, 0, 0));
	    
	    leftTop_curve.setKnots(2, new Point3d(leftTop_curve.ctrl_points[3].x + disC2C3,
						  leftTop_curve.ctrl_points[3].y, 
						  leftTop_curve.ctrl_points[3].z));
	    leftLower_curve.setKnots(2, new Point3d(leftLower_curve.ctrl_points[3].x + disC2C3,
						    leftLower_curve.ctrl_points[3].y, 
						    leftLower_curve.ctrl_points[3].z));

	    for(i=0; i<4; i++){ 
		if(i < 2){
		    m1.transform(leftTop_curve.ctrl_points[i]);
		    m1.transform(leftLower_curve.ctrl_points[i]);
		}else{
		    m2.transform(leftTop_curve.ctrl_points[i]);
		    m2.transform(leftLower_curve.ctrl_points[i]);
		}
	    }
	    
	    leftTop_curve.setAll(unit_len, LEFT);
	    leftLower_curve.setAll(unit_len, LEFT);
	    
	    leftTop_curve.evaluate2();
	    leftLower_curve.evaluate2();
	}

    }
  
    /*
    void phase3bookconstruction2(double lh, double rh, double rotAround_CK2,
				 double mid,
				 double k)
    {
	int i;
	double cw, bt, pw, qr, pr, sr, a, b;
	
	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	
	//update ck2 ck3
	 cover_skeleton2[2].set(-bt, 0, 0);
	 cover_skeleton2[3].set(-bt-cw, 0, 0);
	 frontTurning2= 180.0;
	 
	 pr= Utilities.degree2rad(rotAround_CK2);
	 qr= sineRules(cw, bt, pr);
	 sr= Utilities.degree2rad(90-rotAround_CK2);
	 
	 backTurning2= -Utilities.rad2degree(qr);
	 spineTurning2= rotAround_CK2;

	 a= bt * Math.cos(pr);
	 b= cw * Math.cos(qr);
	 
	 double disX, disY, len; 

	 //update ck0 ck1
	 cover_skeleton2[0].set(a+b - bt, 0 ,0); 
	 Matrix4d.rotAroundZ(pr)
	     .then(Matrix4d.shift(-bt,0,0))
	     .transform(new Point3d(bt,0,0), cover_skeleton2[1]);
	 double disC2C3= pw/3;

	 if(selected_side == RIGHT){
	     interior_curveDOWN.setKnots( 0, new Point3d(mid+k, 0, 0));
	     
	     len= phase3distanceC0C1type2(rotAround_CK2+90);
	     disX= len * Math.cos(sr);
	     disY= len * Math.sin(sr);
	     interior_curveDOWN.setKnots( 1, new Point3d(mid+k+disX, disY, 0));
	     interior_curveDOWN.setKnots( 3, new Point3d(pw-cw, rh-k, 0));
	     interior_curveDOWN.setKnots( 2, new Point3d(interior_curveDOWN.ctrl_points[3].x - disC2C3, 
							 interior_curveDOWN.ctrl_points[3].y, 
							 interior_curveDOWN.ctrl_points[3].z ));
	 }else{
	     interior_curveDOWN.setKnots( 0, new Point3d(mid-k, 0, 0));
	     interior_curveDOWN.setKnots( 1, new Point3d(mid-k, bt, 0));
	     interior_curveDOWN.setKnots( 3, new Point3d(-pw-bt, lh-k, 0));
	     interior_curveDOWN.setKnots( 2, new Point3d(interior_curveDOWN.ctrl_points[3].x + disC2C3, 
							 interior_curveDOWN.ctrl_points[3].y, 
							 interior_curveDOWN.ctrl_points[3].z ));
	 }
	 
	 Matrix4d m1=	 
	     Matrix4d.rotAroundZ(pr)
	     //   Matrix4d.shift( bt-mid,0,0 )
	     //  	     .then(Matrix4d.rotAroundZ(pr))
	     .then(Matrix4d.shift( cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z));
	 
	 Matrix4d m2=
	     Matrix4d.rotAroundZ( -qr)
	     .then(Matrix4d.shift( cover_skeleton2[0].x, cover_skeleton2[0].y, cover_skeleton2[0].z));
	 
	 for(i=0; i<4; i++){
	     if(i < 2){
		 m1.transform(interior_curveDOWN.ctrl_points[i]);
	     }else{
		 if(selected_side == RIGHT){
		     m2.transform(interior_curveDOWN.ctrl_points[i]);
		 }
	     }
	 }

	 double unit_len= config.get_elementLength();
	 if(selected_side == RIGHT){
	     interior_curveUP.setAll(unit_len, RIGHT); // associate with genVectors
	     interior_curveDOWN.setAll(unit_len, RIGHT);
	     interior_curveUP.evaluate3(rightTop_curve.points(1), 1); // copy from 'rightTop_curve'
	 }else{
	     interior_curveUP.setAll(unit_len, LEFT); // associate with genVectors
	     interior_curveDOWN.setAll(unit_len, LEFT);
	     interior_curveUP.evaluate3(leftTop_curve.points(1), 1); // copy from 'rightTop_curve'
	 }

	 interior_curveDOWN.evaluate();
	
	 }*/


    void phase3bookconstruction2(double lh, double rh, double rotAround_CK2,
				 double mid,
				 double k)
    {
	int i;
	double cw, bt, pw, qr, pr, sr, a, b;
	
	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	
	//update ck2 ck3
	 cover_skeleton2[2].set(-bt, 0, 0);
	 cover_skeleton2[3].set(-bt-cw, 0, 0);
	 frontTurning2= 180.0;
	 
	 pr= Utilities.degree2rad(rotAround_CK2);
	 qr= sineRules(cw, bt, pr);
	 sr= Utilities.degree2rad(90-rotAround_CK2);
	 
	 backTurning2= -Utilities.rad2degree(qr);
	 spineTurning2= rotAround_CK2;

	 a= bt * Math.cos(pr);
	 b= cw * Math.cos(qr);
	 
	 double disX, disY, len; 

	 //update ck0 ck1
	 cover_skeleton2[0].set(a+b - bt, 0 ,0); 
	 Matrix4d.rotAroundZ(pr)
	     .then(Matrix4d.shift(-bt,0,0))
	     .transform(new Point3d(bt,0,0), cover_skeleton2[1]);
	 double disC2C3= pw/3;

	 if(selected_side == RIGHT){
	     interior_curveDOWN.setKnots( 0, new Point3d(mid+k, 0, 0));
	     
	     //len= phase3distanceC0C1type2(rotAround_CK2+90);
	     disX= final_length * Math.cos(sr);
	     disY= final_length * Math.sin(sr);
	     interior_curveDOWN.setKnots( 1, new Point3d(mid+k+disX, disY, 0));
	     interior_curveDOWN.setKnots( 3, new Point3d(pw-cw, rh-k, 0));
	     interior_curveDOWN.setKnots( 2, new Point3d(interior_curveDOWN.ctrl_points[3].x - disC2C3, 
							 interior_curveDOWN.ctrl_points[3].y, 
							 interior_curveDOWN.ctrl_points[3].z ));
	 }else{
	     interior_curveDOWN.setKnots( 0, new Point3d(mid-k, 0, 0));

	     //disY= final_length * Math.sin(sr);
	     //if(final_turning_angle > 90)
	     // interior_curveDOWN.setKnots( 1, new Point3d(mid-k, bt,0));
	     //else
	     disY= final_length * Math.sin(sr);
	     interior_curveDOWN.setKnots( 1, new Point3d(mid-k, disY,0));
	     //interior_curveDOWN.setKnots( 1, new Point3d(mid-k, bt, 0));

	     interior_curveDOWN.setKnots( 3, new Point3d(-pw-bt, lh-k, 0));
	     interior_curveDOWN.setKnots( 2, new Point3d(interior_curveDOWN.ctrl_points[3].x + disC2C3, 
							 interior_curveDOWN.ctrl_points[3].y, 
							 interior_curveDOWN.ctrl_points[3].z ));
	 }
	 
	 Matrix4d m1=	 
	     Matrix4d.rotAroundZ(pr)
	     //   Matrix4d.shift( bt-mid,0,0 )
	     //  	     .then(Matrix4d.rotAroundZ(pr))
	     .then(Matrix4d.shift( cover_skeleton2[2].x, cover_skeleton2[2].y, cover_skeleton2[2].z));
	 
	 Matrix4d m2=
	     Matrix4d.rotAroundZ( -qr)
	     .then(Matrix4d.shift( cover_skeleton2[0].x, cover_skeleton2[0].y, cover_skeleton2[0].z));
	 
	 for(i=0; i<4; i++){
	     if(i < 2){
		 m1.transform(interior_curveDOWN.ctrl_points[i]);
	     }else{
		 if(selected_side == RIGHT){
		     m2.transform(interior_curveDOWN.ctrl_points[i]);
		 }
	     }
	 }

	 double unit_len= config.get_elementLength();
	 if(selected_side == RIGHT){
	     interior_curveUP.setAll(unit_len, RIGHT); // associate with genVectors
	     interior_curveDOWN.setAll(unit_len, RIGHT);
	     interior_curveUP.evaluate3(rightTop_curve.points(1), 1); // copy from 'rightTop_curve'
	 }else{
	     interior_curveUP.setAll(unit_len, LEFT); // associate with genVectors
	     interior_curveDOWN.setAll(unit_len, LEFT);
	     interior_curveUP.evaluate3(leftTop_curve.points(1), 1); // copy from 'rightTop_curve'
	 }

	 interior_curveDOWN.evaluate();
	
    }




    /*void phase3bookconstruction4(double h1, double h2, double rotAround_CK2,
				 double midLeft,
				 double midRight)
    {
	int i;
	double cw, bt, pw, qr, pr, sr, a, b;
	
	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	
	//update ck2 ck3
	 cover_skeleton3[2].set(-bt, 0, 0);
	 cover_skeleton3[3].set(-bt-cw, 0, 0);
	 frontTurning3= 180.0;
	 
	 pr= Utilities.degree2rad(rotAround_CK2);
	 qr= sineRules(cw, bt, pr);
	 sr= Utilities.degree2rad(90-rotAround_CK2);
	 
	 backTurning3= -Utilities.rad2degree(qr);
	 spineTurning3= rotAround_CK2;

	 a= bt * Math.cos(pr);
	 b= cw * Math.cos(qr);

	 //update ck0 ck1
	 cover_skeleton3[0].set(a+b - bt, 0 ,0); 
	 Matrix4d.rotAroundZ(pr)
	     .then(Matrix4d.shift(-bt,0,0))
	     .transform(new Point3d(bt,0,0), cover_skeleton3[1]);

	 double disC2C3= pw/3; 
	 double disX, disY, len;

	 if(selected_side == RIGHT){
	    
	     // ctrl pts 0
	     interior_curveDOWN_finish.setKnots(0, new Point3d(midRight, 0 ,0)); 
	     interior_curveUP_finish.setKnots(0, new Point3d(midLeft, 0 ,0)); 

	     // ctrl pts 1
	     interior_curveDOWN_finish.setKnots(1, new Point3d(midRight, bt, 0));
	     interior_curveUP_finish.setKnots(1, new Point3d(midLeft,bt,0));

	     // ctrl pts 3
	     interior_curveDOWN_finish.setKnots(3, new Point3d(-pw-bt, h2, 0));
	     interior_curveUP_finish.setKnots(3, new Point3d(-pw-bt, h1, 0));
	     
	     // ctrl pts 2
	     interior_curveDOWN_finish.setKnots(2, new Point3d(interior_curveDOWN_finish.ctrl_points[3].x + disC2C3,
							       interior_curveDOWN_finish.ctrl_points[3].y, 
							       interior_curveDOWN_finish.ctrl_points[3].z));
	     interior_curveUP_finish.setKnots(2, new Point3d(interior_curveUP_finish.ctrl_points[3].x + disC2C3,
							     interior_curveUP_finish.ctrl_points[3].y, 
							     interior_curveUP_finish.ctrl_points[3].z));

	 }else{
	     // ctrl pts 0
	     interior_curveDOWN_finish.setKnots(0, new Point3d(midLeft, 0 ,0)); 
	     interior_curveUP_finish.setKnots(0, new Point3d(midRight, 0, 0)); 
	     
	     // ctrl pts 1
	     disX= bt * Math.cos(sr);
	     disY= bt * Math.sin(sr);
	     interior_curveDOWN_finish.setKnots(1, new Point3d(midLeft+disX, disY, 0));

	     len= phase3distanceC0C1type2(rotAround_CK2+90);
	     disX= len * Math.cos(sr);
	     disY= len * Math.sin(sr);
	     interior_curveUP_finish.setKnots(1, new Point3d(midRight+disX, disY, 0)); 

	     // ctrl pts 3
	     interior_curveDOWN_finish.setKnots(3, new Point3d(pw-cw, h1, 0));
	     interior_curveUP_finish.setKnots(3, new Point3d(pw-cw, h2, 0)); 
	     
	     // ctrl pts 2
	     interior_curveDOWN_finish.setKnots(2, new Point3d(interior_curveDOWN_finish.ctrl_points[3].x - disC2C3,
							       interior_curveDOWN_finish.ctrl_points[3].y, 
							       interior_curveDOWN_finish.ctrl_points[3].z));
	     interior_curveUP_finish.setKnots(2, new Point3d(interior_curveUP_finish.ctrl_points[3].x - disC2C3,
							     interior_curveUP_finish.ctrl_points[3].y, 
							     interior_curveUP_finish.ctrl_points[3].z)); 
	     
	 }

	 Matrix4d m1=	 
	     Matrix4d.rotAroundZ(pr)
	     //   Matrix4d.shift( bt-mid,0,0 )
	     //  	     .then(Matrix4d.rotAroundZ(pr))
	     .then(Matrix4d.shift( cover_skeleton3[2].x, cover_skeleton3[2].y, cover_skeleton3[2].z));
	 
	 Matrix4d m2=
	     Matrix4d.rotAroundZ( -qr)
	     .then(Matrix4d.shift( cover_skeleton3[0].x, cover_skeleton3[0].y, cover_skeleton3[0].z));
	 
	 for(i=0; i<4; i++){
	     if(i < 2){
		 m1.transform(interior_curveDOWN_finish.ctrl_points[i]);
		 m1.transform(interior_curveUP_finish.ctrl_points[i]);
	     }else{
		 if(selected_side == LEFT){
		     m2.transform(interior_curveDOWN_finish.ctrl_points[i]);
		     m2.transform(interior_curveUP_finish.ctrl_points[i]);
		 }
	     }
	 }

	 double unit_len= config.get_elementLength();
	 if(selected_side == RIGHT){
	     interior_curveUP_finish.setAll(unit_len, LEFT);
	     interior_curveDOWN_finish.setAll(unit_len, LEFT);
	 }else{
	     interior_curveUP_finish.setAll(unit_len, RIGHT);
	     interior_curveDOWN_finish.setAll(unit_len, RIGHT);
	}

	 interior_curveUP_finish.evaluate();
	 interior_curveDOWN_finish.evaluate();
	 
	
	 }*/
    void phase3bookconstruction4(double h1, double h2, double rotAround_CK2,
				 double midLeft,
				 double midRight)
    {
	int i;
	double cw, bt, pw, qr, pr, sr, a, b;
	
	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	pw= config.getPaperWidth(); 
	
	//update ck2 ck3
	 cover_skeleton3[2].set(-bt, 0, 0);
	 cover_skeleton3[3].set(-bt-cw, 0, 0);
	 frontTurning3= 180.0;
	 
	 pr= Utilities.degree2rad(rotAround_CK2);
	 qr= sineRules(cw, bt, pr);
	 sr= Utilities.degree2rad(90-rotAround_CK2);
	 
	 backTurning3= -Utilities.rad2degree(qr);
	 spineTurning3= rotAround_CK2;

	 a= bt * Math.cos(pr);
	 b= cw * Math.cos(qr);

	 //update ck0 ck1
	 cover_skeleton3[0].set(a+b - bt, 0 ,0); 
	 Matrix4d.rotAroundZ(pr)
	     .then(Matrix4d.shift(-bt,0,0))
	     .transform(new Point3d(bt,0,0), cover_skeleton3[1]);

	 double disC2C3= pw/3; 
	 double disX, disY, len;

	 if(selected_side == RIGHT){

	     // ctrl pts 0
	     interior_curveDOWN_finish.setKnots(0, new Point3d(midRight, 0 ,0)); 
	     interior_curveUP_finish.setKnots(0, new Point3d(midLeft, 0 ,0)); 

	     // ctrl pts 1
	     interior_curveDOWN_finish.setKnots(1, new Point3d(midRight, bt, 0));

	     //disX= bt * Math.cos(sr);
	     disY= final_length * Math.sin(sr);
	     interior_curveUP_finish.setKnots(1, new Point3d(midLeft,disY,0));

	     // ctrl pts 3
	     interior_curveDOWN_finish.setKnots(3, new Point3d(-pw-bt, h2, 0));
	     interior_curveUP_finish.setKnots(3, new Point3d(-pw-bt, h1, 0));
	     
	     // ctrl pts 2
	     interior_curveDOWN_finish.setKnots(2, new Point3d(interior_curveDOWN_finish.ctrl_points[3].x + disC2C3,
							       interior_curveDOWN_finish.ctrl_points[3].y, 
							       interior_curveDOWN_finish.ctrl_points[3].z));
	     interior_curveUP_finish.setKnots(2, new Point3d(interior_curveUP_finish.ctrl_points[3].x + disC2C3,
							     interior_curveUP_finish.ctrl_points[3].y, 
							     interior_curveUP_finish.ctrl_points[3].z));

	 }else{
	     // ctrl pts 0
	     interior_curveDOWN_finish.setKnots(0, new Point3d(midLeft, 0 ,0)); 
	     interior_curveUP_finish.setKnots(0, new Point3d(midRight, 0, 0)); 
	     
	     // ctrl pts 1
	     disX= bt * Math.cos(sr);
	     disY= bt * Math.sin(sr);
	     interior_curveDOWN_finish.setKnots(1, new Point3d(midLeft+disX, disY, 0));

	     //len= phase3distanceC0C1type2(rotAround_CK2+90);
	     disX= final_length * Math.cos(sr);
	     disY= final_length * Math.sin(sr);
	     interior_curveUP_finish.setKnots(1, new Point3d(midRight+disX, disY, 0)); 

	     // ctrl pts 3
	     interior_curveDOWN_finish.setKnots(3, new Point3d(pw-cw, h1, 0));
	     interior_curveUP_finish.setKnots(3, new Point3d(pw-cw, h2, 0)); 
	     
	     // ctrl pts 2
	     interior_curveDOWN_finish.setKnots(2, new Point3d(interior_curveDOWN_finish.ctrl_points[3].x - disC2C3,
							       interior_curveDOWN_finish.ctrl_points[3].y, 
							       interior_curveDOWN_finish.ctrl_points[3].z));
	     interior_curveUP_finish.setKnots(2, new Point3d(interior_curveUP_finish.ctrl_points[3].x - disC2C3,
							     interior_curveUP_finish.ctrl_points[3].y, 
							     interior_curveUP_finish.ctrl_points[3].z)); 
	     
	 }

	 Matrix4d m1=	 
	     Matrix4d.rotAroundZ(pr)
	     //   Matrix4d.shift( bt-mid,0,0 )
	     //  	     .then(Matrix4d.rotAroundZ(pr))
	     .then(Matrix4d.shift( cover_skeleton3[2].x, cover_skeleton3[2].y, cover_skeleton3[2].z));
	 
	 Matrix4d m2=
	     Matrix4d.rotAroundZ( -qr)
	     .then(Matrix4d.shift( cover_skeleton3[0].x, cover_skeleton3[0].y, cover_skeleton3[0].z));
	 
	 for(i=0; i<4; i++){
	     if(i < 2){
		 m1.transform(interior_curveDOWN_finish.ctrl_points[i]);
		 m1.transform(interior_curveUP_finish.ctrl_points[i]);
	     }else{
		 if(selected_side == LEFT){
		     m2.transform(interior_curveDOWN_finish.ctrl_points[i]);
		     m2.transform(interior_curveUP_finish.ctrl_points[i]);
		 }
	     }
	 }

	 double unit_len= config.get_elementLength();
	 if(selected_side == RIGHT){
	     interior_curveUP_finish.setAll(unit_len, LEFT);
	     interior_curveDOWN_finish.setAll(unit_len, LEFT);
	 }else{
	     interior_curveUP_finish.setAll(unit_len, RIGHT);
	     interior_curveDOWN_finish.setAll(unit_len, RIGHT);
	}

	 interior_curveUP_finish.evaluate();
	 interior_curveDOWN_finish.evaluate();
	 
	
    }
    

    
    void phase4bookconstruction()
    {
	double cw, bt;
	cw= config.getCoverWidth();
	bt= config.getBookThickness();
	
	cover_skeleton2[0].set( -bt-cw, bt, 0);
	cover_skeleton2[1].set(-bt, bt, 0);
	cover_skeleton2[2].set(-bt, 0, 0);
	cover_skeleton2[3].set(-bt-cw, 0, 0);
	
	backTurning2= 180;
	frontTurning2= 180.0;
	spineTurning2= 90;
	
    }

    // number of face
    // 
    void renderCube( GLCanvas canvas, double [] vArrays, byte [] long_indices, 
		     int faces,
		     byte [] command,
		     Vector3d [] normals)
    {
	GLFunc gl = canvas.gl;
	
	int i, j;
	int vertex_length= 4;
	int color_length= 3;
	byte [] indices= new byte[vertex_length];
	float [] color= new float[color_length];
	boolean ef= false, et= false;
	double [][] texpts= { {0,0},
			      {1,0},
			      {1,1},
			      {0,1} };
	
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glEnableClientState(GL_VERTEX_ARRAY); 
	gl.glVertexPointer (3, GL_DOUBLE, 0, vArrays);

	gl.glEnable(GL_CULL_FACE);
	gl.glCullFace(GL_BACK); // culled here means discarded
	
	
	//selection
	for(i= 0; i<faces; i++){
	    switch(command[i]){
	    case LINE:{ 
		if(Ttp.commentslevel >= 3){
		    System.out.println("line");
		}
		ef= false; et=false;
		break;}
	    case FILL:{
		if(Ttp.commentslevel >= 3){
		    System.out.println("fill" );
		}
		ef= true; et=false;
		break;}
	    case TEXTURE:{ 
		if(Ttp.commentslevel >= 3){
		    System.out.println("texture" );
		}
		ef= true; et=true;
		break;}
	    }
	    
	    
	    if(ef)
		gl.glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	    else
		gl.glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);

	    //normal
	    //color //testing
	    System.arraycopy(cover_color, i*3 , color, 0, color_length);
	    gl.glColor3fv(color);
	  
	    //texture
	    if(et){
		gl.glEnable(GL_TEXTURE_2D);
		gl.glBindTexture(GL_TEXTURE_2D, fixedTexName[0]);
	    }
	    else 
		gl.glDisable(GL_TEXTURE_2D);

	    //vertex
	    System.arraycopy(long_indices, i*4 , indices, 0, vertex_length); 

	    gl.glBegin (GL_QUADS);
	    gl.glNormal3dv(normals[i].get3dv());
	    for (j = 0; j < 4; j++){
		gl.glTexCoord2dv(texpts[j]); 
		gl.glArrayElement(indices[j]);
	    }
	    gl.glEnd();
	    
	  
	    //gl.glDrawElements(GL_QUADS, 4, GL_UNSIGNED_BYTE, indices);
	}
	
	//reset attribute
	gl.glDisableClientState(GL_VERTEX_ARRAY); 
	//gl.glDisable(GL_TEXTURE_2D);
	gl.glPopAttrib();
    }

    
    //trail  
    void renderCube2( GLCanvas canvas, double [] vArrays, byte [] long_indices, 
		      int faces,
		      byte [] command,
		      Vector3d [] normals,
		      int [] textureName,
		      double [][][] texCoord,
		      int material)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor.java: renderCube2()" );
	}

	GLFunc gl = canvas.gl;
	
	int i, j;
	int vertex_length= 4;
	int color_length= 3;
	byte [] indices= new byte[vertex_length];
	float [] color= new float[color_length];
	boolean ef= false, et= false;
	
	gl.glEnableClientState(GL_VERTEX_ARRAY); 
	gl.glVertexPointer (3, GL_DOUBLE, 0, vArrays);

	//gl.glEnable(GL_CULL_FACE);
	//gl.glCullFace(GL_BACK); // culled here means discarded
	
	
	//selection
	for(i= 0; i<faces; i++){
	    switch(command[i]){
	    case LINE:{ 
		if(Ttp.commentslevel >= 3){
		    System.out.println("line");
		}
		ef= false; et=false;
		break;}
	    case FILL:{
		if(Ttp.commentslevel >= 3){
		    System.out.println("fill" );
		}
		ef= true; et=false;
		break;}
	    case TEXTURE:{ 
		if(Ttp.commentslevel >= 3){
		    System.out.println("texture" );
		}
		ef= true; et=true;
		break;}
	    }
	    
	    gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	    if(ef)
		gl.glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	    else
		gl.glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);

	    //normal
	    //color //testing
	    System.arraycopy(cover_color, i*3 , color, 0, color_length);
	    gl.glColor3fv(color);
	    
	    //texture
	    if(et){
		//gl.glEnable(GL_TEXTURE_2D);
		//gl.glBindTexture(GL_TEXTURE_2D, textureName[i]);
		
		gl.glActiveTextureARB(GL_TEXTURE0_ARB);
		gl.glEnable(GL_TEXTURE_2D);
		gl.glBindTexture(GL_TEXTURE_2D, textureName[i]);
		
		if(i==0){ //material texture 
		    ;
		    //gl.glActiveTextureARB(GL_TEXTURE1_ARB);
		    //gl.glEnable(GL_TEXTURE_2D);
		    //gl.glBindTexture(GL_TEXTURE_2D, material);
		}
		
	    }
	   

	    //vertex
	    System.arraycopy(long_indices, i*4 , indices, 0, vertex_length); 

	    gl.glBegin (GL_QUADS);
	    gl.glNormal3dv(normals[i].get3dv());
	    for (j = 0; j < 4; j++){
		gl.glMultiTexCoord2dvARB(GL_TEXTURE0_ARB, texCoord[i][j]);
		//if(i==0) gl.glMultiTexCoord2dvARB(GL_TEXTURE1_ARB, texCoord[i][j]);
		gl.glArrayElement(indices[j]);
	    }
	    gl.glEnd();
	    gl.glPopAttrib();
	    //gl.glDrawElements(GL_QUADS, 4, GL_UNSIGNED_BYTE, indices);
	}	
	//reset attribute
	gl.glDisableClientState(GL_VERTEX_ARRAY); 
		
    }

    
   
    /* Draw cover edge: cylinder+two disks*/
    void displayLedge(GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor.java: displayLedge");
	}

	GLFunc gl= canvas.gl;
	GLUFunc glu= canvas.glu;
	
	long qobj = glu.gluNewQuadric();
	double radius= config.getCoverThickness()/2;
	double height= config.get_zMax() + config.getCoverMargin();
	
	//gl.glCallList(cylinder);
	//cylinder
	glu.gluQuadricDrawStyle(qobj, glu.GLU_SMOOTH); /* flat shaded */
	glu.gluQuadricNormals(qobj, glu.GLU_SMOOTH);
	glu.gluCylinder(qobj, radius, radius, height, 6, 3);
	
	
	//top
	//gl.glCallList(disk);
	glu.gluQuadricDrawStyle(qobj, glu.GLU_FLAT); /* all polygons wireframe */
	glu.gluQuadricNormals(qobj, glu.GLU_FLAT);
	glu.gluDisk(qobj, 0, radius, 6, 4);

	//bottom
	gl.glPushMatrix();
	double zdis= config.get_zMax() + config.getCoverMargin();
	gl.glTranslated(0,0,zdis);
	glu.gluQuadricDrawStyle(qobj, glu.GLU_FLAT); /* all polygons wireframe */
	glu.gluQuadricNormals(qobj, glu.GLU_FLAT);
	glu.gluDisk(qobj, 0, radius, 6, 4);
	gl.glPopMatrix();

    }

    /*testing jumping*/
    void displayCoverline(GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("displayCoverline()" );
	}
	GLFunc gl= canvas.gl;
	if(Ttp.commentslevel >= 3){
	    System.out.println("\tfrontTurning2= "+ frontTurning2);
	    System.out.println("\tspineTurning2= "+ spineTurning2);
	    System.out.println("\tbackTurning2= "+ backTurning2);
	}
	
	// front_line
	gl.glPushMatrix();
	gl.glTranslated(cover_skeleton2[2].x ,cover_skeleton2[2].y, cover_skeleton2[2].z);
	gl.glRotated(frontTurning2, 0,0,1);
	
	//display front line
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glLineWidth(front_line_width);
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, front_line_color);	
	gl.glBegin(GL_LINES);
	gl.glVertex3dv(front_line[0].get3dv()); 
	gl.glVertex3dv(front_line[1].get3dv()); 
	gl.glEnd();
	gl.glPopAttrib();

	gl.glPopMatrix();

	//spine_line
	gl.glPushMatrix();
	if(spineTurning2 <= 0){
	    gl.glTranslated(cover_skeleton2[1].x ,cover_skeleton2[1].y, cover_skeleton2[1].z);
	}else{
	    gl.glTranslated(cover_skeleton2[2].x ,cover_skeleton2[2].y, cover_skeleton2[2].z);
	}
	gl.glRotated(spineTurning2, 0,0,1);
	//display spine line
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glLineWidth(back_line_width);
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, back_line_color);	
	gl.glBegin(GL_LINES);
	if(spineTurning2 <= 0){
	    gl.glVertex3dv(spine_line1[0].get3dv()); 
	    gl.glVertex3dv(spine_line1[1].get3dv()); 
	}else{
	    gl.glVertex3dv(spine_line2[0].get3dv()); 
	    gl.glVertex3dv(spine_line2[1].get3dv()); 
	}
	gl.glEnd();
	gl.glPopAttrib();
	gl.glPopMatrix();
	
	//back_line
	gl.glPushMatrix();
	gl.glTranslated(cover_skeleton2[1].x ,cover_skeleton2[1].y, cover_skeleton2[1].z);
	gl.glRotated(backTurning2, 0,0,1);
	
	//display back line
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glLineWidth(back_line_width);
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, back_line_color);	
	gl.glBegin(GL_LINES);
	gl.glVertex3dv(back_line[0].get3dv()); 
	gl.glVertex3dv(back_line[1].get3dv()); 
	gl.glEnd();
	gl.glPopAttrib(); 
	gl.glPopMatrix();
	
    }

    
    
    
    void displayCover(GLCanvas canvas, int drawing_mode)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor.java: displayCover()" );
	}
	
	GLFunc gl = canvas.gl;
	
	if(Ttp.commentslevel >= 3){
	    System.out.println("frontTurning= "+ frontTurning);
	    System.out.println("spineTurning= "+ spineTurning);
	    System.out.println("backTurning= "+ backTurning);
	}

	//draw the front cover
	double cw= config.getCoverWidth();
	double radius= config.getCoverThickness()/2;
	double cm= config.getCoverMargin();
	
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS) ;
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, config.getCoverColor());
        gl.glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, config.getCoverSpecularColor());
        gl.glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, config.getCoverShiness());
	
	
	gl.glPushMatrix();
	gl.glTranslated(cover_skeleton2[2].x ,cover_skeleton2[2].y, cover_skeleton2[2].z);
	gl.glRotated(frontTurning2, 0,0,1);
	if (drawing_mode == GL_SELECT) gl.glLoadName(config.FRONT_COVER);
	//front cover
	double [][][] cover_texCoord= null;
	
	switch(config.imageformat){
	case PNG: cover_texCoord= front_cover_texCoord[0]; break;
	case JPEG: cover_texCoord= front_cover_texCoord[1]; break;
	case TGA: 
	    cover_texCoord= front_cover_texCoord[2]; break;
	}


	renderCube2(canvas, front_cover_pos_VA, front_cover_indices, 6, 
		    front_cover_command[0],
		    front_cover_normals,
		    front_cover_texName,
		    cover_texCoord,
		    fixedTexName[COVER_MATERIAL] );
	
	//display cover edge
	gl.glPushMatrix();
	gl.glTranslated(cw,radius, -cm);
	displayLedge(canvas); 
	gl.glPopMatrix();

	gl.glPopMatrix();
	
	gl.glPopAttrib(); 
	
	
	
	float white[] = {1.f, 1.f, 1.f, 1.f}; 
	//draw front cover and inside front cover frame 
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS) ;
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, white);
        gl.glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, white);
        gl.glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, config.getCoverShiness());

	gl.glPushMatrix();
	gl.glTranslated(cover_skeleton2[2].x ,cover_skeleton2[2].y, cover_skeleton2[2].z);
	gl.glRotated(frontTurning2, 0,0,1);

	gl.glActiveTextureARB(GL_TEXTURE0_ARB);
	gl.glEnable(GL_TEXTURE_2D);
	gl.glBindTexture(GL_TEXTURE_2D, fixedTexName[BOOK_FRONT_COVER]);
	
	gl.glBegin(GL_QUADS);
	gl.glNormal3d(0,1,0);
	
	gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 0,0);
	gl.glVertex3dv(front_cover_image_frame[0].get3dv());
	gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 1,0);
	gl.glVertex3dv(front_cover_image_frame[1].get3dv());
	gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 1,1);
	gl.glVertex3dv(front_cover_image_frame[2].get3dv());
	gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 0,1);
	gl.glVertex3dv(front_cover_image_frame[3].get3dv());
	gl.glEnd();

	gl.glActiveTextureARB(GL_TEXTURE0_ARB);	
	gl.glEnable(GL_TEXTURE_2D);
	gl.glBindTexture(GL_TEXTURE_2D, fixedTexName[INSIDE_BOOK_FRONT_COVER]);
	
	gl.glBegin(GL_QUADS);
	gl.glNormal3d(0,1,0);
	gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 1,0);
	gl.glVertex3dv(inside_front_cover_image_frame[0].get3dv());
	gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 0,0);
	gl.glVertex3dv(inside_front_cover_image_frame[1].get3dv());
	gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 0,1);
	gl.glVertex3dv(inside_front_cover_image_frame[2].get3dv());
	gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 1,1);
	gl.glVertex3dv(inside_front_cover_image_frame[3].get3dv());
	
	gl.glEnd();
	gl.glPopMatrix();
	gl.glPopAttrib(); 
	
	
	//draw the back cover
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, config.getCoverColor());
        gl.glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, config.getCoverSpecularColor());
        gl.glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, config.getCoverShiness());

	gl.glPushMatrix();
	gl.glTranslated(cover_skeleton2[1].x ,cover_skeleton2[1].y, cover_skeleton2[1].z);
	gl.glRotated(backTurning2, 0,0,1);
	if (drawing_mode == GL_SELECT) gl.glLoadName(config.BACK_COVER);
	renderCube2(canvas, back_cover_pos_VA, back_cover_indices, 6, 
		    back_cover_command[0],
		    back_cover_normals,
		    back_cover_texName,
		    cover_texCoord,
		    fixedTexName[COVER_MATERIAL] );

	//display cover edge
	gl.glPushMatrix();
	gl.glTranslated(cw,-radius, -cm);
	displayLedge(canvas);
	gl.glPopMatrix();
	
	gl.glPopMatrix();
	
	gl.glPopAttrib(); 

	
	    //draw back cover and inside back cover frame 
	    gl.glPushAttrib(GL_ALL_ATTRIB_BITS) ;
	    gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, white);
	    gl.glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, white);
	    gl.glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, config.getCoverShiness());
	    
	    gl.glPushMatrix();
	    gl.glTranslated(cover_skeleton2[1].x ,cover_skeleton2[1].y, cover_skeleton2[1].z);
	    gl.glRotated(backTurning2, 0,0,1);
	
	    

	    gl.glActiveTextureARB(GL_TEXTURE0_ARB);
	    gl.glEnable(GL_TEXTURE_2D);
	    if(config.parameters.getfileType() == DJVU){
	    gl.glBindTexture(GL_TEXTURE_2D, fixedTexName[BOOK_BACK_COVER]);
	    
	    gl.glBegin(GL_QUADS);
	    gl.glNormal3d(0,1,0);
	    
	    gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 1,0);
	    gl.glVertex3dv(back_cover_image_frame[0].get3dv());
	    gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 0,0);
	    gl.glVertex3dv(back_cover_image_frame[1].get3dv());
	    gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 0,1);
	    gl.glVertex3dv(back_cover_image_frame[2].get3dv());
	    gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 1,1);
	    gl.glVertex3dv(back_cover_image_frame[3].get3dv());
	    gl.glEnd();
	    }
	    
	    gl.glBindTexture(GL_TEXTURE_2D, fixedTexName[INSIDE_BOOK_BACK_COVER]);
	    
	    gl.glBegin(GL_QUADS);
	    gl.glNormal3d(0,1,0);
	    gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 0,0);
	    gl.glVertex3dv(inside_back_cover_image_frame[0].get3dv());
	    gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 1,0);
	    gl.glVertex3dv(inside_back_cover_image_frame[1].get3dv());
	    gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 1,1);
	    gl.glVertex3dv(inside_back_cover_image_frame[2].get3dv());
	    gl.glMultiTexCoord2dARB(GL_TEXTURE0_ARB, 0,1);
	    gl.glVertex3dv(inside_back_cover_image_frame[3].get3dv());
	    gl.glEnd();
	    
	    gl.glPopMatrix();
	    gl.glPopAttrib(); 
	

	
	//draw spine
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, config.getCoverColor());
        gl.glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, config.getCoverSpecularColor());
        gl.glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, config.getCoverShiness());
	
	gl.glPushMatrix();
	if (drawing_mode == GL_SELECT) gl.glLoadName(NONE);

	if(spineTurning2 <= 0){// phase2
	    gl.glTranslated(cover_skeleton2[1].x ,cover_skeleton2[1].y, cover_skeleton2[1].z);
	    gl.glRotated(spineTurning2, 0,0,1);
	    spine1.construct_face_two(spineTurning2);
	    spine1.construct_face_five(spineTurning2);
	    spine1.display(drawing_mode, canvas);
	}else{//phase 3
	    gl.glTranslated(cover_skeleton2[2].x ,cover_skeleton2[2].y, cover_skeleton2[2].z);
	    gl.glRotated(spineTurning2, 0,0,1);
	    spine2.construct_face_two(spineTurning2);
	    spine2.construct_face_five(spineTurning2);
	    spine2.display(drawing_mode, canvas);
	}
	gl.glPopMatrix();
	
	gl.glPopAttrib(); 

     }
    
    
    /*
      left/right static pages disappear mainly because page_num out of bound
    */
    void  displayStaticPages(GLCanvas canvas, int drawing_mode)
    {
	int i, pageName, texName;
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor.java: displayStaticPages()");
	}
	
	
	//traverse through 
	for(i= 0; i < 2; i++){
	    
	    pageName= sp[i].getPage_num();
	    
	    if( pageName >= config.firstPage  && 
		pageName <= config.lastPage){ //page_num is within the limit
		
		//check for update static page
		
		if( texturePools.pageAlreadyinitialized(pageName ) ){
		    //existed
		    if(Ttp.commentslevel >= 3){
			System.out.println("BookConstructor.java: displayStaticPages(): page# " + 
					   pageName + " existed in the cache");
		    }
		    
		    texName= texturePools.getTexName(pageName);
		    
		    if(texName > 0){
			//match
			if(Ttp.commentslevel >= 3){
			    System.out.println("BookConstructor.java: displayStaticPages(): current page has already put into GLContext");
			}
			sp[i].setPage_num(texName, pageName);

		    }else{
			//does not match
			if(Ttp.commentslevel >= 3){
			    System.out.println("BookConstructor.java: displayStaticPages(): current page has not yet in the GLContext");
			}
			
			int newTexName= transform2(texturePools.getImageBytes(pageName), pageName);
			sp[i].setPage_num(newTexName, pageName);
		    }
		}else{
		    //not existed
		    if(Ttp.commentslevel >= 3){
			System.out.println("BookConstructor.java: displayStaticPages(): page# " + pageName + " does not exist in the cache");
		    }
		}				
		
		sp[i].display(drawing_mode, canvas);
	    }
	    
	}

    }

    void  displayDynamicPages(GLCanvas canvas, int drawing_mode)
    {
	if(dp != null){
	    dp.display(canvas, drawing_mode);
	}
	
    }
    

    public void  displayStaticPages_edges(GLCanvas canvas)
    {
	int i, page_num;

	//traverse through 
	for(i= 0; i < 2; i++){
	    page_num= sp[i].getPage_num(); 
	    if( page_num >= config.firstPage &&  // ??
		page_num <= config.lastPage){ //page_num is within the limit
		sp[i].displayEdge(canvas, TEXTURE, new Color3f(1.0f, 1.0f, 1.0f));	

	    }
	}
    }

    public void display_rightEdge(GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("\tredraw Right edg");
	}
	sp[0].displayEdgeSkeleton(canvas);
    }

    
    public void display_leftEdge(GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("\tredraw Left edg");
	}
	sp[1].displayEdgeSkeleton(canvas);
    }
    
    void drawStrip(GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor.java: drawStrip()" );
	}
	
	float [] red= {1.0f, 0.0f, 0.0f, 1.0f};
	GLFunc gl = canvas.gl;

      
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS); 
	gl.glMaterialfv(canvas.GL_FRONT_AND_BACK, canvas.GL_AMBIENT_AND_DIFFUSE, red);
	gl.glLineWidth(3f);
	gl.glEnable(GL_LINE_STIPPLE);
	
	gl.glLineStipple(factor, pattern);
	
	//top
	gl.glBegin (GL_LINE_STRIP);
	gl.glVertex3dv(strip[0].get3dv());
	gl.glVertex3dv(strip[1].get3dv());
	gl.glEnd();

	//bottom
	gl.glPushMatrix();
	double zdis= config.getPaperHeight()+.05;
	gl.glTranslated(0,0,zdis);
	gl.glBegin (GL_LINE_STRIP);
	gl.glVertex3dv(strip[0].get3dv());
	gl.glVertex3dv(strip[1].get3dv());
	gl.glEnd();
	gl.glPopMatrix();

	gl.glPopAttrib();

    }


    /*
     * @param drawing_mode: picking & selection 
     */
    /*public void display(GLCanvas canvas, int drawing_mode)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor.java: display()");
	}
	
	GLFunc gl = canvas.gl;
	displayCover(canvas, drawing_mode);
	//drawStrip(canvas);

		
	//gl.glPushMatrix();
	//lift up by n unit, why?
	//gl.glTranslated(0,0.1,0);

	Color3f white= new Color3f(1.0f, 1.0f, 1.0f);
	Color3f yellow= new Color3f(1.0f, 1.0f, 0.0f);
	Color3f cyan= new Color3f(0.0f, 1.0f, 1.0f);
	Color3f red= new Color3f(1.0f, 0.0f, 0.0f);
	//  leftTop_d.displayCurve(canvas, 1, yellow ); // debug
	//  	    leftTop_d.displayPts(canvas, 1, red);//debug
	//  	    rightTop_d.displayCurve(canvas, 1, yellow); //debug
	//  	    rightTop_d.displayPts(canvas, 1, red);//debug
	//  	    leftbottom_d.displayCurve(canvas, 1, white ); // debug
	//  	    rightbottom_d.displayCurve(canvas, 1, white); //debug
	
	//static page
	//displayStaticPages(canvas, drawing_mode);
	
	//display cache
	//texturePools.displayCache();
	
	//testing jumping
	double z= config.getPaperHeight();
	gl.glPushMatrix();
	gl.glTranslated(0,0,z);
	
	//if(spineTurning2 <= 0){// phase2
	//displayCoverline(canvas);
	float [] lc ={1.0f, 1.0f, .0f}; 
	//leftTop_curve.displayCurve(canvas, 1, lc);
	//leftLower_curve.displayCurve(canvas, 1, lc);
	    
	float [] rc ={.5f, 1.0f, .0f}; 
	//rightTop_curve.displayCurve(canvas, 1, rc);
	//rightLower_curve.displayCurve(canvas, 1, rc);
	
	float [] ic ={.0f, .0f, .6f}; 
	//interior_curveUP.displayCurve(canvas, 1, ic);
	//interior_curveDOWN.displayCurve(canvas, 1, ic);
	//interior_curveUP_finish.displayCurve(canvas, 1, ic);
	//interior_curveDOWN_finish.displayCurve(canvas, 1, ic);
	
	//    }else{
	//  		displayCoverline(canvas);
	
	//  		float [] lc ={1.0f, 1.0f, .0f}; 
	//  		leftTop_curve.displayCurve(canvas, 1, lc);
	//  		leftLower_curve.displayCurve(canvas, 1, lc);
	
	//  		float [] rc ={.5f, 1.0f, .0f}; 
	//  		rightTop_curve.displayCurve(canvas, 1, rc);
	//  		rightLower_curve.displayCurve(canvas, 1, rc);
	
	//  		float [] ic ={.0f, .0f, .6f}; 
	//     		interior_curveUP.displayCurve(canvas, 1, ic);
	//     		interior_curveDOWN.displayCurve(canvas, 1, ic);
	//     		interior_curveUP_finish.displayCurve(canvas, 1, ic);
	//     		interior_curveDOWN_finish.displayCurve(canvas, 1, ic);
	//  	    }
	gl.glPopMatrix();
	
	//dynamic page
	if(scene.selection_mode == SELECTED){
	    if(scene.selected_name== config.LEFT_EDGE || scene.selected_name == config.RIGHT_EDGE){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Displaying bundle" );
		}
		if(coverState == OPEN){
		    bundle.display2(drawing_mode, canvas);
		}
	    }else if(scene.selected_name == config.FRONT_COVER){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Displaying moving front cover" );
		}
		
	    }else if(scene.selected_name == config.BACK_COVER){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Displaying moving back cover" );
		}
	    }
	    else if(scene.selected_name == config.FORWARD_BUTTON ||
		    scene.selected_name == config.BACKWARD_BUTTON ){
		if(Ttp.commentslevel >= 3){
		    if(scene.selected_name == config.FORWARD_BUTTON){
			System.out.println("BookConstructor.java: FORWARD_BUTTON selected" );
		    }else{
			System.out.println("BookConstructor.java: BACKWARD_BUTTON selected" );
		    }
		}
		
		if(coverState == OPEN){
		    bundle.display2(drawing_mode, canvas);
		}
		
	    }
	    
	    else if(isPages(scene.selected_name)){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Displaying dynamic page" );
		}
		displayDynamicPages(canvas, drawing_mode);
	    }
	}
    }
    */
    public void display(GLCanvas canvas, int drawing_mode)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor.java: display()");
	}
	
	GLFunc gl = canvas.gl;
	displayCover(canvas, drawing_mode);
	drawStrip(canvas);

		
	//gl.glPushMatrix();
	//lift up by n unit, why?
	//gl.glTranslated(0,0.1,0);

	Color3f white= new Color3f(1.0f, 1.0f, 1.0f);
	Color3f yellow= new Color3f(1.0f, 1.0f, 0.0f);
	Color3f cyan= new Color3f(0.0f, 1.0f, 1.0f);
	Color3f red= new Color3f(1.0f, 0.0f, 0.0f);
	//  leftTop_d.displayCurve(canvas, 1, yellow ); // debug
	//  	    leftTop_d.displayPts(canvas, 1, red);//debug
	//  	    rightTop_d.displayCurve(canvas, 1, yellow); //debug
	//  	    rightTop_d.displayPts(canvas, 1, red);//debug
	//  	    leftbottom_d.displayCurve(canvas, 1, white ); // debug
	//  	    rightbottom_d.displayCurve(canvas, 1, white); //debug
	
	//static page
	displayStaticPages(canvas, drawing_mode);
	
	//display cache
	//texturePools.displayCache();
	
	//testing jumping
	double z= config.getPaperHeight();
	gl.glPushMatrix();
	gl.glTranslated(0,0,z);
	
	//if(spineTurning2 <= 0){// phase2
	//displayCoverline(canvas);
	float [] lc ={1.0f, 1.0f, .0f}; 
	//leftTop_curve.displayCurve(canvas, 1, lc);
	//leftLower_curve.displayCurve(canvas, 1, lc);
	    
	float [] rc ={.5f, 1.0f, .0f}; 
	//rightTop_curve.displayCurve(canvas, 1, rc);
	//rightLower_curve.displayCurve(canvas, 1, rc);
	
	float [] ic ={.0f, .0f, .6f}; 
	//interior_curveUP.displayCurve(canvas, 1, ic);
	//interior_curveDOWN.displayCurve(canvas, 1, ic);
	//interior_curveUP_finish.displayCurve(canvas, 1, ic);
	//interior_curveDOWN_finish.displayCurve(canvas, 1, ic);
	
	//    }else{
	//  		displayCoverline(canvas);
	
	//  		float [] lc ={1.0f, 1.0f, .0f}; 
	//  		leftTop_curve.displayCurve(canvas, 1, lc);
	//  		leftLower_curve.displayCurve(canvas, 1, lc);
	
	//  		float [] rc ={.5f, 1.0f, .0f}; 
	//  		rightTop_curve.displayCurve(canvas, 1, rc);
	//  		rightLower_curve.displayCurve(canvas, 1, rc);
	
	//  		float [] ic ={.0f, .0f, .6f}; 
	//     		interior_curveUP.displayCurve(canvas, 1, ic);
	//     		interior_curveDOWN.displayCurve(canvas, 1, ic);
	//     		interior_curveUP_finish.displayCurve(canvas, 1, ic);
	//     		interior_curveDOWN_finish.displayCurve(canvas, 1, ic);
	//  	    }
	gl.glPopMatrix();
	
	//dynamic page
	if(scene.selection_mode == SELECTED){
	    if(scene.selected_name== config.LEFT_EDGE || scene.selected_name == config.RIGHT_EDGE){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Displaying bundle" );
		}
		if(coverState == OPEN){
		    bundle.display2(drawing_mode, canvas);
		}
	    }else if(scene.selected_name == config.FRONT_COVER){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Displaying moving front cover" );
		}
		
	    }else if(scene.selected_name == config.BACK_COVER){
		if(Ttp.commentslevel >= 3){
		    System.out.println("Displaying moving back cover" );
		}
	    }
	    else if(scene.selected_name == config.FORWARD_BUTTON ||
		    scene.selected_name == config.BACKWARD_BUTTON ){
		if(Ttp.commentslevel >= 3){
		    if(scene.selected_name == config.FORWARD_BUTTON){
			System.out.println("BookConstructor.java: FORWARD_BUTTON selected" );
		    }else{
			System.out.println("BookConstructor.java: BACKWARD_BUTTON selected" );
		    }
		}
		
		if(Scene.readytodisplayMovingPage){
		    
		    if(coverState == OPEN){
			if(Scene.turnNumofPages > 2){
			    bundle.display2(drawing_mode, canvas);
			}else{
			    displayDynamicPages(canvas, drawing_mode);
			}
		    }
		}

		
		
	    }
	    
	    else if(scene.selected_name == config.TURN_RIGHT ||  
		    scene.selected_name == config.TURN_LEFT){

		if(coverState == OPEN){
		    if(Scene.readytodisplayMovingPage){
			displayDynamicPages(canvas, drawing_mode);
		    }
		}
	    }
	    
	    else if(isPages(scene.selected_name)){ //activate by user
		if(Ttp.commentslevel >= 3){
		    System.out.println("Displaying dynamic page" );
		}
		displayDynamicPages(canvas, drawing_mode);
	    }
	}
    }
    

    /*
     * return the total number of papers
     * lies on the left hand side of
     * the double page-spread
     */
    public int getCur_paper()
    {
	return paper_no_lieOnLeft;
    }

    
    public void setSelectedPage2(int selected_page)
    {
	updateSelectedPage(selected_page);
    }
    
    public void setSelectedPage3(int selected_name)
    {
	int selected_page= 0;
	if(selected_name == config.FORWARD_BUTTON || 
	   selected_name == config.TURN_RIGHT){
	    selected_page= sp[0].getPage_num();
	}else if(selected_name == config.BACKWARD_BUTTON || 
		 selected_name == config.TURN_LEFT){
	    selected_page= sp[1].getPage_num();
	}
	
	updateSelectedPage(selected_page);
    }
    
    public int getRightPageNum()
    {
	return sp[0].getPage_num();
    }

    public int getLeftPageNum()
    {
	return sp[1].getPage_num();
    }


    /*
      Without firstWindow & lastWindow
     */
    public void updateSelectedPage(int selected_page)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookContructor.java: updateSelectedPage()");
	    System.out.println("BookContructor.java: selected_page= " + selected_page);
	}
	
	this.selected_page= selected_page;

	howmanyPapers= 1;
	
	if(selected_page % 2 == 0){
	    selected_side= RIGHT;
	    howmanyPagesRight= 2;
	    howmanyPagesLeft= 1;
	    
	    startYi= (double)(paper_no_lieOnLeft+howmanyPapers)/(double)config.get_total_papers() * edge_height;
	    startXi= startYi/edge_m;
	    endXi= 0;
	    
	    sp[0].setStartX(startXi); // new base
	    sp[0].setEndX(endXi); // new base
	    sp[0].setPapers(paper_no_lieOnRight-howmanyPapers); // number of papers at Right hand stack
	}else{ 
	    selected_side= LEFT;
	    
	    howmanyPagesLeft= 2;
	    howmanyPagesRight= 1;
	    
	    endYi= (double)(paper_no_lieOnRight+howmanyPapers)/(double)config.get_total_papers() * edge_height;
	    endXi= endYi/edge_m;
	    startXi= 0;
	    
	    sp[1].setStartX(startXi); // new base
	    sp[1].setEndX(endXi); // new base
	    sp[1].setPapers(paper_no_lieOnLeft-howmanyPapers); // number of papers at Right hand stack
	}

	//generate static pages
	sp[0].genModel(rightTop_curve.getPts(1),
		       rightLower_curve.getPts(1));
	sp[1].genModel(leftTop_curve.getPts(1),
		       leftLower_curve.getPts(1));
	
	
    }


    

    /*
      Only check for advance
    */
    public void checkPassThresholdK()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor: checkPassThresholdK()");
	}
	int page_name;
	int cur_index_new;
	int threshold_index= curWindow.threshold % curWindow.buffersize;

	if(selected_side == RIGHT){
	    page_name= sp[0].getPage_num();
	    cur_index_new= page_name % config.num_dynamic_tex_obj;
	    int left_index= (page_name-1) % config.num_dynamic_tex_obj;
	    
	    if( cur_index_new == threshold_index || left_index ==  threshold_index ){ 
		if( page_name >= lastWindow.leftBoundry &&
		    page_name <= lastWindow.rightBoundry ){
		    if(Ttp.commentslevel >= 3){	
			System.out.println("1. No need to perform filling process");
		    }
		    return;
		}
		
		if( nextWindow.filled == true){
		    if(Ttp.commentslevel >= 3){	
			System.out.println("2. No need to perform filling process");
		    }
		    return;
		}
		if(Ttp.commentslevel >= 3){	
		    System.out.println("Reach the threashold K, cur_index = " + cur_index_new);
		    System.out.println("Start fillin processes for nextWindow");
		}
		startFillingProcess();
	    }
	    
	}else{
	   
	    page_name= sp[1].getPage_num();
	    cur_index_new= page_name % config.num_dynamic_tex_obj;
	    int right_index= (page_name+1) % config.num_dynamic_tex_obj; 
	    
	    if( cur_index_new == threshold_index || right_index ==  threshold_index){
		if( page_name >= firstWindow.leftBoundry &&
		    page_name <= firstWindow.rightBoundry ){
		    if(Ttp.commentslevel >= 3){	
			System.out.println("1. No need to perform filling process");
		    }
		    return;
		}
		
		if( previousWindow.filled == true){
		    if(Ttp.commentslevel >= 3){	
			System.out.println("2. No need to perform filling process");
		    }
		    return;
		}
		
		if(Ttp.commentslevel >= 3){	
		    System.out.println("Start fillin processes for previousWindow");
		}
		startFillingProcess();
	    }
	    
	}
    }

    
    public boolean setSelectedEdge(int selected_edge, double ratio)
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor.java setSelectedEdge" );
	}
	
	boolean turnable= true;
	if(selected_edge == config.LEFT_EDGE){
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tleft edge has been selected" );
	    }
	    howmanyPapers =(int)(ratio * (paper_no_lieOnLeft));

	    if(howmanyPapers < 1) howmanyPapers= 1;
	    howmanyPagesLeft=  howmanyPapers*2;

	    if(config.snapping){
		//snapping
		int page= sp[1].getPage_num() - howmanyPagesLeft;
		int anchorCurPage= 0;
		int anchorPreviousPage= 0;
		int size= anchorPageList.size();
		int lastanchorPage= ((Integer)anchorPageList.get(size-1)).intValue()- 1 ;
		int firstanchorPage= ((Integer)anchorPageList.get(0)).intValue()- 1 ;
		
		if(sp[1].getPage_num() > firstanchorPage){
		    if(page >= firstanchorPage && page <= lastanchorPage){
			if(Ttp.commentslevel >= 3){	
			    System.out.println("\tWithin the range ");
			}
			int rightDifference, leftDifference; 
			int last= size-1;
			
			for(int i= last-1; i >= 0; i-- ){
			    anchorCurPage= ((Integer)anchorPageList.get(i)).intValue(); //right anchor page list
			    anchorCurPage -= 1;
			    
			    if(page == anchorCurPage){ 
				break;
			    }
			    
			    if(page > anchorCurPage){
				anchorPreviousPage= ((Integer)anchorPageList.get(i+1)).intValue(); 
				anchorPreviousPage -= 1;
				if(Ttp.commentslevel >= 3){	
				    System.out.println("\tCurrent anchor page= " + anchorCurPage);
				    System.out.println("\tCurrent page= " + page);
				    System.out.println("\tPrevious anchor page= " + anchorPreviousPage);
				}
				
				if(sp[1].getPage_num() <= anchorPreviousPage){
				    page= anchorCurPage;
				    
				}else{
				    rightDifference= anchorPreviousPage - page;
				    leftDifference=  page - anchorCurPage;
				    				
				    //snap to the new page
				    if(rightDifference <= leftDifference ){
					page= anchorPreviousPage;
				    }else{
					page= anchorCurPage;
				    }
				}
				howmanyPagesLeft= sp[1].getPage_num() - page;
				howmanyPapers= howmanyPagesLeft/2;
				ratio= (double)howmanyPapers/(double)paper_no_lieOnLeft;
				
				//the returned value is used to recalculate 'howmanyPapers'
				if(Ttp.commentslevel >= 3){	
				    System.out.println("\tNew Current page= " + page);
				    System.out.println("\tNew howmanyPagesLeft= " + howmanyPagesLeft);
				    System.out.println("\tNew howmanyPapers= " + howmanyPapers);
				    System.out.println("\tNew ratio= " + ratio);
				}
				
				break;
			    }
			}
		    }//end of if(sp[0].getPage_num() >= firstanchorPage && sp[0].getPage_num() <= lastanchorPage)
		    else{
			if(page < firstanchorPage){
			    page= firstanchorPage;
			}else if(page > lastanchorPage){
			    page= lastanchorPage;
			}
			
			howmanyPagesLeft= sp[1].getPage_num() - page;
			howmanyPapers= howmanyPagesLeft/2;
			ratio= (double)howmanyPapers/(double)paper_no_lieOnLeft;
		    }
		}else{
		    turnable=false;
		}
	    }//end of if(snapping)
	    
	    howmanyPagesRight=  howmanyPagesLeft - 1; 
	    
	}else if(selected_edge == config.RIGHT_EDGE){
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tright edge has been selected" );
	    }
	    
	    howmanyPapers =(int)(ratio * (paper_no_lieOnRight));
	    if(howmanyPapers < 1) howmanyPapers= 1;
	    
	    howmanyPagesRight=  howmanyPapers*2;
	    
	    if(config.snapping){
		//snapping
		int page= sp[0].getPage_num() + howmanyPagesRight;
		int anchorCurPage= 0;
		int anchorPreviousPage= 0;
		int size= anchorPageList.size();
		int lastanchorPage= ((Integer)anchorPageList.get(size-1)).intValue() ;
		int firstanchorPage= ((Integer)anchorPageList.get(0)).intValue() ;
		
		
		if(sp[0].getPage_num() < lastanchorPage){
		    if(page >= firstanchorPage && page <= lastanchorPage){
			int rightDifference, leftDifference; 
			//search through the anchored pages
			for(int i= 1; i < size; i++ ){
			    anchorCurPage= ((Integer)anchorPageList.get(i)).intValue();
			    
			    if(page == anchorCurPage){ 
				break;
			    }
			    
			    if(page < anchorCurPage){ 
				anchorPreviousPage= ((Integer)anchorPageList.get(i-1)).intValue() ;
				if(Ttp.commentslevel >= 3){	
				    System.out.println("\tCurrent anchor page= " + anchorCurPage);
				    System.out.println("\tCurrent page= " + page);
				    System.out.println("\tPrevious anchor page= " + anchorPreviousPage);
				}
				
				
				if(sp[0].getPage_num() >= anchorPreviousPage){
				    page= anchorCurPage;
				}
				
				else{
				    rightDifference= anchorCurPage - page;
				    leftDifference=  page - anchorPreviousPage;
				    
				//snap to the new page
				    if(rightDifference <= leftDifference ){
					page= anchorCurPage;
				    }else{
					page= anchorPreviousPage;
				    }
				}
				
				howmanyPagesRight= page - sp[0].getPage_num();
				howmanyPapers= howmanyPagesRight/2;
				ratio= (double)howmanyPapers/(double)paper_no_lieOnRight;
				
				if(Ttp.commentslevel >= 3){	
				    System.out.println("\tNew Current page= " + page);
				    System.out.println("\tNew howmanyPagesRight= " + howmanyPagesRight);
				    System.out.println("\tNew howmanyPapers= " + howmanyPapers);
				    System.out.println("\tNew ratio= " + ratio);
				}
				
				break;
			    }
			}
		    }//end of if(sp[0].getPage_num() >= firstanchorPage && sp[0].getPage_num() <= lastanchorPage)
		    else{
			if(page < firstanchorPage){
			    page= firstanchorPage;
			}else if(page > lastanchorPage){
			    page= lastanchorPage;
			}
			
			howmanyPagesRight= page - sp[0].getPage_num();
			howmanyPapers= howmanyPagesRight/2;
			ratio= (double)howmanyPapers/(double)paper_no_lieOnRight;
		    }
		    
		}else{
		    turnable= false;
		}
	    }
	    
	    howmanyPagesLeft=  howmanyPagesRight - 1; 
	    
	}

	if(turnable){
	    updateSelectedEdge(selected_edge, ratio);
	}
	return turnable;
    }

    public void setSelectedEdge(int selected_edge, int pageDifference)
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("setSelectedEdge" );
	}
	
	double ratio= 0;
	if(selected_edge == config.LEFT_EDGE){
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tleft edge has been selected" );
	    }
	    howmanyPagesLeft= pageDifference;
	    howmanyPagesRight=  howmanyPagesLeft - 1; 
	    
	    howmanyPapers= howmanyPagesLeft/2; //should be even
	    ratio= (double)howmanyPapers/paper_no_lieOnLeft;
	   
	    
	}else if(selected_edge == config.RIGHT_EDGE){
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tright edge has been selected" );
	    }
	    
	    howmanyPagesRight= pageDifference;
	    howmanyPagesLeft=  howmanyPagesRight - 1; 
	    
	    howmanyPapers= howmanyPagesRight/2;
	    ratio= (double)howmanyPapers/paper_no_lieOnRight;
	}

	updateSelectedEdge(selected_edge, ratio);

    }


    /*
      Assign which side of two page spreads are selected
      1. selected_side will be updated 
      2. how many underneath papers will be flipped over 
    */
    public void updateSelectedEdge(int selected_edge, double ratio)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookConstructor: updateSelectedEdge()" );
	}
	
	if(Ttp.commentslevel >= 3){	
	    System.out.println("\tpaper_no_lieOnLeft= " + paper_no_lieOnLeft);
	    System.out.println("\tpaper_no_lieOnRight= " + paper_no_lieOnRight);
	    System.out.println("\tleft page no= " +  sp[1].getPage_num());
	    System.out.println("\tright page no= " + sp[0].getPage_num());
	}
	//howmanyPagesRight= howmanyPapers*2; 
	//howmanyPagesLeft= howmanyPagesRight-1; 
	double lh=0, rh=0;
	//int papers; 
	if(selected_edge == config.LEFT_EDGE){
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tleft edge has been selected" );
	    }
//  	    howmanyPapers =(int)(ratio * (paper_no_lieOnLeft));

//  	    if(howmanyPapers < 1) howmanyPapers= 1;
//  	    howmanyPagesLeft=  howmanyPapers*2;
//  	    howmanyPagesRight=  howmanyPagesLeft - 1; 

	    if(Ttp.commentslevel >= 3){	
		System.out.println("\thowmanyPapers= " + howmanyPapers );
	    }
	    
	    selected_page= sp[1].getPage_num();// record selected_page
	    selected_side= LEFT; // record selected side

	    initial_lh= paper2h(paper_no_lieOnLeft); // should be global
  	    initial_rh= config.getBookThickness()- initial_lh; // should be global
  	    initial_turning_angle= h2turning(initial_lh); // should be global
  	    jumping_distance= ratio*initial_lh;

	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tinitial lh> " + initial_lh);
		System.out.println("\tinitial rh> " + initial_rh);
		System.out.println("\tinitial spine angle> " + initial_turning_angle );
		System.out.println("\tJumping distance> " + jumping_distance);
	    }

	    final_lh= paper2h(paper_no_lieOnLeft-howmanyPapers); // should be global
	    final_rh= config.getBookThickness()- final_lh; // should be global
	    final_turning_angle= h2turning( final_lh );
	    
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tfinal lh> " + final_lh );
		System.out.println("\tfinal rh> " + final_rh);
		System.out.println("\tfinal spine angle> " + final_turning_angle );
		System.out.println("\tinitial_lh - jumpting_distance> " + (initial_lh-jumping_distance) );
	    }
		
	    howmuchTurningSpineAngle= initial_turning_angle - final_turning_angle ; //positive
	    
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\thowmuchTurningSpineAngle= " + howmuchTurningSpineAngle );
	    }

	    double t, length;
	    double bt= config.getBookThickness();

	    if(initial_turning_angle <= 90.0){
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tinitial_turning_angle <= 90");
		}
		t= final_lh/initial_lh;
		length= distanceC0C1(initial_turning_angle);
		final_length= t*bt + (1-t)*length;

		phase2bookconstruction2(initial_lh, 
					initial_rh, 
					initial_turning_angle,
					initial_lh,
					jumping_distance);
	    }else{
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tinitial_turning_angle > 90");
		}
		t= final_lh/initial_lh;
		length= phase3distanceC0C1(initial_turning_angle);
		final_length= t*bt + (1-t)*length;

		phase3bookconstruction2(initial_lh, 
					initial_rh,
					initial_turning_angle-90,
					initial_lh,
					jumping_distance);
	    }

	    	    
	    //set up interior curve finishing position
	    if(final_turning_angle <= 90.0){
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tfinal_turning_angle <= 90");
		}
		t= initial_rh/final_rh;
		length= distanceC0C1(final_turning_angle);
		final_length= t*bt + (1-t)*length;
		phase2bookconstruction4(initial_rh, //h1 
					final_rh, //h2
					final_turning_angle, 
					initial_lh,     //midleft
					final_lh);  //midright
	    }else{
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tfinal_turning_angle > 90");
		}
		t= initial_rh/final_rh;
		length= phase3distanceC0C1(final_turning_angle);
		final_length= t*bt + (1-t)*length;

		phase3bookconstruction4(final_rh, //h1 
					initial_rh, //h2
					final_turning_angle-90,
					final_lh,     //midleft
					initial_lh);  //midright
	    }
		    
	    pageTurningAngle= 0;
	    pageStopAngle= -180;
	    
	    endYi= (double)(paper_no_lieOnRight+howmanyPapers)/(double)config.get_total_papers() * edge_height;
	    endXi= endYi/edge_m;
	    startXi= 0;
	    
	    sp[1].setStartX(startXi); // new base
	    sp[1].setEndX(endXi); // new base
	    sp[1].setPapers(paper_no_lieOnLeft-howmanyPapers); // number of papers at Right hand stack
	    
	    bundle.setSide(LEFT);
	    startYi= (double)(paper_no_lieOnLeft-howmanyPapers)/(double)config.get_total_papers() * edge_height;
	    startXi= startYi/edge_m;

	    endYi= (double)(paper_no_lieOnRight)/(double)config.get_total_papers() * edge_height;
	    endXi= endYi/edge_m;
	    bundle.setStartX(startXi); // new base
	    bundle.setEndX(endXi); // new base
	    bundle.setPapers(howmanyPapers); // number of papers at Right hand stack



	    /*dpBundle.setStartUPPosition(interior_curveUP.getPoint());
	    dpBundle.setStartDOWNPosition(interior_curveDOWN.getPoint());
	    

	    dpBundle.setTurningDirection(CLOCKWISE);
	    dpBundle.setJackVectors(  interior_curveUP.getVectors(), interior_curveUP_finish.getVectors(),  //left, right
				      interior_curveDOWN.getVectors(), interior_curveDOWN_finish.getVectors()); //left, right
	    dpBundle.setpivotAngle();
	    dpBundle.setRotationAngle(pageTurningAngle);

	    bundle.setSide(LEFT);
	    bundle.genModel2(dpBundle.getUPcurvePts(),
			     dpBundle.getDOWNcurvePts());

			     bundle.setPage_num2(selected_page, curTexName[0], nextTexName[1]);*/

	}else{ //selected_edge == config.RIGHT_EDGE
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tright edge has been selected" );
	    }
	    
//  	    howmanyPapers =(int)(ratio * (paper_no_lieOnRight));
//  	    if(howmanyPapers < 1) howmanyPapers= 1;
//  	    howmanyPagesRight=  howmanyPapers*2; 
//  	    howmanyPagesLeft=  howmanyPagesRight - 1; 

	    if(Ttp.commentslevel >= 3){	
		System.out.println("\thowmanyPapers= " + howmanyPapers );
	    }

	    selected_page= sp[0].getPage_num();
	    selected_side= RIGHT;
		
	    initial_lh= paper2h(paper_no_lieOnLeft); // should be global
	    initial_rh= config.getBookThickness()- initial_lh; // should be global
	    initial_turning_angle= h2turning(initial_lh); // should be global
	    jumping_distance= ratio*initial_rh;
	    
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tinitial lh> " + initial_lh );
		System.out.println("\tinitial rh> " + initial_rh);
		System.out.println("\tinitial spine angle> " + initial_turning_angle );
		System.out.println("\tJumping distance> " + jumping_distance);
	    }
	   	    
	    //set dynamic page
	    final_lh= paper2h(paper_no_lieOnLeft+howmanyPapers); // should be global
	    final_rh= config.getBookThickness()- final_lh; // should be global
	    final_turning_angle= h2turning( final_lh );
	    
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tfinal lh> " + final_lh );
		System.out.println("\tfinal rh> " + final_rh);
		System.out.println("\tfinal spine angle> " + final_turning_angle );
		System.out.println("\tinitial_lh + jumpting_distance> " + (initial_lh+jumping_distance) );
	    }
	    
	    howmuchTurningSpineAngle= final_turning_angle - initial_turning_angle;
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\thowmuchTurningSpineAngle= " + howmuchTurningSpineAngle );
	    }
	    
	    double t, length;
	    double bt= config.getBookThickness();
	    
	    //set up initial interior curve position
	    if(initial_turning_angle <= 90.0){
		//phase2
		t= final_rh/initial_rh;
		length= distanceC0C1(initial_turning_angle);
		bt= config.getBookThickness();
		final_length= t*bt + (1-t)*length;
		
		phase2bookconstruction2(initial_lh, 
					initial_rh, 
					initial_turning_angle,
					initial_lh,
					jumping_distance);
	    }else{
		//phase3
		t= final_rh/initial_rh;
		length= phase3distanceC0C1(initial_turning_angle);
		bt= config.getBookThickness();
		final_length= t*bt + (1-t)*length;
		
		phase3bookconstruction2(initial_lh, 
					initial_rh, 
					initial_turning_angle-90,
					initial_lh,
					jumping_distance);
	    }
		
		
	    //set up interior curve finishing position
	    if(final_turning_angle <= 90.0){
		//phase2
		t= initial_lh/final_lh;
		length= distanceC0C1(final_turning_angle);
		final_length= t*bt + (1-t)*length;
		phase2bookconstruction4(initial_lh, //h1 
					final_lh, //h2
					final_turning_angle, 
					initial_lh, //midleft
					final_lh);  //midright
	    }else{
		//phase3
		t= initial_lh/final_lh;
		length= phase3distanceC0C1(final_turning_angle);
		final_length= t*bt + (1-t)*length;
		
		phase3bookconstruction4(initial_lh, //h1 
					final_lh,   //h2
					final_turning_angle-90,
					initial_lh, //midleft
					final_lh ); //midright
		
	    }
	    
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\thow much the spine is turned> " + howmuchTurningSpineAngle );
	    }
	    
	    pageTurningAngle= 0;
	    pageStopAngle= 180;

	    startYi= (double)(paper_no_lieOnLeft+howmanyPapers)/(double)config.get_total_papers() * edge_height;
	    startXi= startYi/edge_m;
	    endXi= 0;

	    sp[0].setStartX(startXi); // new base
	    sp[0].setEndX(endXi); // new base
	    sp[0].setPapers(paper_no_lieOnRight-howmanyPapers); // number of papers at Right hand stack
	    
	    bundle.setSide(RIGHT);
	    startYi= (double)(paper_no_lieOnLeft)/(double)config.get_total_papers() * edge_height;
	    startXi= startYi/edge_m;

	    endYi= (double)(paper_no_lieOnRight-howmanyPapers)/(double)config.get_total_papers() * edge_height;
	    endXi= endYi/edge_m;
	    bundle.setStartX(startXi); // new base
	    bundle.setEndX(endXi); // new base
	    bundle.setPapers(howmanyPapers); // number of papers at Right hand stack

		
	    /*dpBundle.setStartUPPosition(interior_curveUP.getPoint());
	    dpBundle.setStartDOWNPosition(interior_curveDOWN.getPoint());
	    
	    dpBundle.setTurningDirection(ANTI_CLOCKWISE);
	    dpBundle.setJackVectors(interior_curveUP_finish.getVectors(), interior_curveUP.getVectors(),      //left, right
				    interior_curveDOWN_finish.getVectors(), interior_curveDOWN.getVectors()); //left, right
	    dpBundle.setpivotAngle();
	    dpBundle.setRotationAngle(pageTurningAngle);// interpolate 
	    
	    bundle.setSide(RIGHT);
	    bundle.genModel2(dpBundle.getUPcurvePts(),
			     dpBundle.getDOWNcurvePts());
			     bundle.setPage_num2(selected_page, curTexName[1], nextTexName[0]);*/
	    
	}
	
	rotateSpine(0);
	
    }


    /*
     * get selected names
     */
    public boolean isPreviousPage(int name)
    {
	boolean truth;

	if(config.bufferingOption == DIRECT_ONE || 
	   config.bufferingOption == DIRECT_TWO ){
	    if(selected_side == RIGHT){
		if(name == scene.selected_name || name == (scene.selected_name+howmanyPagesLeft) ) // front or back page
		    truth= true;
		else 
		    truth= false;
		
	    }else{
		if(name == scene.selected_name || name == (scene.selected_name-howmanyPagesRight) )
		    truth= true;
		else 
		    truth= false;
	    }
	    
	}else if(config.bufferingOption == ANCHORING){
	    //not yet implemented
	    truth= false;
	    
	}else if(config.bufferingOption == WINDOWING){
	    //do nothing
	    
	    if(selected_side == RIGHT){
		if(Ttp.commentslevel >= 3){	
		    System.out.println("BookConstructor: Right page is originally seleceted! ");
		}
		
		if(name == scene.selected_name || name == (scene.selected_name + 1) )
		    truth= true;
		else 
		    truth= false;
	    }else if(selected_side == LEFT){
		if(Ttp.commentslevel >= 3){	
		    System.out.println("BookConstructor: Left page is originally seleceted! ");
		}
		
		if(name == scene.selected_name || name == (scene.selected_name - 1) )
		    truth=  true;
		else 
		    truth=  false;
		
	    }else{
		if(Ttp.commentslevel >= 3){	
		    System.out.println("BookConstructor: Unknown selected_side! ");
		}
		truth= false;
	    }
	}else{
	    //do nothing
	    truth= false;
	    
	}

	
	
	return truth;
    }
    


    public void setCoverState(int coverState)
    {
	this.coverState= coverState;	
    }

    public int getCoverState()
    {
	return coverState;	
    }


    public void reset()
    {
	paper_no_lieOnLeft= 0;
	paper_no_lieOnRight= config.get_total_papers();
	
	initialize_CurTwoPagesTexture(config.firstPage);
	
	//edge anchors
	startYi= (double)paper_no_lieOnLeft/(double)config.get_total_papers() * edge_height;
	startXi= startYi/edge_m;
	
	endYi= 0;
	endXi= 0;
	
	sp[0].setStartX(startXi);
	sp[0].setEndX(endXi);// value unsure at moment, here might be redundant
	sp[0].setPapers(paper_no_lieOnRight); // number of papers at Right hand stack
	
	sp[0].setPageUPPageName(rightPageName);
	sp[0].setPageDOWNPageName(config.lastPage);
	sp[1].setPageUPPageName(leftPageName);
    }


    //////////////////////////
    // front cover
    //////////////////////////
    public void setSelectedFrontCover()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("setSelectedFrontCover()" );
	}
	
	selected_side= RIGHT;

	if(coverState == CLOSE){ //completely close
	    selected_page= config.firstPage;
	    howmanyPagesLeft= -1;
	    howmanyPagesRight= 0;

	    coverStartangle= frontTurning2;// frontTurning2 == 0
	    coverStopangle= 180+angleO;

	}else{ // completely open
	    
	    coverStartangle= frontTurning2;
	    coverStopangle= 0;
	    
	    initial_lh= paper2h(paper_no_lieOnLeft); //
	    initial_rh= config.getBookThickness()- initial_lh; //
	    howmuchTurningSpineAngle= h2turning(initial_lh); // between 0 and 180
	    howmuchTurningfrontCoverAngle= frontTurning2;// between 180 and 270
	    
	    init_spineAngle= frontTurning2/howmuchTurningfrontCoverAngle * howmuchTurningSpineAngle ;
	    
	    if(howmuchTurningSpineAngle <= 90){ 
		howmuchTurningC0C1= 90-howmuchTurningSpineAngle;
		initialTurningC0C1= howmuchTurningSpineAngle;
		lenC0C1= distanceC0C1(howmuchTurningSpineAngle);
	    }else{
		howmuchTurningC0C1= howmuchTurningSpineAngle; 
		initialTurningC0C1= ( 90-(howmuchTurningSpineAngle-90) ); //have alreayd inverted, see 'sr' in phase3bookconstruction3type1
		lenC0C1= phase3distanceC0C1(howmuchTurningSpineAngle);
	    }
	    if(Ttp.commentslevel >= 3){
		System.out.println("\tinitial_lh= " + initial_lh );
		System.out.println("\thowmuchTurningSpineAngle= " + howmuchTurningSpineAngle );
		System.out.println("\thowmuchTurningfrontCoverAngle= " + howmuchTurningfrontCoverAngle );
		System.out.println("\thowmuchTurningC0C1= " + howmuchTurningC0C1 );
		System.out.println("\tinitialTurningC0C1= " + initialTurningC0C1 );
		System.out.println("\tlenC0C1= " + lenC0C1 );		
	    }
	    
	}

    }
    
    

    public void rotateCloseFrontCover(double delta)
    {
	if(frontTurning2 < config.HALF_WAY){
	    rotateFrontCover(delta);
	}
	else{
	    rotateFrontCover(-delta);
	}

    }

    public void rotateOpenFrontCover(double delta)
    {
	if(frontTurning2 < config.HALF_WAY){
	    rotateFrontCover(delta);
	}
	else{
	    rotateFrontCover(-delta);
	}
    }

    public double f(double t)
    {
	//return -2*Math.pow(t, 3)+3*Math.pow(t,2);
	return Math.pow(t,3);
    }

    public void stepFrontCoverState(double t)
    {
	frontTurning2 = (1- f(t))*coverStartangle  + f(t)*coverStopangle;
	updateFrontCover();
    }
    
    public void rotateFrontCover(double delta){
	frontTurning2 -= delta;
	updateFrontCover();
    }
    public void updateFrontCover()
    {
	if(Ttp.commentslevel >= 3){	
	    System.out.println("BookConstructor.java: updateFrontCover()");
	}
	double spineAngle;
	//constraint
	if(coverState == CLOSE){
	    if(frontTurning2 < coverStartangle){
		frontTurning2= coverStartangle;
	    }
	   
	    if(frontTurning2 > coverStopangle){
		frontTurning2= coverStopangle;
	    }
	    
	    
	}
	else{// coverState == OPEN
	    if(frontTurning2 > coverStartangle)
		frontTurning2= coverStartangle;
	    
	    if(frontTurning2 < coverStopangle){
		frontTurning2= coverStopangle;
	    }
	    spineAngle= frontTurning2/howmuchTurningfrontCoverAngle * howmuchTurningSpineAngle ;
	    
	    //debug
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tspineAngle= " + spineAngle);
		System.out.println("\tfrontTurning2/howmuchTurningfrontCoverAngle= " + 
				   frontTurning2/howmuchTurningfrontCoverAngle ); // ratio decrease
	    }
	    
	    if(init_spineAngle <= 90.0){
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tinit_spineAngle <= 90.0");
		}
		double c0c1TurningAngle= initialTurningC0C1 + (1-frontTurning2/howmuchTurningfrontCoverAngle) * howmuchTurningC0C1;
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tc0c1TurningAngle= " + c0c1TurningAngle);
		}
		phase2bookconstruction3type3(initial_lh, initial_rh, spineAngle, frontTurning2, c0c1TurningAngle,
					     initial_lh,
					     lenC0C1);
	    }else{
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tinit_spineAngle > 90.0");
		}
		// require 2 transformation
		if(spineAngle <= 90.0){
		    if(Ttp.commentslevel >= 3){	
			System.out.println("\t\tphase2");
		    }
		    phase2bookconstruction3type4(initial_lh, initial_rh, spineAngle, frontTurning2, 
						 initial_lh,
						 lenC0C1 );
		}else{
		    if(Ttp.commentslevel >= 3){	
			System.out.println("\t\tphase3");
		    }
		    double c0c1TurningAngle= initialTurningC0C1 + (1-frontTurning2/howmuchTurningfrontCoverAngle) * howmuchTurningC0C1;
		    
		    if(Ttp.commentslevel >= 3){	
			System.out.println("\t\tc0c1TurningAngle= " + c0c1TurningAngle);
		    }
		    phase3bookconstruction3type3(initial_lh, initial_rh, spineAngle-90, frontTurning2, c0c1TurningAngle,
						 initial_lh,
						 lenC0C1 );
		}
	    }
	    
	}

	sp[0].genModel(rightTop_curve.getPts(1),
		       rightLower_curve.getPts(1));
	sp[1].genModel(leftTop_curve.getPts(1),
		       leftLower_curve.getPts(1));
	
	Point3d left , right;
	if(coverState == CLOSE){
	    left= rightTop_curve.getPoint();
	    right= rightLower_curve.getPoint();
	}else{
	    left= leftLower_curve.getPoint();
	    right= rightLower_curve.getPoint();
	}
	//construct strip
	genStrip(left, right);	
    }
    

    public void setSelectedFrontCover2()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("setSelectedFrontCover2()");
	}
	selected_side= RIGHT;
	initial_lh= config.getBookThickness();
	initial_rh= 0; 
	
	coverStartangle= 180;
	coverStopangle= 0;
    }

    
    public void flip2FrontCover(double delta)
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("flip2FrontCover()");
	}
	
	double spineAngle;
	frontTurning2 -= delta;
	
	if(frontTurning2 > coverStartangle)
	    frontTurning2 = coverStartangle;
	
	if(frontTurning2 < coverStopangle)
	    frontTurning2 = coverStopangle;
	
	spineAngle= frontTurning2;
	if(Ttp.commentslevel >= 3){	
	    System.out.println("\tspineAngle= " + spineAngle);
	}
	
	if(spineAngle <= 90 )
	    phase2bookconstruction3type5(initial_lh, initial_rh, spineAngle, initial_lh);
	else
	    phase3bookconstruction3type5(initial_lh, initial_rh, spineAngle, initial_lh);
	
	sp[1].genModel(leftTop_curve.getPts(1),
		       leftLower_curve.getPts(1));
	Point3d left , right;
	left= leftLower_curve.getPoint();
	right= leftTop_curve.getPoint();
	//construct strip
	genStrip(left, right);	
    }
    
    public void flipFrontCover(double delta)
    {
	if( frontTurning2 > config.HALF_WAY){
	    flip2FrontCover(-delta);
	}else{
	    flip2FrontCover(delta);
	}
    }


    /*
      very bad practice
     */
    public void setSelectedRightEdge(double ratio)
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("setSelectedRightEdge()");
	}
	
	howmanyPapers =(int)(ratio * (paper_no_lieOnRight));
	if(howmanyPapers < 1) howmanyPapers= 1;

	howmanyPagesRight=  howmanyPapers*2;
	
	if(config.snapping){

	    //snapping
	    int page= sp[0].getPage_num() + howmanyPagesRight;
	    int anchorCurPage= 0;
	    int anchorPreviousPage= 0;
	    int size= anchorPageList.size();
	    int lastanchorPage= ((Integer)anchorPageList.get(size-1)).intValue() ;
	    int firstanchorPage= ((Integer)anchorPageList.get(0)).intValue() ;
	
	    if(page >= firstanchorPage && page <= lastanchorPage){
		int rightDifference, leftDifference; 
		//search through the anchored pages
		for(int i= 1; i < size; i++ ){
		    anchorCurPage= ((Integer)anchorPageList.get(i)).intValue();
		    
		    if(page == anchorCurPage){ 
			break;
		    }
		    
		    if(page < anchorCurPage){ 
			anchorPreviousPage= ((Integer)anchorPageList.get(i-1)).intValue() ;
			if(Ttp.commentslevel >= 3){	
			    System.out.println("\tCurrent anchor page= " + anchorCurPage);
			    System.out.println("\tCurrent page= " + page);
			    System.out.println("\tPrevious anchor page= " + anchorPreviousPage);
			}
			
			rightDifference= anchorCurPage - page;
			leftDifference=  page - anchorPreviousPage;
			
			//snap to the new page
			if(rightDifference <= leftDifference ){
			    page= anchorCurPage;
			}else{
			    page= anchorPreviousPage;
			}
			
			howmanyPagesRight= page - sp[0].getPage_num();
			howmanyPapers= howmanyPagesRight/2;
			//the returned value is used to recalculate 'howmanyPapers'
			if(Ttp.commentslevel >= 3){	
			    System.out.println("\tNew Current page= " + page);
			    System.out.println("\tNew howmanyPagesRight= " + howmanyPagesRight);
			    System.out.println("\tNew howmanyPapers= " + howmanyPapers);
			}
			break;
		    }
		}
	    }
	    else{
		if(page < firstanchorPage){
		    page= firstanchorPage;
		}else if(page > lastanchorPage){
		    page= lastanchorPage;
		}
		howmanyPagesRight= page - sp[0].getPage_num();
		howmanyPapers= howmanyPagesRight/2;
		
	    }
	}

	howmanyPagesLeft=  howmanyPagesRight - 1; 
	updateSelectedRightEdge();
    }
    
    public void setSelectedRightEdge(int pageDifference )
    {
	if(Ttp.commentslevel >= 2){ 
	    System.out.println("setSelectedRightEdge()");
	}
	if(Ttp.commentslevel >= 3){	
	    System.out.println("\tpageDifference= " + pageDifference);
	}
	
	howmanyPagesRight= pageDifference;
	howmanyPagesLeft=  howmanyPagesRight - 1; 

	howmanyPapers= howmanyPagesRight/2;
	//if(howmanyPapers < 1) howmanyPapers= 1;// assurance
	updateSelectedRightEdge();
    }
    

    /*
      It is called only when coverState is CLOSE
    */
    public void updateSelectedRightEdge()
    {
	selected_page= sp[0].getPage_num();
	selected_side= RIGHT;
	
	initial_lh= paper2h(howmanyPapers); 
	initial_rh= config.getBookThickness()- initial_lh; //
	howmuchTurningSpineAngle= h2turning(initial_lh); // between 0 and 180

	coverStartangle= 0;
	//frontTurning2 == 0
	if(howmuchTurningSpineAngle <= 90){ //phase2
	    double cw, bt, pr, qr;
	    cw= config.getCoverWidth();
	    bt= config.getBookThickness();
	    pr=  Utilities.degree2rad(90-howmuchTurningSpineAngle);
	    qr= sineRules(cw, bt, pr);
	    coverStopangle= 180 + Utilities.rad2degree(qr);
	}else{//phase3
	    coverStopangle= 180;
	}

	howmuchTurningfrontCoverAngle= coverStopangle;// between 180 and 270	

	
	if(howmuchTurningSpineAngle <= 90){ 
	    howmuchTurningC0C1= 90-howmuchTurningSpineAngle;
	    initialTurningC0C1= howmuchTurningSpineAngle;
	    lenC0C1= distanceC0C1(howmuchTurningSpineAngle);
	}else{
	    howmuchTurningC0C1= howmuchTurningSpineAngle; 
	    initialTurningC0C1= ( 90-(howmuchTurningSpineAngle-90) ); //have alreayd inverted, see 'sr' in phase3bookconstruction3type1
	    lenC0C1= phase3distanceC0C1(howmuchTurningSpineAngle);
	}
	
	if(Ttp.commentslevel >= 3){	
	    System.out.println("\thowmanyPapers= " + howmanyPapers );
	    System.out.println("\thowmuchTurningSpineAngle= " + howmuchTurningSpineAngle );
	    System.out.println("\thowmuchTurningfrontCoverAngle= " + howmuchTurningfrontCoverAngle );
	    System.out.println("\tfrontTurning2= " + frontTurning2);
	    System.out.println("\tcoverStartangle= " + coverStartangle);
	    System.out.println("\tcoverStopangle= " + coverStopangle);
	}
	
	startYi= (double)(howmanyPapers)/(double)config.get_total_papers() * edge_height;
	startXi= startYi/edge_m;
	
	if(Ttp.commentslevel >= 3){	
	    System.out.println("\tstartXi= " + startXi);
	}
	
	sp[0].setStartX(startXi); // new base
	sp[0].setPapers(paper_no_lieOnRight-howmanyPapers); // number of papers at Right hand stack

	endYi= (double)(paper_no_lieOnRight-howmanyPapers)/(double)config.get_total_papers() * edge_height;
	endXi= endYi/edge_m;
	if(Ttp.commentslevel >= 3){	
	    System.out.println("\tendXi= " + endXi);
	}

	sp[1].setEndX(endXi); // new base
	sp[1].setPapers(howmanyPapers); // number of papers at Right hand stack

	//generate first split model
	rotateSpine_RightEdgeSelected(0);
    }

    public void stepSpine_RightEdgeState(double t)
    {
	frontTurning2 = (1- f(t))*coverStartangle  + f(t)*coverStopangle;
	updateSpine_RightEdgeSelected();
    }
    
    
    public void rotateSpine_RightEdgeSelected(double delta)
    {
	frontTurning2 -= delta;
	updateSpine_RightEdgeSelected();
    }

    
    /*
      it is called only when coverState is CLOSE
    */
    public void updateSpine_RightEdgeSelected()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("rotateSpine_RightEdgeSelected()");
	}
	double spineAngle;
	

	if(frontTurning2 < coverStartangle){ // frontTurning2 < 0
	    frontTurning2= coverStartangle;
	}
	
	if(frontTurning2 > coverStopangle){  // frontTurning2 > 
	    frontTurning2= coverStopangle;
	}

	spineAngle= frontTurning2/howmuchTurningfrontCoverAngle * howmuchTurningSpineAngle;
	if(Ttp.commentslevel >= 3){	
	    System.out.println("\tfrontTurning2= " + frontTurning2 );
	    System.out.println("\tspineAngle= " + spineAngle);
	}
	
	if(howmuchTurningSpineAngle > 90){
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\thowmuchTurningSpineAngle > 90.0");
	    }
	    
	    if(spineAngle <= 90.0){
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\t\tphase2");
		}
		
		phase2bookconstruction3type4(initial_lh, initial_rh, spineAngle, frontTurning2, 
					     initial_lh,
					     lenC0C1 );
		
	    }else{
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\t\tphase3");
		}
		double c0c1TurningAngle= initialTurningC0C1 + (1-frontTurning2/howmuchTurningfrontCoverAngle) * howmuchTurningC0C1;
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\t\tc0c1TurningAngle= " + c0c1TurningAngle);
		}
		phase3bookconstruction3type3(initial_lh, initial_rh, spineAngle-90, frontTurning2, c0c1TurningAngle,
					     initial_lh,
					     lenC0C1 );
		
	    }
	}else{
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\thowmuchTurningSpineAngle <= 90.0");
		System.out.println("\t\tphase2");
	    }
	    double c0c1TurningAngle= initialTurningC0C1 + (1-frontTurning2/howmuchTurningfrontCoverAngle) * howmuchTurningC0C1;
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tc0c1TurningAngle= " + c0c1TurningAngle);
	    }
	    phase2bookconstruction3type3(initial_lh, initial_rh, spineAngle, frontTurning2, c0c1TurningAngle,
					 initial_lh,
					 lenC0C1);

	}

	sp[0].genModel(rightTop_curve.getPts(1),
		       rightLower_curve.getPts(1));
	sp[1].genModel(leftTop_curve.getPts(1),
		       leftLower_curve.getPts(1));

	Point3d left , right;
	left= leftLower_curve.getPoint();
	right= rightLower_curve.getPoint();
	//construct strip
	genStrip(left, right);	

    }


    public void setSelectedLeftEdge(double ratio)
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("setSelectedLeftEdge(ratio)");
	    System.out.println("\tRatio= " + ratio);
	}
	
	howmanyPapers =(int)(ratio * (paper_no_lieOnLeft));

	if(howmanyPapers < 1) howmanyPapers= 1;
	howmanyPagesLeft=  howmanyPapers*2;
	
	if(config.snapping){
	    int page= sp[1].getPage_num()-howmanyPagesLeft;
	    int anchorCurPage= 0;
	    int anchorPreviousPage= 0;
	    int size= anchorPageList.size();
	    
	    int lastanchorPage= ((Integer)anchorPageList.get(size-1)).intValue()- 1 ;
	    int firstanchorPage= ((Integer)anchorPageList.get(0)).intValue()- 1 ;
	    
	    if(page >= firstanchorPage && page <= lastanchorPage){
		int rightDifference, leftDifference; 
		int last= size-1;
		
		for(int i= last-1; i >= 0; i-- ){
		    anchorCurPage= ((Integer)anchorPageList.get(i)).intValue(); //right anchor page list
		    anchorCurPage -= 1;
		    
		    if(page == anchorCurPage){ 
			break;
		    }
		    
		    if(page > anchorCurPage){
			anchorPreviousPage= ((Integer)anchorPageList.get(i+1)).intValue(); 
			anchorPreviousPage -= 1;
			
			if(Ttp.commentslevel >= 3){	
			    System.out.println("\tCurrent anchor page= " + anchorCurPage);
			    System.out.println("\tCurrent page= " + page);
			    System.out.println("\tPrevious anchor page= " + anchorPreviousPage);
			}
			
			rightDifference= anchorPreviousPage - page;
			leftDifference=  page - anchorCurPage;
		
			//snap to the new page
			if(rightDifference <= leftDifference ){
			    page= anchorPreviousPage;
			}else{
			    page= anchorCurPage;
			}
			
			howmanyPagesLeft= sp[1].getPage_num()-page;
			howmanyPapers= howmanyPagesLeft/2;
			//the returned value is used to recalculate 'howmanyPapers'
			if(Ttp.commentslevel >= 3){	
			    System.out.println("\tNew Current page= " + page);
			    System.out.println("\tNew howmanyPagesLeft= " + howmanyPagesLeft);
			    System.out.println("\tNew howmanyPapers= " + howmanyPapers);
			}
			break;
		    }
		}
	    }
	    else{
		if(page < firstanchorPage){
		    page= firstanchorPage;
		}else if(page > lastanchorPage){
		    page= lastanchorPage;
		}
		
		howmanyPagesLeft= sp[1].getPage_num() - page;
		howmanyPapers= howmanyPagesLeft/2;
	    }
	}
	
	howmanyPagesRight=  howmanyPagesLeft - 1; 

	updateSelectedLeftEdge();
    }
    
    public void setSelectedLeftEdge(int pageDifference)
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("setSelectedLeftEdge(pageDifference)");
	}
	
	howmanyPagesLeft= pageDifference;
	howmanyPagesRight=  howmanyPagesLeft - 1; 

	howmanyPapers= howmanyPagesLeft/2;
	//if(howmanyPapers < 1) howmanyPapers= 1;// assurance
	updateSelectedLeftEdge();
    }

    /*
      it is called only when coverState is CLOSE
     */
    public void updateSelectedLeftEdge()
    {
	selected_page= sp[1].getPage_num();
	selected_side= LEFT;
	
	initial_lh= paper2h(config.get_total_papers() - howmanyPapers); 
	initial_rh= config.getBookThickness()- initial_lh; 
	initial_turning_angle= h2turning(initial_lh);
	howmuchTurningSpineAngle= (180 - initial_turning_angle);
	

	coverStartangle= 180;
	if(initial_turning_angle <= 90){ //phase2
	    coverStopangle= 0;
	    shifting= 0;
	}else{//phase3
	    double cw, bt, pr, qr;
	    cw= config.getCoverWidth();
	    bt= config.getBookThickness();

	    pr= Utilities.degree2rad(initial_turning_angle-90);
	    qr= sineRules(cw, bt, pr);
	    coverStopangle= -Utilities.rad2degree(qr);
	    shifting= Utilities.abs(coverStopangle);
	}
	
	howmuchTurningbackCoverAngle= Utilities.abs(coverStopangle)+180;
	if(initial_turning_angle <= 90){
	    howmuchTurningC0C1= howmuchTurningSpineAngle;
	    initialTurningC0C1= h2turning(initial_lh);
	    lenC0C1= distanceC0C1( h2turning(initial_lh));
	}else{
	    howmuchTurningC0C1= 90-howmuchTurningSpineAngle;
	    initialTurningC0C1= howmuchTurningSpineAngle;
	    lenC0C1= phase3distanceC0C1( h2turning(initial_lh));
	}
	
	if(Ttp.commentslevel >= 3){	
	    System.out.println("\thowmanyPapers= " + howmanyPapers );
	    System.out.println("\thowmuchTurningSpineAngle= " + howmuchTurningSpineAngle );
	    System.out.println("\thowmuchTurningbackCoverAngle= " + howmuchTurningbackCoverAngle );
	    System.out.println("\tbackTurning2= " + backTurning2);
	    System.out.println("\tcoverStartangle= " + coverStartangle);
	    System.out.println("\tcoverStopangle= " + coverStopangle);
	    System.out.println("\tshifting= " + shifting );
	}
	
	endYi= (double)(howmanyPapers)/(double)config.get_total_papers() * edge_height;
	endXi= endYi/edge_m;
	
	if(Ttp.commentslevel >= 3){	
	    System.out.println("\tendXi= " + endXi);
	}
	
	sp[1].setEndX(endXi); // new base
	sp[1].setPapers(paper_no_lieOnLeft-howmanyPapers); // number of papers at Right hand stack

	startYi= (double)(paper_no_lieOnLeft-howmanyPapers)/(double)config.get_total_papers() * edge_height;
	startXi= startYi/edge_m;

	if(Ttp.commentslevel >= 3){	
	    System.out.println("\tstartXi= " + startXi);
	}
	sp[0].setStartX(startXi); // new base
	sp[0].setPapers(howmanyPapers); // number of papers at Right hand stack
	
	rotateSpine_LeftEdgeSelected(0);
    }

    public void stepSpine_LeftEdgeState(double t)
    {
	backTurning2 = (1- f(t))*coverStartangle  + f(t)*coverStopangle;
	udpateSpine_LeftEdgeSelected();
    }

    public void rotateSpine_LeftEdgeSelected(double delta)
    {
	backTurning2 -= delta;
	udpateSpine_LeftEdgeSelected();
    }


    public void udpateSpine_LeftEdgeSelected()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookCosntructor.java: udpateSpine_LeftEdgeSelected()");
	}	
	double spineAngle;
	

	//constraint
	
	if(backTurning2 > coverStartangle){
	    backTurning2 = coverStartangle;
	}
	
	if(backTurning2 < coverStopangle){ // not tested 
	    backTurning2 = coverStopangle;
	}

	double bTurning= backTurning2+shifting;
	spineAngle= initial_turning_angle + bTurning/howmuchTurningbackCoverAngle * howmuchTurningSpineAngle;
	if(Ttp.commentslevel >= 3){	
	    System.out.println("\tbackTurning2= " + backTurning2 );
	    System.out.println("\tspineAngle= " + spineAngle );
	}
	
	double c0c1TurningAngle= 0;

	if(initial_turning_angle <= 90.0){
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tinit_spineAngle <= 90.0");
	    }
	    
	    if(spineAngle <= 90.0){
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\t\tphase2");
		}
		
		c0c1TurningAngle= initialTurningC0C1 + bTurning/howmuchTurningbackCoverAngle * howmuchTurningC0C1;
		phase2bookconstruction3type3(initial_lh, initial_rh, spineAngle, backTurning2, c0c1TurningAngle,
					     initial_lh,
					     lenC0C1);
		
	    }else{
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\t\tphase3");
		}
		phase3bookconstruction3type4(initial_lh, initial_rh, spineAngle-90, backTurning2,
					     initial_lh,
					     lenC0C1);
	    }

	}else{
	    //System.out.println("\tinit_spineAngle > 90.0");
	    c0c1TurningAngle= initialTurningC0C1 + bTurning/howmuchTurningbackCoverAngle * howmuchTurningC0C1;
	    phase3bookconstruction3type3(initial_lh, initial_rh, spineAngle-90, backTurning2, c0c1TurningAngle,
					 initial_lh,
					 lenC0C1 );
	    

	}

	sp[0].genModel(rightTop_curve.getPts(1),
		       rightLower_curve.getPts(1));
	sp[1].genModel(leftTop_curve.getPts(1),
		       leftLower_curve.getPts(1));
	Point3d left , right;
	left= leftLower_curve.getPoint();
	right= rightLower_curve.getPoint();
	//construct strip
	genStrip(left, right);	

    }

    /*

      with lastWindow & firstWindow
     */
    public void reset_theTwoStaticPages()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("reset_theTwoStaticPages()");
	}

	if(config.bufferingOption == DIRECT_ONE || 
	   config.bufferingOption == DIRECT_TWO ){
	    transitTexName();

	    if(scene.selected_name == config.RIGHT_EDGE){
		paper_no_lieOnLeft= 0;
		paper_no_lieOnRight= config.get_total_papers();
		
		initialize_CurTwoPagesTexture(config.firstPage);

		//sp[1].setPage_num(curTexName[0], -1);             // left
		//sp[0].setPage_num(curTexName[1], config.firstPage);  // right
		
	    }else if(scene.selected_name == config.FRONT_COVER){
		paper_no_lieOnLeft= 0;
		paper_no_lieOnRight= config.get_total_papers();
		
		initialize_CurTwoPagesTexture(config.firstPage);
		//sp[1].setPage_num(curTexName[0], -1);             // left
		//sp[0].setPage_num(curTexName[1], config.firstPage);  // right

		
	    }else if(scene.selected_name == config.LEFT_EDGE){
		paper_no_lieOnLeft= config.get_total_papers();
		paper_no_lieOnRight= 0;
		
		initialize_CurTwoPagesTexture(config.lastPage);

		//sp[1].setPage_num(curTexName[0], config.lastPage);    // left
		//sp[0].setPage_num(curTexName[1], config.lastPage+1);  // right

	    }else if(scene.selected_name == config.BACK_COVER){
		paper_no_lieOnLeft= config.get_total_papers();
		paper_no_lieOnRight= 0;

		initialize_CurTwoPagesTexture(config.lastPage);
		
		//sp[1].setPage_num(curTexName[0], config.lastPage);    // left
		//sp[0].setPage_num(curTexName[1], config.lastPage+1);  // right

	    }else{
		if(Ttp.commentslevel >= 3){	
		    System.out.println("Not permitted here");
		}
	    }
	    
	    sp[0].setPage_num(rightTexName, rightPageName);
	    sp[1].setPage_num(leftTexName, leftPageName);

		
	}else if(config.bufferingOption == ANCHORING){
	    //not yet implemented

	}else if(config.bufferingOption == WINDOWING){
	    //cleanUp texNames in the middle 
	    //check previousWindow
	    if(previousWindow.leftBoundry == firstWindow.leftBoundry && 
	       previousWindow.rightBoundry == firstWindow.rightBoundry ){
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tpreviousWindow == firstWindow");
		}
	    }else{
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tpreviousWindow != firstWindow");
		    System.out.println("\tDelete previousWindow texName");
		}
		
		//release texNames first, then re-initialize texNames to 0
		scene.deleteTexNames(config.num_dynamic_tex_obj, previousWindow.texName);
		previousWindow.init_texNames();
	    }

	    //check lastWindow
	    if(nextWindow.leftBoundry == lastWindow.leftBoundry ){
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tnextWindow == lastWindow");
		}
	    }
	    else{
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tnextWindow != lastWindow");
		    System.out.println("\tDelete nextWindow texName");
		}
		
		scene.deleteTexNames(config.num_dynamic_tex_obj, nextWindow.texName);
		nextWindow.init_texNames();
	    }
	
	    //check curWindow
	    if( curWindow.leftBoundry == lastWindow.leftBoundry ){
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tcurWindow == lastWindow");
		}
	    }else if( (curWindow.leftBoundry == firstWindow.leftBoundry && curWindow.rightBoundry == firstWindow.rightBoundry) ){ 
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tcurWindow == firstWindow");
		}
	    }else{
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tNeither curWindow == firstWindow nor curWindow == firstWindow");
		    System.out.println("\tDelete curWindow texName");
		}
		
		scene.deleteTexNames(config.num_dynamic_tex_obj, curWindow.texName);
		curWindow.init_texNames();
	    }
	    
	    
	    if(scene.selected_name == config.FRONT_COVER || scene.selected_name == config.RIGHT_EDGE ){
		paper_no_lieOnLeft= 0;
		paper_no_lieOnRight= config.get_total_papers();
		
		//scene.initializePageContent2(config.firstPage);
		setRightandLeftPageName();
	    }else{ // scene.selected_name == bc.BACK_COVER
		paper_no_lieOnLeft= config.get_total_papers();
		paper_no_lieOnRight= 0;
		
		//scene.initializePageContent2(config.lastPage);
		setRightandLeftPageName();
	    }
	    
	    //update staticPages
	    sp[0].setPage_num(rightTexName, rightPageName);
	    sp[1].setPage_num(leftTexName, leftPageName);
	    
	}else{
	    //do nothing
	    
	}


    }


    /*
      reset 

      paper_no_lieOnLeft/Right
      static pages' page name
     */
    public void reset_StaticPages()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor: reset_StaticPages()");
	}

	if(selected_side == RIGHT ){
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tRIGHT");
	    }
	    paper_no_lieOnLeft= 0;
	    paper_no_lieOnRight= config.get_total_papers();
	    
	    initialize_CurTwoPagesTexture(config.firstPage);
	    
	    //edge anchors
	    startYi= (double)paper_no_lieOnLeft/(double)config.get_total_papers() * edge_height;
	    startXi= startYi/edge_m;
	    
	    endYi= 0;
	    endXi= 0;
	    
	    sp[0].setStartX(startXi);
	    sp[0].setEndX(endXi);// value unsure at moment, here might be redundant
	    sp[0].setPapers(paper_no_lieOnRight); // number of papers at Right hand stack
	    
	    sp[0].setPageUPPageName(rightPageName);
	    sp[0].setPageDOWNPageName(config.lastPage);
	    sp[1].setPageUPPageName(leftPageName);
	    
		
	}else{
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tLEFT");
	    }
	    paper_no_lieOnLeft= config.get_total_papers();
	    paper_no_lieOnRight= 0;

	    //initialize leftPageName and rightPageName
	    initialize_CurTwoPagesTexture(config.lastPage);

	    startYi= 0;
	    startXi= 0;
	    
	    endYi= (double)paper_no_lieOnRight/config.get_total_papers() * (double)edge_height;
	    endXi= endYi/edge_m;
	    
	    sp[1].setStartX(startXi);
	    sp[1].setEndX(endXi);// value unsure at moment
	    sp[1].setPapers(paper_no_lieOnLeft); // number of papers at left hand stack

	    sp[1].setPageUPPageName(leftPageName);
	    sp[1].setPageDOWNPageName(config.firstPage);
	    
	    sp[0].setPageUPPageName(rightPageName);
	}
    }
    
    
    public void update_StaticPages()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor: update_StaticPages()");
	}
	
	if(selected_side == RIGHT ){
	    startYi= 0;
	    startXi= 0;
	    
	    endYi= (double)paper_no_lieOnRight/(double)config.get_total_papers() * edge_height;
	    endXi= endYi/edge_m;
	    
	    sp[1].setStartX(startXi);
	    sp[1].setEndX(endXi);// value unsure at moment
	    sp[1].setPapers(paper_no_lieOnLeft); // number of papers at left hand stack

	    //sp[1].setPageUPPageName(config.firstPage);
	    //sp[1].setPageDOWNPageName(config.firstPage);
	    
	}else{
	    startYi= (double)paper_no_lieOnLeft/(double)config.get_total_papers() * edge_height;
	    startXi= startYi/edge_m;
	    endYi= 0;
	    endXi= 0;
	    
	    sp[0].setStartX(startXi);
	    sp[0].setEndX(endXi);// value unsure at moment
	    sp[0].setPapers(paper_no_lieOnRight); // number of papers at left hand stack

	}
    }

    /*

      without lastWindow & firstWindow
     */
    public void reset_theTwoStaticPages2()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("reset_theTwoStaticPages2()");
	}
	
	scene.deleteTexNames(config.num_dynamic_tex_obj, previousWindow.texName);
	previousWindow.init_texNames();
	scene.deleteTexNames(config.num_dynamic_tex_obj, nextWindow.texName);
	nextWindow.init_texNames();
	scene.deleteTexNames(config.num_dynamic_tex_obj, curWindow.texName);
	curWindow.init_texNames();

	if(scene.selected_name == config.FRONT_COVER || scene.selected_name == config.RIGHT_EDGE ){
	    paper_no_lieOnLeft= 0;
	    paper_no_lieOnRight= config.get_total_papers();
	    
	    //scene.initializePageContent2(config.firstPage);
	    setRightandLeftPageName();
	}else{
	    paper_no_lieOnLeft= config.get_total_papers();
	    paper_no_lieOnRight= 0;
	    
	    //scene.initializePageContent2(config.lastPage);
	    setRightandLeftPageName();
	}

	sp[0].setPage_num(rightTexName, rightPageName);
	sp[1].setPage_num(leftTexName, leftPageName);
	
    }

        

    public boolean hasfrontCoverLeavedRestPosition()
    {
	
	if(coverState == CLOSE){
	    if(frontTurning > coverThreshold_1 )
		return true;
	    else
		return false;
	}else{
	    if(frontTurning < (coverStartangle-coverThreshold_1)  )
		return true;
	    else
		return false;
	}
	
    }
    
    public boolean isFrontCoverCompletelyOpen()
    {
	if(frontTurning2 >= (coverStopangle-coverThreshold_2)){
	    frontTurning2= coverStopangle;
	    return true;
	}else{
	    return false;
	}

    }
    


    public boolean isFrontCoverCompletelyCloseAgain()
    {
	
	if(frontTurning2 <= (coverStartangle + coverThreshold_2)){
	    frontTurning2= coverStartangle;
	    return true;
	}else{
	    return false;
	}

    }

    public boolean isCloseFrontCover_Rest()
    {
	if(frontTurning2 < config.HALF_WAY ){
	    return isFrontCoverCompletelyCloseAgain();
	}
	else{
	    return isFrontCoverCompletelyOpen();
	}
    
    }

    public boolean isOpenFrontCover_Rest()
    {
	if(frontTurning2 < config.HALF_WAY ){
	    return isFrontCoverCompletelyClose();
	}
	else{
	    return isFrontCoverCompletelyOpenAgain();
	}

    }
     
    
   

     public boolean isFrontCoverCompletelyClose()
    {
	
	if(frontTurning2 <= (coverStopangle + coverThreshold_2)){
	    frontTurning2= coverStopangle;
	    return true;
	}else{
	    return false;
	}

    }

    public boolean isFrontCoverCompletelyOpenAgain()
    {
	//if(frontTurning2 >= (coverStartangle-coverThreshold_2)){
	if(frontTurning2 >= (coverStartangle-coverThreshold_2)){
	    frontTurning2= coverStartangle;
	    return true;
	}else{
	    return false;
	}

    }


    //////////////////////////
    // back cover
    //////////////////////////
    public void setSelectedBackCover()
    {
	selected_side= LEFT;

	if(coverState == CLOSE){ //completely close
	    
	    selected_page= config.lastPage;
	    howmanyPagesLeft= 0;
	    howmanyPagesRight=-1;

	    coverStartangle= 180;
	    coverStopangle= -angleO;
	}else{ // completely open
	    coverStartangle= backTurning2;
	    coverStopangle= 180;

	    initial_lh= paper2h(paper_no_lieOnLeft); //
	    initial_rh= config.getBookThickness()- initial_lh; //
	    howmuchTurningSpineAngle= (180 - h2turning(initial_lh));
	    //howmuchTurningSpineAngle= h2turning(initial_lh); //???
	    howmuchTurningbackCoverAngle= Utilities.abs(backTurning2)+180;
	    
	    init_spineAngle= h2turning(initial_lh);
	    shifting= Utilities.abs(backTurning2);

	    if(init_spineAngle <= 90){
		howmuchTurningC0C1= howmuchTurningSpineAngle;
		initialTurningC0C1= h2turning(initial_lh);
		lenC0C1= distanceC0C1( h2turning(initial_lh));
	    }else{
		howmuchTurningC0C1= 90-howmuchTurningSpineAngle;
		initialTurningC0C1= howmuchTurningSpineAngle;
		lenC0C1= phase3distanceC0C1( h2turning(initial_lh));
	    }

	}
	if(Ttp.commentslevel >= 3){	
	    System.out.println("\tcoverStartangle= " + coverStartangle );
	    System.out.println("\tcoverStopangle= " + coverStopangle );
	    System.out.println("\thowmuchTurningSpineAngle= " +  howmuchTurningSpineAngle );
	    System.out.println("\thowmuchTurningbackCoverAngle= " + howmuchTurningbackCoverAngle );
	    System.out.println("\thowmuchTurningC0C1= " + howmuchTurningC0C1 );
	    System.out.println("\tinitialTurningC0C1= " + initialTurningC0C1 );
	    
	    System.out.println("\tinit_spineAngle= " +  init_spineAngle );
	    System.out.println("\tshifting= " + shifting );
	}
	
    }

    public void rotateCloseBackCover(double delta)
    {
	if(backTurning2 > config.HALF_WAY){
	    rotateBackCover(-delta);
	}else{
	    rotateBackCover(delta);
	}
    }

    public void rotateOpenBackCover(double delta)
    {
	if(backTurning2 > config.HALF_WAY){
	    rotateBackCover(-delta);
	}else{
	    rotateBackCover(delta);
	}
    }

    public void stepBackCoverState(double t)
    {
	backTurning2 = (1- f(t))*coverStartangle  + f(t)*coverStopangle;
	updateBackCover();
    }

    
    public void rotateBackCover(double delta)
    {
	backTurning2 -= delta;
	updateBackCover();
    }
    
    public void updateBackCover()
    {
	double spineAngle;
	
	//constraint
	if(coverState == CLOSE){
	    if(backTurning2 > coverStartangle){
		backTurning2 = coverStartangle;
	    }

	    if(backTurning2 < coverStopangle) // not tested 
		backTurning2 = coverStopangle;
	}
	else{
	    if(backTurning2 < coverStartangle)
		backTurning2 = coverStartangle;

	    if(backTurning2 > coverStopangle)
		backTurning2 = coverStopangle;
	    
	    double bTurning= backTurning2+shifting;
	    spineAngle= init_spineAngle + bTurning/howmuchTurningbackCoverAngle * howmuchTurningSpineAngle;
	    
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tbackTurning2= " + backTurning2 );
		System.out.println("\tspineAngle= " + spineAngle );
	    }

	    double c0c1TurningAngle= 0;
	    
	    
	    if(init_spineAngle <= 90.0){
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tinit_spineAngle <= 90.0");
		}
		if(spineAngle <= 90.0){
		    if(Ttp.commentslevel >= 3){	
			System.out.println("\t\tphase2");
		    }
		    c0c1TurningAngle= initialTurningC0C1 + bTurning/howmuchTurningbackCoverAngle * howmuchTurningC0C1;
		    phase2bookconstruction3type3(initial_lh, initial_rh, spineAngle, backTurning2, c0c1TurningAngle,
						 initial_lh,
						 lenC0C1);
		}else{
		    if(Ttp.commentslevel >= 3){	
			System.out.println("\t\tphase3");
		    }

		    phase3bookconstruction3type4(initial_lh, initial_rh, spineAngle-90, backTurning2,
						 initial_lh,
						 lenC0C1);
		}

	    }else{
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tinit_spineAngle > 90.0");
		}
		c0c1TurningAngle= initialTurningC0C1 + bTurning/howmuchTurningbackCoverAngle * howmuchTurningC0C1;
		phase3bookconstruction3type3(initial_lh, initial_rh, spineAngle-90, backTurning2, c0c1TurningAngle,
					     initial_lh,
					     lenC0C1 );
	    }
	    
	}
	
	sp[0].genModel(rightTop_curve.getPts(1),
		       rightLower_curve.getPts(1));
	sp[1].genModel(leftTop_curve.getPts(1),
		       leftLower_curve.getPts(1));
	
	Point3d left , right;
	left= leftLower_curve.getPoint();
	right= rightLower_curve.getPoint();
	//construct strip
	genStrip(left, right);	
    }

    
    /*
      Set up a few control variables for flip over the book
    */
    public void setSelectedBackCover2()
    {
	selected_side= LEFT;
	initial_lh= 0;
	initial_rh= config.getBookThickness(); 
	//constraint
	coverStartangle= 0;
	coverStopangle= 180;
    }

    
    /*
      Flip to back cover 
     */
    public void flip2BackCover(double delta)
    {
	double spineAngle;
	backTurning2 -= delta;

	if(backTurning2 < coverStartangle)
	    backTurning2 = coverStartangle;
	
	if(backTurning2 > coverStopangle)
	    backTurning2 = coverStopangle;
	
	spineAngle= backTurning2;
	
	if(spineAngle <= 90 )
	    phase2bookconstruction3type5(initial_lh, initial_rh, spineAngle, initial_lh);
	else
	    phase3bookconstruction3type5(initial_lh, initial_rh, spineAngle, initial_lh);

	sp[0].genModel(rightTop_curve.getPts(1),
		       rightLower_curve.getPts(1));

	Point3d left , right;
	left= rightTop_curve.getPoint();
	right= rightLower_curve.getPoint();
	//construct strip
	genStrip(left, right);	
	
    }
    
    public void flipBackCover(double delta)
    {
	if( backTurning2 < config.HALF_WAY){
	    flip2BackCover(delta);
	}else{
	    flip2BackCover(-delta);
	}
    }
    

    public boolean hasbackCoverLeavedRestPosition()
    {
	if(coverState == CLOSE){
	    if(backTurning < (coverStartangle-coverThreshold_1))
		return true;
	    else
		return false;
	}else{
	    if(backTurning > (coverStartangle+coverThreshold_1))
		return true;
	    else
		return false;
	}
    }

    public boolean isBackCoverCompletelyClose()
    {
	if(Ttp.commentslevel >= 3){	
	    System.out.println("backTurning2= " + backTurning2 );
	}
	
	if(backTurning2 >= (coverStopangle - coverThreshold_2)){
	    backTurning2 = coverStopangle;
	    return true;
	}else{
	    return false;
	}
    }

    public boolean isFrontCoverRestore()
    {
	if(frontTurning2 >= (coverStartangle - coverThreshold_2)){
	    frontTurning2 = coverStartangle;
	    return true;
	}else{
	    return false;
	}
    }

    public boolean isFrontCoverFlipOver()
    {
	if(frontTurning2 <= (coverStopangle + coverThreshold_2)){
	    frontTurning2 = coverStopangle;
	    return true;
	}else{
	    return false;
	}
	
    }

    public boolean isFrontCover_TurnOver()
    {
	if(frontTurning2 > config.HALF_WAY){
	    return isFrontCoverRestore();
	}
	else{
	    return isFrontCoverFlipOver();
	}
    }
    

    public boolean isBackCoverRestore()
    {
	if(Ttp.commentslevel >= 3){	
	    System.out.println("backTurning2= " + backTurning2 );
	}
	
	if(backTurning2 <= (coverStartangle + coverThreshold_2)){
	    backTurning2 = coverStartangle;
	    return true;
	}else{
	    return false;
	}
    }
   
    
    public boolean isBackCoverFlipOver()
    {
	if(Ttp.commentslevel >= 3){	
	    System.out.println("backTurning2= " + backTurning2 );
	}
	
	if(backTurning2 >= (coverStopangle - coverThreshold_2)){
	    backTurning2 = coverStopangle;
	    return true;
	}else{
	    return false;
	}
    }
    
    public boolean isBackCover_TurnOver()
    {
	if(backTurning2 < config.HALF_WAY){
	    return isBackCoverRestore();
	}else{
	    return isBackCoverFlipOver();
	}

    }

    public boolean isBackCoverCompletelyOpenAgain()
    {
	if(backTurning2 <= (coverStartangle + coverThreshold_2)){
	    backTurning2 = coverStartangle;
	    return true;
	}else{
	    return false;
	}
    }

    public boolean isBackCoverCompletelyOpen()
    {
	if(backTurning2 <= (coverStopangle + coverThreshold_2)){
	    backTurning2= coverStopangle;
	    return true;
	}else{
	    return false;
	}
    }


    public boolean isBackCoverCompletelyCloseAgain()
    {
	if(backTurning2 >= (coverStartangle - coverThreshold_2)){
	    backTurning2= coverStartangle;
	    return true;
	}else{
	    return false;
	}
    }

    public boolean isCloseBackCover_Rest()
    {
	if(backTurning2 > config.HALF_WAY ){
	    return isBackCoverCompletelyCloseAgain();
	}
	else{
	    return isBackCoverCompletelyOpen();
	}
    
    }
    
    public boolean isOpenBackCover_Rest()
    {
	if(backTurning2 > config.HALF_WAY ){
	    return isBackCoverCompletelyClose();
	}else{
	    return isBackCoverCompletelyOpenAgain();
	}
    }
    
    
    //////////////////////////
    // page side
    //////////////////////////    
    public byte getSelectedSide()
    {
	return selected_side;
    }

    //////////////////////////
    // selected page number
    //////////////////////////    
    public int getSelectedpage()
    {
	return selected_page;
    }
    

    /*
      initialize rightPageName leftPageName 
     */
    public void initialize_CurTwoPagesTexture(int curPageName)
    {
	//copy from 'setWindowAttribute()'
	if((curPageName%2) == 0){// even
	    //right hand page
	    rightPageName= curPageName;
	    
	    if(rightPageName == 0)// be specific
		leftPageName= -1;
	    else  
		leftPageName= rightPageName - 1;
	    
	}else{//odd
	    leftPageName= curPageName;
	    rightPageName= leftPageName + 1;
	}
    }

    /*
      Assign a new texName for left and right pages
    */
    public void genNextTwoPages(GLCanvas canvas)
    {
	GLFunc gl= canvas.gl;
	gl.glGenTextures(2, nextTexName);

	if(selected_side == RIGHT ){
	    gen2PagesTexture(canvas,
			     selected_page+howmanyPagesLeft,
			     nextTexName);
	}else{
	    gen2PagesTexture(canvas,
			     selected_page-howmanyPagesLeft,
			     nextTexName);
	}
    }

    /*
      This is called when book is closed and user turn to
      the selected page 
     */
    public void genCurTwoPages(GLCanvas canvas)
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor: genCurTwoPages()");
	}
	
	GLFunc gl= canvas.gl;
	gl.glGenTextures(2, curTexName);
	
	if(selected_side == RIGHT ){
	    gen2PagesTexture(canvas,
			     selected_page+howmanyPagesLeft,
			     curTexName);
	}else{
	    gen2PagesTexture(canvas,
			     selected_page-howmanyPagesLeft,
			     curTexName);
	}
    }
    
    /*
      used to be 'deleteCurTexName()'
     */
    public void transitTexName()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor: transitTexName()");
	}
	//remove cur
	scene.deleteTexNames(2, curTexName);
	
	//cur= next
	curTexName[0]= nextTexName[0];
	curTexName[1]= nextTexName[1];
	
	if(Ttp.commentslevel >= 3){	
	    System.out.println("\t curTexName[0]= " + curTexName[0]);
	    System.out.println("\t curTexName[1]= " + curTexName[1]);
	    System.out.println("\t nextTexName[0]= " + nextTexName[0]);
	    System.out.println("\t nextTexName[1]= " + nextTexName[1]);
	}
    }

    public void deleteCurTexName()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor: deleteCurTexName()");
	}
	
	scene.deleteTexNames(2, curTexName);
    }



    public void deleteNextTexName()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor: deleteNextTexName()");
	}
	scene.deleteTexNames(2, nextTexName);
    }


    /*
      This is called when the book is at closing state and 
      an user click on the book's edge
     */
    public void jump_SelectedOneStaticPage()
    {
	int pageName, texName, pageLevel;
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor: jump_SelectedOneStaticPage():");
	}
	
	if(selected_side == RIGHT ){
	    pageName= selected_page+howmanyPagesRight;
	    texName= transform(texturePools.getImageBytes(pageName), pageName);
	    pageLevel= texturePools.getPageMaterialLevel(pageName);
	    sp[0].setPageUPContent(pageName, texName);
	    sp[0].setPageDOWNPageName(config.lastPage);
	    sp[0].setPageMaterialUP(pageMaterial[pageLevel]);
	}else{
	    pageName= selected_page-howmanyPagesLeft;
	    texName= transform(texturePools.getImageBytes(pageName), pageName);
	    pageLevel= texturePools.getPageMaterialLevel(pageName);
	    sp[1].setPageUPContent(pageName, texName);
	    sp[1].setPageDOWNPageName(config.firstPage);
	    sp[1].setPageMaterialUP(pageMaterial[pageLevel]);
	}
	
    }


    /*
      Will be shared among ThreadA, ThreadB and BookConstructor, but how (adapter)
      input: image
      output: texture Name
     */
    int transform(byte [] imagebytes, int page_num)
    {
	int result;
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor.java: transform():" );
	}

	if(imagebytes == null){
	    //this page does not exist
	    if(Ttp.commentslevel >= 3){	
		System.out.println("BookConstructor.java: imagebytes == null" );
	    }
	    return 0;
	}

	
	if(!glj.gljMakeCurrent()) {
	    
	    throw new RuntimeException("BookConstructor.java: transform(): gljMakeCurrent failed");
	}
	
	synchronized(texturePools){
	    //this page does exist
	    result= texturePools.getTexName(page_num);
	    if(Ttp.commentslevel >= 3){	
		System.out.println("BookConstructor.java: synchronize(texturePools) result=  " + result);
	    }
	    
	if(result == 0 ){
	    if(Ttp.commentslevel >= 3){	
		System.out.println("BookConstructor.java: perform transformation()");
	    }
	    
	    //generate new texture 
	    int [] texNames= new int[1];
	    
	    this.gl.glGenTextures(1, texNames);
	    result= texNames[0];
	    //update cache
	    texturePools.setTexName(page_num, result);
	
	    //load image bytes from cache to GLContext
	    if(textureReader.readPageTextureFromInputStream(new ByteArrayInputStream(imagebytes, 0, imagebytes.length))){
		if(Ttp.commentslevel >= 3){	
		    System.out.println("BookConstructor.java: transform(): Successful to read from image buffer" );
		}
		textureReader.setupMipmapsTexturing(result);
	    }else{
		if(Ttp.commentslevel >= 3){	
		    System.out.println("BookConstructor.java: transform(): Fail to read from image buffer" );
		}
		result= 0;
	    }
	    
	    
	}else{
	    if(Ttp.commentslevel >= 3){	
		System.out.println("BookConstructor.java: texture is not avaliable");
	    }
	}
	}
	
	glj.gljCheckGL();
	glj.gljFree();

	
	return result;
    }

    /*
      without glj.gljMakeCurrent()
      query from texturePools
     */
    int transform2(byte [] imagebytes, int page_num)
    {
	int result;

	if(imagebytes == null){
	    //this page does not exist
	    if(Ttp.commentslevel >= 3){	
		System.out.println("****BookConstructor.java: transform(): this page not yet avaliable" );
	    }
	    return 0;
	}
	
	synchronized(texturePools){
	    //this page does exist
	    result= texturePools.getTexName(page_num);
	    
	    if(result == 0 ){
		//generate new texture 
		int [] texNames= new int[1];
		this.gl.glGenTextures(1, texNames);
		result= texNames[0];
		//update cache
		texturePools.setTexName(page_num, result);
		
		//if(!glj.gljMakeCurrent()) {
		//  throw new RuntimeException("ThreadA.java: putTexture(): gljMakeCurrent failed");
		//}
		
		//load image bytes from cache to GLContext
		if(textureReader.readPageTextureFromInputStream(new ByteArrayInputStream(imagebytes, 0, imagebytes.length))){
		    if(Ttp.commentslevel >= 3){	
			System.out.println("BookConstructor.java: transform(): Successful to read from image buffer" );
		    }
		    textureReader.setupMipmapsTexturing(result);
		}else{
		    if(Ttp.commentslevel >= 3){	
			System.out.println("BookConstructor.java: transform(): Fail to read from image buffer" );
		    }
		    result= 0;
		}
		
		//glj.gljCheckGL();
		//glj.gljFree();
	    }else{
		
	    }
	}

	return result;

    }



    /* update static page number*/
    public void step_SelectedOneStaticPage()
    {
	if(Ttp.commentslevel >= 2){
	    System.out.println("BookContructor.java: step_SelectedOneStaticPage():");
	}
	//step by how many pages
	int index= 0;

	if(selected_side == RIGHT ){
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tUpdate the right hand page");
	    }
	    //howmanyPagesRight=  howmanyPapers*2; 
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\thowmanyPagesRight: " + howmanyPagesRight );
	    }
	    
	    int pageName= selected_page+howmanyPagesRight;
	    int texName= transform(texturePools.getImageBytes(pageName), pageName);
	    int pageLevel= texturePools.getPageMaterialLevel(pageName);
	    sp[0].setPageUPContent(pageName, texName);
	    sp[0].setPageMaterialUP(pageMaterial[pageLevel]);
	}else{
	    //howmanyPagesLeft=  howmanyPapers*2;
	    if(Ttp.commentslevel >= 3){	
		System.out.println("Update the left hand page");
		System.out.println("\thowmanyPagesLeft: " + howmanyPagesLeft );
	    }

	    int pageName= selected_page-howmanyPagesLeft;
	    int texName= transform(texturePools.getImageBytes(pageName), pageName);
	    int pageLevel= texturePools.getPageMaterialLevel(pageName);
	    sp[1].setPageUPContent(pageName, texName);
	    sp[1].setPageMaterialUP(pageMaterial[pageLevel]);
	}
    }
    
    


    public void step_back_step_SelectedOneStaticPage()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("step_back_step_SelectedOneStaticPage():");
	}
	
	//filling Right hand page
	if(selected_side == RIGHT ){
	    //edge anchors
	    startYi= (double)paper_no_lieOnLeft/(double)config.get_total_papers() * edge_height;
	    startXi= startYi/edge_m;
	    
	    endYi= 0;
	    endXi= 0;
	    
	    sp[0].setStartX(startXi);
	    sp[0].setEndX(endXi);// value unsure at moment, here might be redundant
	    sp[0].setPapers(paper_no_lieOnRight); // number of papers at Right hand stack
	    
	    int pageName= selected_page;
	    int texName= transform(texturePools.getImageBytes(pageName), pageName);
	    int pageLevel= texturePools.getPageMaterialLevel(pageName);
	    
	    sp[0].setPageUPContent(pageName, texName );
	    sp[0].setPageDOWNPageName(config.lastPage);
	    sp[0].setPageMaterialUP(pageMaterial[pageLevel]);
	}else{
	    //edge anchors
	    startYi= 0;
	    startXi= 0;

	    endYi= (double)paper_no_lieOnRight/(double)config.get_total_papers() * edge_height;
	    endXi= endYi/edge_m;
	    
	    sp[1].setStartX(startXi);
	    sp[1].setEndX(endXi);// value unsure at moment, here might be redundant
	    sp[1].setPapers(paper_no_lieOnLeft); // number of papers at Right hand stack
	    
	    
	    int pageName= selected_page;
	    int texName= transform(texturePools.getImageBytes(pageName), pageName);
	    int pageLevel= texturePools.getPageMaterialLevel(pageName);
	    sp[1].setPageUPContent(pageName, texName );
	    sp[1].setPageDOWNPageName(config.firstPage);
	    sp[1].setPageMaterialUP(pageMaterial[pageLevel]);
	}
    }

    
    public void jump_theOtherStaticPage()
    {
	int pageName, texName, pageLevel;
	if(Ttp.commentslevel >= 2){	
	    System.out.println("jump_theOtherStaticPage():");
	}
	if(selected_side == RIGHT ){
	    pageName= selected_page+howmanyPagesLeft;
	    texName= transform(texturePools.getImageBytes(pageName), pageName);
	    pageLevel= texturePools.getPageMaterialLevel(pageName);
	    sp[1].setPageUPContent(pageName, texName);
	    sp[1].setPageDOWNPageName(config.firstPage);
	    sp[1].setPageMaterialUP(pageMaterial[pageLevel]);
	    
	}else{
	    pageName= selected_page-howmanyPagesRight;
	    texName= transform(texturePools.getImageBytes(pageName), pageName);
	    pageLevel= texturePools.getPageMaterialLevel(pageName);
	    sp[0].setPageUPContent(pageName, texName);
	    sp[0].setPageDOWNPageName(config.lastPage);
	    sp[0].setPageMaterialUP(pageMaterial[pageLevel]);
	}

    }

    public void updatePapers()
    {
	if(selected_side == RIGHT ){
	    paper_no_lieOnLeft += howmanyPapers;
	    paper_no_lieOnRight -= howmanyPapers;
	}else{
	    paper_no_lieOnLeft -= howmanyPapers;
	    paper_no_lieOnRight += howmanyPapers;
	}
    }
  
		
    /*
      without lastWindow & firstWindow
     */
    public void step_theOtherStaticPage2()
    {	
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookContructor.java : step_theOtherStaticPage2():");
	}
	//step by how many pages
	//at moment howmanyPapers is equal to 1
		
	if(selected_side == RIGHT ){
	    //howmanyPagesLeft=  howmanyPagesRight - 1; 
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\thowmanyPagesLeft: " + howmanyPagesLeft );
		System.out.println("\tleft page no. updated: " + (selected_page+howmanyPagesLeft));
		System.out.println("\tUpdate Left page ");
	    }
	    
	    int pageName= selected_page+howmanyPagesLeft;
	    int texName= transform(texturePools.getImageBytes(pageName), pageName);
	    int pageLevel= texturePools.getPageMaterialLevel(pageName);
	    sp[1].setPage_num(texName, pageName);
	    sp[1].setPageMaterialUP(pageMaterial[pageLevel]);
	}else{
	    //sp[0].setPage_num(nextTexName[1], selected_page-howmanyPagesRight );
	    int pageName= selected_page-howmanyPagesRight;
	    int texName= transform(texturePools.getImageBytes(pageName), pageName);
	    int pageLevel= texturePools.getPageMaterialLevel(pageName);
	    sp[0].setPage_num(texName, pageName);
	    sp[0].setPageMaterialUP(pageMaterial[pageLevel]);
	}
    }

    
    /*
      with lastWindow & firstWindow
     */
    void advancingWindow()
    {
	//boundry, threshold, buffersize
	if(Ttp.commentslevel >= 3){	
	    System.out.println("Advance Previous Window: ");
	}
	previousWindow.copy(curWindow);// does not include texName
	previousWindow.print();
	
	if(Ttp.commentslevel >= 3){	
	    System.out.println("Advance Current Window attribute> ");
	}
	curWindow.copy(nextWindow);//does not include texName
	curWindow.print();
    }
    
    /*
      with lastWindow & firstWindow
     */
    void recedingWindow()
    {
	//boundry, threshold, buffersize
	if(Ttp.commentslevel >= 3){	
	    System.out.println("Recede next Window: ");
	}

	nextWindow.copy(curWindow);
	nextWindow.print();

	if(Ttp.commentslevel >= 3){	
	    System.out.println("Recede Current Window: ");
	}
	
	curWindow.copy(previousWindow);
	curWindow.print();
    }

    /*without lastWindow & firstWindow */
    void advancingWindow2()
    {
	//boundry, threshold, buffersize
	if(Ttp.commentslevel >= 3){	
	    System.out.println("Advance Previous Window: ");
	}
	previousWindow.copy(curWindow);// does not include texName
	previousWindow.print();
	
	if(Ttp.commentslevel >= 3){	
	    System.out.println("Advance Current Window attribute> ");
	}
	
	curWindow.copy(nextWindow);//does not include texName
	curWindow.print();
    }

    /*without lastWindow & firstWindow */
    void recedingWindow2()
    {
	//boundry, threshold, buffersize
	if(Ttp.commentslevel >= 3){	
	    System.out.println("Recede next Window: ");
	}
	nextWindow.copy(curWindow);
	nextWindow.print();
	
	if(Ttp.commentslevel >= 3){	
	    System.out.println("Recede Current Window: ");
	}
	curWindow.copy(previousWindow);
	curWindow.print();
    }

    public void restoreStaticPage()
    {
	if(selected_side == RIGHT ){
	    sp[0].setPage_num(0, selected_page);
	}else{
	    sp[1].setPage_num(0, selected_page);
	}
    }

    /*
      initialize dynamic page
     */
    public void setDynamicPage()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor: setDynamicPage()");
	}
	int indexUp, indexDown, selected_page_down;

	dp.setStartPosition(rightTop_curve.getPoint()); //rightTop_d.getPoint()
	pageTurningAngle= 0;
	
	indexUp= selected_page % config.num_dynamic_tex_obj; //cur_index

	if(selected_side == RIGHT){
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tANTI_CLOCKWISE");
	    }
	    selected_page_down= selected_page+1; 
	    indexDown= selected_page_down % config.num_dynamic_tex_obj; //nex_index
	    
	    dp.setTurningDirection(ANTI_CLOCKWISE);
	    pageStopAngle= config.getMaxAngle();
	    
	    if(Ttp.commentslevel >= 3){	
		System.out.println("page stop angle > " + pageStopAngle);
	    }

	    if(bufferingOption == DIRECT_ONE || 
	       bufferingOption == DIRECT_TWO){
		int texNameUp= transform(texturePools.getImageBytes(selected_page), selected_page);
		dp.setPageUPContent(selected_page, texNameUp);
		int pageMaterialUp= texturePools.getPageMaterialLevel(selected_page);
		dp.setPageMaterialUP(pageMaterial[pageMaterialUp]);
		
		int texNameDown= transform(texturePools.getImageBytes(selected_page_down), selected_page_down);
		dp.setPageDOWNContent(selected_page_down, texNameDown);
		int pageMaterialDown= texturePools.getPageMaterialLevel(selected_page_down);
		dp.setPageMaterialDOWN(pageMaterial[pageMaterialDown]);
		

	    }else if(bufferingOption == ANCHORING){
		//not yet implemented
		
	    }else if(bufferingOption == WINDOWING){
		if(Ttp.commentslevel >= 3){	
		    System.out.println("\tWindowing");
		}
		
		if(indexUp == tail_index){ // cur_index == tail_index
		    dp.setPageContent(selected_page, selected_page_down, 
				      curWindow.texName[indexUp], 
				      nextWindow.texName[indexDown]);
		}else{
		    dp.setPageContent(selected_page, selected_page_down, 
				      curWindow.texName[indexUp], 
				      curWindow.texName[indexDown]);
		}
		
	    }else{

	    }
	    
	}else{
	    if(Ttp.commentslevel >= 3){	
		System.out.println("\tCLOCKWISE");
	    }
	    
	    selected_page_down= selected_page-1;
	    dp.setTurningDirection(CLOCKWISE);
	    pageStopAngle= -config.getMaxAngle();
	    
	    selected_page_down= selected_page-1;
	    indexDown= selected_page_down % config.num_dynamic_tex_obj; 
	    
	    dp.setTurningDirection(CLOCKWISE);
	    pageStopAngle= -config.getMaxAngle();

	    if(Ttp.commentslevel >= 3){	
		System.out.println("page stop angle > " + pageStopAngle);
	    }
	    
	    if(bufferingOption == DIRECT_ONE || 
	       bufferingOption == DIRECT_TWO){
		/*dp.setPageContent(selected_page, selected_page_down, 
				  curTexName[0], 
				  nextTexName[1]);*/
		int texNameUp= transform(texturePools.getImageBytes(selected_page), selected_page);
		dp.setPageUPContent(selected_page, texNameUp);
		int pageMaterialUp= texturePools.getPageMaterialLevel(selected_page);
		dp.setPageMaterialUP(pageMaterial[pageMaterialUp]);

		int texNameDown= transform(texturePools.getImageBytes(selected_page_down), selected_page_down);
		dp.setPageDOWNContent(selected_page_down, texNameDown);
		int pageMaterialDown= texturePools.getPageMaterialLevel(selected_page_down);
		dp.setPageMaterialDOWN(pageMaterial[pageMaterialDown]);


		
	    }else if(bufferingOption == ANCHORING){
		//not yet implemented
		
	    }else if(bufferingOption == WINDOWING){
		if(indexUp == head_index){ // cur_index == head_index
		    dp.setPageContent(selected_page, selected_page_down, 
				      curWindow.texName[indexUp], 
				      previousWindow.texName[indexDown]);
		}else{
		    dp.setPageContent(selected_page, selected_page_down, 
				      curWindow.texName[indexUp], 
				      curWindow.texName[indexDown]);
		}
	    }else{
		
	    }

	    
	}
	
	if(Ttp.commentslevel >= 3){	
	    System.out.println("page stop angle > " + pageStopAngle);
	}

	//passing currently selected page name 
	//dp.setAll(selected_page, texName[FIRST_PAGE], texName[PAGE_MATERIAL] );
	

	dp.setJackVectors(leftTop_curve.getVectors(),
			  rightTop_curve.getVectors());
	dp.setpivotAngle(leftTop_curve.getPts(1),
			 rightTop_curve.getPts(1)); // independent from the turning direction
	dp.set_approx_rot_angle(pageTurningAngle);
    }

   //   public void resetDynamicPage()
//      {
//  	dp.setStartPosition(rightTop_d.getPoint());
//  	pageTurningAngle= pageTurningAngle-config.getMaxAngle();

//  	if(selected_side == RIGHT){
//  	    dp.setTurningDirection(ANTI_CLOCKWISE);
//  	    pageStopAngle= config.getMaxAngle();
//  	    //System.out.println("page stop angle > " + pageStopAngle);
//  	}else{
//  	    dp.setTurningDirection(CLOCKWISE);
//  	    pageStopAngle= -config.getMaxAngle();
//  	    //System.out.println("page stop angle > " + pageStopAngle);
//  	}
	
//  	dp.setAll(selected_page, texName[FIRST_PAGE], texName[PAGE_MATERIAL] );
	
//  	dp.setJackVectors(leftTop_d.getVectors(),
//  			  rightTop_d.getVectors());
	
//  	dp.setpivotAngle(leftTop_d.getPts(1),
//  			 rightTop_d.getPts(1)); // independent from the turning direction
	
//  	dp.set_approx_rot_angle(pageTurningAngle);
    
//      }


    public void setBundlePages()
    {
	int selected_page_down;
	int texNameUp, texNameDown, pageLevel;
	
	if(selected_side == LEFT){
	    dpBundle.setStartUPPosition(interior_curveUP.getPoint());
	    dpBundle.setStartDOWNPosition(interior_curveDOWN.getPoint());
	    

	    dpBundle.setTurningDirection(CLOCKWISE);
	    dpBundle.setJackVectors(  interior_curveUP.getVectors(), interior_curveUP_finish.getVectors(),  //left, right
				      interior_curveDOWN.getVectors(), interior_curveDOWN_finish.getVectors()); //left, right
	    dpBundle.setpivotAngle(interior_curveDOWN.getPts(1), 
				   interior_curveDOWN_finish.getPts(1));
	    dpBundle.setRotationAngle(pageTurningAngle);

	    //bundle.setSide(LEFT);
	    bundle.genModel2(dpBundle.getUPcurvePts(),
			     dpBundle.getDOWNcurvePts());
	    
	    //one side uses window's texture and the other use nextTexName
	    /*bundle.setPage_num2(selected_page, selected_page-howmanyPagesRight, 
	      curTexName[0], nextTexName[1]);*/
	    texNameUp= transform(texturePools.getImageBytes(selected_page), selected_page);
	    bundle.setPageUPContent(selected_page, texNameUp);
	    pageLevel= texturePools.getPageMaterialLevel(selected_page);
	    bundle.setPageMaterialUP(pageMaterial[pageLevel]);
	    
	    selected_page_down= selected_page-howmanyPagesRight;
	    texNameDown= transform(texturePools.getImageBytes(selected_page_down), selected_page_down);
	    bundle.setPageDOWNContent(selected_page_down, texNameDown);
	    pageLevel= texturePools.getPageMaterialLevel(selected_page_down);
	    bundle.setPageMaterialDOWN(pageMaterial[pageLevel]);
	    
	}else{
	    //selected_side == RIGHT
	    dpBundle.setStartUPPosition(interior_curveUP.getPoint());
	    dpBundle.setStartDOWNPosition(interior_curveDOWN.getPoint());
	    
	    dpBundle.setTurningDirection(ANTI_CLOCKWISE);
	    dpBundle.setJackVectors(interior_curveUP_finish.getVectors(), interior_curveUP.getVectors(),      //left, right
				    interior_curveDOWN_finish.getVectors(), interior_curveDOWN.getVectors()); //left, right
	    dpBundle.setpivotAngle(interior_curveUP_finish.getPts(1), interior_curveUP.getPts(1));
	    dpBundle.setRotationAngle(pageTurningAngle);// interpolate 
	    
	    //bundle.setSide(RIGHT);
	    bundle.genModel2(dpBundle.getUPcurvePts(),
			     dpBundle.getDOWNcurvePts());

	    //one side uses window's texture and the other use nextTexName
	    /*bundle.setPage_num2(selected_page, selected_page+howmanyPagesLeft,  
	      curTexName[1], nextTexName[0]);*/

	    texNameUp= transform(texturePools.getImageBytes(selected_page), selected_page);
	    bundle.setPageUPContent(selected_page, texNameUp);
	    pageLevel= texturePools.getPageMaterialLevel(selected_page);
	    bundle.setPageMaterialUP(pageMaterial[pageLevel]);
	    
	    selected_page_down= selected_page+howmanyPagesLeft;
	    texNameDown= transform(texturePools.getImageBytes(selected_page_down), selected_page_down);
	    bundle.setPageDOWNContent(selected_page_down, texNameDown);
	    pageLevel= texturePools.getPageMaterialLevel(selected_page_down);
	    bundle.setPageMaterialDOWN(pageMaterial[pageLevel]);
	}
	
    }
    
    public void deconstructBundlePages()
    {
	bundle.destroyModel();
    }


    public void stepPage_State(double t)
    {
	pageTurningAngle = f(t)*pageStopAngle;
	udpatePage();
    }

    public void rotatePage(double delta)
    {
	pageTurningAngle -= delta;
	udpatePage();
    }
    
    public void udpatePage()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor.java: updatePage()");
	}

	if(Ttp.commentslevel >= 3){	
	    System.out.println("\tpageTurningAngle= " + pageTurningAngle );
	}

	if(selected_side == RIGHT){
	    if(pageTurningAngle < 0.0){
		pageTurningAngle= 0;
	    }
	}else{
	    if(pageTurningAngle > 0.0){
		pageTurningAngle= 0;
	    }
	}

	dp.set_approx_rot_angle(pageTurningAngle);
    }


    public void rotateLeftPage(double delta)
    {
	if(pageTurningAngle < -config.HALF_WAY){
	    rotatePage(delta);
	}else{
	    rotatePage(-delta);
	}
	

    }

    public void rotateRightPage(double delta){

	if(pageTurningAngle < config.HALF_WAY){
	    rotatePage(delta);
	}else{
	    rotatePage(-delta);
	}
    }
    
    public void stepSpine_State(double t)
    {
	pageTurningAngle = f(t)*pageStopAngle;
	updateSpine();
    }

    
    public void rotateSpine(double delta)
    {
	pageTurningAngle -= delta;
	updateSpine();
    }
    
    public void updateSpine()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor.java: updateSpine()");
	}
	
	double spineAngle;
	double bt= config.getBookThickness();
	double t, length;
	double right_length= 0, left_length= 0;
	double right_t, left_t;
	
	if(selected_side == RIGHT){
	    if(pageTurningAngle < 0.0){
		pageTurningAngle= 0;
	    }

	    if(pageTurningAngle > pageStopAngle){
		pageTurningAngle= pageStopAngle;
	    }
	    t= Math.abs(pageTurningAngle/180);
	    spineAngle= pageTurningAngle/180 * howmuchTurningSpineAngle;
	    spineAngle= initial_turning_angle + spineAngle;

	    //testing jumping
	    if(spineAngle <= 90.0){
		length= distanceC0C1(spineAngle);
		
		right_t= t + (1-t)*(final_rh/initial_rh); //from final_rh/initial_rh to 1 
		right_length= right_t*bt + (1-right_t)*length;

		left_t= t*(initial_lh/final_lh) + (1-t); //from 1 to initial_lh/final_lh 
		left_length= left_t*bt + (1-left_t)*length;
		
		phase2bookconstruction3type2(initial_lh, 
					     final_rh, 
					     spineAngle,
					     initial_lh,  //midLeft
					     final_lh,
					     right_length,
					     left_length,
					     length);   //midRight: final_lh
		
	    }else{
		length= phase3distanceC0C1(spineAngle);
		
		right_t= t + (1-t)*(final_rh/initial_rh); //from final_rh/initial_rh to 1 
		right_length= right_t*bt + (1-right_t)*length;

		left_t= t*(initial_lh/final_lh) + (1-t); //from 1 to initial_lh/final_lh 
		left_length= left_t*bt + (1-left_t)*length;
		
		phase3bookconstruction3type2(initial_lh,
					     final_rh, 
					     spineAngle-90,
					     initial_lh,  //midLeft
					     final_lh,
					     right_length,
					     left_length);  
	    }
	    
	    dpBundle.setStartUPPosition(leftTop_curve.getPoint());
	    dpBundle.setStartDOWNPosition(rightTop_curve.getPoint());

	}else{
	    if(pageTurningAngle > 0.0){
		pageTurningAngle= 0;
	    }

	    if(pageTurningAngle < pageStopAngle){
		pageTurningAngle= pageStopAngle;
	    }

	    t= Math.abs(pageTurningAngle/180);
	    spineAngle= pageTurningAngle/180 * howmuchTurningSpineAngle;
	    spineAngle= initial_turning_angle + spineAngle;
	    
	    if(spineAngle <= 90.0){
		length= distanceC0C1(spineAngle);
		left_t= t + (1-t)*(final_lh/initial_lh); //from final_lh/initial_lh to 1 
		left_length= left_t*bt + (1-left_t)*length;
		
		right_t= t*(initial_rh/final_rh) + (1-t); //from 1 to initial_rh/final_rh
		right_length= right_t*bt + (1-right_t)*length;
		
		phase2bookconstruction3type2(final_lh,    //lh
					     initial_rh,  //rh
					     spineAngle,
					     final_lh,    //midLeft
					     initial_lh,
					     right_length,
					     left_length,
					     length); //midright
		
	    }else{
		left_t= t + (1-t)*(final_lh/initial_lh); //from final_lh/initial_lh to 1 
		length= phase3distanceC0C1(spineAngle);
		left_length= left_t*bt + (1-left_t)*length;
		
		right_t= t*(initial_rh/final_rh) + (1-t); //from 1 to initial_rh/final_rh
		length= phase3distanceC0C1(spineAngle);
		right_length= right_t*bt + (1-right_t)*length;


		phase3bookconstruction3type2(final_lh,    //lh
					     initial_rh,  //rh,
					     spineAngle-90,
					     final_lh,    //midLeft
					     initial_lh,
					     right_length,
					     left_length);
		
	    }

	    dpBundle.setStartUPPosition(rightTop_curve.getPoint());
	    dpBundle.setStartDOWNPosition(leftTop_curve.getPoint());
	}

	dpBundle.setRotationAngle(pageTurningAngle);
	bundle.genModel2(dpBundle.getUPcurvePts(),
			 dpBundle.getDOWNcurvePts());
	
	if(Ttp.commentslevel >= 3){	
	    System.out.println("\tpageTurningAngle= " + pageTurningAngle);
	    System.out.println("\tspineAngle= " + spineAngle);
	}

	sp[0].genModel(rightTop_curve.getPts(1),
		       rightLower_curve.getPts(1));
	sp[1].genModel(leftTop_curve.getPts(1),
		       leftLower_curve.getPts(1));
	
	Point3d left , right;
	left= leftLower_curve.getPoint();
	right= rightLower_curve.getPoint();
	//construct strip
	genStrip(left, right);	
	

    }
    


    public boolean hasPageLeavedRestPosition()
    {
	if(selected_side == RIGHT){
	    if(pageTurningAngle > coverThreshold_1)
		return true;
	    else
		return false;
	}else{
	    if(pageTurningAngle < -coverThreshold_1 )
		return true;
	    else
		return false;
	}
    }

    public boolean isRightPage_rest_on_Left()
    {
	if(pageTurningAngle >= pageStopAngle)
	    return true;
	else
	    return false;
    }

    public boolean isRightPage_rest_on_Right()
    {
	//if(pageTurningAngle <= coverThreshold_2)
	if(pageTurningAngle <= 0)
	    return true;
	else
	    return false;
    }
    
    public boolean isLeftPage_rest_on_Right()
    {
	if(pageTurningAngle <= pageStopAngle)
	    return true;
	else
	    return false;
    }

    public boolean isLeftPage_rest_on_Left()
    {
	if(pageTurningAngle >= 0)
	    return true;
	else
	    return false;
    }
    
    public boolean isLeftPage_Rest()
    {
	if(pageTurningAngle < -config.HALF_WAY){
	    return isLeftPage_rest_on_Right();
	}
	else{
	    return isLeftPage_rest_on_Left();
	}
    }
   
    public boolean isRightPage_Rest()
    {
	if(pageTurningAngle < config.HALF_WAY){
	    return isRightPage_rest_on_Right();
	}
	else{
	    return isRightPage_rest_on_Left();
	}
    }
    
   
    //Query angle
    public double getFrontCoverTurningAngle()
    {
	return frontTurning2;
    }

    public double getBackCoverTurningAngle()
    {
	return backTurning2;
    }
 
    public double getPageTurningAngle()
    {
	return pageTurningAngle;
    }

    public boolean isFrontCoverFacingUP()
    {
	if( paper_no_lieOnLeft == 0){
	    return true;
	}else{
	    return false;
	}
	
    }
    
    public boolean isFrontCoverFacingDOWN()
    {
	if(paper_no_lieOnLeft == config.get_total_papers()){
	    return true;
	}else{
	    return false;
	}
    }

    public boolean isPages(int sName)
    {
	
	if(sName >= config.firstPage && sName  <= config.lastPage){
	    return true;
	}else {
	    return false;
	}
    }

    /*
      is called by scene.doCleanup()
     */
    public void deleteTextureNames()
    {
	if(Ttp.commentslevel >= 2){	
	    System.out.println("BookConstructor.java: deleteTextureNames():");
	}
	
	int len;

	//free fixedTexName
	len= fixedTexName.length;
	gl.glDeleteTextures(len, fixedTexName);
	
	//free pageMaterial
	len= pageMaterial.length;
	gl.glDeleteTextures(len, pageMaterial);
	
	//free page textures
	int [] texNames= texturePools.getPageNames();
	len= texNames.length;
	gl.glDeleteTextures(len, texNames);
    }


    protected void displayReadingPlane()
    {
	//drawing front cover
	//drawing back cover
	//drawing pages and two covers
	//  drawing right page
	//  drawing left page
	//  drawing both page
	
	updateReadingPlanePosition();
	drawingRightImage();
	drawingLeftImage();
    }

    protected void updateReadingPlanePosition()
    {
	double dvalue= config.readingplane_dvalue;
	
	for(int i= 0; i<4; i++){
	    for(int j= 0; j<4; j++){
		finish_Right_Control_pts[i][j].z= -dvalue; 
		finish_Left_Control_pts[i][j].z= -dvalue; 
	    }
	}

    }
    
    protected void drawingRightImage()
    {
	//query right texture name from static page
	
	int page_num=  sp[0].getPage_num();
	
	if(page_num > config.lastPage && coverState == OPEN){
	    //if(config.parameters.getfileType() == DJVU){
	    drawingRectangle(fixedTexName[INSIDE_BOOK_BACK_COVER ], NONE,  rightPage_texCoord, finish_Right_Control_pts );//changed
		//}
	}
	else if( page_num <= config.lastPage && coverState == OPEN){
	    drawingRectangle(sp[0].getTextureName(), sp[0].getPageMaterial(), rightPage_texCoord, finish_Right_Control_pts );//changed
	}
	
	else if(page_num == config.firstPage && coverState == CLOSE){
	    drawingRectangle(fixedTexName[BOOK_FRONT_COVER], NONE, rightPage_texCoord, finish_Right_Control_pts ); //changed
	}
	else{

	}
	
    }


    
    protected void drawingRectangle(int texname, int pageMaterial, double texCoord [][], Point3d corners [][]) //changed
    {
	float [] white= {1.f,1.f,1.f, 1.f}; 
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS);
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, white);
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, white);
	gl.glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, config.getPageShiness());
	
	gl.glActiveTextureARB(GL_TEXTURE0_ARB);
	gl.glEnable(GL_TEXTURE_2D);
	gl.glBindTexture(GL_TEXTURE_2D, texname); //texname

	gl.glActiveTextureARB(GL_TEXTURE1_ARB);
	gl.glEnable(GL_TEXTURE_2D);
	gl.glBindTexture(GL_TEXTURE_2D, pageMaterial); //changed
	
	gl.glBegin(GL_QUADS);
	/*int i;
	for(i=0; i<4; i++){
	    gl.glMultiTexCoord2dvARB(GL_TEXTURE0_ARB, texCoord[i]);
	    gl.glVertex3dv(corners[i].get3dv());
	    }*/
	
	gl.glMultiTexCoord2dvARB(GL_TEXTURE0_ARB, texCoord[0]);
	gl.glMultiTexCoord2dvARB(GL_TEXTURE1_ARB, texCoord[0]);//changed
	gl.glVertex3dv(corners[3][0].get3dv());
	gl.glMultiTexCoord2dvARB(GL_TEXTURE0_ARB, texCoord[1]);	
	gl.glMultiTexCoord2dvARB(GL_TEXTURE1_ARB, texCoord[1]);//changed
	gl.glVertex3dv(corners[3][3].get3dv());
	gl.glMultiTexCoord2dvARB(GL_TEXTURE0_ARB, texCoord[2]);
	gl.glMultiTexCoord2dvARB(GL_TEXTURE1_ARB, texCoord[2]);//changed
	gl.glVertex3dv(corners[0][3].get3dv());
	gl.glMultiTexCoord2dvARB(GL_TEXTURE0_ARB, texCoord[3]);
	gl.glMultiTexCoord2dvARB(GL_TEXTURE1_ARB, texCoord[3]);//changed
	gl.glVertex3dv(corners[0][0].get3dv());
	
	
	gl.glEnd();
	gl.glPopAttrib();
	

    }

    protected void drawingLeftImage()
    {
	//query right texture name from static page
	int page_num=  sp[1].getPage_num();

	
	if(page_num == -1 && coverState == OPEN){
	    //if(config.parameters.getfileType() == DJVU){
	    drawingRectangle(fixedTexName[INSIDE_BOOK_FRONT_COVER], NONE, leftPage_texCoord, finish_Left_Control_pts  );//changed
		//}
	}
	else if( page_num > config.firstPage && coverState == OPEN){
	    drawingRectangle(sp[1].getTextureName(), sp[0].getPageMaterial(), leftPage_texCoord, finish_Left_Control_pts ); //changed
	    
	}

	else if(page_num == config.lastPage && coverState == CLOSE){
	    if(config.parameters.getfileType() == DJVU){
		drawingRectangle(fixedTexName[BOOK_BACK_COVER], NONE,  leftPage_texCoord, finish_Left_Control_pts ); //changed
	    }
	    
	}
	else{

	}
    }
    
    
    

    /*test
    public void draw_start_right()
    {
	float [] blue= {1.f, 1.f, 1.f, 1.f};
	gl.glPushAttrib(GL_ALL_ATTRIB_BITS);
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, blue);
	gl.glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, blue);
	gl.glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, config.getCoverShiness());
	
	gl.glBegin (GL_POINTS);
	int i;
	System.out.println("before Scene.java: start_right[0]= " + start_right[0].toString());
	Point3d out= new Point3d();
	//modelviewmatrix.transform(start_right[0], out);
	System.out.println("after Scene.java: start_right[0]= " + start_right[0].toString());
	//for(i=0; i<4; i++){
	
	gl.glVertex3dv(out.get3dv());
	//}
	gl.glEnd();
	gl.glPopAttrib();
	
	}*/
    

    public void pageUP()
    {
	int page_num=  sp[1].getPage_num();

	if(page_num == config.lastPage &&  coverState == CLOSE){
	    setSelectedBackCover();
	    jump_SelectedOneStaticPage();
	    jump_theOtherStaticPage();
	    coverState = OPEN;
	    pageReconstruction2();
	}
	else if( page_num < config.firstPage &&  coverState == OPEN){
	    //close cover
	    setSelectedFrontCover();
	    setCoverState(CLOSE);
	    reset_StaticPages();
	    pageReconstruction2();
	    deconstructBundlePages();//disconstruct pagebundles

	
	}
	else{
	    if( page_num >= 1){
		updateSelectedPage(page_num);
		jump_SelectedOneStaticPage();
		jump_theOtherStaticPage();
		updatePapers();
		update_StaticPages();
		pageReconstruction2();
	    }
	}
    }

    public void pageDOWN()
    {
	int page_num=  sp[0].getPage_num();

	if(page_num == config.firstPage &&  coverState == CLOSE){
	    //open cover
	    setSelectedFrontCover();
	    jump_SelectedOneStaticPage();
	    jump_theOtherStaticPage();
	    coverState = OPEN;
	    pageReconstruction2();
	    
	    
	}else if( page_num > config.lastPage &&  coverState == OPEN){
	    //close cover
	    setSelectedBackCover();
	    setCoverState(CLOSE);
	    reset_StaticPages();
	    pageReconstruction2();
	    deconstructBundlePages();//disconstruct pagebundles

	
	}else{ 
	    if( page_num < config.lastPage){
		updateSelectedPage(sp[0].getPage_num());
		jump_SelectedOneStaticPage();
		jump_theOtherStaticPage();
		updatePapers();
		update_StaticPages();
		pageReconstruction2();
	    }
	}
    }

   

    public Point3d [][] getFinishRightControlPoints()
    {
	return this.finish_Right_Control_pts;
    }

    public Point3d [][] getStartRightControlPoints()
    {
	return this.start_Right_Control_pts;
    }

    public Point3d [][] getStartLeftControlPoints()
    {
	return this.start_Left_Control_pts;
    }
    
    public Point3d [][] getFinishLeftControlPoints()
    {
	return this.finish_Left_Control_pts;
    }
    

}

